************************************************************************
*
*     counterterms for H->ZZ->uudd (generic u,d)
*
************************************************************************
      subroutine HZZ1133_count_bgf(F,pz12,pz34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pz12,pz34
      complex*16 pre,ct,ct12,ct34,cazff12(-1:1),cazff34(-1:1)
      include 'COMMON/xparam.inc'
c bosonic renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
      complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
      complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
      complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
      complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
      complex*16 ct_hww,ct_hzz,ct_hza
      common/xrenc_bgf/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &                  dZeer,dZeel,dZnnl,dZffr,dZffl,
     &                  ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &                  ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &                  ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &                  ct_hww,ct_hzz,ct_hza
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14

c Aff/Zff couplings
c note that qf is charge of isospin duplet (particle, not anti-particle)
c charges of outgoing fermions according to 2233/1133/1144
      cazff12(-1) = qf(1)/(-1d0+2d0*qf(1)*xsw2)*2d0*xsw*xcw
      cazff12(+1) = xcw/xsw
      cazff34(-1) = qf(3)/(1d0+2d0*qf(3)*xsw2)*2d0*xsw*xcw
      cazff34(+1) = xcw/xsw

c counterterms for self energies
      ct =  dmz2/(s12-xmz2) - dZzz
     &     +dmz2/(s34-xmz2) - dZzz

      PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0  *ct

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

c ZA-mixing self energy counterterms
      ct12 = xmz2/s12*dZza/2d0 - (dZaz+dZza)/2d0
      ct34 = xmz2/s34*dZza/2d0 - (dZaz+dZza)/2d0

      PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)    *(ct12*cazff12(-1)+ct34*cazff34(-1))
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW                        *(ct12*cazff12(-1)+ct34*cazff34(+1))
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW                        *(ct12*cazff12(+1)+ct34*cazff34(-1))
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &                             *(ct12*cazff12(+1)+ct34*cazff34(+1))

c counterterms for vertex diagrams
      PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)      *(ct_hzz+ct_Zffl(1)+ct_Zffl(3))
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW                          *(ct_hzz+ct_Zffl(1)+ct_Zffr(3))
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW                          *(ct_hzz+ct_Zffr(1)+ct_Zffl(3))
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
     &                               *(ct_hzz+ct_Zffr(1)+ct_Zffr(3))

      end

************************************************************************
*
*     bosonic self energies for H->ZZ->uudd (generic u,d)
*
************************************************************************
      subroutine HZZ1133_self_bos_bgf(F,pz12,pz34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pz12,pz34
      complex*16 A0,xA0_,B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
      complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
      complex*16 pre,K(1)
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S10F2100aF2100F2300aF2300,   Model: SMbgf4f

C       G(T1,N6,FULL)+G(T2,N16,FULL)
        A0 = xA0_(XMH2)

        PRE = -((A0*ALPHA*PZ12*PZ34*(PZ12+PZ34)*XCW2**(-3)*XMW)/
     &  (64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T1,N1,FULL)+G(T1,N10,FULL)+G(T1,N2,FULL)+G(T1,N3,FULL)+
C       G(T1,N4,FULL)+G(T1,N5,FULL)+G(T1,N8,FULL)+G(T1,N9,FULL)+
C       G(T2,N11,FULL)+G(T2,N12,FULL)+G(T2,N13,FULL)+G(T2,N14,FULL)+
C       G(T2,N15,FULL)+G(T2,N18,FULL)+G(T2,N19,FULL)+G(T2,N20,FULL)
        A0 = xA0_(XMW2)

        PRE = -((ALPHA*PZ12*PZ34*XMW)/(32D0*PI*S12*S34*XCW2*XSW))

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(8D0*XMW2*(PZ12*S12*
     &  S34+PZ34*S12*S34-2D0*QF(3)*S12*XSW2+2D0*QF(1)*S34*XSW2-2D0*
     &  QF(1)*PZ12*S12*S34*XSW2+2D0*QF(3)*PZ12*S12*S34*XSW2-2D0*
     &  QF(1)*PZ34*S12*S34*XSW2+2D0*QF(3)*PZ34*S12*S34*XSW2+4D0*
     &  QF(1)*QF(3)*S12*XSW2**2+4D0*QF(1)*QF(3)*S34*XSW2**2-4D0*
     &  QF(1)*QF(3)*PZ12*S12*S34*XSW2**2-4D0*QF(1)*QF(3)*PZ34*S12*
     &  S34*XSW2**2)+A0*XCW2**(-2)*(-(9D0*PZ12*S12*S34*XCW2**2)-9D0*
     &  PZ34*S12*S34*XCW2**2+2D0*PZ12*S12*S34*XCW2*XSW2+2D0*PZ34*
     &  S12*S34*XCW2*XSW2+20D0*QF(3)*S12*XCW2**2*XSW2-20D0*QF(1)*
     &  S34*XCW2**2*XSW2+18D0*QF(1)*PZ12*S12*S34*XCW2**2*XSW2-18D0*
     &  QF(3)*PZ12*S12*S34*XCW2**2*XSW2+18D0*QF(1)*PZ34*S12*S34*
     &  XCW2**2*XSW2-18D0*QF(3)*PZ34*S12*S34*XCW2**2*XSW2-PZ12*S12*
     &  S34*XSW2**2-PZ34*S12*S34*XSW2**2-4D0*QF(3)*S12*XCW2*XSW2**2+
     &  4D0*QF(1)*S34*XCW2*XSW2**2-4D0*QF(1)*PZ12*S12*S34*XCW2*
     &  XSW2**2+4D0*QF(3)*PZ12*S12*S34*XCW2*XSW2**2-4D0*QF(1)*PZ34*
     &  S12*S34*XCW2*XSW2**2+4D0*QF(3)*PZ34*S12*S34*XCW2*XSW2**2-
     &  40D0*QF(1)*QF(3)*S12*XCW2**2*XSW2**2-40D0*QF(1)*QF(3)*S34*
     &  XCW2**2*XSW2**2+36D0*QF(1)*QF(3)*PZ12*S12*S34*XCW2**2*XSW2**
     &  2+36D0*QF(1)*QF(3)*PZ34*S12*S34*XCW2**2*XSW2**2+2D0*QF(1)*
     &  PZ12*S12*S34*XSW2**3-2D0*QF(3)*PZ12*S12*S34*XSW2**3+2D0*
     &  QF(1)*PZ34*S12*S34*XSW2**3-2D0*QF(3)*PZ34*S12*S34*XSW2**3+
     &  8D0*QF(1)*QF(3)*S12*XCW2*XSW2**3+8D0*QF(1)*QF(3)*S34*XCW2*
     &  XSW2**3-8D0*QF(1)*QF(3)*PZ12*S12*S34*XCW2*XSW2**3-8D0*QF(1)*
     &  QF(3)*PZ34*S12*S34*XCW2*XSW2**3+4D0*QF(1)*QF(3)*PZ12*S12*
     &  S34*XSW2**4+4D0*QF(1)*QF(3)*PZ34*S12*S34*XSW2**4))
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(-(8D0*XMW2*(S12-PZ12*
     &  S12*S34-PZ34*S12*S34-2D0*QF(1)*S12*XSW2-2D0*QF(1)*S34*XSW2+
     &  2D0*QF(1)*PZ12*S12*S34*XSW2+2D0*QF(1)*PZ34*S12*S34*XSW2))+
     &  A0*XCW2**(-2)*(10D0*S12*XCW2**2-9D0*PZ12*S12*S34*XCW2**2-
     &  9D0*PZ34*S12*S34*XCW2**2-2D0*S12*XCW2*XSW2+2D0*PZ12*S12*S34*
     &  XCW2*XSW2+2D0*PZ34*S12*S34*XCW2*XSW2-20D0*QF(1)*S12*XCW2**2*
     &  XSW2-20D0*QF(1)*S34*XCW2**2*XSW2+18D0*QF(1)*PZ12*S12*S34*
     &  XCW2**2*XSW2+18D0*QF(1)*PZ34*S12*S34*XCW2**2*XSW2-PZ12*S12*
     &  S34*XSW2**2-PZ34*S12*S34*XSW2**2+4D0*QF(1)*S12*XCW2*XSW2**2+
     &  4D0*QF(1)*S34*XCW2*XSW2**2-4D0*QF(1)*PZ12*S12*S34*XCW2*
     &  XSW2**2-4D0*QF(1)*PZ34*S12*S34*XCW2*XSW2**2+2D0*QF(1)*PZ12*
     &  S12*S34*XSW2**3+2D0*QF(1)*PZ34*S12*S34*XSW2**3)))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(8D0*XMW2*(S34-PZ12*
     &  S12*S34-PZ34*S12*S34+2D0*QF(3)*S12*XSW2+2D0*QF(3)*S34*XSW2-
     &  2D0*QF(3)*PZ12*S12*S34*XSW2-2D0*QF(3)*PZ34*S12*S34*XSW2)+A0*
     &  XCW2**(-2)*(-(10D0*S34*XCW2**2)+9D0*PZ12*S12*S34*XCW2**2+
     &  9D0*PZ34*S12*S34*XCW2**2+2D0*S34*XCW2*XSW2-2D0*PZ12*S12*S34*
     &  XCW2*XSW2-2D0*PZ34*S12*S34*XCW2*XSW2-20D0*QF(3)*S12*XCW2**2*
     &  XSW2-20D0*QF(3)*S34*XCW2**2*XSW2+18D0*QF(3)*PZ12*S12*S34*
     &  XCW2**2*XSW2+18D0*QF(3)*PZ34*S12*S34*XCW2**2*XSW2+PZ12*S12*
     &  S34*XSW2**2+PZ34*S12*S34*XSW2**2+4D0*QF(3)*S12*XCW2*XSW2**2+
     &  4D0*QF(3)*S34*XCW2*XSW2**2-4D0*QF(3)*PZ12*S12*S34*XCW2*
     &  XSW2**2-4D0*QF(3)*PZ34*S12*S34*XCW2*XSW2**2+2D0*QF(3)*PZ12*
     &  S12*S34*XSW2**3+2D0*QF(3)*PZ34*S12*S34*XSW2**3)))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(8D0*(S12+S34-PZ12*
     &  S12*S34-PZ34*S12*S34)*XMW2+A0*XCW2**(-2)*(-(10D0*S12*XCW2**
     &  2)-10D0*S34*XCW2**2+9D0*PZ12*S12*S34*XCW2**2+9D0*PZ34*S12*
     &  S34*XCW2**2+2D0*S12*XCW2*XSW2+2D0*S34*XCW2*XSW2-2D0*PZ12*
     &  S12*S34*XCW2*XSW2-2D0*PZ34*S12*S34*XCW2*XSW2+PZ12*S12*S34*
     &  XSW2**2+PZ34*S12*S34*XSW2**2))

C       G(T1,N7,FULL)+G(T2,N17,FULL)
        A0 = xA0_(XMZ2)

        PRE = -((A0*ALPHA*PZ12*PZ34*(PZ12+PZ34)*XCW2**(-3)*XMW)/
     &  (64D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N23,FULL)+G(T3,N24,FULL)+G(T3,N47,FULL)+G(T3,N48,FULL)
        CALL xB012345_(S12,XMH2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PZ12**2*PZ34*XCW2**(-3)*XMW*(-(B2(0,0))+(B0*
     &  XMW2)/XCW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N21,FULL)+G(T3,N22,FULL)+G(T3,N32,FULL)+G(T3,N33,FULL)+
C       G(T3,N34,FULL)+G(T3,N35,FULL)+G(T3,N44,FULL)+G(T3,N45,FULL)+
C       G(T3,N46,FULL)+G(T3,N49,FULL)+G(T3,N50,FULL)+G(T3,N51,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)
        K(1) = -(9D0*PZ12*S12*XCW2**2)+2D0*PZ12*S12*XCW2*XSW2-20D0*
     &  QF(1)*XCW2**2*XSW2+18D0*QF(1)*PZ12*S12*XCW2**2*XSW2-PZ12*
     &  S12*XSW2**2+4D0*QF(1)*XCW2*XSW2**2-4D0*QF(1)*PZ12*S12*XCW2*
     &  XSW2**2+2D0*QF(1)*PZ12*S12*XSW2**3

        PRE = (ALPHA*PZ12*PZ34*XMW)/(48D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)+PRE*XSW2**(-2)*(1D0+2D0*QF(3)*XSW2)*
     &  ((3D0*B2(0,0)*K(1)*XCW2**(-2))/S12-(2D0*(S12-6D0*XMW2)*
     &  (PZ12*S12+2D0*QF(1)*XSW2-2D0*QF(1)*PZ12*S12*XSW2))/S12+6D0*
     &  B0*XCW2**(-2)*(-(4D0*PZ12*S12*XCW2**2)+PZ12*XMW2-8D0*QF(1)*
     &  XCW2**2*XSW2+8D0*QF(1)*PZ12*S12*XCW2**2*XSW2-2D0*QF(1)*PZ12*
     &  XMW2*XSW2))
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*((3D0*B2(0,0)*K(1)*
     &  XCW2**(-2))/S12-(2D0*(S12-6D0*XMW2)*(PZ12*S12+2D0*QF(1)*
     &  XSW2-2D0*QF(1)*PZ12*S12*XSW2))/S12+6D0*B0*XCW2**(-2)*(-(4D0*
     &  PZ12*S12*XCW2**2)+PZ12*XMW2-8D0*QF(1)*XCW2**2*XSW2+8D0*
     &  QF(1)*PZ12*S12*XCW2**2*XSW2-2D0*QF(1)*PZ12*XMW2*XSW2)))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2)*(-
     &  ((2D0*(1D0-PZ12*S12)*(S12-6D0*XMW2))/S12)+6D0*B0*XCW2**(-2)*
     &  (-(4D0*XCW2**2)+4D0*PZ12*S12*XCW2**2-PZ12*XMW2)+(3D0*B2(0,
     &  0)*XCW2**(-2)*(-(10D0*XCW2**2)+9D0*PZ12*S12*XCW2**2+2D0*
     &  XCW2*XSW2-2D0*PZ12*S12*XCW2*XSW2+PZ12*S12*XSW2**2))/S12))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((2D0*(1D0-PZ12*
     &  S12)*(S12-6D0*XMW2))/S12)+6D0*B0*XCW2**(-2)*(-(4D0*XCW2**2)+
     &  4D0*PZ12*S12*XCW2**2-PZ12*XMW2)+(3D0*B2(0,0)*XCW2**(-2)*(-
     &  (10D0*XCW2**2)+9D0*PZ12*S12*XCW2**2+2D0*XCW2*XSW2-2D0*PZ12*
     &  S12*XCW2*XSW2+PZ12*S12*XSW2**2))/S12)

C       G(T4,N54,FULL)+G(T4,N55,FULL)+G(T4,N78,FULL)+G(T4,N79,FULL)
        CALL xB012345_(S34,XMH2,XMZ2,B0,B1,B2,B3,B4,B5,2,0)

        PRE = -((ALPHA*PZ12*PZ34**2*XCW2**(-3)*XMW*(-(B2(0,0))+(B0*
     &  XMW2)/XCW2))/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T4,N52,FULL)+G(T4,N53,FULL)+G(T4,N63,FULL)+G(T4,N64,FULL)+
C       G(T4,N65,FULL)+G(T4,N66,FULL)+G(T4,N75,FULL)+G(T4,N76,FULL)+
C       G(T4,N77,FULL)+G(T4,N80,FULL)+G(T4,N81,FULL)+G(T4,N82,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,2,0)
        K(1) = 9D0*PZ34*S34*XCW2**2-2D0*PZ34*S34*XCW2*XSW2-20D0*
     &  QF(3)*XCW2**2*XSW2+18D0*QF(3)*PZ34*S34*XCW2**2*XSW2+PZ34*
     &  S34*XSW2**2+4D0*QF(3)*XCW2*XSW2**2-4D0*QF(3)*PZ34*S34*XCW2*
     &  XSW2**2+2D0*QF(3)*PZ34*S34*XSW2**3

        PRE = (ALPHA*PZ12*PZ34*XMW)/(48D0*PI*XCW2*XSW)

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  ((3D0*B2(0,0)*K(1)*XCW2**(-2))/S34+(2D0*(S34-6D0*XMW2)*
     &  (PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2))/S34+6D0*
     &  B0*XCW2**(-2)*(4D0*PZ34*S34*XCW2**2-PZ34*XMW2-8D0*QF(3)*
     &  XCW2**2*XSW2+8D0*QF(3)*PZ34*S34*XCW2**2*XSW2-2D0*QF(3)*PZ34*
     &  XMW2*XSW2))
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2)*(-
     &  ((2D0*(1D0-PZ34*S34)*(S34-6D0*XMW2))/S34)+6D0*B0*XCW2**(-2)*
     &  (-(4D0*XCW2**2)+4D0*PZ34*S34*XCW2**2-PZ34*XMW2)+(3D0*B2(0,
     &  0)*XCW2**(-2)*(-(10D0*XCW2**2)+9D0*PZ34*S34*XCW2**2+2D0*
     &  XCW2*XSW2-2D0*PZ34*S34*XCW2*XSW2+PZ34*S34*XSW2**2))/S34))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*((3D0*B2(0,0)*K(1)*
     &  XCW2**(-2))/S34+(2D0*(S34-6D0*XMW2)*(PZ34*S34-2D0*QF(3)*
     &  XSW2+2D0*QF(3)*PZ34*S34*XSW2))/S34+6D0*B0*XCW2**(-2)*(4D0*
     &  PZ34*S34*XCW2**2-PZ34*XMW2-8D0*QF(3)*XCW2**2*XSW2+8D0*QF(3)*
     &  PZ34*S34*XCW2**2*XSW2-2D0*QF(3)*PZ34*XMW2*XSW2)))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((2D0*(1D0-PZ34*
     &  S34)*(S34-6D0*XMW2))/S34)+6D0*B0*XCW2**(-2)*(-(4D0*XCW2**2)+
     &  4D0*PZ34*S34*XCW2**2-PZ34*XMW2)+(3D0*B2(0,0)*XCW2**(-2)*(-
     &  (10D0*XCW2**2)+9D0*PZ34*S34*XCW2**2+2D0*XCW2*XSW2-2D0*PZ34*
     &  S34*XCW2*XSW2+PZ34*S34*XSW2**2))/S34)

      end

************************************************************************
*
*     vertex diagrams (bosonic) for H->ZZ->uudd (generic u,d)
*
************************************************************************
      subroutine HZZ1133_vert_bos_bgf(F,pz12,pz34)
      implicit none
      complex*16 B0,B1(1),B2(0:2,0:2),B3(0:2,0:2,2)
      complex*16 B4(0:2,0:2,0:2,0:2),B5(0:2,0:2,0:2,0:2,2)
      complex*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
      complex*16   C4(0:2,0:2,0:2,0:2)
      complex*16 F(13,-1:1,-1:1),pz12,pz34
      complex*16 pre,K(15)
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S10F2100aF2100F2300aF2300,   Model: SMbgf4f

C       G(T8,N96,FULL)
        CALL xB012345_(MH2,XMH2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((3D0*ALPHA*B0*PZ12*PZ34*XCW2**(-2)*XMH2)/(128D0*PI*
     &  XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T8,N100,FULL)+G(T8,N83,FULL)+G(T8,N84,FULL)+G(T8,N85,
C       FULL)+G(T8,N86,FULL)+G(T8,N87,FULL)+G(T8,N88,FULL)+G(T8,N89,
C       FULL)+G(T8,N90,FULL)+G(T8,N91,FULL)+G(T8,N92,FULL)+G(T8,N93,
C       FULL)+G(T8,N94,FULL)+G(T8,N95,FULL)+G(T8,N98,FULL)+G(T8,N99,
C       FULL)
        CALL xB012345_(MH2,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA)/(64D0*PI*S12*S34*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(-(16D0*XMW*(PZ12*
     &  S12+2D0*QF(1)*XSW2-2D0*QF(1)*PZ12*S12*XSW2)*(PZ34*S34-2D0*
     &  QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2))+(B0*XCW2**(-2)*(PZ12*
     &  PZ34*S12*S34*XCW2**2*XMH2+18D0*PZ12*PZ34*S12*S34*XCW2**2*
     &  XMW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2-4D0*QF(3)*PZ12*
     &  S12*XCW2**2*XMH2*XSW2+4D0*QF(1)*PZ34*S34*XCW2**2*XMH2*XSW2-
     &  2D0*QF(1)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+2D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2-4D0*PZ12*PZ34*S12*S34*
     &  XCW2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2+40D0*
     &  QF(1)*PZ34*S34*XCW2**2*XMW2*XSW2-36D0*QF(1)*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2*XSW2+36D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*
     &  XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(3)*PZ12*S12*
     &  XCW2*XMH2*XSW2**2-4D0*QF(1)*PZ34*S34*XCW2*XMH2*XSW2**2+4D0*
     &  QF(1)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2-4D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2*XMH2*XSW2**2-16D0*QF(1)*QF(3)*XCW2**2*
     &  XMH2*XSW2**2+8D0*QF(1)*QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2**2+
     &  8D0*QF(1)*QF(3)*PZ34*S34*XCW2**2*XMH2*XSW2**2-4D0*QF(1)*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2**2+2D0*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**2+8D0*QF(3)*PZ12*S12*XCW2*XMW2*XSW2**2-
     &  8D0*QF(1)*PZ34*S34*XCW2*XMW2*XSW2**2+8D0*QF(1)*PZ12*PZ34*
     &  S12*S34*XCW2*XMW2*XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMW2*XSW2**2-96D0*QF(1)*QF(3)*XCW2**2*XMW2*XSW2**2+80D0*
     &  QF(1)*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2**2+80D0*QF(1)*QF(3)*
     &  PZ34*S34*XCW2**2*XMW2*XSW2**2-72D0*QF(1)*QF(3)*PZ12*PZ34*
     &  S12*S34*XCW2**2*XMW2*XSW2**2-2D0*QF(1)*PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**3+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3-8D0*
     &  QF(1)*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**3-8D0*QF(1)*QF(3)*PZ34*
     &  S34*XCW2*XMH2*XSW2**3+8D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2*XMH2*XSW2**3-4D0*QF(1)*PZ12*PZ34*S12*S34*XMW2*XSW2**3+
     &  4D0*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**3-16D0*QF(1)*QF(3)*
     &  PZ12*S12*XCW2*XMW2*XSW2**3-16D0*QF(1)*QF(3)*PZ34*S34*XCW2*
     &  XMW2*XSW2**3+16D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2**3-4D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**4-8D0*
     &  QF(1)*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**4))/XMW)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(-(16D0*(1D0-PZ34*S34)*
     &  XMW*(PZ12*S12+2D0*QF(1)*XSW2-2D0*QF(1)*PZ12*S12*XSW2))+(B0*
     &  XCW2**(-2)*(2D0*PZ12*S12*XCW2**2*XMH2-PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2+20D0*PZ12*S12*XCW2**2*XMW2-18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2-2D0*PZ12*S12*XCW2*XMH2*XSW2+2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(1)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(1)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(1)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(1)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2-4D0*
     &  PZ12*S12*XCW2*XMW2*XSW2+4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2+48D0*QF(1)*XCW2**2*XMW2*XSW2-40D0*QF(1)*PZ12*S12*XCW2**
     &  2*XMW2*XSW2-40D0*QF(1)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(1)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2-PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(1)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(1)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(1)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2-2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(1)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+8D0*QF(1)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2-8D0*QF(1)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*
     &  QF(1)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(1)*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**3))/XMW))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(16D0*(1D0-PZ12*S12)*
     &  XMW*(PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2)+(B0*
     &  XCW2**(-2)*(-(2D0*PZ34*S34*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-20D0*PZ34*S34*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(3)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(3)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*
     &  PZ34*S34*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2+48D0*QF(3)*XCW2**2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**
     &  2*XMW2*XSW2-40D0*QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(3)*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**3))/XMW))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-(16D0*(1D0-PZ12*
     &  S12)*(1D0-PZ34*S34)*XMW)+(B0*XCW2**(-2)*(4D0*XCW2**2*XMH2-
     &  2D0*PZ12*S12*XCW2**2*XMH2-2D0*PZ34*S34*XCW2**2*XMH2+PZ12*
     &  PZ34*S12*S34*XCW2**2*XMH2+24D0*XCW2**2*XMW2-20D0*PZ12*S12*
     &  XCW2**2*XMW2-20D0*PZ34*S34*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*XMH2*XSW2+2D0*PZ34*S34*
     &  XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2+4D0*
     &  PZ12*S12*XCW2*XMW2*XSW2+4D0*PZ34*S34*XCW2*XMW2*XSW2-4D0*
     &  PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*
     &  XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2))/XMW)

C       G(T8,N97,FULL)
        CALL xB012345_(MH2,XMZ2,XMZ2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-3)*(XCW2*XMH2+2D0*
     &  XMW2))/(128D0*PI*XMW*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T10,N104,FULL)+G(T10,N105,FULL)
        CALL xB012345_(S12,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-2)*XMW)/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T10,N106,FULL)
        CALL xB012345_(S12,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-3)*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N101,FULL)+G(T9,N102,FULL)
        CALL xB012345_(S34,XMW2,XMW2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-2)*XMW)/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T9,N103,FULL)
        CALL xB012345_(S34,XMZ2,XMH2,B0,B1,B2,B3,B4,B5,0,0)

        PRE = -((ALPHA*B0*PZ12*PZ34*XCW2**(-3)*XMW)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-PRE*XSW2**(-2)*(1D0-2D0*QF(1)*XSW2)*
     &  (1D0+2D0*QF(3)*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE

C       G(T3,N10,FULL)+G(T3,N12,FULL)
      CALL xC01234_(RMF2(1),MH2,T11,CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S34)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)**2*(PZ34*S34-2D0*QF(1)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*
     &  S34*XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*QF(1)*QF(3)*PZ34*S34*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2)**
     &  2*(PZ34*S34-2D0*QF(1)*XCW2-2D0*QF(1)*PZ34*S34*XSW2))/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(1)**3*PRE*XSW*(PZ34*S34+2D0*
     &  QF(3)*XCW2+2D0*QF(3)*PZ34*S34*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)**3*QF(3)*PRE*XSW*(XCW2+PZ34*
     &  S34*XSW2)

C       G(T3,N11,FULL)+G(T3,N9,FULL)
      CALL xC01234_(RMF2(1),MH2,T11,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = -((C1(2)*ALPHA*XMW)/(16D0*PI*S34*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(PZ34*S34-2D0*QF(1)*PZ34*S34*
     &  XSW2+2D0*QF(3)*PZ34*S34*XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*
     &  QF(1)*QF(3)*PZ34*S34*XSW2**2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(PZ34*S34-2D0*QF(1)*
     &  XCW2-2D0*QF(1)*PZ34*S34*XSW2)

C       G(T2,N5,FULL)+G(T2,N7,FULL)
      CALL xC01234_(RMF2(1),MH2,T12,CMF2(2),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = -((C1(2)*ALPHA*XMW)/(16D0*PI*S34*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(PZ34*S34-2D0*QF(1)*PZ34*S34*
     &  XSW2+2D0*QF(3)*PZ34*S34*XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*
     &  QF(1)*QF(3)*PZ34*S34*XSW2**2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(PZ34*S34-2D0*QF(1)*
     &  XCW2-2D0*QF(1)*PZ34*S34*XSW2)

      if (qf(1).ne.0d0) then
C       G(T1,N3,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(1),NULL,CMF2(1),CMF2(1),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(1)**2*ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S12+C1(2)*S12+C2(1,2)*S12+C0*S12)*XCW2**(-2)*XMW)/(8D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
      endif

C       G(T1,N2,FULL)
        CALL xC01234_(RMF2(1),S12,RMF2(1),CMF2(2),XMW2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PZ12*PZ34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S12+2D0*
     &  C1(2)*S12)*XMW)/(16D0*PI*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T4,N13,FULL)+G(T4,N15,FULL)
      CALL xC01234_(RMF2(3),MH2,T13,CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(2)*ALPHA*XMW)/(16D0*PI*S12*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(PZ12*S12-2D0*QF(1)*PZ12*S12*
     &  XSW2+2D0*QF(3)*PZ12*S12*XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*
     &  QF(1)*QF(3)*PZ12*S12*XSW2**2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*(PZ12*S12+2D0*QF(3)*
     &  XCW2+2D0*QF(3)*PZ12*S12*XSW2)

      if (qf(3).ne.0d0) then
C       G(T7,N81,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(3),NULL,CMF2(3),CMF2(3),C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((QF(3)**2*ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)+C1(1)*
     &  S34+C1(2)*S34+C2(1,2)*S34+C0*S34)*XCW2**(-2)*XMW)/(8D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW
      endif

C       G(T7,N80,FULL)
        CALL xC01234_(RMF2(3),S34,RMF2(3),CMF2(4),XMW2,XMW2,C0,C1,C2,C3,
     &  C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-4D0*C2(0,0)+2D0*C1(1)*S34+2D0*
     &  C1(2)*S34)*XMW)/(16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE

C       G(T1,N4,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(1),CMF2(1),CMF2(1),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*
     &  S12-C2(1,1)*S12-C2(1,2)*S12)*XCW2**(-3)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)**3*(1D0+2D0*QF(3)*XSW2))/XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(1)**3*PRE*XSW*(1D0+2D0*QF(3)*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)**3*QF(3)*PRE*XSW*XSW2

C       G(T1,N1,FULL)
        CALL xC01234_(S12,RMF2(1),RMF2(1),CMF2(2),CMF2(2),XMW2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S12-C1(2)*
     &  S12-C2(1,1)*S12-C2(1,2)*S12)*XCW2**(-2)*XMW*(1D0+2D0*QF(2)*
     &  XSW2))/(16D0*PI*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(3)*XSW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE

C       G(T5,N49,FULL)+G(T5,N50,FULL)+G(T5,N55,FULL)+G(T5,N56,FULL)
       CALL xC01234_(S12,MH2,S34,XMH2,XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = XCW2*XMH2+2D0*XMW2
        K(4) = 2D0*C1(1)*XMW+2D0*C1(2)*XMW+(C2(1,2)*(XCW2*XMH2+2D0*
     &  XMW2))/XMW

        PRE = -((ALPHA*PZ12*PZ34*XCW2**(-3))/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-K(1)*K(2)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2)*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*QF(3)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*(-((C2(0,0)*K(3))/
     &  XMW)+(2D0*C0*XMW*XMW2)/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(5,-1,1) = F(5,-1,1)-(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)+(2D0*K(2)*K(4)*QF(1)*PRE)/XSW2
        F(5,1,1) = F(5,1,1)+4D0*K(4)*QF(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(6,-1,1) = F(6,-1,1)-(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)+(2D0*K(2)*K(4)*QF(1)*PRE)/XSW2
        F(6,1,1) = F(6,1,1)+4D0*K(4)*QF(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(7,-1,1) = F(7,-1,1)-(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)+(2D0*K(2)*K(4)*QF(1)*PRE)/XSW2
        F(7,1,1) = F(7,1,1)+4D0*K(4)*QF(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-K(1)*K(2)*K(4)*PRE*XSW2**(-2)
        F(8,-1,1) = F(8,-1,1)-(2D0*K(1)*K(4)*QF(3)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)+(2D0*K(2)*K(4)*QF(1)*PRE)/XSW2
        F(8,1,1) = F(8,1,1)+4D0*K(4)*QF(1)*QF(3)*PRE

C       G(T5,N17,FULL)+G(T5,N18,FULL)+G(T5,N19,FULL)+G(T5,N20,FULL)+
C       G(T5,N21,FULL)+G(T5,N22,FULL)+G(T5,N23,FULL)+G(T5,N24,FULL)+
C       G(T5,N25,FULL)+G(T5,N26,FULL)+G(T5,N27,FULL)+G(T5,N28,FULL)+
C       G(T5,N29,FULL)+G(T5,N30,FULL)+G(T5,N31,FULL)+G(T5,N32,FULL)+
C       G(T5,N33,FULL)+G(T5,N34,FULL)+G(T5,N35,FULL)+G(T5,N36,FULL)+
C       G(T5,N37,FULL)+G(T5,N38,FULL)+G(T5,N39,FULL)+G(T5,N40,FULL)+
C       G(T5,N41,FULL)+G(T5,N42,FULL)+G(T5,N43,FULL)+G(T5,N44,FULL)+
C       G(T5,N45,FULL)+G(T5,N46,FULL)+G(T5,N47,FULL)+G(T5,N48,FULL)+
C       G(T5,N51,FULL)+G(T5,N52,FULL)+G(T5,N53,FULL)+G(T5,N54,FULL)+
C       G(T5,N57,FULL)+G(T5,N58,FULL)+G(T5,N59,FULL)+G(T5,N60,FULL)+
C       G(T5,N63,FULL)+G(T5,N64,FULL)+G(T5,N65,FULL)+G(T5,N66,FULL)+
C       G(T5,N67,FULL)+G(T5,N68,FULL)+G(T5,N69,FULL)+G(T5,N70,FULL)+
C       G(T5,N71,FULL)+G(T5,N72,FULL)+G(T5,N73,FULL)+G(T5,N74,FULL)
       CALL xC01234_(S12,MH2,S34,XMW2,XMW2,XMW2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2
        K(3) = XCW2+XSW2
        K(4) = -((2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+XSW2)*(1D0-2D0*
     &  QF(1)*XSW2))/XCW2)-(2D0*C1(2)*PZ12*PZ34*XMW*(XCW2+XSW2)*
     &  (1D0-2D0*QF(1)*XSW2))/XCW2+(4D0*C0*XMW*(PZ12*S12-2D0*PZ12*
     &  PZ34*S12*S34-4D0*PZ12*S12*XCW2+4D0*PZ12*PZ34*S12*S34*XCW2-
     &  2D0*QF(1)*PZ12*S12*XSW2-2D0*QF(1)*PZ34*S34*XSW2+4D0*QF(1)*
     &  PZ12*PZ34*S12*S34*XSW2-8D0*QF(1)*XCW2*XSW2+8D0*QF(1)*PZ12*
     &  S12*XCW2*XSW2+8D0*QF(1)*PZ34*S34*XCW2*XSW2-8D0*QF(1)*PZ12*
     &  PZ34*S12*S34*XCW2*XSW2))/(S12*S34)+(C2(1,2)*(2D0*PZ12*S12*
     &  XCW2**2*XMH2-PZ12*PZ34*S12*S34*XCW2**2*XMH2+20D0*PZ12*S12*
     &  XCW2**2*XMW2-18D0*PZ12*PZ34*S12*S34*XCW2**2*XMW2-2D0*PZ12*
     &  S12*XCW2*XMH2*XSW2+2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2+8D0*
     &  QF(1)*XCW2**2*XMH2*XSW2-4D0*QF(1)*PZ12*S12*XCW2**2*XMH2*
     &  XSW2-4D0*QF(1)*PZ34*S34*XCW2**2*XMH2*XSW2+2D0*QF(1)*PZ12*
     &  PZ34*S12*S34*XCW2**2*XMH2*XSW2-4D0*PZ12*S12*XCW2*XMW2*XSW2+
     &  4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+48D0*QF(1)*XCW2**2*
     &  XMW2*XSW2-40D0*QF(1)*PZ12*S12*XCW2**2*XMW2*XSW2-40D0*QF(1)*
     &  PZ34*S34*XCW2**2*XMW2*XSW2+36D0*QF(1)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2-PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(1)*
     &  PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(1)*PZ34*S34*XCW2*XMH2*
     &  XSW2**2-4D0*QF(1)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2-2D0*
     &  PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(1)*PZ12*S12*XCW2*XMW2*
     &  XSW2**2+8D0*QF(1)*PZ34*S34*XCW2*XMW2*XSW2**2-8D0*QF(1)*PZ12*
     &  PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*QF(1)*PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**3+4D0*QF(1)*PZ12*PZ34*S12*S34*XMW2*XSW2**3))/
     &  (S12*S34*XCW2*XMW)
        K(5) = -((2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/XCW2)-(2D0*C1(2)*PZ12*PZ34*XMW*(XCW2+XSW2)*
     &  (1D0+2D0*QF(3)*XSW2))/XCW2+(4D0*C0*XMW*(PZ34*S34-2D0*PZ12*
     &  PZ34*S12*S34-4D0*PZ34*S34*XCW2+4D0*PZ12*PZ34*S12*S34*XCW2+
     &  2D0*QF(3)*PZ12*S12*XSW2+2D0*QF(3)*PZ34*S34*XSW2-4D0*QF(3)*
     &  PZ12*PZ34*S12*S34*XSW2+8D0*QF(3)*XCW2*XSW2-8D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2-8D0*QF(3)*PZ34*S34*XCW2*XSW2+8D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2*XSW2))/(S12*S34)-(C2(1,2)*(-(2D0*PZ34*S34*
     &  XCW2**2*XMH2)+PZ12*PZ34*S12*S34*XCW2**2*XMH2-20D0*PZ34*S34*
     &  XCW2**2*XMW2+18D0*PZ12*PZ34*S12*S34*XCW2**2*XMW2+2D0*PZ34*
     &  S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2+8D0*
     &  QF(3)*XCW2**2*XMH2*XSW2-4D0*QF(3)*PZ12*S12*XCW2**2*XMH2*
     &  XSW2-4D0*QF(3)*PZ34*S34*XCW2**2*XMH2*XSW2+2D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*PZ34*S34*XCW2*XMW2*XSW2-
     &  4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+48D0*QF(3)*XCW2**2*
     &  XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2-40D0*QF(3)*
     &  PZ34*S34*XCW2**2*XMW2*XSW2+36D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(3)*PZ34*S34*XCW2*XMH2*
     &  XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2+2D0*
     &  PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*PZ12*S12*XCW2*XMW2*
     &  XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XMW2*XSW2**2-8D0*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**3+4D0*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**3))/
     &  (S12*S34*XCW2*XMW)
        K(6) = (2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+XSW2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2))/XCW2+(2D0*C1(2)*PZ12*PZ34*XMW*
     &  (XCW2+XSW2)*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*QF(3)*XSW2))/XCW2+
     &  (8D0*C0*XMW*(PZ12*PZ34*S12*S34-2D0*PZ12*PZ34*S12*S34*XCW2-
     &  QF(3)*PZ12*S12*XSW2+QF(1)*PZ34*S34*XSW2-2D0*QF(1)*PZ12*PZ34*
     &  S12*S34*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XSW2+4D0*QF(3)*
     &  PZ12*S12*XCW2*XSW2-4D0*QF(1)*PZ34*S34*XCW2*XSW2+4D0*QF(1)*
     &  PZ12*PZ34*S12*S34*XCW2*XSW2-4D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2*XSW2+2D0*QF(1)*QF(3)*PZ12*S12*XSW2**2+2D0*QF(1)*QF(3)*
     &  PZ34*S34*XSW2**2-4D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+
     &  8D0*QF(1)*QF(3)*XCW2*XSW2**2-8D0*QF(1)*QF(3)*PZ12*S12*XCW2*
     &  XSW2**2-8D0*QF(1)*QF(3)*PZ34*S34*XCW2*XSW2**2+8D0*QF(1)*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2**2))/(S12*S34)+(C2(1,2)*
     &  (PZ12*PZ34*S12*S34*XCW2**2*XMH2+18D0*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2-4D0*QF(3)*
     &  PZ12*S12*XCW2**2*XMH2*XSW2+4D0*QF(1)*PZ34*S34*XCW2**2*XMH2*
     &  XSW2-2D0*QF(1)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2-4D0*PZ12*PZ34*S12*
     &  S34*XCW2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2+
     &  40D0*QF(1)*PZ34*S34*XCW2**2*XMW2*XSW2-36D0*QF(1)*PZ12*PZ34*
     &  S12*S34*XCW2**2*XMW2*XSW2+36D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ12*S12*XCW2*XMH2*XSW2**2-4D0*QF(1)*PZ34*S34*XCW2*XMH2*
     &  XSW2**2+4D0*QF(1)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2-4D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2-16D0*QF(1)*QF(3)*
     &  XCW2**2*XMH2*XSW2**2+8D0*QF(1)*QF(3)*PZ12*S12*XCW2**2*XMH2*
     &  XSW2**2+8D0*QF(1)*QF(3)*PZ34*S34*XCW2**2*XMH2*XSW2**2-4D0*
     &  QF(1)*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2**2+2D0*PZ12*
     &  PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*PZ12*S12*XCW2*XMW2*
     &  XSW2**2-8D0*QF(1)*PZ34*S34*XCW2*XMW2*XSW2**2+8D0*QF(1)*PZ12*
     &  PZ34*S12*S34*XCW2*XMW2*XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2*XMW2*XSW2**2-96D0*QF(1)*QF(3)*XCW2**2*XMW2*XSW2**2+
     &  80D0*QF(1)*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2**2+80D0*QF(1)*
     &  QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2**2-72D0*QF(1)*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2**2*XMW2*XSW2**2-2D0*QF(1)*PZ12*PZ34*S12*
     &  S34*XMH2*XSW2**3+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3-
     &  8D0*QF(1)*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**3-8D0*QF(1)*QF(3)*
     &  PZ34*S34*XCW2*XMH2*XSW2**3+8D0*QF(1)*QF(3)*PZ12*PZ34*S12*
     &  S34*XCW2*XMH2*XSW2**3-4D0*QF(1)*PZ12*PZ34*S12*S34*XMW2*
     &  XSW2**3+4D0*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**3-16D0*QF(1)*
     &  QF(3)*PZ12*S12*XCW2*XMW2*XSW2**3-16D0*QF(1)*QF(3)*PZ34*S34*
     &  XCW2*XMW2*XSW2**3+16D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMW2*XSW2**3-4D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**4-
     &  8D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**4))/(S12*S34*
     &  XCW2*XMW)
        K(7) = (4D0*C0*(PZ12*S12+PZ34*S34-2D0*PZ12*PZ34*S12*S34+4D0*
     &  XCW2-4D0*PZ12*S12*XCW2-4D0*PZ34*S34*XCW2+4D0*PZ12*PZ34*S12*
     &  S34*XCW2)*XMW)/(S12*S34)-(2D0*C1(1)*PZ12*PZ34*XMW*(XCW2+
     &  XSW2))/XCW2-(2D0*C1(2)*PZ12*PZ34*XMW*(XCW2+XSW2))/XCW2-
     &  (C2(1,2)*(4D0*XCW2**2*XMH2-2D0*PZ12*S12*XCW2**2*XMH2-2D0*
     &  PZ34*S34*XCW2**2*XMH2+PZ12*PZ34*S12*S34*XCW2**2*XMH2+24D0*
     &  XCW2**2*XMW2-20D0*PZ12*S12*XCW2**2*XMW2-20D0*PZ34*S34*XCW2**
     &  2*XMW2+18D0*PZ12*PZ34*S12*S34*XCW2**2*XMW2+2D0*PZ12*S12*
     &  XCW2*XMH2*XSW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+4D0*PZ12*S12*XCW2*XMW2*XSW2+4D0*PZ34*
     &  S34*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+
     &  PZ12*PZ34*S12*S34*XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*
     &  XSW2**2))/(S12*S34*XCW2*XMW)
        K(8) = PZ12*S12+PZ34*S34-2D0*PZ12*PZ34*S12*S34+4D0*XCW2-4D0*
     &  PZ12*S12*XCW2-4D0*PZ34*S34*XCW2+4D0*PZ12*PZ34*S12*S34*XCW2
        K(9) = PZ12*S12-2D0*PZ12*PZ34*S12*S34-4D0*PZ12*S12*XCW2+4D0*
     &  PZ12*PZ34*S12*S34*XCW2-2D0*QF(1)*PZ12*S12*XSW2-2D0*QF(1)*
     &  PZ34*S34*XSW2+4D0*QF(1)*PZ12*PZ34*S12*S34*XSW2-8D0*QF(1)*
     &  XCW2*XSW2+8D0*QF(1)*PZ12*S12*XCW2*XSW2+8D0*QF(1)*PZ34*S34*
     &  XCW2*XSW2-8D0*QF(1)*PZ12*PZ34*S12*S34*XCW2*XSW2
        K(10) = PZ34*S34-2D0*PZ12*PZ34*S12*S34-4D0*PZ34*S34*XCW2+
     &  4D0*PZ12*PZ34*S12*S34*XCW2+2D0*QF(3)*PZ12*S12*XSW2+2D0*
     &  QF(3)*PZ34*S34*XSW2-4D0*QF(3)*PZ12*PZ34*S12*S34*XSW2+8D0*
     &  QF(3)*XCW2*XSW2-8D0*QF(3)*PZ12*S12*XCW2*XSW2-8D0*QF(3)*PZ34*
     &  S34*XCW2*XSW2+8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2
        K(11) = 4D0*XCW2**2*XMH2-2D0*PZ12*S12*XCW2**2*XMH2-2D0*PZ34*
     &  S34*XCW2**2*XMH2+PZ12*PZ34*S12*S34*XCW2**2*XMH2+24D0*XCW2**
     &  2*XMW2-20D0*PZ12*S12*XCW2**2*XMW2-20D0*PZ34*S34*XCW2**2*
     &  XMW2+18D0*PZ12*PZ34*S12*S34*XCW2**2*XMW2+2D0*PZ12*S12*XCW2*
     &  XMH2*XSW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*S12*S34*
     &  XCW2*XMH2*XSW2+4D0*PZ12*S12*XCW2*XMW2*XSW2+4D0*PZ34*S34*
     &  XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+PZ12*
     &  PZ34*S12*S34*XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2
        K(12) = PZ12*PZ34*S12*S34-2D0*PZ12*PZ34*S12*S34*XCW2-QF(3)*
     &  PZ12*S12*XSW2+QF(1)*PZ34*S34*XSW2-2D0*QF(1)*PZ12*PZ34*S12*
     &  S34*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XSW2+4D0*QF(3)*PZ12*
     &  S12*XCW2*XSW2-4D0*QF(1)*PZ34*S34*XCW2*XSW2+4D0*QF(1)*PZ12*
     &  PZ34*S12*S34*XCW2*XSW2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XSW2+2D0*QF(1)*QF(3)*PZ12*S12*XSW2**2+2D0*QF(1)*QF(3)*PZ34*
     &  S34*XSW2**2-4D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34*XSW2**2+8D0*
     &  QF(1)*QF(3)*XCW2*XSW2**2-8D0*QF(1)*QF(3)*PZ12*S12*XCW2*
     &  XSW2**2-8D0*QF(1)*QF(3)*PZ34*S34*XCW2*XSW2**2+8D0*QF(1)*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XSW2**2
        K(13) = 2D0*PZ12*S12*XCW2**2*XMH2-PZ12*PZ34*S12*S34*XCW2**2*
     &  XMH2+20D0*PZ12*S12*XCW2**2*XMW2-18D0*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2-2D0*PZ12*S12*XCW2*XMH2*XSW2+2D0*PZ12*PZ34*S12*
     &  S34*XCW2*XMH2*XSW2+8D0*QF(1)*XCW2**2*XMH2*XSW2-4D0*QF(1)*
     &  PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(1)*PZ34*S34*XCW2**2*XMH2*
     &  XSW2+2D0*QF(1)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2-4D0*PZ12*
     &  S12*XCW2*XMW2*XSW2+4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2+
     &  48D0*QF(1)*XCW2**2*XMW2*XSW2-40D0*QF(1)*PZ12*S12*XCW2**2*
     &  XMW2*XSW2-40D0*QF(1)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*QF(1)*
     &  PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2-PZ12*PZ34*S12*S34*XMH2*
     &  XSW2**2+4D0*QF(1)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(1)*PZ34*
     &  S34*XCW2*XMH2*XSW2**2-4D0*QF(1)*PZ12*PZ34*S12*S34*XCW2*XMH2*
     &  XSW2**2-2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(1)*PZ12*
     &  S12*XCW2*XMW2*XSW2**2+8D0*QF(1)*PZ34*S34*XCW2*XMW2*XSW2**2-
     &  8D0*QF(1)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*QF(1)*
     &  PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(1)*PZ12*PZ34*S12*S34*
     &  XMW2*XSW2**3
        K(14) = -(2D0*PZ34*S34*XCW2**2*XMH2)+PZ12*PZ34*S12*S34*
     &  XCW2**2*XMH2-20D0*PZ34*S34*XCW2**2*XMW2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2+2D0*PZ34*S34*XCW2*XMH2*XSW2-2D0*PZ12*PZ34*
     &  S12*S34*XCW2*XMH2*XSW2+8D0*QF(3)*XCW2**2*XMH2*XSW2-4D0*
     &  QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2-4D0*QF(3)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2+2D0*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+4D0*
     &  PZ34*S34*XCW2*XMW2*XSW2-4D0*PZ12*PZ34*S12*S34*XCW2*XMW2*
     &  XSW2+48D0*QF(3)*XCW2**2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**
     &  2*XMW2*XSW2-40D0*QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2+36D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*
     &  XMH2*XSW2**2+4D0*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ34*S34*XCW2*XMH2*XSW2**2-4D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMH2*XSW2**2+2D0*PZ12*PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*
     &  PZ12*S12*XCW2*XMW2*XSW2**2+8D0*QF(3)*PZ34*S34*XCW2*XMW2*
     &  XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*XCW2*XMW2*XSW2**2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3+4D0*QF(3)*PZ12*PZ34*
     &  S12*S34*XMW2*XSW2**3
        K(15) = PZ12*PZ34*S12*S34*XCW2**2*XMH2+18D0*PZ12*PZ34*S12*
     &  S34*XCW2**2*XMW2-2D0*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2-4D0*
     &  QF(3)*PZ12*S12*XCW2**2*XMH2*XSW2+4D0*QF(1)*PZ34*S34*XCW2**2*
     &  XMH2*XSW2-2D0*QF(1)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2-4D0*PZ12*PZ34*S12*
     &  S34*XCW2*XMW2*XSW2-40D0*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2+
     &  40D0*QF(1)*PZ34*S34*XCW2**2*XMW2*XSW2-36D0*QF(1)*PZ12*PZ34*
     &  S12*S34*XCW2**2*XMW2*XSW2+36D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2**2*XMW2*XSW2+PZ12*PZ34*S12*S34*XMH2*XSW2**2+4D0*QF(3)*
     &  PZ12*S12*XCW2*XMH2*XSW2**2-4D0*QF(1)*PZ34*S34*XCW2*XMH2*
     &  XSW2**2+4D0*QF(1)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2-4D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XCW2*XMH2*XSW2**2-16D0*QF(1)*QF(3)*
     &  XCW2**2*XMH2*XSW2**2+8D0*QF(1)*QF(3)*PZ12*S12*XCW2**2*XMH2*
     &  XSW2**2+8D0*QF(1)*QF(3)*PZ34*S34*XCW2**2*XMH2*XSW2**2-4D0*
     &  QF(1)*QF(3)*PZ12*PZ34*S12*S34*XCW2**2*XMH2*XSW2**2+2D0*PZ12*
     &  PZ34*S12*S34*XMW2*XSW2**2+8D0*QF(3)*PZ12*S12*XCW2*XMW2*
     &  XSW2**2-8D0*QF(1)*PZ34*S34*XCW2*XMW2*XSW2**2+8D0*QF(1)*PZ12*
     &  PZ34*S12*S34*XCW2*XMW2*XSW2**2-8D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XCW2*XMW2*XSW2**2-96D0*QF(1)*QF(3)*XCW2**2*XMW2*XSW2**2+
     &  80D0*QF(1)*QF(3)*PZ12*S12*XCW2**2*XMW2*XSW2**2+80D0*QF(1)*
     &  QF(3)*PZ34*S34*XCW2**2*XMW2*XSW2**2-72D0*QF(1)*QF(3)*PZ12*
     &  PZ34*S12*S34*XCW2**2*XMW2*XSW2**2-2D0*QF(1)*PZ12*PZ34*S12*
     &  S34*XMH2*XSW2**3+2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**3-
     &  8D0*QF(1)*QF(3)*PZ12*S12*XCW2*XMH2*XSW2**3-8D0*QF(1)*QF(3)*
     &  PZ34*S34*XCW2*XMH2*XSW2**3+8D0*QF(1)*QF(3)*PZ12*PZ34*S12*
     &  S34*XCW2*XMH2*XSW2**3-4D0*QF(1)*PZ12*PZ34*S12*S34*XMW2*
     &  XSW2**3+4D0*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**3-16D0*QF(1)*
     &  QF(3)*PZ12*S12*XCW2*XMW2*XSW2**3-16D0*QF(1)*QF(3)*PZ34*S34*
     &  XCW2*XMW2*XSW2**3+16D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34*XCW2*
     &  XMW2*XSW2**3-4D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2**4-
     &  8D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34*XMW2*XSW2**4

        PRE = -((ALPHA)/(16D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*XSW2**(-2)*((C2(0,0)*K(15)*
     &  XCW2**(-2))/XMW-4D0*XMW*(PZ12*S12+2D0*QF(1)*XSW2-2D0*QF(1)*
     &  PZ12*S12*XSW2)*(PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*
     &  XSW2)+C0*XCW2**(-2)*XMW*(4D0*PZ12*PZ34*S12**2*S34*XCW2+4D0*
     &  PZ12*PZ34*S12*S13*S34*XCW2+4D0*PZ12*PZ34*S12*S14*S34*XCW2+
     &  4D0*PZ12*PZ34*S12*S23*S34*XCW2+4D0*PZ12*PZ34*S12*S24*S34*
     &  XCW2+4D0*PZ12*PZ34*S12*S34**2*XCW2-8D0*PZ12*PZ34*S12*S13*
     &  S34*XCW2**2-8D0*PZ12*PZ34*S12*S14*S34*XCW2**2-8D0*PZ12*PZ34*
     &  S12*S23*S34*XCW2**2-8D0*PZ12*PZ34*S12*S24*S34*XCW2**2-PZ12*
     &  PZ34*S12*S34*XMH2-4D0*PZ12*PZ34*S12*S34*XMW2-4D0*QF(3)*PZ12*
     &  S12*S13*XCW2*XSW2-4D0*QF(3)*PZ12*S12*S14*XCW2*XSW2-4D0*
     &  QF(3)*PZ12*S12*S23*XCW2*XSW2-4D0*QF(3)*PZ12*S12*S24*XCW2*
     &  XSW2-8D0*QF(3)*PZ12*S12*S34*XCW2*XSW2+8D0*QF(1)*PZ34*S12*
     &  S34*XCW2*XSW2-8D0*QF(1)*PZ12*PZ34*S12**2*S34*XCW2*XSW2+8D0*
     &  QF(3)*PZ12*PZ34*S12**2*S34*XCW2*XSW2+4D0*QF(1)*PZ34*S13*S34*
     &  XCW2*XSW2-8D0*QF(1)*PZ12*PZ34*S12*S13*S34*XCW2*XSW2+8D0*
     &  QF(3)*PZ12*PZ34*S12*S13*S34*XCW2*XSW2+4D0*QF(1)*PZ34*S14*
     &  S34*XCW2*XSW2-8D0*QF(1)*PZ12*PZ34*S12*S14*S34*XCW2*XSW2+8D0*
     &  QF(3)*PZ12*PZ34*S12*S14*S34*XCW2*XSW2+4D0*QF(1)*PZ34*S23*
     &  S34*XCW2*XSW2-8D0*QF(1)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2+8D0*
     &  QF(3)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2+4D0*QF(1)*PZ34*S24*
     &  S34*XCW2*XSW2-8D0*QF(1)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2+8D0*
     &  QF(3)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2-8D0*QF(1)*PZ12*PZ34*
     &  S12*S34**2*XCW2*XSW2+8D0*QF(3)*PZ12*PZ34*S12*S34**2*XCW2*
     &  XSW2+16D0*QF(3)*PZ12*S12*S13*XCW2**2*XSW2+16D0*QF(3)*PZ12*
     &  S12*S14*XCW2**2*XSW2+16D0*QF(3)*PZ12*S12*S23*XCW2**2*XSW2+
     &  16D0*QF(3)*PZ12*S12*S24*XCW2**2*XSW2-16D0*QF(1)*PZ34*S13*
     &  S34*XCW2**2*XSW2+16D0*QF(1)*PZ12*PZ34*S12*S13*S34*XCW2**2*
     &  XSW2-16D0*QF(3)*PZ12*PZ34*S12*S13*S34*XCW2**2*XSW2-16D0*
     &  QF(1)*PZ34*S14*S34*XCW2**2*XSW2+16D0*QF(1)*PZ12*PZ34*S12*
     &  S14*S34*XCW2**2*XSW2-16D0*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2**
     &  2*XSW2-16D0*QF(1)*PZ34*S23*S34*XCW2**2*XSW2+16D0*QF(1)*PZ12*
     &  PZ34*S12*S23*S34*XCW2**2*XSW2-16D0*QF(3)*PZ12*PZ34*S12*S23*
     &  S34*XCW2**2*XSW2-16D0*QF(1)*PZ34*S24*S34*XCW2**2*XSW2+16D0*
     &  QF(1)*PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2-16D0*QF(3)*PZ12*
     &  PZ34*S12*S24*S34*XCW2**2*XSW2+2D0*QF(1)*PZ12*PZ34*S12*S34*
     &  XMH2*XSW2-2D0*QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2+8D0*QF(1)*
     &  PZ12*PZ34*S12*S34*XMW2*XSW2-8D0*QF(3)*PZ12*PZ34*S12*S34*
     &  XMW2*XSW2+8D0*QF(1)*QF(3)*PZ12*S12*S13*XCW2*XSW2**2+8D0*
     &  QF(1)*QF(3)*PZ12*S12*S14*XCW2*XSW2**2+8D0*QF(1)*QF(3)*PZ12*
     &  S12*S23*XCW2*XSW2**2+8D0*QF(1)*QF(3)*PZ12*S12*S24*XCW2*
     &  XSW2**2+16D0*QF(1)*QF(3)*PZ12*S12*S34*XCW2*XSW2**2+16D0*
     &  QF(1)*QF(3)*PZ34*S12*S34*XCW2*XSW2**2-16D0*QF(1)*QF(3)*PZ12*
     &  PZ34*S12**2*S34*XCW2*XSW2**2+8D0*QF(1)*QF(3)*PZ34*S13*S34*
     &  XCW2*XSW2**2-16D0*QF(1)*QF(3)*PZ12*PZ34*S12*S13*S34*XCW2*
     &  XSW2**2+8D0*QF(1)*QF(3)*PZ34*S14*S34*XCW2*XSW2**2-16D0*
     &  QF(1)*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2*XSW2**2+8D0*QF(1)*
     &  QF(3)*PZ34*S23*S34*XCW2*XSW2**2-16D0*QF(1)*QF(3)*PZ12*PZ34*
     &  S12*S23*S34*XCW2*XSW2**2+8D0*QF(1)*QF(3)*PZ34*S24*S34*XCW2*
     &  XSW2**2-16D0*QF(1)*QF(3)*PZ12*PZ34*S12*S24*S34*XCW2*XSW2**2-
     &  16D0*QF(1)*QF(3)*PZ12*PZ34*S12*S34**2*XCW2*XSW2**2+32D0*
     &  QF(1)*QF(3)*S13*XCW2**2*XSW2**2-32D0*QF(1)*QF(3)*PZ12*S12*
     &  S13*XCW2**2*XSW2**2+32D0*QF(1)*QF(3)*S14*XCW2**2*XSW2**2-
     &  32D0*QF(1)*QF(3)*PZ12*S12*S14*XCW2**2*XSW2**2+32D0*QF(1)*
     &  QF(3)*S23*XCW2**2*XSW2**2-32D0*QF(1)*QF(3)*PZ12*S12*S23*
     &  XCW2**2*XSW2**2+32D0*QF(1)*QF(3)*S24*XCW2**2*XSW2**2-32D0*
     &  QF(1)*QF(3)*PZ12*S12*S24*XCW2**2*XSW2**2-32D0*QF(1)*QF(3)*
     &  PZ34*S13*S34*XCW2**2*XSW2**2+32D0*QF(1)*QF(3)*PZ12*PZ34*S12*
     &  S13*S34*XCW2**2*XSW2**2-32D0*QF(1)*QF(3)*PZ34*S14*S34*XCW2**
     &  2*XSW2**2+32D0*QF(1)*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2**2*
     &  XSW2**2-32D0*QF(1)*QF(3)*PZ34*S23*S34*XCW2**2*XSW2**2+32D0*
     &  QF(1)*QF(3)*PZ12*PZ34*S12*S23*S34*XCW2**2*XSW2**2-32D0*
     &  QF(1)*QF(3)*PZ34*S24*S34*XCW2**2*XSW2**2+32D0*QF(1)*QF(3)*
     &  PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2**2+4D0*QF(1)*QF(3)*PZ12*
     &  PZ34*S12*S34*XMH2*XSW2**2+16D0*QF(1)*QF(3)*PZ12*PZ34*S12*
     &  S34*XMW2*XSW2**2)))/(S12*S34)
        F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(-((C2(0,0)*K(13)*
     &  XCW2**(-2))/XMW)+4D0*(1D0-PZ34*S34)*XMW*(PZ12*S12+2D0*QF(1)*
     &  XSW2-2D0*QF(1)*PZ12*S12*XSW2)+C0*XCW2**(-2)*XMW*(-(2D0*PZ12*
     &  S12*S13*XCW2)-2D0*PZ12*S12*S14*XCW2-2D0*PZ12*S12*S23*XCW2-
     &  2D0*PZ12*S12*S24*XCW2-4D0*PZ12*S12*S34*XCW2+4D0*PZ12*PZ34*
     &  S12**2*S34*XCW2+4D0*PZ12*PZ34*S12*S13*S34*XCW2+4D0*PZ12*
     &  PZ34*S12*S14*S34*XCW2+4D0*PZ12*PZ34*S12*S23*S34*XCW2+4D0*
     &  PZ12*PZ34*S12*S24*S34*XCW2+4D0*PZ12*PZ34*S12*S34**2*XCW2+
     &  8D0*PZ12*S12*S13*XCW2**2+8D0*PZ12*S12*S14*XCW2**2+8D0*PZ12*
     &  S12*S23*XCW2**2+8D0*PZ12*S12*S24*XCW2**2-8D0*PZ12*PZ34*S12*
     &  S13*S34*XCW2**2-8D0*PZ12*PZ34*S12*S14*S34*XCW2**2-8D0*PZ12*
     &  PZ34*S12*S23*S34*XCW2**2-8D0*PZ12*PZ34*S12*S24*S34*XCW2**2-
     &  PZ12*PZ34*S12*S34*XMH2-4D0*PZ12*PZ34*S12*S34*XMW2+4D0*QF(1)*
     &  PZ12*S12*S13*XCW2*XSW2+4D0*QF(1)*PZ12*S12*S14*XCW2*XSW2+4D0*
     &  QF(1)*PZ12*S12*S23*XCW2*XSW2+4D0*QF(1)*PZ12*S12*S24*XCW2*
     &  XSW2+8D0*QF(1)*PZ12*S12*S34*XCW2*XSW2+8D0*QF(1)*PZ34*S12*
     &  S34*XCW2*XSW2-8D0*QF(1)*PZ12*PZ34*S12**2*S34*XCW2*XSW2+4D0*
     &  QF(1)*PZ34*S13*S34*XCW2*XSW2-8D0*QF(1)*PZ12*PZ34*S12*S13*
     &  S34*XCW2*XSW2+4D0*QF(1)*PZ34*S14*S34*XCW2*XSW2-8D0*QF(1)*
     &  PZ12*PZ34*S12*S14*S34*XCW2*XSW2+4D0*QF(1)*PZ34*S23*S34*XCW2*
     &  XSW2-8D0*QF(1)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2+4D0*QF(1)*
     &  PZ34*S24*S34*XCW2*XSW2-8D0*QF(1)*PZ12*PZ34*S12*S24*S34*XCW2*
     &  XSW2-8D0*QF(1)*PZ12*PZ34*S12*S34**2*XCW2*XSW2+16D0*QF(1)*
     &  S13*XCW2**2*XSW2-16D0*QF(1)*PZ12*S12*S13*XCW2**2*XSW2+16D0*
     &  QF(1)*S14*XCW2**2*XSW2-16D0*QF(1)*PZ12*S12*S14*XCW2**2*XSW2+
     &  16D0*QF(1)*S23*XCW2**2*XSW2-16D0*QF(1)*PZ12*S12*S23*XCW2**2*
     &  XSW2+16D0*QF(1)*S24*XCW2**2*XSW2-16D0*QF(1)*PZ12*S12*S24*
     &  XCW2**2*XSW2-16D0*QF(1)*PZ34*S13*S34*XCW2**2*XSW2+16D0*
     &  QF(1)*PZ12*PZ34*S12*S13*S34*XCW2**2*XSW2-16D0*QF(1)*PZ34*
     &  S14*S34*XCW2**2*XSW2+16D0*QF(1)*PZ12*PZ34*S12*S14*S34*XCW2**
     &  2*XSW2-16D0*QF(1)*PZ34*S23*S34*XCW2**2*XSW2+16D0*QF(1)*PZ12*
     &  PZ34*S12*S23*S34*XCW2**2*XSW2-16D0*QF(1)*PZ34*S24*S34*XCW2**
     &  2*XSW2+16D0*QF(1)*PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2+2D0*
     &  QF(1)*PZ12*PZ34*S12*S34*XMH2*XSW2+8D0*QF(1)*PZ12*PZ34*S12*
     &  S34*XMW2*XSW2)))/(S12*S34*XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(-((C2(0,0)*K(14)*
     &  XCW2**(-2))/XMW)-4D0*(1D0-PZ12*S12)*XMW*(PZ34*S34-2D0*QF(3)*
     &  XSW2+2D0*QF(3)*PZ34*S34*XSW2)+C0*XCW2**(-2)*XMW*(4D0*PZ34*
     &  S12*S34*XCW2-4D0*PZ12*PZ34*S12**2*S34*XCW2+2D0*PZ34*S13*S34*
     &  XCW2-4D0*PZ12*PZ34*S12*S13*S34*XCW2+2D0*PZ34*S14*S34*XCW2-
     &  4D0*PZ12*PZ34*S12*S14*S34*XCW2+2D0*PZ34*S23*S34*XCW2-4D0*
     &  PZ12*PZ34*S12*S23*S34*XCW2+2D0*PZ34*S24*S34*XCW2-4D0*PZ12*
     &  PZ34*S12*S24*S34*XCW2-4D0*PZ12*PZ34*S12*S34**2*XCW2-8D0*
     &  PZ34*S13*S34*XCW2**2+8D0*PZ12*PZ34*S12*S13*S34*XCW2**2-8D0*
     &  PZ34*S14*S34*XCW2**2+8D0*PZ12*PZ34*S12*S14*S34*XCW2**2-8D0*
     &  PZ34*S23*S34*XCW2**2+8D0*PZ12*PZ34*S12*S23*S34*XCW2**2-8D0*
     &  PZ34*S24*S34*XCW2**2+8D0*PZ12*PZ34*S12*S24*S34*XCW2**2+PZ12*
     &  PZ34*S12*S34*XMH2+4D0*PZ12*PZ34*S12*S34*XMW2+4D0*QF(3)*PZ12*
     &  S12*S13*XCW2*XSW2+4D0*QF(3)*PZ12*S12*S14*XCW2*XSW2+4D0*
     &  QF(3)*PZ12*S12*S23*XCW2*XSW2+4D0*QF(3)*PZ12*S12*S24*XCW2*
     &  XSW2+8D0*QF(3)*PZ12*S12*S34*XCW2*XSW2+8D0*QF(3)*PZ34*S12*
     &  S34*XCW2*XSW2-8D0*QF(3)*PZ12*PZ34*S12**2*S34*XCW2*XSW2+4D0*
     &  QF(3)*PZ34*S13*S34*XCW2*XSW2-8D0*QF(3)*PZ12*PZ34*S12*S13*
     &  S34*XCW2*XSW2+4D0*QF(3)*PZ34*S14*S34*XCW2*XSW2-8D0*QF(3)*
     &  PZ12*PZ34*S12*S14*S34*XCW2*XSW2+4D0*QF(3)*PZ34*S23*S34*XCW2*
     &  XSW2-8D0*QF(3)*PZ12*PZ34*S12*S23*S34*XCW2*XSW2+4D0*QF(3)*
     &  PZ34*S24*S34*XCW2*XSW2-8D0*QF(3)*PZ12*PZ34*S12*S24*S34*XCW2*
     &  XSW2-8D0*QF(3)*PZ12*PZ34*S12*S34**2*XCW2*XSW2+16D0*QF(3)*
     &  S13*XCW2**2*XSW2-16D0*QF(3)*PZ12*S12*S13*XCW2**2*XSW2+16D0*
     &  QF(3)*S14*XCW2**2*XSW2-16D0*QF(3)*PZ12*S12*S14*XCW2**2*XSW2+
     &  16D0*QF(3)*S23*XCW2**2*XSW2-16D0*QF(3)*PZ12*S12*S23*XCW2**2*
     &  XSW2+16D0*QF(3)*S24*XCW2**2*XSW2-16D0*QF(3)*PZ12*S12*S24*
     &  XCW2**2*XSW2-16D0*QF(3)*PZ34*S13*S34*XCW2**2*XSW2+16D0*
     &  QF(3)*PZ12*PZ34*S12*S13*S34*XCW2**2*XSW2-16D0*QF(3)*PZ34*
     &  S14*S34*XCW2**2*XSW2+16D0*QF(3)*PZ12*PZ34*S12*S14*S34*XCW2**
     &  2*XSW2-16D0*QF(3)*PZ34*S23*S34*XCW2**2*XSW2+16D0*QF(3)*PZ12*
     &  PZ34*S12*S23*S34*XCW2**2*XSW2-16D0*QF(3)*PZ34*S24*S34*XCW2**
     &  2*XSW2+16D0*QF(3)*PZ12*PZ34*S12*S24*S34*XCW2**2*XSW2+2D0*
     &  QF(3)*PZ12*PZ34*S12*S34*XMH2*XSW2+8D0*QF(3)*PZ12*PZ34*S12*
     &  S34*XMW2*XSW2)))/(S12*S34*XSW2)
        F(1,1,1) = F(1,1,1)+(4D0*QF(1)*QF(3)*PRE*(4D0*(1D0-PZ12*
     &  S12)*(1D0-PZ34*S34)*XMW-(C2(0,0)*K(11)*XCW2**(-2))/XMW+C0*
     &  XCW2**(-2)*XMW*(2D0*PZ12*S12*S13*XCW2+2D0*PZ12*S12*S14*XCW2+
     &  2D0*PZ12*S12*S23*XCW2+2D0*PZ12*S12*S24*XCW2+4D0*PZ12*S12*
     &  S34*XCW2+4D0*PZ34*S12*S34*XCW2-4D0*PZ12*PZ34*S12**2*S34*
     &  XCW2+2D0*PZ34*S13*S34*XCW2-4D0*PZ12*PZ34*S12*S13*S34*XCW2+
     &  2D0*PZ34*S14*S34*XCW2-4D0*PZ12*PZ34*S12*S14*S34*XCW2+2D0*
     &  PZ34*S23*S34*XCW2-4D0*PZ12*PZ34*S12*S23*S34*XCW2+2D0*PZ34*
     &  S24*S34*XCW2-4D0*PZ12*PZ34*S12*S24*S34*XCW2-4D0*PZ12*PZ34*
     &  S12*S34**2*XCW2+8D0*S13*XCW2**2-8D0*PZ12*S12*S13*XCW2**2+
     &  8D0*S14*XCW2**2-8D0*PZ12*S12*S14*XCW2**2+8D0*S23*XCW2**2-
     &  8D0*PZ12*S12*S23*XCW2**2+8D0*S24*XCW2**2-8D0*PZ12*S12*S24*
     &  XCW2**2-8D0*PZ34*S13*S34*XCW2**2+8D0*PZ12*PZ34*S12*S13*S34*
     &  XCW2**2-8D0*PZ34*S14*S34*XCW2**2+8D0*PZ12*PZ34*S12*S14*S34*
     &  XCW2**2-8D0*PZ34*S23*S34*XCW2**2+8D0*PZ12*PZ34*S12*S23*S34*
     &  XCW2**2-8D0*PZ34*S24*S34*XCW2**2+8D0*PZ12*PZ34*S12*S24*S34*
     &  XCW2**2+PZ12*PZ34*S12*S34*XMH2+4D0*PZ12*PZ34*S12*S34*
     &  XMW2)))/(S12*S34)
        F(5,-1,-1) = F(5,-1,-1)-(K(6)*PRE*XSW2**(-2))/XCW2
        F(5,-1,1) = F(5,-1,1)+(2D0*K(4)*QF(3)*PRE)/(XCW2*XSW2)
        F(5,1,-1) = F(5,1,-1)-(2D0*K(5)*QF(1)*PRE)/(XCW2*XSW2)
        F(5,1,1) = F(5,1,1)-(4D0*K(7)*QF(1)*QF(3)*PRE)/XCW2
        F(6,-1,-1) = F(6,-1,-1)-(K(6)*PRE*XSW2**(-2))/XCW2
        F(6,-1,1) = F(6,-1,1)+(2D0*K(4)*QF(3)*PRE)/(XCW2*XSW2)
        F(6,1,-1) = F(6,1,-1)-(2D0*K(5)*QF(1)*PRE)/(XCW2*XSW2)
        F(6,1,1) = F(6,1,1)-(4D0*K(7)*QF(1)*QF(3)*PRE)/XCW2
        F(7,-1,-1) = F(7,-1,-1)-(K(6)*PRE*XSW2**(-2))/XCW2
        F(7,-1,1) = F(7,-1,1)+(2D0*K(4)*QF(3)*PRE)/(XCW2*XSW2)
        F(7,1,-1) = F(7,1,-1)-(2D0*K(5)*QF(1)*PRE)/(XCW2*XSW2)
        F(7,1,1) = F(7,1,1)-(4D0*K(7)*QF(1)*QF(3)*PRE)/XCW2
        F(8,-1,-1) = F(8,-1,-1)-(K(6)*PRE*XSW2**(-2))/XCW2
        F(8,-1,1) = F(8,-1,1)+(2D0*K(4)*QF(3)*PRE)/(XCW2*XSW2)
        F(8,1,-1) = F(8,1,-1)-(2D0*K(5)*QF(1)*PRE)/(XCW2*XSW2)
        F(8,1,1) = F(8,1,1)-(4D0*K(7)*QF(1)*QF(3)*PRE)/XCW2

C       G(T5,N61,FULL)+G(T5,N62,FULL)
       CALL xC01234_(S12,MH2,S34,XMZ2,XMH2,XMH2,C0,C1,C2,C3,C4,B0,B1,B2,
     &  B3,2,0)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = 1D0+2D0*QF(3)*XSW2

        PRE = -((3D0*ALPHA*PZ12*PZ34*XCW2**(-2)*XMH2)/(32D0*PI*XSW))

        F(1,-1,-1) = F(1,-1,-1)-K(1)*K(2)*PRE*((C0*XMW)/XCW2-(C2(0,
     &  0))/XMW)*XSW2**(-2)
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)*QF(3)*PRE*((C0*XMW)/XCW2-
     &  (C2(0,0))/XMW))/XSW2
        F(1,1,-1) = F(1,1,-1)+(2D0*K(2)*QF(1)*PRE*((C0*XMW)/XCW2-
     &  (C2(0,0))/XMW))/XSW2
        F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*((C0*XMW)/XCW2-
     &  (C2(0,0))/XMW)
        F(5,-1,-1) = F(5,-1,-1)-(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(5,-1,1) = F(5,-1,1)-(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(5,1,-1) = F(5,1,-1)+(2D0*C2(1,2)*K(2)*QF(1)*PRE)/(XMW*
     &  XSW2)
        F(5,1,1) = F(5,1,1)+(4D0*C2(1,2)*QF(1)*QF(3)*PRE)/XMW
        F(6,-1,-1) = F(6,-1,-1)-(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(6,-1,1) = F(6,-1,1)-(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(6,1,-1) = F(6,1,-1)+(2D0*C2(1,2)*K(2)*QF(1)*PRE)/(XMW*
     &  XSW2)
        F(6,1,1) = F(6,1,1)+(4D0*C2(1,2)*QF(1)*QF(3)*PRE)/XMW
        F(7,-1,-1) = F(7,-1,-1)-(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(7,-1,1) = F(7,-1,1)-(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(7,1,-1) = F(7,1,-1)+(2D0*C2(1,2)*K(2)*QF(1)*PRE)/(XMW*
     &  XSW2)
        F(7,1,1) = F(7,1,1)+(4D0*C2(1,2)*QF(1)*QF(3)*PRE)/XMW
        F(8,-1,-1) = F(8,-1,-1)-(C2(1,2)*K(1)*K(2)*PRE*XSW2**(-2))/
     &  XMW
        F(8,-1,1) = F(8,-1,1)-(2D0*C2(1,2)*K(1)*QF(3)*PRE)/(XMW*
     &  XSW2)
        F(8,1,-1) = F(8,1,-1)+(2D0*C2(1,2)*K(2)*QF(1)*PRE)/(XMW*
     &  XSW2)
        F(8,1,1) = F(8,1,1)+(4D0*C2(1,2)*QF(1)*QF(3)*PRE)/XMW

C       G(T7,N82,FULL)
        CALL xC01234_(S34,RMF2(3),RMF2(3),CMF2(3),CMF2(3),XMZ2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = -((ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*
     &  S34-C2(1,1)*S34-C2(1,2)*S34)*XCW2**(-3)*XMW)/(32D0*PI))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)*(1D0+2D0*QF(3)*XSW2)**3)/XSW
        F(1,-1,1) = F(1,-1,1)-8D0*QF(3)**3*PRE*XSW*(1D0-2D0*QF(1)*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  3)/(XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)*QF(3)**3*PRE*XSW*XSW2

C       G(T7,N79,FULL)
        CALL xC01234_(S34,RMF2(3),RMF2(3),CMF2(4),CMF2(4),XMW2,C0,C1,C2,
     &  C3,C4,B0,B1,B2,B3,2,1)

        PRE = (ALPHA*PZ12*PZ34*(1D0-2D0*C2(0,0)-C1(1)*S34-C1(2)*S34-
     &  C2(1,1)*S34-C2(1,2)*S34)*XCW2**(-2)*XMW*(1D0-2D0*QF(4)*
     &  XSW2))/(16D0*PI*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE

C       G(T2,N6,FULL)+G(T2,N8,FULL)
      CALL xC01234_(T12,MH2,RMF2(1),CMF2(1),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S34)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0-2D0*QF(1)*
     &  XSW2)**2*(PZ34*S34-2D0*QF(1)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*
     &  S34*XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*QF(1)*QF(3)*PZ34*S34*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2)**
     &  2*(PZ34*S34-2D0*QF(1)*XCW2-2D0*QF(1)*PZ34*S34*XSW2))/(XSW*
     &  XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*QF(1)**3*PRE*XSW*(PZ34*S34+2D0*
     &  QF(3)*XCW2+2D0*QF(3)*PZ34*S34*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)**3*QF(3)*PRE*XSW*(XCW2+PZ34*
     &  S34*XSW2)

C       G(T4,N14,FULL)+G(T4,N16,FULL)
      CALL xC01234_(T13,MH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S12)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)**2*(PZ12*S12-2D0*QF(1)*PZ12*S12*XSW2+2D0*QF(3)*PZ12*
     &  S12*XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*QF(1)*QF(3)*PZ12*S12*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)-8D0*QF(3)**3*PRE*XSW*(PZ12*S12-2D0*
     &  QF(1)*XCW2-2D0*QF(1)*PZ12*S12*XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  2*(PZ12*S12+2D0*QF(3)*XCW2+2D0*QF(3)*PZ12*S12*XSW2))/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)*QF(3)**3*PRE*XSW*(XCW2+PZ12*
     &  S12*XSW2)

C       G(T6,N75,FULL)+G(T6,N77,FULL)
      CALL xC01234_(T14,MH2,RMF2(3),CMF2(3),XMZ2,XMZ2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XCW2**(-3)*XMW)/(32D0*PI*S12)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*XSW2**(-2)*(1D0+2D0*QF(3)*
     &  XSW2)**2*(PZ12*S12-2D0*QF(1)*PZ12*S12*XSW2+2D0*QF(3)*PZ12*
     &  S12*XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*QF(1)*QF(3)*PZ12*S12*
     &  XSW2**2))/XSW
        F(1,-1,1) = F(1,-1,1)-8D0*QF(3)**3*PRE*XSW*(PZ12*S12-2D0*
     &  QF(1)*XCW2-2D0*QF(1)*PZ12*S12*XSW2)
        F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2)**
     &  2*(PZ12*S12+2D0*QF(3)*XCW2+2D0*QF(3)*PZ12*S12*XSW2))/(XSW*
     &  XSW2)
        F(1,1,1) = F(1,1,1)+16D0*QF(1)*QF(3)**3*PRE*XSW*(XCW2+PZ12*
     &  S12*XSW2)

C       G(T6,N76,FULL)+G(T6,N78,FULL)
      CALL xC01234_(T14,MH2,RMF2(3),CMF2(4),XMW2,XMW2,C0,C1,C2,C3,C4,B0,
     &  B1,B2,B3,1,1)

        PRE = (C1(1)*ALPHA*XMW)/(16D0*PI*S12*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(PZ12*S12-2D0*QF(1)*PZ12*S12*
     &  XSW2+2D0*QF(3)*PZ12*S12*XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*
     &  QF(1)*QF(3)*PZ12*S12*XSW2**2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*(PZ12*S12+2D0*QF(3)*
     &  XCW2+2D0*QF(3)*PZ12*S12*XSW2)

      end

************************************************************************
*
*     boxes for H->ZZ->uudd (generic u,d)
*
************************************************************************
      subroutine HZZ1133_box_bgf(F,pz12,pz34)
      implicit none
      complex*16 F(13,-1:1,-1:1),pz12,pz34
      complex*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
      complex*16   C4(0:2,0:2,0:2,0:2)
      complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
      complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
      complex*16 pre,K(9)
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fermion masses as flag (i*1d-20)
      complex*16 cme2,cmf2(5)
      real*8 me2,rme2,mf2(5),rmf2(5)
      common/fmass/me2,rme2,cme2,mf2,rmf2,cmf2

C       Process: S10F2100aF2100F2300aF2300,   Model: SMbgf4f

C       G(T6,N17,FULL)+G(T6,N18,FULL)+G(T6,N19,FULL)
        CALL xD012345_(RMF2(1),MH2,S34,RMF2(1),S12,T11,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ34*S34
        K(2) = PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2

        PRE = (ALPHA*XMW)/(16D0*PI*S34*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(-(4D0*D2(0,0)*K(2))-2D0*D1(3)*
     &  K(2)*(S23+S24)+(D1(1)*(MH2*PZ34*S34-PZ34*S34*T11-2D0*PZ34*
     &  S13*S34*XCW2-2D0*PZ34*S14*S34*XCW2+2D0*QF(3)*MH2*PZ34*S34*
     &  XSW2-2D0*QF(3)*PZ34*S34*T11*XSW2+4D0*QF(3)*S13*XCW2*XSW2+
     &  4D0*QF(3)*S14*XCW2*XSW2-4D0*QF(3)*PZ34*S13*S34*XCW2*XSW2-
     &  4D0*QF(3)*PZ34*S14*S34*XCW2*XSW2))/XCW2-(D1(2)*(PZ34*S34*
     &  T11+2D0*PZ34*S23*S34*XCW2+2D0*PZ34*S24*S34*XCW2+2D0*QF(3)*
     &  PZ34*S34*T11*XSW2-4D0*QF(3)*S23*XCW2*XSW2-4D0*QF(3)*S24*
     &  XCW2*XSW2+4D0*QF(3)*PZ34*S23*S34*XCW2*XSW2+4D0*QF(3)*PZ34*
     &  S24*S34*XCW2*XSW2))/XCW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(4D0*D2(0,0)*K(1)+2D0*
     &  D1(3)*K(1)*(S23+S24)+(D1(1)*(MH2*PZ34*S34-PZ34*S34*T11+2D0*
     &  S13*XCW2+2D0*S14*XCW2-2D0*PZ34*S13*S34*XCW2-2D0*PZ34*S14*
     &  S34*XCW2))/XCW2-(D1(2)*(PZ34*S34*T11-2D0*S23*XCW2-2D0*S24*
     &  XCW2+2D0*PZ34*S23*S34*XCW2+2D0*PZ34*S24*S34*XCW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(5,-1,1) = F(5,-1,1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ34*S34-2D0*PZ34*S34*XCW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(3)*XCW2*XSW2-4D0*QF(3)*PZ34*S34*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(6,-1,1) = F(6,-1,1)-4D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ34*S34+2D0*XCW2-2D0*PZ34*S34*
     &  XCW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)+(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(7,-1,1) = F(7,-1,1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ34*S34-2D0*PZ34*S34*XCW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(3)*XCW2*XSW2-4D0*QF(3)*PZ34*S34*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(8,-1,1) = F(8,-1,1)-4D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ34*S34+2D0*XCW2-2D0*PZ34*S34*
     &  XCW2))/XCW2)

C       G(T1,N1,FULL)+G(T1,N2,FULL)+G(T1,N3,FULL)
        CALL xD012345_(RMF2(1),MH2,S34,RMF2(1),S12,T12,CMF2(2),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ34*S34
        K(2) = PZ34*S34-2D0*QF(3)*XSW2+2D0*QF(3)*PZ34*S34*XSW2

        PRE = (ALPHA*XMW)/(16D0*PI*S34*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(-(4D0*D2(0,0)*K(2))-2D0*D1(3)*
     &  K(2)*(S13+S14)-(D1(2)*(PZ34*S34*T12+2D0*PZ34*S13*S34*XCW2+
     &  2D0*PZ34*S14*S34*XCW2+2D0*QF(3)*PZ34*S34*T12*XSW2-4D0*QF(3)*
     &  S13*XCW2*XSW2-4D0*QF(3)*S14*XCW2*XSW2+4D0*QF(3)*PZ34*S13*
     &  S34*XCW2*XSW2+4D0*QF(3)*PZ34*S14*S34*XCW2*XSW2))/XCW2+
     &  (D1(1)*(MH2*PZ34*S34-PZ34*S34*T12-2D0*PZ34*S23*S34*XCW2-2D0*
     &  PZ34*S24*S34*XCW2+2D0*QF(3)*MH2*PZ34*S34*XSW2-2D0*QF(3)*
     &  PZ34*S34*T12*XSW2+4D0*QF(3)*S23*XCW2*XSW2+4D0*QF(3)*S24*
     &  XCW2*XSW2-4D0*QF(3)*PZ34*S23*S34*XCW2*XSW2-4D0*QF(3)*PZ34*
     &  S24*S34*XCW2*XSW2))/XCW2))/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*QF(3)*PRE*(4D0*D2(0,0)*K(1)+2D0*
     &  D1(3)*K(1)*(S13+S14)-(D1(2)*(PZ34*S34*T12-2D0*S13*XCW2-2D0*
     &  S14*XCW2+2D0*PZ34*S13*S34*XCW2+2D0*PZ34*S14*S34*XCW2))/XCW2+
     &  (D1(1)*(MH2*PZ34*S34-PZ34*S34*T12+2D0*S23*XCW2+2D0*S24*XCW2-
     &  2D0*PZ34*S23*S34*XCW2-2D0*PZ34*S24*S34*XCW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ34*S34-2D0*PZ34*S34*XCW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(3)*XCW2*XSW2-4D0*QF(3)*PZ34*S34*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(5,-1,1) = F(5,-1,1)-4D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ34*S34+2D0*XCW2-2D0*PZ34*S34*
     &  XCW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)+(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(6,-1,1) = F(6,-1,1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE
        F(7,-1,-1) = F(7,-1,-1)-(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ34*S34-2D0*PZ34*S34*XCW2+2D0*QF(3)*PZ34*
     &  S34*XSW2+4D0*QF(3)*XCW2*XSW2-4D0*QF(3)*PZ34*S34*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(7,-1,1) = F(7,-1,1)-4D0*QF(3)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ34*S34+2D0*XCW2-2D0*PZ34*S34*
     &  XCW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)+(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(8,-1,1) = F(8,-1,1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(3)*PRE

C       G(T7,N20,FULL)+G(T7,N21,FULL)+G(T7,N22,FULL)
        CALL xD012345_(RMF2(3),MH2,S12,RMF2(3),S34,T13,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ12*S12
        K(2) = PZ12*S12+2D0*QF(1)*XSW2-2D0*QF(1)*PZ12*S12*XSW2

        PRE = -((ALPHA*XMW)/(16D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-(PRE*(-(4D0*D2(0,0)*K(2))-2D0*D1(3)*
     &  K(2)*(S14+S24)+(D1(1)*(MH2*PZ12*S12-PZ12*S12*T13-2D0*PZ12*
     &  S12*S13*XCW2-2D0*PZ12*S12*S23*XCW2-2D0*QF(1)*MH2*PZ12*S12*
     &  XSW2+2D0*QF(1)*PZ12*S12*T13*XSW2-4D0*QF(1)*S13*XCW2*XSW2+
     &  4D0*QF(1)*PZ12*S12*S13*XCW2*XSW2-4D0*QF(1)*S23*XCW2*XSW2+
     &  4D0*QF(1)*PZ12*S12*S23*XCW2*XSW2))/XCW2-(D1(2)*(PZ12*S12*
     &  T13+2D0*PZ12*S12*S14*XCW2+2D0*PZ12*S12*S24*XCW2-2D0*QF(1)*
     &  PZ12*S12*T13*XSW2+4D0*QF(1)*S14*XCW2*XSW2-4D0*QF(1)*PZ12*
     &  S12*S14*XCW2*XSW2+4D0*QF(1)*S24*XCW2*XSW2-4D0*QF(1)*PZ12*
     &  S12*S24*XCW2*XSW2))/XCW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*(4D0*D2(0,0)*K(1)+2D0*
     &  D1(3)*K(1)*(S14+S24)+(D1(1)*(MH2*PZ12*S12-PZ12*S12*T13+2D0*
     &  S13*XCW2-2D0*PZ12*S12*S13*XCW2+2D0*S23*XCW2-2D0*PZ12*S12*
     &  S23*XCW2))/XCW2-(D1(2)*(PZ12*S12*T13-2D0*S14*XCW2+2D0*PZ12*
     &  S12*S14*XCW2-2D0*S24*XCW2+2D0*PZ12*S12*S24*XCW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)-(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(5,1,-1) = F(5,1,-1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(1)*PRE
        F(6,-1,-1) = F(6,-1,-1)-(4D0*(D1(1)+D2(1,2))*K(2)*PRE)/XSW2
        F(6,1,-1) = F(6,1,-1)-8D0*(D1(1)+D2(1,2))*K(1)*QF(1)*PRE
        F(7,-1,-1) = F(7,-1,-1)+(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ12*S12-2D0*PZ12*S12*XCW2-2D0*QF(1)*PZ12*
     &  S12*XSW2-4D0*QF(1)*XCW2*XSW2+4D0*QF(1)*PZ12*S12*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(7,1,-1) = F(7,1,-1)-4D0*QF(1)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ12*S12+2D0*XCW2-2D0*PZ12*S12*
     &  XCW2))/XCW2)
        F(8,-1,-1) = F(8,-1,-1)+(2D0*PRE*(2D0*D2(2,2)*K(2)+2D0*D2(2,
     &  3)*K(2)+(D1(3)*(PZ12*S12-2D0*PZ12*S12*XCW2-2D0*QF(1)*PZ12*
     &  S12*XSW2-4D0*QF(1)*XCW2*XSW2+4D0*QF(1)*PZ12*S12*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(8,1,-1) = F(8,1,-1)-4D0*QF(1)*PRE*(-(2D0*D2(2,2)*K(1))-
     &  2D0*D2(2,3)*K(1)+(D1(3)*(PZ12*S12+2D0*XCW2-2D0*PZ12*S12*
     &  XCW2))/XCW2)

C       G(T9,N26,FULL)+G(T9,N27,FULL)+G(T9,N28,FULL)
        CALL xD012345_(RMF2(3),S12,MH2,RMF2(3),S34,T14,CMF2(4),XMW2,
     &  XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-PZ12*S12
        K(2) = PZ12*S12+2D0*QF(1)*XSW2-2D0*QF(1)*PZ12*S12*XSW2

        PRE = -((ALPHA*XMW)/(16D0*PI*S12*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)+(PRE*(4D0*D2(0,0)*K(2)+2D0*D1(1)*
     &  K(2)*(S13+S23)+(D1(2)*(PZ12*S12*T14+2D0*PZ12*S12*S13*XCW2+
     &  2D0*PZ12*S12*S23*XCW2-2D0*QF(1)*PZ12*S12*T14*XSW2+4D0*QF(1)*
     &  S13*XCW2*XSW2-4D0*QF(1)*PZ12*S12*S13*XCW2*XSW2+4D0*QF(1)*
     &  S23*XCW2*XSW2-4D0*QF(1)*PZ12*S12*S23*XCW2*XSW2))/XCW2-
     &  (D1(3)*(MH2*PZ12*S12-PZ12*S12*T14-2D0*PZ12*S12*S14*XCW2-2D0*
     &  PZ12*S12*S24*XCW2-2D0*QF(1)*MH2*PZ12*S12*XSW2+2D0*QF(1)*
     &  PZ12*S12*T14*XSW2-4D0*QF(1)*S14*XCW2*XSW2+4D0*QF(1)*PZ12*
     &  S12*S14*XCW2*XSW2-4D0*QF(1)*S24*XCW2*XSW2+4D0*QF(1)*PZ12*
     &  S12*S24*XCW2*XSW2))/XCW2))/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*QF(1)*PRE*(4D0*D2(0,0)*K(1)+2D0*
     &  D1(1)*K(1)*(S13+S23)-(D1(2)*(PZ12*S12*T14-2D0*S13*XCW2+2D0*
     &  PZ12*S12*S13*XCW2-2D0*S23*XCW2+2D0*PZ12*S12*S23*XCW2))/XCW2+
     &  (D1(3)*(MH2*PZ12*S12-PZ12*S12*T14+2D0*S14*XCW2-2D0*PZ12*S12*
     &  S14*XCW2+2D0*S24*XCW2-2D0*PZ12*S12*S24*XCW2))/XCW2)
        F(5,-1,-1) = F(5,-1,-1)+(2D0*PRE*(2D0*D2(1,2)*K(2)+2D0*D2(2,
     &  2)*K(2)+(D1(1)*(PZ12*S12-2D0*PZ12*S12*XCW2-2D0*QF(1)*PZ12*
     &  S12*XSW2-4D0*QF(1)*XCW2*XSW2+4D0*QF(1)*PZ12*S12*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(5,1,-1) = F(5,1,-1)-4D0*QF(1)*PRE*(-(2D0*D2(1,2)*K(1))-
     &  2D0*D2(2,2)*K(1)+(D1(1)*(PZ12*S12+2D0*XCW2-2D0*PZ12*S12*
     &  XCW2))/XCW2)
        F(6,-1,-1) = F(6,-1,-1)+(2D0*PRE*(2D0*D2(1,2)*K(2)+2D0*D2(2,
     &  2)*K(2)+(D1(1)*(PZ12*S12-2D0*PZ12*S12*XCW2-2D0*QF(1)*PZ12*
     &  S12*XSW2-4D0*QF(1)*XCW2*XSW2+4D0*QF(1)*PZ12*S12*XCW2*XSW2))/
     &  XCW2))/XSW2
        F(6,1,-1) = F(6,1,-1)-4D0*QF(1)*PRE*(-(2D0*D2(1,2)*K(1))-
     &  2D0*D2(2,2)*K(1)+(D1(1)*(PZ12*S12+2D0*XCW2-2D0*PZ12*S12*
     &  XCW2))/XCW2)
        F(7,-1,-1) = F(7,-1,-1)-(4D0*(D1(3)+D2(2,3))*K(2)*PRE)/XSW2
        F(7,1,-1) = F(7,1,-1)-8D0*(D1(3)+D2(2,3))*K(1)*QF(1)*PRE
        F(8,-1,-1) = F(8,-1,-1)-(4D0*(D1(3)+D2(2,3))*K(2)*PRE)/XSW2
        F(8,1,-1) = F(8,1,-1)-8D0*(D1(3)+D2(2,3))*K(1)*QF(1)*PRE

C       G(T5,N13,FULL)+G(T5,N15,FULL)
        CALL xD012345_(S12,RMF2(3),MH2,RMF2(3),T13,T14,CMF2(3),
     &  CMF2(3),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0+2D0*QF(3)*XSW2
        K(2) = S14+S24
        K(3) = D2(1,2)+D2(2,2)
        K(4) = 2D0*S12+S13+S23
        K(5) = PZ12*S12-2D0*QF(1)*XCW2-2D0*QF(1)*PZ12*S12*XSW2
        K(6) = PZ12*S12+2D0*QF(3)*XCW2+2D0*QF(3)*PZ12*S12*XSW2
        K(7) = D1(3)+D2(1,3)+D2(2,3)
        K(8) = PZ12*S12-2D0*QF(1)*PZ12*S12*XSW2+2D0*QF(3)*PZ12*S12*
     &  XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*QF(1)*QF(3)*PZ12*S12*
     &  XSW2**2
        K(9) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(MH2-T14))/S12

        PRE = (ALPHA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)**2*K(8)*K(9)*PRE*XSW2**(-2))/
     &  XSW
        F(1,-1,1) = F(1,-1,1)-8D0*K(5)*K(9)*QF(3)**3*PRE*XSW
        F(1,1,-1) = F(1,1,-1)+(2D0*K(1)**2*K(6)*K(9)*QF(1)*PRE)/
     &  (XSW*XSW2)
        F(1,1,1) = F(1,1,1)+16D0*K(9)*QF(1)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2)
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(5,-1,1) = F(5,-1,1)+(16D0*K(3)*K(5)*QF(3)**3*PRE*XSW)/S12
        F(5,1,-1) = F(5,1,-1)-(4D0*K(1)**2*K(3)*K(6)*QF(1)*PRE)/
     &  (S12*XSW*XSW2)
        F(5,1,1) = F(5,1,1)-(32D0*K(3)*QF(1)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(6,-1,1) = F(6,-1,1)+(16D0*K(3)*K(5)*QF(3)**3*PRE*XSW)/S12
        F(6,1,-1) = F(6,1,-1)-(4D0*K(1)**2*K(3)*K(6)*QF(1)*PRE)/
     &  (S12*XSW*XSW2)
        F(6,1,1) = F(6,1,1)-(32D0*K(3)*QF(1)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(7,-1,1) = F(7,-1,1)-(16D0*K(5)*K(7)*QF(3)**3*PRE*XSW)/S12
        F(7,1,-1) = F(7,1,-1)+(4D0*K(1)**2*K(6)*K(7)*QF(1)*PRE)/
     &  (S12*XSW*XSW2)
        F(7,1,1) = F(7,1,1)+(32D0*K(7)*QF(1)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S12*XSW)
        F(8,-1,1) = F(8,-1,1)-(16D0*K(5)*K(7)*QF(3)**3*PRE*XSW)/S12
        F(8,1,-1) = F(8,1,-1)+(4D0*K(1)**2*K(6)*K(7)*QF(1)*PRE)/
     &  (S12*XSW*XSW2)
        F(8,1,1) = F(8,1,1)+(32D0*K(7)*QF(1)*QF(3)**3*PRE*XSW*(XCW2+
     &  PZ12*S12*XSW2))/S12

C       G(T5,N14,FULL)+G(T5,N16,FULL)
        CALL xD012345_(S12,RMF2(3),MH2,RMF2(3),T13,T14,CMF2(4),
     &  CMF2(4),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = PZ12*S12-2D0*QF(4)*XCW2-2D0*QF(4)*PZ12*S12*XSW2
        K(2) = D1(3)+D2(1,3)+D2(2,3)
        K(3) = PZ12*S12-2D0*QF(1)*PZ12*S12*XSW2-2D0*QF(4)*PZ12*S12*
     &  XSW2+4D0*QF(1)*QF(4)*XCW2*XSW2+4D0*QF(1)*QF(4)*PZ12*S12*
     &  XSW2**2
        K(4) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S12+(D2(1,2)*(2D0*
     &  S12+S13+S23))/S12-(D1(3)*(S14+S24))/S12-(D2(1,3)*(S14+S24))/
     &  S12+(D2(2,2)*T14)/S12-(D2(2,3)*(MH2-T14))/S12

        PRE = -((ALPHA*XMW)/(16D0*PI*XCW2*XSW*XSW2))

        F(1,-1,-1) = F(1,-1,-1)-(K(3)*K(4)*PRE)/XSW2
        F(1,1,-1) = F(1,1,-1)+2D0*K(1)*K(4)*QF(1)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S12*XSW2)
        F(5,1,-1) = F(5,1,-1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(1)*
     &  PRE)/S12
        F(6,-1,-1) = F(6,-1,-1)+(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S12*XSW2)
        F(6,1,-1) = F(6,1,-1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(1)*
     &  PRE)/S12
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(2)*K(3)*PRE)/(S12*XSW2)
        F(7,1,-1) = F(7,1,-1)+(4D0*K(1)*K(2)*QF(1)*PRE)/S12
        F(8,-1,-1) = F(8,-1,-1)-(2D0*K(2)*K(3)*PRE)/(S12*XSW2)
        F(8,1,-1) = F(8,1,-1)+(4D0*K(1)*K(2)*QF(1)*PRE)/S12

C       G(T4,N10,FULL)+G(T4,N12,FULL)
        CALL xD012345_(S34,RMF2(1),MH2,RMF2(1),T12,T11,CMF2(1),
     &  CMF2(1),XMZ2,XMZ2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = 1D0-2D0*QF(1)*XSW2
        K(2) = S13+S14
        K(3) = D2(1,2)+D2(2,2)
        K(4) = S23+S24+2D0*S34
        K(5) = PZ34*S34-2D0*QF(1)*XCW2-2D0*QF(1)*PZ34*S34*XSW2
        K(6) = PZ34*S34+2D0*QF(3)*XCW2+2D0*QF(3)*PZ34*S34*XSW2
        K(7) = D1(3)+D2(1,3)+D2(2,3)
        K(8) = PZ34*S34-2D0*QF(1)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*S34*
     &  XSW2-4D0*QF(1)*QF(3)*XCW2*XSW2-4D0*QF(1)*QF(3)*PZ34*S34*
     &  XSW2**2
        K(9) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(MH2-T11))/S34

        PRE = (ALPHA*XCW2**(-3)*XMW)/(32D0*PI)

        F(1,-1,-1) = F(1,-1,-1)-(K(1)**2*K(8)*K(9)*PRE*XSW2**(-2))/
     &  XSW
        F(1,-1,1) = F(1,-1,1)-(2D0*K(1)**2*K(5)*K(9)*QF(3)*PRE)/
     &  (XSW*XSW2)
        F(1,1,-1) = F(1,1,-1)+8D0*K(6)*K(9)*QF(1)**3*PRE*XSW
        F(1,1,1) = F(1,1,1)+16D0*K(9)*QF(1)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2)
        F(5,-1,-1) = F(5,-1,-1)-(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(5,-1,1) = F(5,-1,1)-(4D0*K(1)**2*K(5)*K(7)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(5,1,-1) = F(5,1,-1)+(16D0*K(6)*K(7)*QF(1)**3*PRE*XSW)/S34
        F(5,1,1) = F(5,1,1)+(32D0*K(7)*QF(1)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34
        F(6,-1,-1) = F(6,-1,-1)+(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(6,-1,1) = F(6,-1,1)+(4D0*K(1)**2*K(3)*K(5)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(6,1,-1) = F(6,1,-1)-(16D0*K(3)*K(6)*QF(1)**3*PRE*XSW)/S34
        F(6,1,1) = F(6,1,1)-(32D0*K(3)*QF(1)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34
        F(7,-1,-1) = F(7,-1,-1)-(2D0*K(1)**2*K(7)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(7,-1,1) = F(7,-1,1)-(4D0*K(1)**2*K(5)*K(7)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(7,1,-1) = F(7,1,-1)+(16D0*K(6)*K(7)*QF(1)**3*PRE*XSW)/S34
        F(7,1,1) = F(7,1,1)+(32D0*K(7)*QF(1)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34
        F(8,-1,-1) = F(8,-1,-1)+(2D0*K(1)**2*K(3)*K(8)*PRE*XSW2**(-
     &  2))/(S34*XSW)
        F(8,-1,1) = F(8,-1,1)+(4D0*K(1)**2*K(3)*K(5)*QF(3)*PRE)/
     &  (S34*XSW*XSW2)
        F(8,1,-1) = F(8,1,-1)-(16D0*K(3)*K(6)*QF(1)**3*PRE*XSW)/S34
        F(8,1,1) = F(8,1,1)-(32D0*K(3)*QF(1)**3*QF(3)*PRE*XSW*(XCW2+
     &  PZ34*S34*XSW2))/S34

C       G(T4,N11,FULL)+G(T4,N9,FULL)
        CALL xD012345_(S34,RMF2(1),MH2,RMF2(1),T12,T11,CMF2(2),
     &  CMF2(2),XMW2,XMW2,D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,2,1)
        K(1) = PZ34*S34+2D0*QF(2)*XCW2+2D0*QF(2)*PZ34*S34*XSW2
        K(2) = D1(3)+D2(1,3)+D2(2,3)
        K(3) = PZ34*S34+2D0*QF(2)*PZ34*S34*XSW2+2D0*QF(3)*PZ34*S34*
     &  XSW2+4D0*QF(2)*QF(3)*XCW2*XSW2+4D0*QF(2)*QF(3)*PZ34*S34*
     &  XSW2**2
        K(4) = D1(1)+D1(2)+D2(1,1)+(2D0*D2(0,0))/S34-(D1(3)*(S13+
     &  S14))/S34-(D2(1,3)*(S13+S14))/S34+(D2(1,2)*(S23+S24+2D0*
     &  S34))/S34+(D2(2,2)*T11)/S34-(D2(2,3)*(MH2-T11))/S34

        PRE = (ALPHA*XMW)/(16D0*PI*XCW2*XSW*XSW2)

        F(1,-1,-1) = F(1,-1,-1)+(K(3)*K(4)*PRE)/XSW2
        F(1,-1,1) = F(1,-1,1)+2D0*K(1)*K(4)*QF(3)*PRE
        F(5,-1,-1) = F(5,-1,-1)+(2D0*K(2)*K(3)*PRE)/(S34*XSW2)
        F(5,-1,1) = F(5,-1,1)+(4D0*K(1)*K(2)*QF(3)*PRE)/S34
        F(6,-1,-1) = F(6,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S34*XSW2)
        F(6,-1,1) = F(6,-1,1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(3)*
     &  PRE)/S34
        F(7,-1,-1) = F(7,-1,-1)+(2D0*K(2)*K(3)*PRE)/(S34*XSW2)
        F(7,-1,1) = F(7,-1,1)+(4D0*K(1)*K(2)*QF(3)*PRE)/S34
        F(8,-1,-1) = F(8,-1,-1)-(2D0*(D2(1,2)+D2(2,2))*K(3)*PRE)/
     &  (S34*XSW2)
        F(8,-1,1) = F(8,-1,1)-(4D0*(D2(1,2)+D2(2,2))*K(1)*QF(3)*
     &  PRE)/S34

      end
