**************************************************************
*
*     tree amplitude H->ZZ/WW->4f
*       call setprods before
*
**************************************************************
      function m2_hvv4f()
      implicit none
      integer i1,i2,i3,i4,perm,f1p,f2p,f3p,f4p,f1m,f2m,f3m,f4m
      integer diag,nondiag
      real*8 m2_hvv4f,M2,M2dg,M2dg42,M2ndg
      complex*16 m(-1:1,-1:1,-1:1,-1:1),m42(-1:1,-1:1,-1:1,-1:1)
      include 'COMMON/processpar.inc'
      include 'COMMON/options.inc'
c m2flip
      real*8 m2flip(4)
      common/m2flip/m2flip
c m2born (diagonal and non-diagonal contribution)
      real*8 M2B_dg,M2B_dg42,M2B_ndg
      common/m2born/M2B_dg,M2B_dg42,M2B_ndg

c symmetry factor
      if (fname(1).eq.fname(3)) then
        perm=4
      else
        perm=1
      endif

c QCD contributions for subtraction functions
      diag = 0 !diagonal part (type a)
      nondiag = 0 !non-diagonal part (type b), type c and d are IR safe
      if (qqcd.eq.1.or.qqcd.eq.2.or.qqcd.eq.3) diag = 1
      if (qqcd.eq.1.or.qqcd.eq.2.or.qqcd.eq.4) nondiag = 1

      m2_hvv4f = 0d0
      M2B_dg = 0d0
      M2B_dg42 = 0d0
      M2B_ndg = 0d0
      do i1 = 1,4
        m2flip(i1) = 0d0
      enddo
      do i1=-1,1,2
      do i2=-1,1,2
      do i3=-1,1,2
      do i4=-1,1,2
        m(i1,i2,i3,i4)=0d0
        m42(i1,i2,i3,i4)=0d0   !for matrix element with f2<->f4
      enddo
      enddo
      enddo
      enddo

      if(cc.eq.1)then  !CC and mixed
        call m_hvv4f(m,+1,1,2,3,4,3)   ! H->WW->nue/num anti-e/mu mu anti-num
        if(nc.eq.1)
     &     call m_hvv4f(m42,-1,1,4,3,2,2) ! H->ZZ->num anti-num mu anti-mu
      else             !NC
        call m_hvv4f(m,+1,1,2,3,4,2)   ! H->ZZ->e anti-e mu anti-mu
        if(perm.eq.4)
     &     call m_hvv4f(m42,-1,1,4,3,2,2) ! H->ZZ->mu anti-mu mu anti-mu
      endif

c sum over fermion helicities
      do i1=-1,1,2
      do i2=-1,1,2
      do i3=-1,1,2
      do i4=-1,1,2
        f1p = int((2+pol(1)*i1)/2)
        f2p = int((2+pol(2)*i2)/2)
        f3p = int((2+pol(3)*i3)/2)
        f4p = int((2+pol(4)*i4)/2)
        f1m = int((2-pol(1)*i1)/2)
        f2m = int((2-pol(2)*i2)/2)
        f3m = int((2-pol(3)*i3)/2)
        f4m = int((2-pol(4)*i4)/2)

        M2dg = abs(m(i1,i2,i3,i4))**2 *color/perm
        M2dg42 = abs(m42(i1,i2,i3,i4))**2 *color/perm
        M2ndg =  2d0*dreal(m(i1,i2,i3,i4)*dconjg(m42(i1,i2,i3,i4)))
     &       *dsqrt(dfloat(color))/perm
        M2 = M2dg + M2dg42 + M2ndg

        M2B_dg = M2B_dg + M2dg *f1p*f2p*f3p*f4p
        M2B_dg42 = M2B_dg42 + M2dg42 *f1p*f2p*f3p*f4p
        M2B_ndg = M2B_ndg + M2ndg *f1p*f2p*f3p*f4p

        m2flip(1) = m2flip(1) + M2 *f1m*f2p*f3p*f4p
        m2flip(2) = m2flip(2) + M2 *f1p*f2m*f3p*f4p
        m2flip(3) = m2flip(3) + M2 *f1p*f2p*f3m*f4p
        m2flip(4) = m2flip(4) + M2 *f1p*f2p*f3p*f4m
      enddo
      enddo
      enddo
      enddo

      m2_hvv4f = M2B_dg + M2B_dg42 + M2B_ndg

      if (diag.eq.0) then
        M2B_dg = 0d0
        M2B_dg42 = 0d0
      endif
      if (nondiag.eq.0) M2B_ndg = 0d0

      end

**************************************************************
*
*     tree amplitude H->ZZ/WW->4f+gamma
*       call setprods before
*
**************************************************************
      function m2_hvv4fga()
      implicit none
      integer i1,i2,i3,i4,i5,perm
      real*8 m2_hvv4fga
      complex*16 m(-1:1,-1:1,-1:1,-1:1,-1:1)
      complex*16 m42(-1:1,-1:1,-1:1,-1:1,-1:1)
      include 'COMMON/processpar.inc'

c symmetry factor
      if (fname(1).eq.fname(3)) then
        perm=4
      else
        perm=1
      endif

      m2_hvv4fga = 0d0
      do i1=-1,1,2
      do i2=-1,1,2
      do i3=-1,1,2
      do i4=-1,1,2
      do i5=-1,1,2
        m(i1,i2,i3,i4,i5)=0d0
        m42(i1,i2,i3,i4,i5)=0d0 !for matrix element with f2<->f4
      enddo
      enddo
      enddo
      enddo
      enddo

      if(cc.eq.1)then
        call m_hww4fga(m,+1,1,2,3,4,q)   ! H->WW->nue/num anti-e/mu mu anti-num
        if(nc.eq.1)
     &     call m_hzz4fga(m42,-1,1,4,3,2,q) ! H->ZZ->num anti-num mu anti-mu
      else     ! charge q effectively interchanged through f1,f4,f3,f2
        call m_hzz4fga(m,+1,1,2,3,4,q)   ! H->ZZ->e anti-e mu anti-mu
        if(perm.eq.4)
     &     call m_hzz4fga(m42,-1,1,4,3,2,q) ! H->ZZ->mu anti-mu mu anti-mu
      endif

c sum over fermion helicities
      do i1=-1,1,2
      do i2=-1,1,2
      do i3=-1,1,2
      do i4=-1,1,2
      do i5=-1,1,2
        m2_hvv4fga = m2_hvv4fga +
     &      int((2+pol(1)*i1)/2)*int((2+pol(2)*i2)/2)
     &      *int((2+pol(3)*i3)/2)*int((2+pol(4)*i4)/2)
     &      *int((2+pol(5)*i5)/2)
     &      *( abs(m(i1,i2,i3,i4,i5))**2
     &        +abs(m42(i1,i2,i3,i4,i5))**2
     &        +2d0*dreal(m(i1,i2,i3,i4,i5)
     &           *dconjg(m42(i1,i2,i3,i4,i5)))/dsqrt(dfloat(color)) )
     &      *color/perm
      enddo
      enddo
      enddo
      enddo
      enddo

      end

**************************************************************
*
*     tree amplitude H->ZZ/WW->4f+gluon
*       call setprods before
*
**************************************************************
      function m2_hvv4fgluon()
      implicit none
      integer i1,i2,i3,i4,i5,perm,diag,nondiag
      real*8 m2_hvv4fgluon,ch1100(4),ch0011(4),ch1001(4),ch0110(4)
      real*8 CF
      complex*16 m1100(-1:1,-1:1,-1:1,-1:1,-1:1)
      complex*16 m0011(-1:1,-1:1,-1:1,-1:1,-1:1)
      complex*16 m421001(-1:1,-1:1,-1:1,-1:1,-1:1)
      complex*16 m420110(-1:1,-1:1,-1:1,-1:1,-1:1)
      include 'COMMON/processpar.inc'
      include 'COMMON/param.inc'
      include 'COMMON/options.inc'

      m2_hvv4fgluon = 0d0
      if (quark(1).eq.0.and.quark(3).eq.0) return

      CF=4d0/3d0

c symmetry factor
      if (fname(1).eq.fname(3)) then
        perm=4
      else
        perm=1
      endif

      diag = 0 !diagonal part (type a)
      nondiag = 0 !non-diagonal part (type b), type c and d are IR safe
      if (qqcd.eq.1.or.qqcd.eq.2.or.qqcd.eq.3) diag = 1
      if (qqcd.eq.1.or.qqcd.eq.2.or.qqcd.eq.4) nondiag = 1

      m2_hvv4fgluon = 0d0
      do i1=-1,1,2
      do i2=-1,1,2
      do i3=-1,1,2
      do i4=-1,1,2
      do i5=-1,1,2
        m1100(i1,i2,i3,i4,i5)=0d0   !charges 1,1,0,0
        m0011(i1,i2,i3,i4,i5)=0d0   !charges 0,0,1,1
        m421001(i1,i2,i3,i4,i5)=0d0 !for matrix element with f2<->f4
        m420110(i1,i2,i3,i4,i5)=0d0 !for matrix element with f2<->f4
      enddo
      enddo
      enddo
      enddo
      enddo

! electric charge set to 1(0)
! has to be re-interchanged (2<->4) because already interchanged
! effectively through f2<->f4
      ch1100(1) = 1
      ch1100(2) = 1
      ch1100(3) = 0
      ch1100(4) = 0
      ch0011(1) = 0
      ch0011(2) = 0
      ch0011(3) = 1
      ch0011(4) = 1
      ch1001(1) = 1
      ch1001(2) = 0
      ch1001(3) = 0
      ch1001(4) = 1
      ch0110(1) = 0
      ch0110(2) = 1
      ch0110(3) = 1
      ch0110(4) = 0

      if(cc.eq.1)then
        if (quark(1).eq.1) call m_hww4fga(m1100,+1,1,2,3,4,ch1100)
        if (quark(3).eq.1) call m_hww4fga(m0011,+1,1,2,3,4,ch0011)
        if(nc.eq.1) then
          call m_hzz4fga(m421001,-1,1,4,3,2,ch1001)
          call m_hzz4fga(m420110,-1,1,4,3,2,ch0110)
        endif
      else
        if (quark(1).eq.1) call m_hzz4fga(m1100,+1,1,2,3,4,ch1100)
        if (quark(3).eq.1) call m_hzz4fga(m0011,+1,1,2,3,4,ch0011)
        if(perm.eq.4) then
          call m_hzz4fga(m421001,-1,1,4,3,2,ch1001)
          call m_hzz4fga(m420110,-1,1,4,3,2,ch0110)
        endif
      endif

c sum over fermion helicities
      do i1=-1,1,2
      do i2=-1,1,2
      do i3=-1,1,2
      do i4=-1,1,2
      do i5=-1,1,2
        if (diag.eq.1) then
          m2_hvv4fgluon = m2_hvv4fgluon +
     &      int((2+pol(1)*i1)/2)*int((2+pol(2)*i2)/2)
     &      *int((2+pol(3)*i3)/2)*int((2+pol(4)*i4)/2)
     &      *int((2+pol(5)*i5)/2)
     &      *( abs(m1100(i1,i2,i3,i4,i5))**2
     &        +abs(m0011(i1,i2,i3,i4,i5))**2
     &        +abs(m421001(i1,i2,i3,i4,i5))**2
     &        +abs(m420110(i1,i2,i3,i4,i5))**2 )
     &      *CF*color/perm *alphas/alpha
        endif
        if (nondiag.eq.1) then
          m2_hvv4fgluon = m2_hvv4fgluon +
     &      int((2+pol(1)*i1)/2)*int((2+pol(2)*i2)/2)
     &      *int((2+pol(3)*i3)/2)*int((2+pol(4)*i4)/2)
     &      *int((2+pol(5)*i5)/2)
     &        *2d0*dreal(( m1100(i1,i2,i3,i4,i5)
     &                    +m0011(i1,i2,i3,i4,i5))
     &            *dconjg( m421001(i1,i2,i3,i4,i5)
     &                    +m420110(i1,i2,i3,i4,i5)))
     &        *CF*dsqrt(dfloat(color))/perm *alphas/alpha
        endif
      enddo
      enddo
      enddo
      enddo
      enddo

      end

**************************************************************
*
*     Born matrix element H->ZZ/WW->4f
*
**************************************************************
      subroutine m_hvv4f(m,sgn,f1,f2,f3,f4,vbos)
      implicit none
      integer i1,i2,i3,i4,f1,f2,f3,f4,vbos,sgn,hel(4)
      complex*16 F(-1:1,-1:1),m(-1:1,-1:1,-1:1,-1:1),pre,propv
      include 'COMMON/param.inc'
c couplings
      complex*16 cvf(-1:1,3,4),cvs(3)
      common/couplings/cvf,cvs
c prods
      complex*16 sp(5,5),csp(5,5)
      real*8 vp(5,5)
      common/prods/sp,csp,vp

      F(+1,+1)=csp(f1,f3)*sp(f2,f4)
      F(+1,-1)=csp(f1,f4)*sp(f2,f3)
      F(-1,-1)=dconjg(F(+1,+1))
      F(-1,+1)=dconjg(F(+1,-1))

      pre=sgn*2d0*cvs(vbos)*propv(vp(f1,f2),vbos)
     &                     *propv(vp(f3,f4),vbos)

c matrix element for different helicities, i1.ne.i2, i3.ne.i4
      do i1=-1,1,2
      i2=-i1
      do i3=-1,1,2
      i4=-i3
      hel(1)=i1
      hel(2)=i2
      hel(3)=i3
      hel(4)=i4
        m(hel(f1),hel(f2),hel(f3),hel(f4)) =
     &     m(hel(f1),hel(f2),hel(f3),hel(f4)) + pre*cvf(i1,vbos,f1)
     &         *cvf(i3,vbos,f3)*F(i1,i3)
      enddo
      enddo

      end

**************************************************************
*
*     Born matrix element H->ZZ->4f+gamma
*
**************************************************************
      subroutine m_hzz4fga(m,sgn,f1,f2,f3,f4,charge)
      implicit none
      integer i,i1,i2,i3,i4,i5,f1,f2,f3,f4,vbos,sgn,cmpl,hel(4)
      real*8 charge(4)
      complex*16 F(-1:1,-1:1,-1:1),m(-1:1,-1:1,-1:1,-1:1,-1:1)
      complex*16 propv,pre,A,pv(4,4,-1:1),pvga(4,4,-1:1)
      include 'COMMON/param.inc'
      include 'COMMON/processpar.inc'
c couplings
      complex*16 cvf(-1:1,3,4),cvs(3)
      common/couplings/cvf,cvs
c prods
      complex*16 sp(5,5),csp(5,5)
      real*8 vp(5,5)
      common/prods/sp,csp,vp

      A(i1,i2,i3,i4,cmpl)=pvga(i1,i2,cmpl)*pv(i3,i4,cmpl)
     &     *sp(i2,i4)*charge(i1)/sp(i1,5)
     &     *(csp(5,i3)-sp(i1,i2)*csp(i1,i3)/sp(i2,5))

      vbos=2  ! vector boson: Z

c propagators should not be complex conjugated because of width
      pv(f1,f2,+1) = propv(vp(f1,f2),vbos)
      pv(f1,f2,-1) = dconjg(pv(f1,f2,+1))
      pv(f3,f4,+1) = propv(vp(f3,f4),vbos)
      pv(f3,f4,-1) = dconjg(pv(f3,f4,+1))
      pvga(f1,f2,+1) = propv(vp(f1,f2)+vp(f1,5)+vp(f2,5),vbos)
      pvga(f1,f2,-1) = dconjg(pvga(f1,f2,+1))
      pvga(f3,f4,+1) = propv(vp(f3,f4)+vp(f3,5)+vp(f4,5),vbos)
      pvga(f3,f4,-1) = dconjg(pvga(f3,f4,+1))

      do i=-1,1,2
        pv(f2,f1,i) = pv(f1,f2,i)
        pv(f4,f3,i) = pv(f3,f4,i)
        pvga(f2,f1,i) = pvga(f1,f2,i)
        pvga(f4,f3,i) = pvga(f3,f4,i)
      enddo

      F(+1,+1,+1) = +A(f1,f2,f3,f4,+1) +A(f3,f4,f1,f2,+1)
      F(+1,+1,-1) = -dconjg(A(f2,f1,f4,f3,-1) +A(f4,f3,f2,f1,-1))
      F(+1,-1,+1) = +A(f1,f2,f4,f3,+1) -A(f4,f3,f1,f2,+1)
      F(-1,+1,+1) = -A(f2,f1,f3,f4,+1) +A(f3,f4,f2,f1,+1)
      F(+1,-1,-1) = dconjg(-A(f2,f1,f3,f4,-1) +A(f3,f4,f2,f1,-1))
      F(-1,+1,-1) = dconjg(+A(f1,f2,f4,f3,-1) -A(f4,f3,f1,f2,-1))
      F(-1,-1,+1) = - (A(f2,f1,f4,f3,+1) +A(f4,f3,f2,f1,+1))
      F(-1,-1,-1) = dconjg(+A(f1,f2,f3,f4,-1) +A(f3,f4,f1,f2,-1))

      pre=-sgn*2d0*dsqrt(2d0)*dsqrt(4d0*pi*alpha)*cvs(vbos)

c matrix element for different helicities, i1.ne.i2, i3.ne.i4
      do i1=-1,1,2
      i2=-i1
      do i3=-1,1,2
      i4=-i3
      do i5=-1,1,2
      hel(1)=i1
      hel(2)=i2
      hel(3)=i3
      hel(4)=i4
        m(hel(f1),hel(f2),hel(f3),hel(f4),i5) =
     &     m(hel(f1),hel(f2),hel(f3),hel(f4),i5) +
     &       pre*cvf(i1,vbos,f1)*cvf(i3,vbos,f3)*F(i1,i3,i5)
      enddo
      enddo
      enddo

      end

**************************************************************
*
*     Born matrix element H->WW->4f+gamma
*
**************************************************************
      subroutine m_hww4fga(m,sgn,f1,f2,f3,f4,charge)
      implicit none
      integer i,i1,i2,i3,i4,i5,f1,f2,f3,f4,vbos,sgn,cmpl,hel(4)
      real*8 charge(4)
      complex*16 F(-1:1,-1:1,-1:1),m(-1:1,-1:1,-1:1,-1:1,-1:1)
      complex*16 propv,pre,A,pv(4,4,-1:1),pvga(4,4,-1:1)
      include 'COMMON/param.inc'
      include 'COMMON/processpar.inc'
c couplings
      complex*16 cvf(-1:1,3,4),cvs(3)
      common/couplings/cvf,cvs
c prods
      complex*16 sp(5,5),csp(5,5)
      real*8 vp(5,5)
      common/prods/sp,csp,vp

      A(i1,i2,i3,i4,cmpl)=pvga(i1,i2,cmpl)*pv(i3,i4,cmpl)*sp(i2,i4)
     &     *(charge(i1)/sp(i1,5)+(charge(i1)-charge(i2))
     &                           *pv(i1,i2,cmpl)*csp(i1,5))
     &     *(csp(5,i3)-sp(i1,i2)*csp(i1,i3)/sp(i2,5))
     &    -1d0/2d0*(charge(i1)-charge(i2))*pv(i1,i2,cmpl)*pv(i3,i4,cmpl)
     &     *csp(i1,i3)*sp(i2,i4)**2/sp(5,i2)/sp(5,i4)

      vbos=3  ! vector boson: W

c propagators should not be complex conjugated because of width
      pv(f1,f2,+1) = propv(vp(f1,f2),vbos)
      pv(f1,f2,-1) = dconjg(pv(f1,f2,+1))
      pv(f3,f4,+1) = propv(vp(f3,f4),vbos)
      pv(f3,f4,-1) = dconjg(pv(f3,f4,+1))
      pvga(f1,f2,+1) = propv(vp(f1,f2)+vp(f1,5)+vp(f2,5),vbos)
      pvga(f1,f2,-1) = dconjg(pvga(f1,f2,+1))
      pvga(f3,f4,+1) = propv(vp(f3,f4)+vp(f3,5)+vp(f4,5),vbos)
      pvga(f3,f4,-1) = dconjg(pvga(f3,f4,+1))

      do i=-1,1,2
        pv(f2,f1,i) = pv(f1,f2,i)
        pv(f4,f3,i) = pv(f3,f4,i)
        pvga(f2,f1,i) = pvga(f1,f2,i)
        pvga(f4,f3,i) = pvga(f3,f4,i)
      enddo

      F(+1,+1,+1) = +A(f1,f2,f3,f4,+1) +A(f3,f4,f1,f2,+1)
      F(+1,+1,-1) = -dconjg(A(f2,f1,f4,f3,-1) +A(f4,f3,f2,f1,-1))
      F(+1,-1,+1) = +A(f1,f2,f4,f3,+1) -A(f4,f3,f1,f2,+1)
      F(-1,+1,+1) = -A(f2,f1,f3,f4,+1) +A(f3,f4,f2,f1,+1)
      F(+1,-1,-1) = dconjg(-A(f2,f1,f3,f4,-1) +A(f3,f4,f2,f1,-1))
      F(-1,+1,-1) = dconjg(+A(f1,f2,f4,f3,-1) -A(f4,f3,f1,f2,-1))
      F(-1,-1,+1) = - (A(f2,f1,f4,f3,+1) +A(f4,f3,f2,f1,+1))
      F(-1,-1,-1) = dconjg(+A(f1,f2,f3,f4,-1) +A(f3,f4,f1,f2,-1))

      pre=-sgn*2d0*dsqrt(2d0)*dsqrt(4d0*pi*alpha)*cvs(vbos)

c matrix element for different helicities, i1.ne.i2, i3.ne.i4
      do i1=-1,1,2
      i2=-i1
      do i3=-1,1,2
      i4=-i3
      do i5=-1,1,2
      hel(1)=i1
      hel(2)=i2
      hel(3)=i3
      hel(4)=i4
        m(hel(f1),hel(f2),hel(f3),hel(f4),i5) =
     &     m(hel(f1),hel(f2),hel(f3),hel(f4),i5) +
     &      pre*cvf(i1,vbos,f1)*cvf(i3,vbos,f3)*F(i1,i3,i5)
      enddo
      enddo
      enddo

      end

************************************************************************
*
*     calculate Weyl products for outgoing particles
*
*     n: number of outgoing particles
************************************************************************
      subroutine setprods(mom,n)
      implicit none
      complex*16 eiph(5)
      real*8 e(5),th(5),re(5),cth2(5),sth2(5),mom(0:3,5),k
      integer n,i,j
c prods
      complex*16 sp(5,5),csp(5,5)
      real*8 vp(5,5)
      common/prods/sp,csp,vp

        do i=1,n
          e(i)    = mom(0,i)
	  re(i)   = dsqrt(e(i))
          k       = dsqrt(mom(1,i)**2+mom(2,i)**2+mom(3,i)**2)
          th(i)   = acos(mom(3,i)/k)
	  cth2(i) = cos(th(i)/2d0)
	  sth2(i) = sin(th(i)/2d0)
          if (abs(sin(th(i))).lt.1d-10) then
            eiph(i) = 1d0
          else
            eiph(i) = dcmplx(mom(1,i),mom(2,i))/k/sin(th(i))
          endif
        enddo

	do i=2,n
	do j=1,i-1
	   sp(i,j) = 2d0*re(i)*re(j)
     &	             *(cth2(i)/eiph(i)*sth2(j)-sth2(i)*cth2(j)/eiph(j))
	  csp(i,j) = dconjg(sp(i,j))
	   vp(i,j) = sp(i,j)*csp(i,j)
	   sp(j,i) = - sp(i,j)
	  csp(j,i) = -csp(i,j)
	   vp(j,i) =   vp(i,j)
        enddo
        enddo

      end

************************************************************************
*
*	Generic gauge-boson propagator
*-----------------------------------------------------------------------
*	general form:  1 / ( p2 - mv(p2) ),
*	gauge bosons:  v = a,z,w,
*	  qprop = 0:  mv(p2) = mv(iv)^2,
*	  qprop = 1:  mv(p2) = mv(iv)^2 - i*mv(iv)*gv(iv),
*	  qprop = 2:  mv(p2) = mv(iv)^2 - i*mv(iv)*gv(iv)*theta(p2),
*	  qprop = 3:  mv(p2) = mv(iv)^2 - i*p2/mv*gv(iv)*theta(p2),
*-----------------------------------------------------------------------
*       25.8.98 Stefan Dittmaier
*
************************************************************************
      function PropV(p2,iv)
      implicit none
      complex*16 PropV
      real*8 p2,theta,x
      integer iv
      include 'COMMON/options.inc'
c boson masses
      real*8 mb(4),mb2(4),gb(4)
      common/bosmass/mb,mb2,gb

	theta(x) = .5d0+sign(.5d0,x)

	if (qprop.eq.0) then
          PropV = 1d0/( p2-mb2(iv) )
          return
	elseif ((qprop.eq.1)) then
          PropV = 1d0/( p2-mb2(iv)+dcmplx(0d0,mb(iv)*gb(iv)))
          return
	elseif (qprop.eq.2) then
          PropV = 1d0/( p2-mb2(iv)+dcmplx(0d0,mb(iv)*gb(iv))*theta(p2) )
          return
	elseif (qprop.eq.3) then
          PropV = 1d0/( p2-mb2(iv)
     &		        +dcmplx(0d0,p2/mb(iv)*gb(iv))*theta(p2) )
          return
        endif

	write(*,*) 'Propagator flag not defined, qprop = ',qprop
	stop

	end
