***********************************************************************
	subroutine xC01234_sing(Q01,Q12,Q20,M02,M12,M22,
     &			  C0,C1,C2,C3,C4,B0,B1,B2,B3,rank,ext)
***********************************************************************
*	3-point tensor coefficients with complex masses
*	--- expansion about vanishing Gram determinant ---
*-----------------------------------------------------------------------
*       18.10.04 Stefan Dittmaier
***********************************************************************
        implicit real*8 (a-z)
        complex*16 K(68),xC0_
        complex*16 M02,M12,M22,F1,F2
        complex*16  B0,   B1(1),   B2(0:2,0:2),   B3(0:2,0:2,2)
        complex*16  B4(0:2,0:2,0:2,0:2),  B5(0:2,0:2,0:2,0:2,2)
        complex*16  B0_1, B1_1(1), B2_1(0:2,0:2), B3_1(0:2,0:2,2)
        complex*16  B4_1(0:2,0:2,0:2,0:2),B5_1(0:2,0:2,0:2,0:2,2)
        complex*16  B0_2, B1_2(1), B2_2(0:2,0:2), B3_2(0:2,0:2,2)
        complex*16  B4_2(0:2,0:2,0:2,0:2),B5_2(0:2,0:2,0:2,0:2,2)
        complex*16  C0, C1(2), C2(0:2,0:2), C3(0:2,0:2,2)
	complex*16  C4(0:2,0:2,0:2,0:2),C5(0:2,0:2,0:2,0:2,2)
	complex*16  C6(0:2,0:2,0:2,0:2,0:2,0:2)
	integer rank,ext,ord,i,j,i1,i2,i3,i4,i5,i6,rankord,ncase

	if (rank.gt.4) then
	  write(*,*) 'rank>4 not implemented in xC01234_sing !',rank
	  stop
	endif

	p12  = q01
	p22  = q20
	p1p2 = (q01+q20-q12)/2d0
	f1   = p12-m12+m02
	f2   = p22-m22+m02

	ref     = (abs(q01)+abs(q12)+abs(q20))/3d0

	if (abs(q01).lt.abs(q20)) then
	  ncase = 1
	  critfa = abs((p12*p22-p1p2**2)/(f2*p1p2-f1*p22))
	  critfb = abs((f2*p1p2-f1*p22)/ref**2)
	else
	  ncase = 2
	  critfa = abs((p12*p22-p1p2**2)/(f2*p12-f1*p1p2))
	  critfb = abs((f2*p12-f1*p1p2)/ref**2)
	endif

c*** critical size of expansion parameter
	crita = 1d-4
	critb = 1d-2

c special case of small "f-determinant"
	if ((critfa.gt.crita).or.(critfb.lt.critb)) then
	  call xC01234_sing2(Q01,Q12,Q20,M02,M12,M22,
     &			  C0,C1,C2,C3,C4,B0,B1,B2,B3,B4,B5,rank,ext)

c*** |q01| < |q20|
	elseif (ncase.eq.1) then

	  call xC01234_singx(Q01,Q12,Q20,M02,M12,M22,
     &			  C0,C1,C2,C3,C4,B0,B1,B2,B3,rank,ext)

c*** |q01| > |q20|
	else

	  call xC01234_singx(Q20,Q12,Q01,M02,M22,M12,
     &			  C0,C1,C2,C3,C4,B0,B1,B2,B3,rank,ext)
	  call Cswap(C0,C1,C2,C3,C4,1,2,rank)

	endif

c*** test output
c	write(*,*)
c	write(*,*) 'args ',Q01,Q12,Q20,M02,M12,M22
c	write(*,*) 'del  ',del/ref
c	write(*,*) 'crit ',abs((q01*q20-p1p2**2)/(f1*p1p2-f2*p12))
c        write(*,*) ' C0          = ',xC0_(Q01,Q12,Q20,M02,M12,M22,0)
c        write(*,*) 'aC0          = ',C0
c        write(*,*) 'aC1(1)       = ',C1(1)
c        write(*,*) 'aC1(2)       = ',C1(2)
c        write(*,*) 'aC2(0,0)     = ',C2(0,0)
c        write(*,*) 'aC2(1,1)     = ',C2(1,1)
c        write(*,*) 'aC2(1,2)     = ',C2(1,2)
c        write(*,*) 'aC2(2,2)     = ',C2(2,2)
c        write(*,*) 'aC3(0,0,1)   = ',C3(0,0,1)
c        write(*,*) 'aC3(0,0,2)   = ',C3(0,0,2)
c        write(*,*) 'aC3(1,1,1)   = ',C3(1,1,1)
c        write(*,*) 'aC3(1,1,2)   = ',C3(1,1,2)
c        write(*,*) 'aC3(1,2,2)   = ',C3(1,2,2)
c        write(*,*) 'aC3(2,2,2)   = ',C3(2,2,2)
c        write(*,*) 'aC4(0,0,0,0) = ',C4(0,0,0,0)
c        write(*,*) 'aC4(0,0,1,1) = ',C4(0,0,1,1)
c        write(*,*) 'aC4(0,0,1,2) = ',C4(0,0,1,2)
c        write(*,*) 'aC4(0,0,2,2) = ',C4(0,0,2,2)
c        write(*,*) 'aC4(1,1,1,1) = ',C4(1,1,1,1)
c        write(*,*) 'aC4(1,1,1,2) = ',C4(1,1,1,2)
c        write(*,*) 'aC4(1,1,2,2) = ',C4(1,1,2,2)
c        write(*,*) 'aC4(1,2,2,2) = ',C4(1,2,2,2)
c        write(*,*) 'aC4(2,2,2,2) = ',C4(2,2,2,2)

	end

***********************************************************************
	subroutine xC01234_singx(Q01,Q12,Q20,M02,M12,M22,
     &			  C0,C1,C2,C3,C4,B0,B1,B2,B3,rank,ext)
***********************************************************************
*	3-point tensor coefficients with complex masses
*	--- expansion about vanishing Gram determinant ---
* 	condition |q20| > 0,|q01|
*-----------------------------------------------------------------------
*       25.11.04 Stefan Dittmaier
***********************************************************************
        implicit real*8 (a-z)
        complex*16 K(68),xC0_
        complex*16 M02,M12,M22,F1,F2
        complex*16  B0,   B1(1),   B2(0:2,0:2),   B3(0:2,0:2,2)
        complex*16  B4(0:2,0:2,0:2,0:2),  B5(0:2,0:2,0:2,0:2,2)
        complex*16  B0_1, B1_1(1), B2_1(0:2,0:2), B3_1(0:2,0:2,2)
        complex*16  B4_1(0:2,0:2,0:2,0:2),B5_1(0:2,0:2,0:2,0:2,2)
        complex*16  B0_2, B1_2(1), B2_2(0:2,0:2), B3_2(0:2,0:2,2)
        complex*16  B4_2(0:2,0:2,0:2,0:2),B5_2(0:2,0:2,0:2,0:2,2)
        complex*16  C0, C1(2), C2(0:2,0:2), C3(0:2,0:2,2)
	complex*16  C4(0:2,0:2,0:2,0:2),C5(0:2,0:2,0:2,0:2,2)
	complex*16  C6(0:2,0:2,0:2,0:2,0:2,0:2)
	complex*16  W0( 1, 1),V0( 1),X0( 1),IW0( 1, 1)
	complex*16  W1( 3, 3),V1( 3),X1( 3),IW1( 3, 3)
	complex*16  W2( 5, 5),V2( 5),X2( 5),IW2( 5, 5)
	complex*16  W3( 8, 8),V3( 8),X3( 8),IW3( 8, 8)
	complex*16  W4(11,11),V4(11),X4(11),IW4(11,11)
	complex*16  W5(15,15),V5(15),X5(15),IW5(15,15)
	integer rank,ext,ord,i,j,i1,i2,i3,i4,i5,i6,rankord

c*** order of expansion
	ord = 2

	rankord = rank+ord

	if ((rank.gt.4).or.(ord.gt.2)) then
	  write(*,*) 'rank>4, ord>2 not implemented in xC01234_sing !',
     &			rank,ord
	  stop
	endif

	p12  = q01
	p22  = q20
	p1p2 = (q01+q20-q12)/2d0
	f1   = p12-m12+m02
	f2   = p22-m22+m02

c*** initialization
	  C0              = 0d0
	  C2(0,0)         = 0d0
	  C4(0,0,0,0)     = 0d0
	  C6(0,0,0,0,0,0) = 0d0
	do 100 i1=1,2
	  C1(i1)         = 0d0
	  C3(0,0,i1)     = 0d0
	  C5(0,0,0,0,i1) = 0d0
	do 100 i2=i1,2
	  C2(i1,i2)         = 0d0
	  C4(0,0,i1,i2)     = 0d0
	  C6(0,0,0,0,i1,i2) = 0d0
	do 100 i3=i2,2
	  C3(i1,i2,i3)     = 0d0
	  C5(0,0,i1,i2,i3) = 0d0
	do 100 i4=i3,2
	  C4(i1,i2,i3,i4)     = 0d0
	  C6(0,0,i1,i2,i3,i4) = 0d0
	do 100 i5=i4,2
	  C5(i1,i2,i3,i4,i5) = 0d0
	do 100 i6=i5,2
	  C6(i1,i2,i3,i4,i5,i6) = 0d0
100	continue

	p12  = p1p2**2/p22
	del  = q01-p12
	f1   = p12-m12+m02

	CALL xB012345_(q12,M22,M12,B0  ,B1  ,B2  ,  B3,  B4,  B5,
     &			rankord,ext)
        CALL xB012345_(q20,M02,M22,B0_1,B1_1,B2_1,B3_1,B4_1,B5_1,
     &			rankord,ext)
        CALL xB012345_(q01,M02,M12,B0_2,B1_2,B2_2,B3_2,B4_2,B5_2,
     &			rankord,ext)

c matrices for sets of linear equations
        K(1) = -(P1P2)+P22
        K(2) = F2*P1P2-DEL*P22-F1*P22

        W0(1,1) = K(2)
	IW0(1,1) = 1d0/W0(1,1)

	if (rankord.eq.0) goto 200

	do i=1,3
	do j=1,3
	  W1(i,j) = 0d0
	enddo
	enddo
        W1(1,1) = (F2)/2D0
        W1(1,2) = (F2*P1P2)/(2D0*P22)
        W1(1,3) = -3D0
        W1(2,1) = K(2)
        W1(2,3) = 2D0*P1P2
        W1(3,2) = K(2)
        W1(3,3) = -(2D0*P22)
	call xinverse(W1,IW1,3)

	if (rankord.eq.1) goto 200

	do i=1,5
	do j=1,5
	  W2(i,j) = 0d0
	enddo
	enddo
        W2(1,1) = (F2)/2D0
        W2(1,2) = (F2*P1P2)/(2D0*P22)
        W2(1,4) = -3D0
        W2(1,5) = (2D0*P1P2)/P22
        W2(2,2) = (F2)/2D0
        W2(2,3) = (F2*P1P2)/(2D0*P22)
        W2(2,5) = -5D0
        W2(3,1) = K(2)
        W2(3,4) = 4D0*P1P2
        W2(4,2) = K(2)
        W2(4,4) = -(2D0*P22)
        W2(4,5) = 2D0*P1P2
        W2(5,3) = K(2)
        W2(5,5) = -(4D0*P22)
	call xinverse(W2,IW2,5)

	if (rankord.eq.2) goto 200

	do i=1,8
	do j=1,8
	  W3(i,j) = 0d0
	enddo
	enddo
        W3(1,5) = -5D0
        W3(1,8) = -(DEL)
        W3(2,1) = (F2)/2D0
        W3(2,2) = (F2*P1P2)/(2D0*P22)
        W3(2,5) = 2D0/P22
        W3(2,6) = -3D0
        W3(2,7) = (4D0*P1P2)/P22
        W3(3,2) = (F2)/2D0
        W3(3,3) = (F2*P1P2)/(2D0*P22)
        W3(3,7) = -5D0
        W3(3,8) = (2D0*P1P2)/P22
        W3(4,3) = (F2)/2D0
        W3(4,4) = (F2*P1P2)/(2D0*P22)
        W3(4,8) = -7D0
        W3(5,1) = K(2)
        W3(5,6) = 6D0*P1P2
        W3(6,2) = K(2)
        W3(6,6) = -(2D0*P22)
        W3(6,7) = 4D0*P1P2
        W3(7,3) = K(2)
        W3(7,7) = -(4D0*P22)
        W3(7,8) = 2D0*P1P2
        W3(8,4) = K(2)
        W3(8,8) = -(6D0*P22)
	call xinverse(W3,IW3,8)

	if (rankord.eq.3) goto 200

	do i=1,11
	do j=1,11
	  W4(i,j) = 0d0
	enddo
	enddo
        W4(1,6) = -5D0
        W4(1,7) = (2D0*P1P2)/P22
        W4(1,10) = -(DEL)
        W4(2,7) = -7D0
        W4(2,11) = -(DEL)
        W4(3,1) = (F2)/2D0
        W4(3,2) = (F2*P1P2)/(2D0*P22)
        W4(3,6) = 6D0/P22
        W4(3,8) = -3D0
        W4(3,9) = (6D0*P1P2)/P22
        W4(4,2) = (F2)/2D0
        W4(4,3) = (F2*P1P2)/(2D0*P22)
        W4(4,7) = 2D0/P22
        W4(4,9) = -5D0
        W4(4,10) = (4D0*P1P2)/P22
        W4(5,3) = (F2)/2D0
        W4(5,4) = (F2*P1P2)/(2D0*P22)
        W4(5,10) = -7D0
        W4(5,11) = (2D0*P1P2)/P22
        W4(6,4) = (F2)/2D0
        W4(6,5) = (F2*P1P2)/(2D0*P22)
        W4(6,11) = -9D0
        W4(7,1) = K(2)
        W4(7,8) = 8D0*P1P2
        W4(8,2) = K(2)
        W4(8,8) = -(2D0*P22)
        W4(8,9) = 6D0*P1P2
        W4(9,3) = K(2)
        W4(9,9) = -(4D0*P22)
        W4(9,10) = 4D0*P1P2
        W4(10,4) = K(2)
        W4(10,10) = -(6D0*P22)
        W4(10,11) = 2D0*P1P2
        W4(11,5) = K(2)
        W4(11,11) = -(8D0*P22)
	call xinverse(W4,IW4,11)

	if (rankord.eq.4) goto 200

	do i=1,15
	do j=1,15
	  W5(i,j) = 0d0
	enddo
	enddo
        W5(1,7) = -7D0
        W5(1,10) = -(DEL)
        W5(2,7) = 2D0/P22
        W5(2,8) = -5D0
        W5(2,9) = (4D0*P1P2)/P22
        W5(2,13) = -(DEL)
        W5(3,9) = -7D0
        W5(3,10) = (2D0*P1P2)/P22
        W5(3,14) = -(DEL)
        W5(4,10) = -9D0
        W5(4,15) = -(DEL)
        W5(5,1) = (F2)/2D0
        W5(5,2) = (F2*P1P2)/(2D0*P22)
        W5(5,8) = 12D0/P22
        W5(5,11) = -3D0
        W5(5,12) = (8D0*P1P2)/P22
        W5(6,2) = (F2)/2D0
        W5(6,3) = (F2*P1P2)/(2D0*P22)
        W5(6,9) = 6D0/P22
        W5(6,12) = -5D0
        W5(6,13) = (6D0*P1P2)/P22
        W5(7,3) = (F2)/2D0
        W5(7,4) = (F2*P1P2)/(2D0*P22)
        W5(7,10) = 2D0/P22
        W5(7,13) = -7D0
        W5(7,14) = (4D0*P1P2)/P22
        W5(8,4) = (F2)/2D0
        W5(8,5) = (F2*P1P2)/(2D0*P22)
        W5(8,14) = -9D0
        W5(8,15) = (2D0*P1P2)/P22
        W5(9,5) = (F2)/2D0
        W5(9,6) = (F2*P1P2)/(2D0*P22)
        W5(9,15) = -11D0
        W5(10,1) = K(2)
        W5(10,11) = 10D0*P1P2
        W5(11,2) = K(2)
        W5(11,11) = -(2D0*P22)
        W5(11,12) = 8D0*P1P2
        W5(12,3) = K(2)
        W5(12,12) = -(4D0*P22)
        W5(12,13) = 6D0*P1P2
        W5(13,4) = K(2)
        W5(13,13) = -(6D0*P22)
        W5(13,14) = 4D0*P1P2
        W5(14,5) = K(2)
        W5(14,14) = -(8D0*P22)
        W5(14,15) = 2D0*P1P2
        W5(15,6) = K(2)
        W5(15,15) = -(10D0*P22)
	call xinverse(W5,IW5,15)

200	continue

	i1=0
201	continue
	if (i1.gt.ord) goto 250

        V0(1) = K(1)*B0+B0_2*P1P2-B0_1*P22+2D0*C1(1)*DEL*P22
	X0(1) = IW0(1,1)*V0(1)
        C0 = X0(1)

	if (rankord-i1.eq.0) goto 202

        V1(1) = -(1D0/2D0)-(B0)/2D0+C2(1,1)*DEL-C0*M02+(B1(1)*K(1))/
     &  (2D0*P22)+(B1_2(1)*P1P2)/(2D0*P22)
        V1(2) = -(B1(1)*K(1))-K(1)*B0-B1_1(1)*P22+2D0*C2(1,2)*DEL*
     &  P22
        V1(3) = B1(1)*K(1)+B1_2(1)*P1P2+2D0*C2(1,1)*DEL*P22
	do i=1,3
	  X1(i) = 0d0
	do j=1,3
	  X1(i) = X1(i) + IW1(i,j)*V1(j)
	enddo
	enddo
        C1(2) = X1(1)
        C1(1) = X1(2)
        C2(0,0) = X1(3)

	if (rankord-i1.eq.1) goto 202

        V2(1) = 1D0/6D0+(B0)/2D0+C3(1,1,2)*DEL-C1(2)*M02-(B2(0,0))/
     &  (2D0*P22)+(B2_2(0,0))/(2D0*P22)-(B2(1,1)*K(1))/(2D0*P22)-
     &  (C2(0,0)*F2)/(2D0*P22)+(B1(1)*P1P2)/(2D0*P22)
        V2(2) = 1D0/6D0-(B1(1))/2D0+C3(1,1,1)*DEL-C1(1)*M02+(B2(1,
     &  1)*K(1))/(2D0*P22)+(B2_2(1,1)*P1P2)/(2D0*P22)
        V2(3) = 2D0*B1(1)*K(1)+B2(1,1)*K(1)+K(1)*B0-B2_1(1,1)*P22+
     &  2D0*C3(1,2,2)*DEL*P22
        V2(4) = -(B1(1)*K(1))-B2(1,1)*K(1)+2D0*C3(1,1,2)*DEL*P22
        V2(5) = B2(1,1)*K(1)+B2_2(1,1)*P1P2+2D0*C3(1,1,1)*DEL*P22
	do i=1,5
	  X2(i) = 0d0
	do j=1,5
	  X2(i) = X2(i) + IW2(i,j)*V2(j)
	enddo
	enddo
        C2(2,2) = X2(1)
        C2(1,2) = X2(2)
        C2(1,1) = X2(3)
        C3(0,0,2) = X2(4)
        C3(0,0,1) = X2(5)

	if (rankord-i1.eq.2) goto 202

        V3(1) = -((B2(0,0))/2D0)-(C3(0,0,2)*F2)/2D0-C2(0,0)*M02+
     &  (B3(0,0,1)*K(1))/(2D0*P22)+(B3_2(0,0,1)*P1P2)/(2D0*P22)-
     &  (C3(0,0,1)*F2*P1P2)/(2D0*P22)+((P1P2**2+DEL*P22-2D0*M02*P22-
     &  2D0*M12*P22-2D0*M22*P22-P1P2*P22+P22**2))/(24D0*P22)
        V3(2) = -(1D0/12D0)-(B0)/2D0+C4(1,1,2,2)*DEL-C2(2,2)*M02+
     &  B2(0,0)/P22+B3(0,0,1)/P22+(B3(1,1,1)*K(1))/(2D0*P22)-(C3(0,
     &  0,2)*F2)/P22-(B1(1)*(P1P2+P22))/(2D0*P22)+(B2(1,1)*(-(2D0*
     &  P1P2)+P22))/(2D0*P22)
        V3(3) = -(1D0/24D0)+(B1(1))/2D0+C4(1,1,1,2)*DEL-C2(1,2)*M02-
     &  (B3(0,0,1))/(2D0*P22)+(B3_2(0,0,1))/(2D0*P22)-(B3(1,1,1)*
     &  K(1))/(2D0*P22)-(C3(0,0,1)*F2)/(2D0*P22)+(B2(1,1)*P1P2)/
     &  (2D0*P22)
        V3(4) = -(1D0/12D0)-(B2(1,1))/2D0+C4(1,1,1,1)*DEL-C2(1,1)*
     &  M02+(B3(1,1,1)*K(1))/(2D0*P22)+(B3_2(1,1,1)*P1P2)/(2D0*P22)
        V3(5) = -(3D0*B1(1)*K(1))-3D0*B2(1,1)*K(1)-B3(1,1,1)*K(1)-
     &  K(1)*B0-B3_1(1,1,1)*P22+2D0*C4(1,2,2,2)*DEL*P22
        V3(6) = B1(1)*K(1)+2D0*B2(1,1)*K(1)+B3(1,1,1)*K(1)+2D0*C4(1,
     &  1,2,2)*DEL*P22
        V3(7) = -(B2(1,1)*K(1))-B3(1,1,1)*K(1)+2D0*C4(1,1,1,2)*DEL*
     &  P22
        V3(8) = B3(1,1,1)*K(1)+B3_2(1,1,1)*P1P2+2D0*C4(1,1,1,1)*DEL*
     &  P22
	do i=1,8
	  X3(i) = 0d0
	do j=1,8
	  X3(i) = X3(i) + IW3(i,j)*V3(j)
	enddo
	enddo
        C3(2,2,2) = X3(1)
        C3(1,2,2) = X3(2)
        C3(1,1,2) = X3(3)
        C3(1,1,1) = X3(4)
        C4(0,0,0,0) = X3(5)
        C4(0,0,2,2) = X3(6)
        C4(0,0,1,2) = X3(7)
        C4(0,0,1,1) = X3(8)

	if (rankord-i1.eq.3) goto 202

        V4(1) = (B2(0,0))/2D0-(C4(0,0,2,2)*F2)/2D0-C3(0,0,2)*M02-
     &  (B4(0,0,0,0))/(2D0*P22)+(B4_2(0,0,0,0))/(2D0*P22)-(B4(0,0,1,
     &  1)*K(1))/(2D0*P22)-(C4(0,0,0,0)*F2)/(2D0*P22)+(B3(0,0,1)*
     &  P1P2)/(2D0*P22)-(C4(0,0,1,2)*F2*P1P2)/(2D0*P22)-((3D0*P1P2**
     &  2+3D0*DEL*P22-5D0*M02*P22-5D0*M12*P22-10D0*M22*P22-4D0*P1P2*
     &  P22+4D0*P22**2))/(240D0*P22)
        V4(2) = -((B3(0,0,1))/2D0)-(C4(0,0,1,2)*F2)/2D0-C3(0,0,1)*
     &  M02+(B4(0,0,1,1)*K(1))/(2D0*P22)+(B4_2(0,0,1,1)*P1P2)/(2D0*
     &  P22)-(C4(0,0,1,1)*F2*P1P2)/(2D0*P22)-((4D0*P1P2**2+4D0*DEL*
     &  P22-5D0*M02*P22-10D0*M12*P22-5D0*M22*P22-4D0*P1P2*P22+3D0*
     &  P22**2))/(240D0*P22)
        V4(3) = 1D0/20D0+(B0)/2D0+C5(1,1,2,2,2)*DEL-C3(2,2,2)*M02-
     &  (3D0*B2(0,0))/(2D0*P22)-(3D0*B3(0,0,1))/P22-(3D0*B4(0,0,1,
     &  1))/(2D0*P22)-(B4(1,1,1,1)*K(1))/(2D0*P22)-(3D0*C4(0,0,2,2)*
     &  F2)/(2D0*P22)+(3D0*B2(1,1)*P1P2)/(2D0*P22)+(B1(1)*(P1P2+2D0*
     &  P22))/(2D0*P22)-(B3(1,1,1)*(-(3D0*P1P2)+2D0*P22))/(2D0*P22)
        V4(4) = 1D0/60D0-(B1(1))/2D0+C5(1,1,1,2,2)*DEL-C3(1,2,2)*
     &  M02+B3(0,0,1)/P22+B4(0,0,1,1)/P22+(B4(1,1,1,1)*K(1))/(2D0*
     &  P22)-(C4(0,0,1,2)*F2)/P22-(B2(1,1)*(P1P2+P22))/(2D0*P22)+
     &  (B3(1,1,1)*(-(2D0*P1P2)+P22))/(2D0*P22)
        V4(5) = 1D0/60D0+(B2(1,1))/2D0+C5(1,1,1,1,2)*DEL-C3(1,1,2)*
     &  M02-(B4(0,0,1,1))/(2D0*P22)+(B4_2(0,0,1,1))/(2D0*P22)-(B4(1,
     &  1,1,1)*K(1))/(2D0*P22)-(C4(0,0,1,1)*F2)/(2D0*P22)+(B3(1,1,
     &  1)*P1P2)/(2D0*P22)
        V4(6) = 1D0/20D0-(B3(1,1,1))/2D0+C5(1,1,1,1,1)*DEL-C3(1,1,
     &  1)*M02+(B4(1,1,1,1)*K(1))/(2D0*P22)+(B4_2(1,1,1,1)*P1P2)/
     &  (2D0*P22)
        V4(7) = 4D0*B1(1)*K(1)+6D0*B2(1,1)*K(1)+4D0*B3(1,1,1)*K(1)+
     &  B4(1,1,1,1)*K(1)+K(1)*B0-B4_1(1,1,1,1)*P22+2D0*C5(1,2,2,2,
     &  2)*DEL*P22
        V4(8) = -(B1(1)*K(1))-3D0*B2(1,1)*K(1)-3D0*B3(1,1,1)*K(1)-
     &  B4(1,1,1,1)*K(1)+2D0*C5(1,1,2,2,2)*DEL*P22
        V4(9) = B2(1,1)*K(1)+2D0*B3(1,1,1)*K(1)+B4(1,1,1,1)*K(1)+
     &  2D0*C5(1,1,1,2,2)*DEL*P22
        V4(10) = -(B3(1,1,1)*K(1))-B4(1,1,1,1)*K(1)+2D0*C5(1,1,1,1,
     &  2)*DEL*P22
        V4(11) = B4(1,1,1,1)*K(1)+B4_2(1,1,1,1)*P1P2+2D0*C5(1,1,1,1,
     &  1)*DEL*P22
	do i=1,11
	  X4(i) = 0d0
	do j=1,11
	  X4(i) = X4(i) + IW4(i,j)*V4(j)
	enddo
	enddo
        C4(2,2,2,2) = X4(1)
        C4(1,2,2,2) = X4(2)
        C4(1,1,2,2) = X4(3)
        C4(1,1,1,2) = X4(4)
        C4(1,1,1,1) = X4(5)
        C5(0,0,0,0,2) = X4(6)
        C5(0,0,0,0,1) = X4(7)
        C5(0,0,2,2,2) = X4(8)
        C5(0,0,1,2,2) = X4(9)
        C5(0,0,1,1,2) = X4(10)
        C5(0,0,1,1,1) = X4(11)

	if (rankord-i1.eq.4) goto 202

        V5(1) = -((B4(0,0,0,0))/2D0)-(C5(0,0,0,0,2)*F2)/2D0-C4(0,0,
     &  0,0)*M02+(B5(0,0,0,0,1)*K(1))/(2D0*P22)+(B5_2(0,0,0,0,1)*
     &  P1P2)/(2D0*P22)-(C5(0,0,0,0,1)*F2*P1P2)/(2D0*P22)-(P22**(-
     &  2)*(3D0*P1P2**4+6D0*DEL*P1P2**2*P22-9D0*M02*P1P2**2*P22-
     &  12D0*M12*P1P2**2*P22-9D0*M22*P1P2**2*P22-6D0*P1P2**3*P22+
     &  3D0*DEL**2*P22**2-9D0*DEL*M02*P22**2+15D0*M02**2*P22**2-
     &  12D0*DEL*M12*P22**2+15D0*M02*M12*P22**2+15D0*M12**2*P22**2-
     &  9D0*DEL*M22*P22**2+15D0*M02*M22*P22**2+15D0*M12*M22*P22**2+
     &  15D0*M22**2*P22**2-6D0*DEL*P1P2*P22**2+6D0*M02*P1P2*P22**2+
     &  12D0*M12*P1P2*P22**2+12D0*M22*P1P2*P22**2+9D0*P1P2**2*P22**
     &  2+5D0*DEL*P22**3-9D0*M02*P22**3-9D0*M12*P22**3-12D0*M22*
     &  P22**3-6D0*P1P2*P22**3+3D0*P22**4))/1440D0
        V5(2) = -((B2(0,0))/2D0)-(C5(0,0,2,2,2)*F2)/2D0-C4(0,0,2,2)*
     &  M02+B4(0,0,0,0)/P22+B5(0,0,0,0,1)/P22+(B5(0,0,1,1,1)*K(1))/
     &  (2D0*P22)-(C5(0,0,0,0,2)*F2)/P22-(C5(0,0,1,2,2)*F2*P1P2)/
     &  (2D0*P22)-(B3(0,0,1)*(P1P2+P22))/(2D0*P22)+(B4(0,0,1,1)*(-
     &  (2D0*P1P2)+P22))/(2D0*P22)+((2D0*P1P2**2+2D0*DEL*P22-3D0*
     &  M02*P22-3D0*M12*P22-9D0*M22*P22-3D0*P1P2*P22+3D0*P22**2))/
     &  (360D0*P22)
        V5(3) = (B3(0,0,1))/2D0-(C5(0,0,1,2,2)*F2)/2D0-C4(0,0,1,2)*
     &  M02-(B5(0,0,0,0,1))/(2D0*P22)+(B5_2(0,0,0,0,1))/(2D0*P22)-
     &  (B5(0,0,1,1,1)*K(1))/(2D0*P22)-(C5(0,0,0,0,1)*F2)/(2D0*P22)+
     &  (B4(0,0,1,1)*P1P2)/(2D0*P22)-(C5(0,0,1,1,2)*F2*P1P2)/(2D0*
     &  P22)+((3D0*P1P2**2+3D0*DEL*P22-3D0*M02*P22-6D0*M12*P22-6D0*
     &  M22*P22-4D0*P1P2*P22+3D0*P22**2))/(720D0*P22)
        V5(4) = -((B4(0,0,1,1))/2D0)-(C5(0,0,1,1,2)*F2)/2D0-C4(0,0,
     &  1,1)*M02+(B5(0,0,1,1,1)*K(1))/(2D0*P22)+(B5_2(0,0,1,1,1)*
     &  P1P2)/(2D0*P22)-(C5(0,0,1,1,1)*F2*P1P2)/(2D0*P22)+((3D0*
     &  P1P2**2+3D0*DEL*P22-3D0*M02*P22-9D0*M12*P22-3D0*M22*P22-3D0*
     &  P1P2*P22+2D0*P22**2))/(360D0*P22)
        V5(5) = -(1D0/30D0)-(B0)/2D0+C6(1,1,2,2,2,2)*DEL-C4(2,2,2,
     &  2)*M02+(2D0*B2(0,0))/P22+(6D0*B3(0,0,1))/P22+(6D0*B4(0,0,1,
     &  1))/P22+(2D0*B5(0,0,1,1,1))/P22+(B5(1,1,1,1,1)*K(1))/(2D0*
     &  P22)-(2D0*C5(0,0,2,2,2)*F2)/P22-(B2(1,1)*(2D0*P1P2+P22))/
     &  P22+(B3(1,1,1)*(-(3D0*P1P2)+P22))/P22-(B1(1)*(P1P2+3D0*
     &  P22))/(2D0*P22)+(B4(1,1,1,1)*(-(4D0*P1P2)+3D0*P22))/(2D0*
     &  P22)
        V5(6) = -(1D0/120D0)+(B1(1))/2D0+C6(1,1,1,2,2,2)*DEL-C4(1,2,
     &  2,2)*M02-(3D0*B3(0,0,1))/(2D0*P22)-(3D0*B4(0,0,1,1))/P22-
     &  (3D0*B5(0,0,1,1,1))/(2D0*P22)-(B5(1,1,1,1,1)*K(1))/(2D0*
     &  P22)-(3D0*C5(0,0,1,2,2)*F2)/(2D0*P22)+(3D0*B3(1,1,1)*P1P2)/
     &  (2D0*P22)+(B2(1,1)*(P1P2+2D0*P22))/(2D0*P22)-(B4(1,1,1,1)*(-
     &  (3D0*P1P2)+2D0*P22))/(2D0*P22)
        V5(7) = -(1D0/180D0)-(B2(1,1))/2D0+C6(1,1,1,1,2,2)*DEL-C4(1,
     &  1,2,2)*M02+B4(0,0,1,1)/P22+B5(0,0,1,1,1)/P22+(B5(1,1,1,1,1)*
     &  K(1))/(2D0*P22)-(C5(0,0,1,1,2)*F2)/P22-(B3(1,1,1)*(P1P2+
     &  P22))/(2D0*P22)+(B4(1,1,1,1)*(-(2D0*P1P2)+P22))/(2D0*P22)
        V5(8) = -(1D0/120D0)+(B3(1,1,1))/2D0+C6(1,1,1,1,1,2)*DEL-
     &  C4(1,1,1,2)*M02-(B5(0,0,1,1,1))/(2D0*P22)+(B5_2(0,0,1,1,1))/
     &  (2D0*P22)-(B5(1,1,1,1,1)*K(1))/(2D0*P22)-(C5(0,0,1,1,1)*F2)/
     &  (2D0*P22)+(B4(1,1,1,1)*P1P2)/(2D0*P22)
        V5(9) = -(1D0/30D0)-(B4(1,1,1,1))/2D0+C6(1,1,1,1,1,1)*DEL-
     &  C4(1,1,1,1)*M02+(B5(1,1,1,1,1)*K(1))/(2D0*P22)+(B5_2(1,1,1,
     &  1,1)*P1P2)/(2D0*P22)
        V5(10) = -(5D0*B1(1)*K(1))-10D0*B2(1,1)*K(1)-10D0*B3(1,1,1)*
     &  K(1)-5D0*B4(1,1,1,1)*K(1)-B5(1,1,1,1,1)*K(1)-K(1)*B0-B5_1(1,
     &  1,1,1,1)*P22+2D0*C6(1,2,2,2,2,2)*DEL*P22
        V5(11) = B1(1)*K(1)+4D0*B2(1,1)*K(1)+6D0*B3(1,1,1)*K(1)+4D0*
     &  B4(1,1,1,1)*K(1)+B5(1,1,1,1,1)*K(1)+2D0*C6(1,1,2,2,2,2)*DEL*
     &  P22
        V5(12) = -(B2(1,1)*K(1))-3D0*B3(1,1,1)*K(1)-3D0*B4(1,1,1,1)*
     &  K(1)-B5(1,1,1,1,1)*K(1)+2D0*C6(1,1,1,2,2,2)*DEL*P22
        V5(13) = B3(1,1,1)*K(1)+2D0*B4(1,1,1,1)*K(1)+B5(1,1,1,1,1)*
     &  K(1)+2D0*C6(1,1,1,1,2,2)*DEL*P22
        V5(14) = -(B4(1,1,1,1)*K(1))-B5(1,1,1,1,1)*K(1)+2D0*C6(1,1,
     &  1,1,1,2)*DEL*P22
        V5(15) = B5(1,1,1,1,1)*K(1)+B5_2(1,1,1,1,1)*P1P2+2D0*C6(1,1,
     &  1,1,1,1)*DEL*P22
	do i=1,15
	  X5(i) = 0d0
	do j=1,15
	  X5(i) = X5(i) + IW5(i,j)*V5(j)
	enddo
	enddo
        C5(2,2,2,2,2) = X5(1)
        C5(1,2,2,2,2) = X5(2)
        C5(1,1,2,2,2) = X5(3)
        C5(1,1,1,2,2) = X5(4)
        C5(1,1,1,1,2) = X5(5)
        C5(1,1,1,1,1) = X5(6)
        C6(0,0,0,0,0,0) = X5(7)
        C6(0,0,0,0,2,2) = X5(8)
        C6(0,0,0,0,1,2) = X5(9)
        C6(0,0,0,0,1,1) = X5(10)
        C6(0,0,2,2,2,2) = X5(11)
        C6(0,0,1,2,2,2) = X5(12)
        C6(0,0,1,1,2,2) = X5(13)
        C6(0,0,1,1,1,2) = X5(14)
        C6(0,0,1,1,1,1) = X5(15)

202	continue
	i1=i1+1
	goto 201
250	continue

c*** remaining non-ordered coefficients up to rank 4
        C2(2,1) = C2(1,2)
        C3(2,1,1) = C3(1,1,2)
        C3(1,2,1) = C3(1,1,2)
        C3(2,1,2) = C3(1,2,2)
        C3(2,2,1) = C3(1,2,2)
        C4(0,0,2,1) = C4(0,0,1,2)
        C4(2,1,1,1) = C4(1,1,1,2)
        C4(1,2,1,1) = C4(1,1,1,2)
        C4(1,1,2,1) = C4(1,1,1,2)
        C4(2,2,1,1) = C4(1,1,2,2)
        C4(2,1,2,1) = C4(1,1,2,2)
        C4(2,1,1,2) = C4(1,1,2,2)
        C4(1,2,2,1) = C4(1,1,2,2)
        C4(1,2,1,2) = C4(1,1,2,2)
        C4(2,2,2,1) = C4(1,2,2,2)
        C4(2,2,1,2) = C4(1,2,2,2)
        C4(2,1,2,2) = C4(1,2,2,2)

	end

***********************************************************************
	subroutine xC01234_sing2(Q01,Q12,Q20,M02,M12,M22,
     &			  C0,C1,C2,C3,C4,B0,B1,B2,B3,B4,B5,rank,ext)
***********************************************************************
*	3-point tensor coefficients with complex masses
*	--- expansion about vanishing Gram determinant
*	    and about vanishing Cayley determinant ---
*-----------------------------------------------------------------------
*       11.11.04 Stefan Dittmaier
***********************************************************************
        implicit real*8 (a-z)
        complex*16 K(68)
        complex*16 M02,M12,M22,F1,F2,delf,xC0_
        complex*16  B0,   B1(1),   B2(0:2,0:2),   B3(0:2,0:2,2)
        complex*16  B4(0:2,0:2,0:2,0:2),  B5(0:2,0:2,0:2,0:2,2)
        complex*16  C0, C1(2), C2(0:2,0:2), C3(0:2,0:2,2)
	complex*16  C4(0:2,0:2,0:2,0:2),C5(0:2,0:2,0:2,0:2,2)
	complex*16  C6(0:2,0:2,0:2,0:2,0:2,0:2)
	integer rank,ext,ord,i,j,i1,i2,i3,i4,i5,i6,rankord

	if (rank.gt.4) then
	  write(*,*) 'rank>4 not implemented in xC01234_sing2 !',rank
	  stop
	endif

	p12  = q01
	p22  = q20
	p1p2 = (q01+q20-q12)/2d0
	f1   = p12-m12+m02
	f2   = p22-m22+m02

c*** |q01| < |q20|
	if (abs(q01).lt.abs(q20)) then

	  call xC01234_sing2x(Q01,Q12,Q20,M02,M12,M22,
     &			  C0,C1,C2,C3,C4,B0,B1,B2,B3,B4,B5,rank,ext)

c*** |q01| > |q20|
	else

	  call xC01234_sing2x(Q20,Q12,Q01,M02,M22,M12,
     &			  C0,C1,C2,C3,C4,B0,B1,B2,B3,B4,B5,rank,ext)
	  call Cswap(C0,C1,C2,C3,C4,1,2,rank)

	endif

c*** test output
c	write(*,*)
c	write(*,*) 'args ',Q01,Q12,Q20,M02,M12,M22
c	write(*,*) 'del/ref  ',del/ref
c	write(*,*) 'delf/ref ',delf/ref
c	write(*,*) 'p12  ',p12
c	write(*,*) 'p22  ',p22
c	write(*,*) 'p1p2 ',p1p2
c	write(*,*) 'f1   ',f1,p12-m12+m02
c	write(*,*) 'f2   ',f2,p22-m22+m02
c        write(*,*) 'f1mp ',(-(F1**2)+4D0*M02*P12)/ref**2
c        write(*,*) 'f2mp ',(-(F2**2)+4D0*M02*P22)/ref**2
c        write(*,*) 'rank,ord: ',rank,ord
c        write(*,*) '  C0          = ',xC0_(Q01,Q12,Q20,M02,M12,M22,0)
c        write(*,*) 'aaC0          = ',C0
c        write(*,*) 'aaC1(1)       = ',C1(1)
c        write(*,*) 'aaC1(2)       = ',C1(2)
c        write(*,*) 'aaC2(0,0)     = ',C2(0,0)
c        write(*,*) 'aaC2(1,1)     = ',C2(1,1)
c        write(*,*) 'aaC2(1,2)     = ',C2(1,2)
c        write(*,*) 'aaC2(2,2)     = ',C2(2,2)
c        write(*,*) 'aaC3(0,0,1)   = ',C3(0,0,1)
c        write(*,*) 'aaC3(0,0,2)   = ',C3(0,0,2)
c        write(*,*) 'aaC3(1,1,1)   = ',C3(1,1,1)
c        write(*,*) 'aaC3(1,1,2)   = ',C3(1,1,2)
c        write(*,*) 'aaC3(1,2,2)   = ',C3(1,2,2)
c        write(*,*) 'aaC3(2,2,2)   = ',C3(2,2,2)
c        write(*,*) 'aaC4(0,0,0,0) = ',C4(0,0,0,0)
c        write(*,*) 'aaC4(0,0,1,1) = ',C4(0,0,1,1)
c        write(*,*) 'aaC4(0,0,1,2) = ',C4(0,0,1,2)
c        write(*,*) 'aaC4(0,0,2,2) = ',C4(0,0,2,2)
c
c        write(*,*) 'aaC4(1,1,1,1) = ',C4(1,1,1,1)
c        write(*,*) 'aaC4(1,1,1,2) = ',C4(1,1,1,2)
c        write(*,*) 'aaC4(1,1,2,2) = ',C4(1,1,2,2)
c        write(*,*) 'aaC4(1,2,2,2) = ',C4(1,2,2,2)
c        write(*,*) 'aaC4(2,2,2,2) = ',C4(2,2,2,2)

	end

***********************************************************************
	subroutine xC01234_sing2x(Q01,Q12,Q20,M02,M12,M22,
     &			  C0,C1,C2,C3,C4,B0,B1,B2,B3,B4,B5,rank,ext)
***********************************************************************
*	3-point tensor coefficients with complex masses
*	--- expansion about vanishing Gram determinant
*	    and about vanishing Cayley determinant ---
* 	condition |q20| > 0,|q01|
*-----------------------------------------------------------------------
*       26.11.04 Stefan Dittmaier
***********************************************************************
        implicit real*8 (a-z)
        complex*16 K(68)
        complex*16 M02,M12,M22,F1,F2,delf,xC0_
        complex*16  B0,   B1(1),   B2(0:2,0:2),   B3(0:2,0:2,2)
        complex*16  B4(0:2,0:2,0:2,0:2),  B5(0:2,0:2,0:2,0:2,2)
        complex*16  B0_1, B1_1(1), B2_1(0:2,0:2), B3_1(0:2,0:2,2)
        complex*16  B4_1(0:2,0:2,0:2,0:2),B5_1(0:2,0:2,0:2,0:2,2)
        complex*16  B0_2, B1_2(1), B2_2(0:2,0:2), B3_2(0:2,0:2,2)
        complex*16  B4_2(0:2,0:2,0:2,0:2),B5_2(0:2,0:2,0:2,0:2,2)
        complex*16  C0, C1(2), C2(0:2,0:2), C3(0:2,0:2,2)
	complex*16  C4(0:2,0:2,0:2,0:2),C5(0:2,0:2,0:2,0:2,2)
	complex*16  C6(0:2,0:2,0:2,0:2,0:2,0:2)
	complex*16  W0( 2, 2),V0( 2),X0( 2),IW0( 2, 2)
	complex*16  W1( 4, 4),V1( 4),X1( 4),IW1( 4, 4)
	complex*16  W2( 7, 7),V2( 7),X2( 7),IW2( 7, 7)
	complex*16  W3(10,10),V3(10),X3(10),IW3(10,10)
	complex*16  W4(14,14),V4(14),X4(14),IW4(14,14)
	integer rank,ext,ord,i,j,i1,i2,i3,i4,i5,i6,rankord

        common/Bsub/B0_1,B1_1,B2_1,B3_1,B4_1,B5_1,
     &              B0_2,B1_2,B2_2,B3_2,B4_2,B5_2

c*** order of expansion
	ord = 0

	rankord = rank+2*ord

c	if ((rank.gt.4).or.(ord.gt.1)) then
c	  write(*,*) 'rank>4, ord>1 not implemented in xC01234_sing2 !',
c     &			rank,ord
c	  stop
c	endif

c*** initialization
	  C0              = 0d0
	  C2(0,0)         = 0d0
	  C4(0,0,0,0)     = 0d0
	  C6(0,0,0,0,0,0) = 0d0
	do 100 i1=1,2
	  C1(i1)         = 0d0
	  C3(0,0,i1)     = 0d0
	  C5(0,0,0,0,i1) = 0d0
	do 100 i2=i1,2
	  C2(i1,i2)         = 0d0
	  C4(0,0,i1,i2)     = 0d0
	  C6(0,0,0,0,i1,i2) = 0d0
	do 100 i3=i2,2
	  C3(i1,i2,i3)     = 0d0
	  C5(0,0,i1,i2,i3) = 0d0
	do 100 i4=i3,2
	  C4(i1,i2,i3,i4)     = 0d0
	  C6(0,0,i1,i2,i3,i4) = 0d0
	do 100 i5=i4,2
	  C5(i1,i2,i3,i4,i5) = 0d0
	do 100 i6=i5,2
	  C6(i1,i2,i3,i4,i5,i6) = 0d0
100	continue

	p12  = q01
	p22  = q20
	p1p2 = (q01+q20-q12)/2d0
	f1   = p12-m12+m02
	f2   = p22-m22+m02

	ref  = (abs(q01)+abs(q12)+abs(q20))/3d0

	p12  = p1p2**2/p22
	del  = q01-p12
	f1   = f2*p1p2/p22
	delf = p12-m12+m02-f1

c	CALL xB012345_(q12,M22,M12,B0  ,B1  ,B2  ,  B3,  B4,  B5,
c     &			rank+ord+1,ext)
c        CALL xB012345_(q20,M02,M22,B0_1,B1_1,B2_1,B3_1,B4_1,B5_1,
c     &			rank+ord+1,ext)
c        CALL xB012345_(q01,M02,M12,B0_2,B1_2,B2_2,B3_2,B4_2,B5_2,
c     &			rank+ord+1,ext)

c matrices for sets of linear equations
        K(1) = DEL+DELF
        K(2) = F2-2D0*P1P2
        K(3) = F2-2D0*P22
        K(4) = -(F2**2)+4D0*M02*P22
        K(5) = -(P1P2)+P22
        K(6) = F2-4D0*P1P2+2D0*P22
        K(7) = F2-P1P2-P22
        K(8) = DEL*F2-DEL*P1P2-DELF*P1P2
        K(9) = F2*P1P2+DEL*P22+DELF*P22
        K(10) = F2*P1P2+DEL*P22+DELF*P22-F2*P22

	do i=1,2
	do j=1,2
	  W0(i,j) = 0d0
	enddo
	enddo
        W0(1,1) = (K(4))/(4D0*P22)
        W0(1,2) = -3D0
        W0(2,2) = 2D0*F2
	call xinverse(W0,IW0,2)

	if (rankord.le.0) goto 302

	do i=1,4
	do j=1,4
	  W1(i,j) = 0d0
	enddo
	enddo
        W1(1,1) = (K(4))/(4D0*P22)
        W1(1,3) = -3D0
        W1(1,4) = (2D0*P1P2)/P22
        W1(2,2) = (K(4))/(4D0*P22)
        W1(2,4) = -5D0
        W1(3,3) = 2D0*F2
        W1(3,4) = -((2D0*K(9))/P22)
        W1(4,4) = 4D0*F2
	call xinverse(W1,IW1,4)

	if (rankord.le.1) goto 300

	do i=1,7
	do j=1,7
	  W2(i,j) = 0d0
	enddo
	enddo
        W2(1,4) = -5D0
        W2(1,7) = -(DEL)
        W2(2,1) = (K(4))/(4D0*P22)
        W2(2,4) = 2D0/P22
        W2(2,5) = -3D0
        W2(2,6) = (4D0*P1P2)/P22
        W2(3,2) = (K(4))/(4D0*P22)
        W2(3,6) = -5D0
        W2(3,7) = (2D0*P1P2)/P22
        W2(4,3) = (K(4))/(4D0*P22)
        W2(4,7) = -7D0
        W2(5,5) = 2D0*F2
        W2(5,6) = -((4D0*K(9))/P22)
        W2(6,6) = 4D0*F2
        W2(6,7) = -((2D0*K(9))/P22)
        W2(7,7) = 6D0*F2
	call xinverse(W2,IW2,7)

	if (rankord.le.2) goto 300

	do i=1,10
	do j=1,10
	  W3(i,j) = 0d0
	enddo
	enddo
        W3(1,5) = -5D0
        W3(1,6) = (2D0*P1P2)/P22
        W3(1,9) = -(DEL)
        W3(2,6) = -7D0
        W3(2,10) = -(DEL)
        W3(3,1) = (K(4))/(4D0*P22)
        W3(3,5) = 6D0/P22
        W3(3,7) = -3D0
        W3(3,8) = (6D0*P1P2)/P22
        W3(4,2) = (K(4))/(4D0*P22)
        W3(4,6) = 2D0/P22
        W3(4,8) = -5D0
        W3(4,9) = (4D0*P1P2)/P22
        W3(5,3) = (K(4))/(4D0*P22)
        W3(5,9) = -7D0
        W3(5,10) = (2D0*P1P2)/P22
        W3(6,4) = (K(4))/(4D0*P22)
        W3(6,10) = -9D0
        W3(7,7) = 2D0*F2
        W3(7,8) = -((6D0*K(9))/P22)
        W3(8,8) = 4D0*F2
        W3(8,9) = -((4D0*K(9))/P22)
        W3(9,9) = 6D0*F2
        W3(9,10) = -((2D0*K(9))/P22)
        W3(10,10) = 8D0*F2
	call xinverse(W3,IW3,10)

	if (rankord.le.3) goto 300

	do i=1,14
	do j=1,14
	  W4(i,j) = 0d0
	enddo
	enddo
        W4(1,6) = -7D0
        W4(1,9) = -(DEL)
        W4(2,6) = 2D0/P22
        W4(2,7) = -5D0
        W4(2,8) = (4D0*P1P2)/P22
        W4(2,12) = -(DEL)
        W4(3,8) = -7D0
        W4(3,9) = (2D0*P1P2)/P22
        W4(3,13) = -(DEL)
        W4(4,9) = -9D0
        W4(4,14) = -(DEL)
        W4(5,1) = (K(4))/(4D0*P22)
        W4(5,7) = 12D0/P22
        W4(5,10) = -3D0
        W4(5,11) = (8D0*P1P2)/P22
        W4(6,2) = (K(4))/(4D0*P22)
        W4(6,8) = 6D0/P22
        W4(6,11) = -5D0
        W4(6,12) = (6D0*P1P2)/P22
        W4(7,3) = (K(4))/(4D0*P22)
        W4(7,9) = 2D0/P22
        W4(7,12) = -7D0
        W4(7,13) = (4D0*P1P2)/P22
        W4(8,4) = (K(4))/(4D0*P22)
        W4(8,13) = -9D0
        W4(8,14) = (2D0*P1P2)/P22
        W4(9,5) = (K(4))/(4D0*P22)
        W4(9,14) = -11D0
        W4(10,10) = 2D0*F2
        W4(10,11) = -((8D0*K(9))/P22)
        W4(11,11) = 4D0*F2
        W4(11,12) = -((6D0*K(9))/P22)
        W4(12,12) = 6D0*F2
        W4(12,13) = -((4D0*K(9))/P22)
        W4(13,13) = 8D0*F2
        W4(13,14) = -((2D0*K(9))/P22)
        W4(14,14) = 10D0*F2
	call xinverse(W4,IW4,14)

300	continue

	i1=0
301	continue
	if (i1.gt.2*ord) goto 350

        V0(1) = -(1D0/2D0)+C2(1,1)*DEL+(B1(1)*K(5))/(2D0*P22)+(K(3)*
     &  B0)/(4D0*P22)-(B0_2*F2)/(4D0*P22)+(B1_2(1)*P1P2)/(2D0*P22)
        V0(2) = -(2D0*C2(1,1)*K(8))+2D0*C2(1,2)*K(1)*P22-(B1_2(1)*
     &  K(9))/P22+(B1(1)*(K(9)-F2*P22))/P22
	do i=1,2
	  X0(i) = 0d0
	do j=1,2
	  X0(i) = X0(i) + IW0(i,j)*V0(j)
	enddo
	enddo
        C0 = X0(1)
        C2(0,0) = X0(2)

	if (rankord-i1.le.0) goto 302

        V1(1) = 1D0/6D0+C3(1,1,2)*DEL-(B2(0,0))/(2D0*P22)+(B2_2(0,
     &  0))/(2D0*P22)-(B1(1)*K(2))/(4D0*P22)-(B2(1,1)*K(5))/(2D0*
     &  P22)-(K(3)*B0)/(4D0*P22)
        V1(2) = 1D0/6D0+C3(1,1,1)*DEL+(B1(1)*K(3))/(4D0*P22)+(B2(1,
     &  1)*K(5))/(2D0*P22)-(B1_2(1)*F2)/(4D0*P22)+(B2_2(1,1)*P1P2)/
     &  (2D0*P22)
        V1(3) = -(2D0*C3(1,1,2)*K(8))+2D0*C3(1,2,2)*K(1)*P22-(B1(1)*
     &  (K(9)-F2*P22))/P22-(B2(1,1)*(K(9)-F2*P22))/P22
        V1(4) = -(2D0*C3(1,1,1)*K(8))+2D0*C3(1,1,2)*K(1)*P22-
     &  (B2_2(1,1)*K(9))/P22+(B2(1,1)*(K(9)-F2*P22))/P22
	do i=1,4
	  X1(i) = 0d0
	do j=1,4
	  X1(i) = X1(i) + IW1(i,j)*V1(j)
	enddo
	enddo
        C1(2) = X1(1)
        C1(1) = X1(2)
        C3(0,0,2) = X1(3)
        C3(0,0,1) = X1(4)

	if (rankord-i1.le.1) goto 302

        V2(1) = (B2(0,0)*K(3))/(4D0*P22)-(C2(0,0)*K(4))/(4D0*P22)+
     &  (B3(0,0,1)*K(5))/(2D0*P22)-(B2_2(0,0)*F2)/(4D0*P22)+(B3_2(0,
     &  0,1)*P1P2)/(2D0*P22)+((P1P2**2+DEL*P22-2D0*M02*P22-2D0*M12*
     &  P22-2D0*M22*P22-P1P2*P22+P22**2))/(24D0*P22)
        V2(2) = -(1D0/12D0)+C4(1,1,2,2)*DEL+B2(0,0)/P22+B3(0,0,1)/
     &  P22+(B3(1,1,1)*K(5))/(2D0*P22)+(B2(1,1)*K(6))/(4D0*P22)+
     &  (B1(1)*K(7))/(2D0*P22)+(K(3)*B0)/(4D0*P22)
        V2(3) = -(1D0/24D0)+C4(1,1,1,2)*DEL-(B3(0,0,1))/(2D0*P22)+
     &  (B3_2(0,0,1))/(2D0*P22)-(B2(1,1)*K(2))/(4D0*P22)-(B1(1)*
     &  K(3))/(4D0*P22)-(B3(1,1,1)*K(5))/(2D0*P22)
        V2(4) = -(1D0/12D0)+C4(1,1,1,1)*DEL+(B2(1,1)*K(3))/(4D0*
     &  P22)+(B3(1,1,1)*K(5))/(2D0*P22)-(B2_2(1,1)*F2)/(4D0*P22)+
     &  (B3_2(1,1,1)*P1P2)/(2D0*P22)
        V2(5) = -(2D0*C4(1,1,2,2)*K(8))+2D0*C4(1,2,2,2)*K(1)*P22+
     &  (B1(1)*(K(9)-F2*P22))/P22+(2D0*B2(1,1)*(K(9)-F2*P22))/P22+
     &  (B3(1,1,1)*(K(9)-F2*P22))/P22
        V2(6) = -(2D0*C4(1,1,1,2)*K(8))+2D0*C4(1,1,2,2)*K(1)*P22-
     &  (B2(1,1)*(K(9)-F2*P22))/P22-(B3(1,1,1)*(K(9)-F2*P22))/P22
        V2(7) = -(2D0*C4(1,1,1,1)*K(8))+2D0*C4(1,1,1,2)*K(1)*P22-
     &  (B3_2(1,1,1)*K(9))/P22+(B3(1,1,1)*(K(9)-F2*P22))/P22
	do i=1,7
	  X2(i) = 0d0
	do j=1,7
	  X2(i) = X2(i) + IW2(i,j)*V2(j)
	enddo
	enddo
        C2(2,2) = X2(1)
        C2(1,2) = X2(2)
        C2(1,1) = X2(3)
        C4(0,0,0,0) = X2(4)
        C4(0,0,2,2) = X2(5)
        C4(0,0,1,2) = X2(6)
        C4(0,0,1,1) = X2(7)

	if (rankord-i1.le.2) goto 302

        V3(1) = -((B4(0,0,0,0))/(2D0*P22))+(B4_2(0,0,0,0))/(2D0*
     &  P22)-(B3(0,0,1)*K(2))/(4D0*P22)-(B2(0,0)*K(3))/(4D0*P22)-
     &  (C3(0,0,2)*K(4))/(4D0*P22)-(B4(0,0,1,1)*K(5))/(2D0*P22)-
     &  ((3D0*P1P2**2+3D0*DEL*P22-5D0*M02*P22-5D0*M12*P22-10D0*M22*
     &  P22-4D0*P1P2*P22+4D0*P22**2))/(240D0*P22)
        V3(2) = (B3(0,0,1)*K(3))/(4D0*P22)-(C3(0,0,1)*K(4))/(4D0*
     &  P22)+(B4(0,0,1,1)*K(5))/(2D0*P22)-(B3_2(0,0,1)*F2)/(4D0*
     &  P22)+(B4_2(0,0,1,1)*P1P2)/(2D0*P22)-((4D0*P1P2**2+4D0*DEL*
     &  P22-5D0*M02*P22-10D0*M12*P22-5D0*M22*P22-4D0*P1P2*P22+3D0*
     &  P22**2))/(240D0*P22)
        V3(3) = 1D0/20D0+C5(1,1,2,2,2)*DEL-(3D0*B2(0,0))/(2D0*P22)-
     &  (3D0*B3(0,0,1))/P22-(3D0*B4(0,0,1,1))/(2D0*P22)-(3D0*B2(1,
     &  1)*K(2))/(4D0*P22)-(B4(1,1,1,1)*K(5))/(2D0*P22)-(K(3)*B0)/
     &  (4D0*P22)-(B1(1)*(3D0*F2-2D0*P1P2-4D0*P22))/(4D0*P22)-(B3(1,
     &  1,1)*(F2-6D0*P1P2+4D0*P22))/(4D0*P22)
        V3(4) = 1D0/60D0+C5(1,1,1,2,2)*DEL+B3(0,0,1)/P22+B4(0,0,1,
     &  1)/P22+(B1(1)*K(3))/(4D0*P22)+(B4(1,1,1,1)*K(5))/(2D0*P22)+
     &  (B3(1,1,1)*K(6))/(4D0*P22)+(B2(1,1)*K(7))/(2D0*P22)
        V3(5) = 1D0/60D0+C5(1,1,1,1,2)*DEL-(B4(0,0,1,1))/(2D0*P22)+
     &  (B4_2(0,0,1,1))/(2D0*P22)-(B3(1,1,1)*K(2))/(4D0*P22)-(B2(1,
     &  1)*K(3))/(4D0*P22)-(B4(1,1,1,1)*K(5))/(2D0*P22)
        V3(6) = 1D0/20D0+C5(1,1,1,1,1)*DEL+(B3(1,1,1)*K(3))/(4D0*
     &  P22)+(B4(1,1,1,1)*K(5))/(2D0*P22)-(B3_2(1,1,1)*F2)/(4D0*
     &  P22)+(B4_2(1,1,1,1)*P1P2)/(2D0*P22)
        V3(7) = -(2D0*C5(1,1,2,2,2)*K(8))+2D0*C5(1,2,2,2,2)*K(1)*
     &  P22-(B1(1)*(K(9)-F2*P22))/P22-(3D0*B2(1,1)*(K(9)-F2*P22))/
     &  P22-(3D0*B3(1,1,1)*(K(9)-F2*P22))/P22-(B4(1,1,1,1)*(K(9)-F2*
     &  P22))/P22
        V3(8) = -(2D0*C5(1,1,1,2,2)*K(8))+2D0*C5(1,1,2,2,2)*K(1)*
     &  P22+(B2(1,1)*(K(9)-F2*P22))/P22+(2D0*B3(1,1,1)*(K(9)-F2*
     &  P22))/P22+(B4(1,1,1,1)*(K(9)-F2*P22))/P22
        V3(9) = -(2D0*C5(1,1,1,1,2)*K(8))+2D0*C5(1,1,1,2,2)*K(1)*
     &  P22-(B3(1,1,1)*(K(9)-F2*P22))/P22-(B4(1,1,1,1)*(K(9)-F2*
     &  P22))/P22
        V3(10) = -(2D0*C5(1,1,1,1,1)*K(8))+2D0*C5(1,1,1,1,2)*K(1)*
     &  P22-(B4_2(1,1,1,1)*K(9))/P22+(B4(1,1,1,1)*(K(9)-F2*P22))/P22
	do i=1,10
	  X3(i) = 0d0
	do j=1,10
	  X3(i) = X3(i) + IW3(i,j)*V3(j)
	enddo
	enddo
        C3(2,2,2) = X3(1)
        C3(1,2,2) = X3(2)
        C3(1,1,2) = X3(3)
        C3(1,1,1) = X3(4)
        C5(0,0,0,0,2) = X3(5)
        C5(0,0,0,0,1) = X3(6)
        C5(0,0,2,2,2) = X3(7)
        C5(0,0,1,2,2) = X3(8)
        C5(0,0,1,1,2) = X3(9)
        C5(0,0,1,1,1) = X3(10)

	if (rankord-i1.le.3) goto 302

        V4(1) = (B4(0,0,0,0)*K(3))/(4D0*P22)-(C4(0,0,0,0)*K(4))/
     &  (4D0*P22)+(B5(0,0,0,0,1)*K(5))/(2D0*P22)-(B4_2(0,0,0,0)*F2)/
     &  (4D0*P22)+(B5_2(0,0,0,0,1)*P1P2)/(2D0*P22)-(P22**(-2)*(3D0*
     &  P1P2**4+6D0*DEL*P1P2**2*P22-9D0*M02*P1P2**2*P22-12D0*M12*
     &  P1P2**2*P22-9D0*M22*P1P2**2*P22-6D0*P1P2**3*P22+3D0*DEL**2*
     &  P22**2-9D0*DEL*M02*P22**2+15D0*M02**2*P22**2-12D0*DEL*M12*
     &  P22**2+15D0*M02*M12*P22**2+15D0*M12**2*P22**2-9D0*DEL*M22*
     &  P22**2+15D0*M02*M22*P22**2+15D0*M12*M22*P22**2+15D0*M22**2*
     &  P22**2-6D0*DEL*P1P2*P22**2+6D0*M02*P1P2*P22**2+12D0*M12*
     &  P1P2*P22**2+12D0*M22*P1P2*P22**2+9D0*P1P2**2*P22**2+5D0*DEL*
     &  P22**3-9D0*M02*P22**3-9D0*M12*P22**3-12D0*M22*P22**3-6D0*
     &  P1P2*P22**3+3D0*P22**4))/1440D0
        V4(2) = B4(0,0,0,0)/P22+B5(0,0,0,0,1)/P22+(B2(0,0)*K(3))/
     &  (4D0*P22)-(C4(0,0,2,2)*K(4))/(4D0*P22)+(B5(0,0,1,1,1)*K(5))/
     &  (2D0*P22)+(B4(0,0,1,1)*K(6))/(4D0*P22)+(B3(0,0,1)*K(7))/
     &  (2D0*P22)+((2D0*P1P2**2+2D0*DEL*P22-3D0*M02*P22-3D0*M12*P22-
     &  9D0*M22*P22-3D0*P1P2*P22+3D0*P22**2))/(360D0*P22)
        V4(3) = -((B5(0,0,0,0,1))/(2D0*P22))+(B5_2(0,0,0,0,1))/(2D0*
     &  P22)-(B4(0,0,1,1)*K(2))/(4D0*P22)-(B3(0,0,1)*K(3))/(4D0*
     &  P22)-(C4(0,0,1,2)*K(4))/(4D0*P22)-(B5(0,0,1,1,1)*K(5))/(2D0*
     &  P22)+((3D0*P1P2**2+3D0*DEL*P22-3D0*M02*P22-6D0*M12*P22-6D0*
     &  M22*P22-4D0*P1P2*P22+3D0*P22**2))/(720D0*P22)
        V4(4) = (B4(0,0,1,1)*K(3))/(4D0*P22)-(C4(0,0,1,1)*K(4))/
     &  (4D0*P22)+(B5(0,0,1,1,1)*K(5))/(2D0*P22)-(B4_2(0,0,1,1)*F2)/
     &  (4D0*P22)+(B5_2(0,0,1,1,1)*P1P2)/(2D0*P22)+((3D0*P1P2**2+
     &  3D0*DEL*P22-3D0*M02*P22-9D0*M12*P22-3D0*M22*P22-3D0*P1P2*
     &  P22+2D0*P22**2))/(360D0*P22)
        V4(5) = -(1D0/30D0)+C6(1,1,2,2,2,2)*DEL+(2D0*B2(0,0))/P22+
     &  (6D0*B3(0,0,1))/P22+(6D0*B4(0,0,1,1))/P22+(2D0*B5(0,0,1,1,
     &  1))/P22+(B5(1,1,1,1,1)*K(5))/(2D0*P22)+(K(3)*B0)/(4D0*P22)+
     &  (B3(1,1,1)*(F2-3D0*P1P2+P22))/P22+(B2(1,1)*(3D0*F2-4D0*P1P2-
     &  2D0*P22))/(2D0*P22)+(B1(1)*(2D0*F2-P1P2-3D0*P22))/(2D0*P22)+
     &  (B4(1,1,1,1)*(F2-8D0*P1P2+6D0*P22))/(4D0*P22)
        V4(6) = -(1D0/120D0)+C6(1,1,1,2,2,2)*DEL-(3D0*B3(0,0,1))/
     &  (2D0*P22)-(3D0*B4(0,0,1,1))/P22-(3D0*B5(0,0,1,1,1))/(2D0*
     &  P22)-(3D0*B3(1,1,1)*K(2))/(4D0*P22)-(B1(1)*K(3))/(4D0*P22)-
     &  (B5(1,1,1,1,1)*K(5))/(2D0*P22)-(B2(1,1)*(3D0*F2-2D0*P1P2-
     &  4D0*P22))/(4D0*P22)-(B4(1,1,1,1)*(F2-6D0*P1P2+4D0*P22))/
     &  (4D0*P22)
        V4(7) = -(1D0/180D0)+C6(1,1,1,1,2,2)*DEL+B4(0,0,1,1)/P22+
     &  B5(0,0,1,1,1)/P22+(B2(1,1)*K(3))/(4D0*P22)+(B5(1,1,1,1,1)*
     &  K(5))/(2D0*P22)+(B4(1,1,1,1)*K(6))/(4D0*P22)+(B3(1,1,1)*
     &  K(7))/(2D0*P22)
        V4(8) = -(1D0/120D0)+C6(1,1,1,1,1,2)*DEL-(B5(0,0,1,1,1))/
     &  (2D0*P22)+(B5_2(0,0,1,1,1))/(2D0*P22)-(B4(1,1,1,1)*K(2))/
     &  (4D0*P22)-(B3(1,1,1)*K(3))/(4D0*P22)-(B5(1,1,1,1,1)*K(5))/
     &  (2D0*P22)
        V4(9) = -(1D0/30D0)+C6(1,1,1,1,1,1)*DEL+(B4(1,1,1,1)*K(3))/
     &  (4D0*P22)+(B5(1,1,1,1,1)*K(5))/(2D0*P22)-(B4_2(1,1,1,1)*F2)/
     &  (4D0*P22)+(B5_2(1,1,1,1,1)*P1P2)/(2D0*P22)
        V4(10) = -(2D0*C6(1,1,2,2,2,2)*K(8))+2D0*C6(1,2,2,2,2,2)*
     &  K(1)*P22+(B1(1)*(K(9)-F2*P22))/P22+(4D0*B2(1,1)*(K(9)-F2*
     &  P22))/P22+(6D0*B3(1,1,1)*(K(9)-F2*P22))/P22+(4D0*B4(1,1,1,
     &  1)*(K(9)-F2*P22))/P22+(B5(1,1,1,1,1)*(K(9)-F2*P22))/P22
        V4(11) = -(2D0*C6(1,1,1,2,2,2)*K(8))+2D0*C6(1,1,2,2,2,2)*
     &  K(1)*P22-(B2(1,1)*(K(9)-F2*P22))/P22-(3D0*B3(1,1,1)*(K(9)-
     &  F2*P22))/P22-(3D0*B4(1,1,1,1)*(K(9)-F2*P22))/P22-(B5(1,1,1,
     &  1,1)*(K(9)-F2*P22))/P22
        V4(12) = -(2D0*C6(1,1,1,1,2,2)*K(8))+2D0*C6(1,1,1,2,2,2)*
     &  K(1)*P22+(B3(1,1,1)*(K(9)-F2*P22))/P22+(2D0*B4(1,1,1,1)*
     &  (K(9)-F2*P22))/P22+(B5(1,1,1,1,1)*(K(9)-F2*P22))/P22
        V4(13) = -(2D0*C6(1,1,1,1,1,2)*K(8))+2D0*C6(1,1,1,1,2,2)*
     &  K(1)*P22-(B4(1,1,1,1)*(K(9)-F2*P22))/P22-(B5(1,1,1,1,1)*
     &  (K(9)-F2*P22))/P22
        V4(14) = -(2D0*C6(1,1,1,1,1,1)*K(8))+2D0*C6(1,1,1,1,1,2)*
     &  K(1)*P22-(B5_2(1,1,1,1,1)*K(9))/P22+(B5(1,1,1,1,1)*(K(9)-F2*
     &  P22))/P22
	do i=1,14
	  X4(i) = 0d0
	do j=1,14
	  X4(i) = X4(i) + IW4(i,j)*V4(j)
	enddo
	enddo
        C4(2,2,2,2) = X4(1)
        C4(1,2,2,2) = X4(2)
        C4(1,1,2,2) = X4(3)
        C4(1,1,1,2) = X4(4)
        C4(1,1,1,1) = X4(5)
        C6(0,0,0,0,0,0) = X4(6)
        C6(0,0,0,0,2,2) = X4(7)
        C6(0,0,0,0,1,2) = X4(8)
        C6(0,0,0,0,1,1) = X4(9)
        C6(0,0,2,2,2,2) = X4(10)
        C6(0,0,1,2,2,2) = X4(11)
        C6(0,0,1,1,2,2) = X4(12)
        C6(0,0,1,1,1,2) = X4(13)
        C6(0,0,1,1,1,1) = X4(14)

302	continue
	i1=i1+2
	goto 301
350	continue

c*** remaining non-ordered coefficients up to rank 4
        C2(2,1) = C2(1,2)
        C3(2,1,1) = C3(1,1,2)
        C3(1,2,1) = C3(1,1,2)
        C3(2,1,2) = C3(1,2,2)
        C3(2,2,1) = C3(1,2,2)
        C4(0,0,2,1) = C4(0,0,1,2)
        C4(2,1,1,1) = C4(1,1,1,2)
        C4(1,2,1,1) = C4(1,1,1,2)
        C4(1,1,2,1) = C4(1,1,1,2)
        C4(2,2,1,1) = C4(1,1,2,2)
        C4(2,1,2,1) = C4(1,1,2,2)
        C4(2,1,1,2) = C4(1,1,2,2)
        C4(1,2,2,1) = C4(1,1,2,2)
        C4(1,2,1,2) = C4(1,1,2,2)
        C4(2,2,2,1) = C4(1,2,2,2)
        C4(2,2,1,2) = C4(1,2,2,2)
        C4(2,1,2,2) = C4(1,2,2,2)

	end

***********************************************************************
        SUBROUTINE xD012345_sing(Q1,Q2,Q3,Q4,Q23,Q12,M02,M12,M22,M32,
     *                     D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
***********************************************************************
*	4-point tensor coefficients with complex masses
*	--- expansion about vanishing Gram determinant ---
*-----------------------------------------------------------------------
*       4.11.04 Stefan Dittmaier
***********************************************************************
        implicit real*8 (a-z)
        complex*16 nix
        complex*16 K(27),xD0_
        complex*16 M02,M12,M22,M32,F1,F2,F3
        COMPLEX*16   B0,  B1(1),  B2(0:2,0:2),  B3(0:2,0:2,2)
        COMPLEX*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
        COMPLEX*16   C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_1,C1_1(2),C2_1(0:2,0:2),C3_1(0:2,0:2,2)
        COMPLEX*16 C4_1(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_2,C1_2(2),C2_2(0:2,0:2),C3_2(0:2,0:2,2)
        COMPLEX*16 C4_2(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_3,C1_3(2),C2_3(0:2,0:2),C3_3(0:2,0:2,2)
        COMPLEX*16 C4_3(0:2,0:2,0:2,0:2)
        COMPLEX*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	real*8 aux(3)
	integer rank,ext,ord,i,j,i1,i2,i3,i4,i5,rankord,ncase

	if (rank.gt.3) then
	  write(*,*) 'rank>3 not implemented in xD012345_sing !',rank
	  stop
	endif

	p12  = q1
	p22  = q12
	p32  = q4
	p1p2 = (p12+p22-q2 )/2d0
	p1p3 = (p12+p32-q23)/2d0
	p2p3 = (p22+p32-q3 )/2d0

	f1   = p12-m12+m02
	f2   = p22-m22+m02
	f3   = p32-m32+m02

	ref  = (abs(q1)+abs(q2)+abs(q3)+abs(q4)+abs(q23)+abs(q12))/6d0
        aux(1) = abs(P2P3**2-P22*P32) / ref**2
        aux(2) = abs(P1P3**2-P12*P32) / ref**2
        aux(3) = abs(P1P2**2-P12*P22) / ref**2

	ncase = 0
	auxmax = 0d0
	do i=1,3
	if (aux(i).gt.auxmax) then
	  auxmax = aux(i)
	  ncase  = i
	endif
	enddo

c*** critical size of expansion parameter
        crita = 1d-4
        critb = 1d-2

	if (ncase.eq.1) then
          critfa = abs((-p12*P2P3**2+p12*P22*P32-P1P3**2*P22
     &                 +2D0*P1P2*P1P3*P2P3-P1P2**2*P32) /
     &                (F3*P1P3*P22-F3*P1P2*P2P3-F2*P1P3*P2P3
     &                 +F1*P2P3**2+F2*P1P2*P32-F1*P22*P32))
          critfb = abs((F3*P1P3*P22-F3*P1P2*P2P3-F2*P1P3*P2P3
     &                 +F1*P2P3**2+F2*P1P2*P32-F1*P22*P32)/ref**3)
	elseif (ncase.eq.2) then
          critfa = abs((-p12*P2P3**2+p12*P22*P32-P1P3**2*P22
     &                 +2D0*P1P2*P1P3*P2P3-P1P2**2*P32) /
     &                (-(F3*P1P2*P1P3)+F2*P1P3**2+F3*P12*P2P3
     &                 -F1*P1P3*P2P3-F2*P12*P32+F1*P1P2*P32))
          critfb = abs((-(F3*P1P2*P1P3)+F2*P1P3**2+F3*P12*P2P3
     &                 -F1*P1P3*P2P3-F2*P12*P32+F1*P1P2*P32)/ref**3)
	elseif (ncase.eq.3) then
          critfa = abs((-p12*P2P3**2+p12*P22*P32-P1P3**2*P22
     &                 +2D0*P1P2*P1P3*P2P3-P1P2**2*P32) /
     &                (F3*P1P2**2-F2*P1P2*P1P3-F3*P12*P22
     &                 +F1*P1P3*P22+F2*P12*P2P3-F1*P1P2*P2P3))
          critfb = abs((F3*P1P2**2-F2*P1P2*P1P3-F3*P12*P22
     &                 +F1*P1P3*P22+F2*P12*P2P3-F1*P1P2*P2P3)/ref**3)
	endif

c special case of small "f-determinant"
	if ((critfa.gt.crita).or.(critfb.lt.critb)) then
          call xD012345_sing2(Q1,Q2,Q3,Q4,Q23,Q12,M02,M12,M22,M32,
     &                     D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)

c |P2P3**2-P22*P32| maximal
	elseif (ncase.eq.1) then
c momentum ordering 123
          call xD012345_singx(Q1,Q2,Q3,Q4,Q23,Q12,M02,M12,M22,M32,
     &                   D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)

c |P1P3**2-P12*P32| maximal
 	elseif (ncase.eq.2) then
c momentum ordering 231
          call xD012345_singx(Q12,Q3,Q23,Q1,Q2,Q4,M02,M22,M32,M12,
     &                   D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
          call Drot(D0,D1,D2,D3,D4,D5,1,2,3,rank)

c |P1P2**2-P12*P22| maximal
	elseif (ncase.eq.3) then
c momentum ordering 312
          call xD012345_singx(Q4,Q23,Q2,Q12,Q3,Q1,M02,M32,M12,M22,
     &                   D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
          call Drot(D0,D1,D2,D3,D4,D5,1,3,2,rank)
	endif

c*** test output
c        write(*,*)
c        write(*,*) 'args   ', Q1,Q2,Q3,Q4,Q23,Q12,M02,M12,M22,M32
c        write(*,*) 'aux1   ', aux1
c        write(*,*) 'aux2   ', aux2
c        write(*,*) 'aux3   ', aux3
c        write(*,*) 'crit1a ', critf1a
c        write(*,*) 'crit2a ', critf2a
c        write(*,*) 'crit3a ', critf3a
c        write(*,*) ' D0          = ',
c     &		xD0_(Q1,Q2,Q3,Q4,Q12,Q23,M02,M12,M22,M32,0)
c        write(*,*) 'aD0          = ',D0
c        write(*,*) 'aD1(1)       = ',D1(1)
c        write(*,*) 'aD1(2)       = ',D1(2)
c        write(*,*) 'aD1(3)       = ',D1(3)
c        write(*,*) 'aD2(0,0)     = ',D2(0,0)
c        write(*,*) 'aD2(1,1)     = ',D2(1,1)
c        write(*,*) 'aD2(1,2)     = ',D2(1,2)
c        write(*,*) 'aD2(1,3)     = ',D2(1,3)
c        write(*,*) 'aD2(2,2)     = ',D2(2,2)
c        write(*,*) 'aD2(2,3)     = ',D2(2,3)
c        write(*,*) 'aD2(3,3)     = ',D2(3,3)
c        write(*,*) 'aD3(0,0,1)   = ',D3(0,0,1)
c        write(*,*) 'aD3(0,0,2)   = ',D3(0,0,2)
c        write(*,*) 'aD3(0,0,3)   = ',D3(0,0,3)
c        write(*,*) 'aD3(1,1,1)   = ',D3(1,1,1)
c        write(*,*) 'aD3(1,1,2)   = ',D3(1,1,2)
c        write(*,*) 'aD3(1,1,3)   = ',D3(1,1,3)
c        write(*,*) 'aD3(1,2,2)   = ',D3(1,2,2)
c        write(*,*) 'aD3(1,2,3)   = ',D3(1,2,3)
c        write(*,*) 'aD3(1,3,3)   = ',D3(1,3,3)
c        write(*,*) 'aD3(2,2,2)   = ',D3(2,2,2)
c        write(*,*) 'aD3(2,2,3)   = ',D3(2,2,3)
c        write(*,*) 'aD3(2,3,3)   = ',D3(2,3,3)
c        write(*,*) 'aD3(3,3,3)   = ',D3(3,3,3)
c        write(*,*) 'aD4(0,0,0,0) = ',D4(0,0,0,0)
c        write(*,*) 'aD4(0,0,1,1) = ',D4(0,0,1,1)
c        write(*,*) 'aD4(0,0,1,2) = ',D4(0,0,1,2)
c        write(*,*) 'aD4(0,0,1,3) = ',D4(0,0,1,3)
c        write(*,*) 'aD4(0,0,2,2) = ',D4(0,0,2,2)
c        write(*,*) 'aD4(0,0,2,3) = ',D4(0,0,2,3)
c        write(*,*) 'aD4(0,0,3,3) = ',D4(0,0,3,3)
c
c        write(*,*) 'aD4(1,1,1,1) = ',D4(1,1,1,1)
c        write(*,*) 'aD4(1,1,1,2) = ',D4(1,1,1,2)
c        write(*,*) 'aD4(1,1,1,3) = ',D4(1,1,1,3)
c        write(*,*) 'aD4(1,1,2,2) = ',D4(1,1,2,2)
c        write(*,*) 'aD4(1,1,2,3) = ',D4(1,1,2,3)
c        write(*,*) 'aD4(1,1,3,3) = ',D4(1,1,3,3)
c        write(*,*) 'aD4(1,2,2,2) = ',D4(1,2,2,2)
c        write(*,*) 'aD4(1,2,2,3) = ',D4(1,2,2,3)
c        write(*,*) 'aD4(1,2,3,3) = ',D4(1,2,3,3)
c        write(*,*) 'aD4(1,3,3,3) = ',D4(1,3,3,3)
c        write(*,*) 'aD4(2,2,2,2) = ',D4(2,2,2,2)
c        write(*,*) 'aD4(2,2,2,3) = ',D4(2,2,2,3)
c        write(*,*) 'aD4(2,2,3,3) = ',D4(2,2,3,3)
c        write(*,*) 'aD4(2,3,3,3) = ',D4(2,3,3,3)
c        write(*,*) 'aD4(3,3,3,3) = ',D4(3,3,3,3)

	end

***********************************************************************
        SUBROUTINE xD012345_singx(Q1,Q2,Q3,Q4,Q23,Q12,M02,M12,M22,M32,
     *                     D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
***********************************************************************
*	4-point tensor coefficients with complex masses
*	--- expansion about vanishing Gram determinant ---
*	explicit calculation under conditions
*         |P2P3**2-P22*P32| > 0,|P1P3**2-P12*P32|,|P1P2**2-P12*P22|
*-----------------------------------------------------------------------
*       25.11.04 Stefan Dittmaier
***********************************************************************
        implicit real*8 (a-z)
        complex*16 K(27),xD0_
        complex*16 M02,M12,M22,M32,F1,F2,F3
        COMPLEX*16   B0,  B1(1),  B2(0:2,0:2),  B3(0:2,0:2,2)
        COMPLEX*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
        COMPLEX*16   C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_1,C1_1(2),C2_1(0:2,0:2),C3_1(0:2,0:2,2)
        COMPLEX*16 C4_1(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_2,C1_2(2),C2_2(0:2,0:2),C3_2(0:2,0:2,2)
        COMPLEX*16 C4_2(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_3,C1_3(2),C2_3(0:2,0:2),C3_3(0:2,0:2,2)
        COMPLEX*16 C4_3(0:2,0:2,0:2,0:2)
        COMPLEX*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16  W0( 1, 1),V0( 1),X0( 1),IW0( 1, 1)
	complex*16  W1( 4, 4),V1( 4),X1( 4),IW1( 4, 4)
	complex*16  W2( 9, 9),V2( 9),X2( 9),IW2( 9, 9)
	complex*16  W3(17,17),V3(17),X3(17),IW3(17,17)
	complex*16  W4(28,28),V4(28),X4(28),IW4(28,28)
	integer rank,ext,ord,i,j,i1,i2,i3,i4,i5,rankord

c*** order of expansion
	ord = 1

	rankord = rank+ord

	if ((rank.gt.3).or.(ord.gt.1)) then
	  write(*,*) 'rank>3, ord>1 not implemented in xD012345_sing !',
     &			rank,ord
	  stop
	endif

c*** initialization
	  D0          = 0d0
	  D2(0,0)     = 0d0
	  D4(0,0,0,0) = 0d0
	do 100 i1=1,3
	  D1(i1)         = 0d0
	  D3(0,0,i1)     = 0d0
	  D5(0,0,0,0,i1) = 0d0
	do 100 i2=i1,3
	  D2(i1,i2)     = 0d0
	  D4(0,0,i1,i2) = 0d0
	do 100 i3=i2,3
	  D3(i1,i2,i3)     = 0d0
	  D5(0,0,i1,i2,i3) = 0d0
	do 100 i4=i3,3
	  D4(i1,i2,i3,i4) = 0d0
	do 100 i5=i4,3
	  D5(i1,i2,i3,i4,i5) = 0d0
100	continue

	p12  = q1
	p22  = q12
	p32  = q4
	p1p2 = (p12+p22-q2 )/2d0
	p1p3 = (p12+p32-q23)/2d0
	p2p3 = (p22+p32-q3 )/2d0

	f1   = p12-m12+m02
	f2   = p22-m22+m02
	f3   = p32-m32+m02

	p12  = (P1P3**2*P22-2D0*P1P2*P1P3*P2P3+P1P2**2*P32)
     &  	/(-P2P3**2+P22*P32)
	del  = q1-p12
	f1   = p12-m12+m02

        CALL xC01234_(Q2,Q3,Q23,M12,M22,M32,
     &            C0  ,C1  ,C2  ,C3  ,C4  ,B0,B1,B2,B3,rankord,ext)
        CALL xC01234_(Q12,Q3,Q4,M02,M22,M32,
     &            C0_1,C1_1,C2_1,C3_1,C4_1,B0,B1,B2,B3,rankord,ext)
        CALL xC01234_(Q1,Q23,Q4,M02,M12,M32,
     &            C0_2,C1_2,C2_2,C3_2,C4_2,B0,B1,B2,B3,rankord,ext)
        CALL xC01234_(Q1,Q2,Q12,M02,M12,M22,
     &            C0_3,C1_3,C2_3,C3_3,C4_3,B0,B1,B2,B3,rankord,ext)

c matrices for sets of linear equations
        K(1) = P1P3*P22-2D0*P1P2*P2P3
        K(2) = P1P3*P22-P1P2*P2P3
        K(3) = 2D0*P2P3-P32
        K(4) = F3*P2P3-F2*P32
        K(5) = 2D0*F3*P2P3-F2*P32
        K(6) = -(P1P3*P2P3)+P1P2*P32
        K(7) = P1P3*P2P3-P1P2*P32
        K(8) = -(P2P3**2)+P22*P32
        K(9) = P2P3**2-P22*P32
        K(10) = F3*P1P3*P22-2D0*F3*P1P2*P2P3+F2*P1P2*P32
        K(11) = -(2D0*F3*P2P3**2)+F3*P22*P32+F2*P2P3*P32
        K(12) = 2D0*F3*P2P3**2-F3*P22*P32-F2*P2P3*P32
        K(13) = P1P3*P22-2D0*P1P2*P2P3+P22*P2P3+P1P2*P32-P22*P32
        K(14) = P1P3*P22-2D0*P1P2*P2P3+2D0*P2P3**2+P1P2*P32-2D0*P22*
     &  P32
        K(15) = P1P3*P22-2D0*P1P2*P2P3+2D0*P2P3**2+P1P2*P32-P22*P32-
     &  P2P3*P32
        K(16) = P1P3*P22-P1P2*P2P3-P1P3*P2P3+P2P3**2+P1P2*P32-P22*
     &  P32
        K(17) = 2D0*P1P3*P22-4D0*P1P2*P2P3+P22*P2P3+2D0*P2P3**2+2D0*
     &  P1P2*P32-3D0*P22*P32
        K(18) = 2D0*P1P3*P22-4D0*P1P2*P2P3+4D0*P2P3**2+2D0*P1P2*P32-
     &  3D0*P22*P32-P2P3*P32
        K(19) = 3D0*P1P3*P22-6D0*P1P2*P2P3+P22*P2P3+4D0*P2P3**2+3D0*
     &  P1P2*P32-5D0*P22*P32
        K(20) = 3D0*P1P3*P22-6D0*P1P2*P2P3+2D0*P22*P2P3+2D0*P2P3**2+
     &  3D0*P1P2*P32-4D0*P22*P32
        K(21) = 3D0*P1P3*P22-6D0*P1P2*P2P3+6D0*P2P3**2+3D0*P1P2*P32-
     &  5D0*P22*P32-P2P3*P32
        K(22) = 3D0*P1P3*P22-6D0*P1P2*P2P3+6D0*P2P3**2+3D0*P1P2*P32-
     &  4D0*P22*P32-2D0*P2P3*P32
        K(23) = 2D0*P1P3*P22-4D0*P1P2*P2P3+P22*P2P3+2D0*P2P3**2+2D0*
     &  P1P2*P32-2D0*P22*P32-P2P3*P32
        K(24) = 3D0*P1P3*P22-6D0*P1P2*P2P3+P22*P2P3+4D0*P2P3**2+3D0*
     &  P1P2*P32-4D0*P22*P32-P2P3*P32
        K(25) = 3D0*P1P3*P22-6D0*P1P2*P2P3+P22*P2P3+4D0*P2P3**2+3D0*
     &  P1P2*P32-3D0*P22*P32-2D0*P2P3*P32
        K(26) = 3D0*P1P3*P22-6D0*P1P2*P2P3+2D0*P22*P2P3+2D0*P2P3**2+
     &  3D0*P1P2*P32-3D0*P22*P32-P2P3*P32
        K(27) = F3*P1P3*P22-F3*P1P2*P2P3-F2*P1P3*P2P3+DEL*P2P3**2+
     &  F1*P2P3**2+F2*P1P2*P32-DEL*P22*P32-F1*P22*P32

        W0(1,1) = (K(27))/2D0
	IW0(1,1) = 1d0/W0(1,1)

	if (rankord.eq.0) goto 200

	do i=1,4
	do j=1,4
	  W1(i,j) = 0d0
	enddo
	enddo
        W1(1,1) = (K(10))/2D0
        W1(1,2) = -((K(4)*P22)/2D0)
        W1(1,3) = (K(11))/2D0
        W1(1,4) = 2D0*K(9)
        W1(2,1) = (K(27))/2D0
        W1(2,4) = K(9)
        W1(3,2) = (K(27))/2D0
        W1(3,4) = K(6)
        W1(4,3) = (K(27))/2D0
        W1(4,4) = K(2)
	call xinverse(W1,IW1,4)

	if (rankord.eq.1) goto 200

	do i=1,9
	do j=1,9
	  W2(i,j) = 0d0
	enddo
	enddo
        W2(1,1) = (K(10))/2D0
        W2(1,2) = -((K(4)*P22)/2D0)
        W2(1,3) = (K(11))/2D0
        W2(1,7) = 4D0*K(9)
        W2(2,2) = (K(10))/2D0
        W2(2,4) = -((K(4)*P22)/2D0)
        W2(2,5) = (K(11))/2D0
        W2(2,7) = -(2D0*K(7))
        W2(2,8) = 2D0*K(9)
        W2(3,3) = (K(10))/2D0
        W2(3,5) = -((K(4)*P22)/2D0)
        W2(3,6) = (K(11))/2D0
        W2(3,7) = 2D0*K(2)
        W2(3,9) = 2D0*K(9)
        W2(4,1) = (K(27))/2D0
        W2(4,7) = 2D0*K(9)
        W2(5,2) = (K(27))/2D0
        W2(5,7) = K(6)
        W2(5,8) = K(9)
        W2(6,3) = (K(27))/2D0
        W2(6,7) = K(2)
        W2(6,9) = K(9)
        W2(7,4) = (K(27))/2D0
        W2(7,8) = -(2D0*K(7))
        W2(8,5) = (K(27))/2D0
        W2(8,8) = K(2)
        W2(8,9) = K(6)
        W2(9,6) = (K(27))/2D0
        W2(9,9) = 2D0*K(2)
	call xinverse(W2,IW2,9)

	if (rankord.eq.2) goto 200

	do i=1,17
	do j=1,17
	  W3(i,j) = 0d0
	enddo
	enddo
        W3(1,11) = 4D0*K(9)
        W3(1,12) = -(K(8)*DEL)
        W3(2,1) = (K(10))/2D0
        W3(2,2) = -((K(4)*P22)/2D0)
        W3(2,3) = (K(11))/2D0
        W3(2,12) = 6D0*K(9)
        W3(3,2) = (K(10))/2D0
        W3(3,4) = -((K(4)*P22)/2D0)
        W3(3,5) = (K(11))/2D0
        W3(3,12) = -(2D0*K(7))
        W3(3,13) = 4D0*K(9)
        W3(4,3) = (K(10))/2D0
        W3(4,5) = -((K(4)*P22)/2D0)
        W3(4,6) = (K(11))/2D0
        W3(4,12) = 2D0*K(2)
        W3(4,14) = 4D0*K(9)
        W3(5,4) = (K(10))/2D0
        W3(5,7) = -((K(4)*P22)/2D0)
        W3(5,8) = (K(11))/2D0
        W3(5,11) = 2D0*P32
        W3(5,13) = -(4D0*K(7))
        W3(5,15) = 2D0*K(9)
        W3(6,5) = (K(10))/2D0
        W3(6,8) = -((K(4)*P22)/2D0)
        W3(6,9) = (K(11))/2D0
        W3(6,11) = -(2D0*P2P3)
        W3(6,13) = 2D0*K(2)
        W3(6,14) = -(2D0*K(7))
        W3(6,16) = 2D0*K(9)
        W3(7,6) = (K(10))/2D0
        W3(7,9) = -((K(4)*P22)/2D0)
        W3(7,10) = (K(11))/2D0
        W3(7,11) = 2D0*P22
        W3(7,14) = 4D0*K(2)
        W3(7,17) = 2D0*K(9)
        W3(8,1) = (K(27))/2D0
        W3(8,12) = 3D0*K(9)
        W3(9,2) = (K(27))/2D0
        W3(9,12) = K(6)
        W3(9,13) = 2D0*K(9)
        W3(10,3) = (K(27))/2D0
        W3(10,12) = K(2)
        W3(10,14) = 2D0*K(9)
        W3(11,4) = (K(27))/2D0
        W3(11,13) = -(2D0*K(7))
        W3(11,15) = K(9)
        W3(12,5) = (K(27))/2D0
        W3(12,13) = K(2)
        W3(12,14) = K(6)
        W3(12,16) = K(9)
        W3(13,6) = (K(27))/2D0
        W3(13,14) = 2D0*K(2)
        W3(13,17) = K(9)
        W3(14,7) = (K(27))/2D0
        W3(14,15) = -(3D0*K(7))
        W3(15,8) = (K(27))/2D0
        W3(15,15) = K(2)
        W3(15,16) = -(2D0*K(7))
        W3(16,9) = (K(27))/2D0
        W3(16,16) = 2D0*K(2)
        W3(16,17) = K(6)
        W3(17,10) = (K(27))/2D0
        W3(17,17) = 3D0*K(2)
	call xinverse(W3,IW3,17)

	if (rankord.eq.3) goto 200

	do i=1,28
	do j=1,28
	  W4(i,j) = 0d0
	enddo
	enddo
        W4(1,16) = 6D0*K(9)
        W4(1,19) = -(K(8)*DEL)
        W4(2,16) = -(2D0*K(7))
        W4(2,17) = 4D0*K(9)
        W4(2,20) = -(K(8)*DEL)
        W4(3,16) = 2D0*K(2)
        W4(3,18) = 4D0*K(9)
        W4(3,21) = -(K(8)*DEL)
        W4(4,1) = (K(10))/2D0
        W4(4,2) = -((K(4)*P22)/2D0)
        W4(4,3) = (K(11))/2D0
        W4(4,19) = 8D0*K(9)
        W4(5,2) = (K(10))/2D0
        W4(5,4) = -((K(4)*P22)/2D0)
        W4(5,5) = (K(11))/2D0
        W4(5,19) = -(2D0*K(7))
        W4(5,20) = 6D0*K(9)
        W4(6,3) = (K(10))/2D0
        W4(6,5) = -((K(4)*P22)/2D0)
        W4(6,6) = (K(11))/2D0
        W4(6,19) = 2D0*K(2)
        W4(6,21) = 6D0*K(9)
        W4(7,4) = (K(10))/2D0
        W4(7,7) = -((K(4)*P22)/2D0)
        W4(7,8) = (K(11))/2D0
        W4(7,16) = 2D0*P32
        W4(7,20) = -(4D0*K(7))
        W4(7,22) = 4D0*K(9)
        W4(8,5) = (K(10))/2D0
        W4(8,8) = -((K(4)*P22)/2D0)
        W4(8,9) = (K(11))/2D0
        W4(8,16) = -(2D0*P2P3)
        W4(8,20) = 2D0*K(2)
        W4(8,21) = -(2D0*K(7))
        W4(8,23) = 4D0*K(9)
        W4(9,6) = (K(10))/2D0
        W4(9,9) = -((K(4)*P22)/2D0)
        W4(9,10) = (K(11))/2D0
        W4(9,16) = 2D0*P22
        W4(9,21) = 4D0*K(2)
        W4(9,24) = 4D0*K(9)
        W4(10,7) = (K(10))/2D0
        W4(10,11) = -((K(4)*P22)/2D0)
        W4(10,12) = (K(11))/2D0
        W4(10,17) = 6D0*P32
        W4(10,22) = -(6D0*K(7))
        W4(10,25) = 2D0*K(9)
        W4(11,8) = (K(10))/2D0
        W4(11,12) = -((K(4)*P22)/2D0)
        W4(11,13) = (K(11))/2D0
        W4(11,17) = -(4D0*P2P3)
        W4(11,18) = 2D0*P32
        W4(11,22) = 2D0*K(2)
        W4(11,23) = -(4D0*K(7))
        W4(11,26) = 2D0*K(9)
        W4(12,9) = (K(10))/2D0
        W4(12,13) = -((K(4)*P22)/2D0)
        W4(12,14) = (K(11))/2D0
        W4(12,17) = 2D0*P22
        W4(12,18) = -(4D0*P2P3)
        W4(12,23) = 4D0*K(2)
        W4(12,24) = -(2D0*K(7))
        W4(12,27) = 2D0*K(9)
        W4(13,10) = (K(10))/2D0
        W4(13,14) = -((K(4)*P22)/2D0)
        W4(13,15) = (K(11))/2D0
        W4(13,18) = 6D0*P22
        W4(13,24) = 6D0*K(2)
        W4(13,28) = 2D0*K(9)
        W4(14,1) = (K(27))/2D0
        W4(14,19) = 4D0*K(9)
        W4(15,2) = (K(27))/2D0
        W4(15,19) = K(6)
        W4(15,20) = 3D0*K(9)
        W4(16,3) = (K(27))/2D0
        W4(16,19) = K(2)
        W4(16,21) = 3D0*K(9)
        W4(17,4) = (K(27))/2D0
        W4(17,20) = -(2D0*K(7))
        W4(17,22) = 2D0*K(9)
        W4(18,5) = (K(27))/2D0
        W4(18,20) = K(2)
        W4(18,21) = K(6)
        W4(18,23) = 2D0*K(9)
        W4(19,6) = (K(27))/2D0
        W4(19,21) = 2D0*K(2)
        W4(19,24) = 2D0*K(9)
        W4(20,7) = (K(27))/2D0
        W4(20,22) = -(3D0*K(7))
        W4(20,25) = K(9)
        W4(21,8) = (K(27))/2D0
        W4(21,22) = K(2)
        W4(21,23) = -(2D0*K(7))
        W4(21,26) = K(9)
        W4(22,9) = (K(27))/2D0
        W4(22,23) = 2D0*K(2)
        W4(22,24) = K(6)
        W4(22,27) = K(9)
        W4(23,10) = (K(27))/2D0
        W4(23,24) = 3D0*K(2)
        W4(23,28) = K(9)
        W4(24,11) = (K(27))/2D0
        W4(24,25) = -(4D0*K(7))
        W4(25,12) = (K(27))/2D0
        W4(25,25) = K(2)
        W4(25,26) = -(3D0*K(7))
        W4(26,13) = (K(27))/2D0
        W4(26,26) = 2D0*K(2)
        W4(26,27) = -(2D0*K(7))
        W4(27,14) = (K(27))/2D0
        W4(27,27) = 3D0*K(2)
        W4(27,28) = K(6)
        W4(28,15) = (K(27))/2D0
        W4(28,28) = 4D0*K(2)
	call xinverse(W4,IW4,28)

200	continue

	i1=0
201	continue
	if (i1.gt.ord) goto 250

        V0(1) = -(((K(2)+K(6)+K(9))*C0)/2D0)+(K(9)*C0_1)/2D0-(K(7)*
     &  C0_2)/2D0+(K(2)*C0_3)/2D0+D1(1)*K(8)*DEL
	X0(1) = IW0(1,1)*V0(1)
        D0 = X0(1)

	if (rankord-i1.eq.0) goto 202

        V1(1) = (C1_3(1)*K(1))/2D0+D2(1,1)*K(8)*DEL+K(9)*D0*M02-
     &  (C1_3(2)*P22*P2P3)/2D0+(C1_2(1)*P1P2*P32)/2D0+(C1_2(2)*P2P3*
     &  P32)/2D0+(C1(1)*(K(1)+P22*P2P3+P1P2*P32-P22*P32))/2D0+(C0*
     &  (K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*P32))/2D0+(C1(2)*(K(1)+
     &  2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V1(2) = (C1_3(1)*K(2))/2D0-(C1_2(1)*K(7))/2D0+(C1(1)*(K(2)+
     &  K(6)+K(9)))/2D0+(C1(2)*(K(2)+K(6)+K(9)))/2D0+((K(2)+K(6)+
     &  K(9))*C0)/2D0+D2(1,1)*K(8)*DEL
        V1(3) = (C1_3(2)*K(2))/2D0+(C1_1(1)*K(9))/2D0-(C1(1)*(K(2)+
     &  K(6)+K(9)))/2D0+D2(1,2)*K(8)*DEL
        V1(4) = -((C1_2(2)*K(7))/2D0)+(C1_1(2)*K(9))/2D0-(C1(2)*
     &  (K(2)+K(6)+K(9)))/2D0+D2(1,3)*K(8)*DEL
	do i=1,4
	  X1(i) = 0d0
	do j=1,4
	  X1(i) = X1(i) + IW1(i,j)*V1(j)
	enddo
	enddo
        D1(1) = X1(1)
        D1(2) = X1(2)
        D1(3) = X1(3)
        D2(0,0) = X1(4)

	if (rankord-i1.eq.1) goto 202

        V2(1) = (C2_3(1,1)*K(1))/2D0-(C1(1)*K(17))/2D0-(C1(2)*
     &  K(18))/2D0-(C2(1,2)*K(23))/2D0+D3(1,1,1)*K(8)*DEL+D1(1)*
     &  K(9)*M02-(C2_3(1,2)*P22*P2P3)/2D0+(C2_2(1,1)*P1P2*P32)/2D0+
     &  (C2_2(1,2)*P2P3*P32)/2D0-(C2(1,1)*(K(1)+P22*P2P3+P1P2*P32-
     &  P22*P32))/2D0-(C0*(K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*P32))/
     &  2D0-(C2(2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/
     &  2D0
        V2(2) = (C2_3(1,2)*K(1))/2D0+(C2(0,0)*K(3))/2D0+(D2(0,0)*
     &  K(5))/2D0+D3(1,1,2)*K(8)*DEL+D1(2)*K(9)*M02-C2_3(0,0)*P2P3-
     &  (C2_3(2,2)*P22*P2P3)/2D0+(C2_2(0,0)*P32)/2D0+(C2(1,1)*(K(1)+
     &  P22*P2P3+P1P2*P32-P22*P32))/2D0+(C1(1)*(K(1)+2D0*P2P3**2+
     &  P1P2*P32-2D0*P22*P32))/2D0+(C2(1,2)*(K(1)+2D0*P2P3**2+P1P2*
     &  P32-P22*P32-P2P3*P32))/2D0
        V2(3) = D3(1,1,3)*K(8)*DEL+D1(3)*K(9)*M02-(C2(0,0)*P22)/2D0+
     &  (C2_3(0,0)*P22)/2D0-(D2(0,0)*F3*P22)/2D0+(C2_2(1,2)*P1P2*
     &  P32)/2D0+(C2_2(2,2)*P2P3*P32)/2D0+(C2(1,2)*(K(1)+P22*P2P3+
     &  P1P2*P32-P22*P32))/2D0+(C1(2)*(K(1)+2D0*P2P3**2+P1P2*P32-
     &  2D0*P22*P32))/2D0+(C2(2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*
     &  P32-P2P3*P32))/2D0
        V2(4) = (C2_3(1,1)*K(2))/2D0-(C2_2(1,1)*K(7))/2D0-C1(1)*
     &  (K(2)+K(6)+K(9))-C1(2)*(K(2)+K(6)+K(9))-(C2(1,1)*(K(2)+K(6)+
     &  K(9)))/2D0-C2(1,2)*(K(2)+K(6)+K(9))-(C2(2,2)*(K(2)+K(6)+
     &  K(9)))/2D0-((K(2)+K(6)+K(9))*C0)/2D0+D3(1,1,1)*K(8)*DEL
        V2(5) = (C2_3(1,2)*K(2))/2D0+(C1(1)*(K(2)+K(6)+K(9)))/2D0+
     &  (C2(1,1)*(K(2)+K(6)+K(9)))/2D0+(C2(1,2)*(K(2)+K(6)+K(9)))/
     &  2D0+D3(1,1,2)*K(8)*DEL
        V2(6) = -((C2_2(1,2)*K(7))/2D0)+(C1(2)*(K(2)+K(6)+K(9)))/
     &  2D0+(C2(1,2)*(K(2)+K(6)+K(9)))/2D0+(C2(2,2)*(K(2)+K(6)+
     &  K(9)))/2D0+D3(1,1,3)*K(8)*DEL
        V2(7) = (C2_3(2,2)*K(2))/2D0+(C2_1(1,1)*K(9))/2D0-(C2(1,1)*
     &  (K(2)+K(6)+K(9)))/2D0+D3(1,2,2)*K(8)*DEL
        V2(8) = (C2_1(1,2)*K(9))/2D0-(C2(1,2)*(K(2)+K(6)+K(9)))/2D0+
     &  D3(1,2,3)*K(8)*DEL
        V2(9) = -((C2_2(2,2)*K(7))/2D0)+(C2_1(2,2)*K(9))/2D0-(C2(2,
     &  2)*(K(2)+K(6)+K(9)))/2D0+D3(1,3,3)*K(8)*DEL
	do i=1,9
	  X2(i) = 0d0
	do j=1,9
	  X2(i) = X2(i) + IW2(i,j)*V2(j)
	enddo
	enddo
        D2(1,1) = X2(1)
        D2(1,2) = X2(2)
        D2(1,3) = X2(3)
        D2(2,2) = X2(4)
        D2(2,3) = X2(5)
        D2(3,3) = X2(6)
        D3(0,0,1) = X2(7)
        D3(0,0,2) = X2(8)
        D3(0,0,3) = X2(9)

	if (rankord-i1.eq.2) goto 202

        V3(1) = (C3_3(0,0,1)*K(1))/2D0-(D3(0,0,1)*K(10))/2D0+(D3(0,
     &  0,3)*K(12))/2D0+(K(9))/12D0+D2(0,0)*K(9)*M02+(D3(0,0,2)*
     &  K(4)*P22)/2D0-(C3_3(0,0,2)*P22*P2P3)/2D0+(C3_2(0,0,1)*P1P2*
     &  P32)/2D0+(C3_2(0,0,2)*P2P3*P32)/2D0+(C3(0,0,1)*(K(1)+P22*
     &  P2P3+P1P2*P32-P22*P32))/2D0+(C2(0,0)*(K(1)+2D0*P2P3**2+P1P2*
     &  P32-2D0*P22*P32))/2D0+(C3(0,0,2)*(K(1)+2D0*P2P3**2+P1P2*P32-
     &  P22*P32-P2P3*P32))/2D0
        V3(2) = (C3_3(1,1,1)*K(1))/2D0+(C1(1)*K(19))/2D0+(C2(1,1)*
     &  K(20))/2D0+(C1(2)*K(21))/2D0+(C2(2,2)*K(22))/2D0+C2(1,2)*
     &  K(24)+(C3(1,2,2)*K(25))/2D0+(C3(1,1,2)*K(26))/2D0+D4(1,1,1,
     &  1)*K(8)*DEL+D2(1,1)*K(9)*M02-(C3_3(1,1,2)*P22*P2P3)/2D0+
     &  (C3_2(1,1,1)*P1P2*P32)/2D0+(C3_2(1,1,2)*P2P3*P32)/2D0+(C3(1,
     &  1,1)*(K(1)+P22*P2P3+P1P2*P32-P22*P32))/2D0+(C0*(K(1)+2D0*
     &  P2P3**2+P1P2*P32-2D0*P22*P32))/2D0+(C3(2,2,2)*(K(1)+2D0*
     &  P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V3(3) = (C3_3(1,1,2)*K(1))/2D0-(C2(1,1)*K(17))/2D0-(C2(1,2)*
     &  K(18))/2D0-(C3(1,1,2)*K(23))/2D0-(C2(0,0)*K(3))/2D0-(C3(0,0,
     &  1)*K(3))/2D0-(C3(0,0,2)*K(3))/2D0+(D3(0,0,1)*K(5))/2D0+D4(1,
     &  1,1,2)*K(8)*DEL+D2(1,2)*K(9)*M02-C3_3(0,0,1)*P2P3-(C3_3(1,2,
     &  2)*P22*P2P3)/2D0+(C3_2(0,0,1)*P32)/2D0-(C3(1,1,1)*(K(1)+P22*
     &  P2P3+P1P2*P32-P22*P32))/2D0-(C1(1)*(K(1)+2D0*P2P3**2+P1P2*
     &  P32-2D0*P22*P32))/2D0-(C3(1,2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-
     &  P22*P32-P2P3*P32))/2D0
        V3(4) = -((C2(1,2)*K(17))/2D0)-(C2(2,2)*K(18))/2D0-(C3(1,2,
     &  2)*K(23))/2D0+D4(1,1,1,3)*K(8)*DEL+D2(1,3)*K(9)*M02+(C2(0,
     &  0)*P22)/2D0+(C3(0,0,1)*P22)/2D0+(C3(0,0,2)*P22)/2D0+(C3_3(0,
     &  0,1)*P22)/2D0-(D3(0,0,1)*F3*P22)/2D0+(C3_2(1,1,2)*P1P2*P32)/
     &  2D0+(C3_2(1,2,2)*P2P3*P32)/2D0-(C3(1,1,2)*(K(1)+P22*P2P3+
     &  P1P2*P32-P22*P32))/2D0-(C1(2)*(K(1)+2D0*P2P3**2+P1P2*P32-
     &  2D0*P22*P32))/2D0-(C3(2,2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*
     &  P32-P2P3*P32))/2D0
        V3(5) = (C3_3(1,2,2)*K(1))/2D0+C3(0,0,1)*K(3)+D3(0,0,2)*
     &  K(5)+D4(1,1,2,2)*K(8)*DEL+D2(2,2)*K(9)*M02-2D0*C3_3(0,0,2)*
     &  P2P3-(C3_3(2,2,2)*P22*P2P3)/2D0+(C3(1,1,1)*(K(1)+P22*P2P3+
     &  P1P2*P32-P22*P32))/2D0+(C2(1,1)*(K(1)+2D0*P2P3**2+P1P2*P32-
     &  2D0*P22*P32))/2D0+(C3(1,1,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*
     &  P32-P2P3*P32))/2D0
        V3(6) = (C3(0,0,2)*K(3))/2D0+(D3(0,0,3)*K(5))/2D0+D4(1,1,2,
     &  3)*K(8)*DEL+D2(2,3)*K(9)*M02-(C3(0,0,1)*P22)/2D0+(C3_3(0,0,
     &  2)*P22)/2D0-(D3(0,0,2)*F3*P22)/2D0+(C3_2(0,0,2)*P32)/2D0+
     &  (C3(1,1,2)*(K(1)+P22*P2P3+P1P2*P32-P22*P32))/2D0+(C2(1,2)*
     &  (K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*P32))/2D0+(C3(1,2,2)*
     &  (K(1)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V3(7) = D4(1,1,3,3)*K(8)*DEL+D2(3,3)*K(9)*M02-C3(0,0,2)*P22-
     &  D3(0,0,3)*F3*P22+(C3_2(1,2,2)*P1P2*P32)/2D0+(C3_2(2,2,2)*
     &  P2P3*P32)/2D0+(C3(1,2,2)*(K(1)+P22*P2P3+P1P2*P32-P22*P32))/
     &  2D0+(C2(2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*P32))/2D0+
     &  (C3(2,2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V3(8) = (C3_3(1,1,1)*K(2))/2D0-(C3_2(1,1,1)*K(7))/2D0+(3D0*
     &  C1(1)*(K(2)+K(6)+K(9)))/2D0+(3D0*C1(2)*(K(2)+K(6)+K(9)))/
     &  2D0+(3D0*C2(1,1)*(K(2)+K(6)+K(9)))/2D0+3D0*C2(1,2)*(K(2)+
     &  K(6)+K(9))+(3D0*C2(2,2)*(K(2)+K(6)+K(9)))/2D0+(C3(1,1,1)*
     &  (K(2)+K(6)+K(9)))/2D0+(3D0*C3(1,1,2)*(K(2)+K(6)+K(9)))/2D0+
     &  (3D0*C3(1,2,2)*(K(2)+K(6)+K(9)))/2D0+(C3(2,2,2)*(K(2)+K(6)+
     &  K(9)))/2D0+((K(2)+K(6)+K(9))*C0)/2D0+D4(1,1,1,1)*K(8)*DEL
        V3(9) = (C3_3(1,1,2)*K(2))/2D0-(C1(1)*(K(2)+K(6)+K(9)))/2D0-
     &  C2(1,1)*(K(2)+K(6)+K(9))-C2(1,2)*(K(2)+K(6)+K(9))-(C3(1,1,
     &  1)*(K(2)+K(6)+K(9)))/2D0-C3(1,1,2)*(K(2)+K(6)+K(9))-(C3(1,2,
     &  2)*(K(2)+K(6)+K(9)))/2D0+D4(1,1,1,2)*K(8)*DEL
        V3(10) = -((C3_2(1,1,2)*K(7))/2D0)-(C1(2)*(K(2)+K(6)+K(9)))/
     &  2D0-C2(1,2)*(K(2)+K(6)+K(9))-C2(2,2)*(K(2)+K(6)+K(9))-(C3(1,
     &  1,2)*(K(2)+K(6)+K(9)))/2D0-C3(1,2,2)*(K(2)+K(6)+K(9))-(C3(2,
     &  2,2)*(K(2)+K(6)+K(9)))/2D0+D4(1,1,1,3)*K(8)*DEL
        V3(11) = (C3_3(1,2,2)*K(2))/2D0+(C2(1,1)*(K(2)+K(6)+K(9)))/
     &  2D0+(C3(1,1,1)*(K(2)+K(6)+K(9)))/2D0+(C3(1,1,2)*(K(2)+K(6)+
     &  K(9)))/2D0+D4(1,1,2,2)*K(8)*DEL
        V3(12) = (C2(1,2)*(K(2)+K(6)+K(9)))/2D0+(C3(1,1,2)*(K(2)+
     &  K(6)+K(9)))/2D0+(C3(1,2,2)*(K(2)+K(6)+K(9)))/2D0+D4(1,1,2,
     &  3)*K(8)*DEL
        V3(13) = -((C3_2(1,2,2)*K(7))/2D0)+(C2(2,2)*(K(2)+K(6)+
     &  K(9)))/2D0+(C3(1,2,2)*(K(2)+K(6)+K(9)))/2D0+(C3(2,2,2)*
     &  (K(2)+K(6)+K(9)))/2D0+D4(1,1,3,3)*K(8)*DEL
        V3(14) = (C3_3(2,2,2)*K(2))/2D0+(C3_1(1,1,1)*K(9))/2D0-
     &  (C3(1,1,1)*(K(2)+K(6)+K(9)))/2D0+D4(1,2,2,2)*K(8)*DEL
        V3(15) = (C3_1(1,1,2)*K(9))/2D0-(C3(1,1,2)*(K(2)+K(6)+
     &  K(9)))/2D0+D4(1,2,2,3)*K(8)*DEL
        V3(16) = (C3_1(1,2,2)*K(9))/2D0-(C3(1,2,2)*(K(2)+K(6)+
     &  K(9)))/2D0+D4(1,2,3,3)*K(8)*DEL
        V3(17) = -((C3_2(2,2,2)*K(7))/2D0)+(C3_1(2,2,2)*K(9))/2D0-
     &  (C3(2,2,2)*(K(2)+K(6)+K(9)))/2D0+D4(1,3,3,3)*K(8)*DEL
	do i=1,17
	  X3(i) = 0d0
	do j=1,17
	  X3(i) = X3(i) + IW3(i,j)*V3(j)
	enddo
	enddo
        D3(1,1,1) = X3(1)
        D3(1,1,2) = X3(2)
        D3(1,1,3) = X3(3)
        D3(1,2,2) = X3(4)
        D3(1,2,3) = X3(5)
        D3(1,3,3) = X3(6)
        D3(2,2,2) = X3(7)
        D3(2,2,3) = X3(8)
        D3(2,3,3) = X3(9)
        D3(3,3,3) = X3(10)
        D4(0,0,0,0) = X3(11)
        D4(0,0,1,1) = X3(12)
        D4(0,0,1,2) = X3(13)
        D4(0,0,1,3) = X3(14)
        D4(0,0,2,2) = X3(15)
        D4(0,0,2,3) = X3(16)
        D4(0,0,3,3) = X3(17)

	if (rankord-i1.eq.3) goto 202

        V4(1) = (C4_3(0,0,1,1)*K(1))/2D0-(D4(0,0,1,1)*K(10))/2D0+
     &  (D4(0,0,1,3)*K(12))/2D0-(C3(0,0,1)*K(17))/2D0-(C3(0,0,2)*
     &  K(18))/2D0-(C4(0,0,1,2)*K(23))/2D0+(K(8))/48D0+D3(0,0,1)*
     &  K(9)*M02+(D4(0,0,1,2)*K(4)*P22)/2D0-(C4_3(0,0,1,2)*P22*
     &  P2P3)/2D0+(C4_2(0,0,1,1)*P1P2*P32)/2D0+(C4_2(0,0,1,2)*P2P3*
     &  P32)/2D0-(C4(0,0,1,1)*(K(1)+P22*P2P3+P1P2*P32-P22*P32))/2D0-
     &  (C2(0,0)*(K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*P32))/2D0-(C4(0,
     &  0,2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V4(2) = (C4_3(0,0,1,2)*K(1))/2D0-(D4(0,0,1,2)*K(10))/2D0+
     &  (D4(0,0,2,3)*K(12))/2D0+(C4(0,0,0,0)*K(3))/2D0+(D4(0,0,0,0)*
     &  K(5))/2D0+(K(8))/48D0+D3(0,0,2)*K(9)*M02+(D4(0,0,2,2)*K(4)*
     &  P22)/2D0-C4_3(0,0,0,0)*P2P3-(C4_3(0,0,2,2)*P22*P2P3)/2D0+
     &  (C4_2(0,0,0,0)*P32)/2D0+(C4(0,0,1,1)*(K(1)+P22*P2P3+P1P2*
     &  P32-P22*P32))/2D0+(C3(0,0,1)*(K(1)+2D0*P2P3**2+P1P2*P32-2D0*
     &  P22*P32))/2D0+(C4(0,0,1,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*
     &  P32-P2P3*P32))/2D0
        V4(3) = -((D4(0,0,1,3)*K(10))/2D0)+(D4(0,0,3,3)*K(12))/2D0+
     &  (K(8))/48D0+D3(0,0,3)*K(9)*M02-(C4(0,0,0,0)*P22)/2D0+
     &  (C4_3(0,0,0,0)*P22)/2D0+(D4(0,0,2,3)*K(4)*P22)/2D0-(D4(0,0,
     &  0,0)*F3*P22)/2D0+(C4_2(0,0,1,2)*P1P2*P32)/2D0+(C4_2(0,0,2,
     &  2)*P2P3*P32)/2D0+(C4(0,0,1,2)*(K(1)+P22*P2P3+P1P2*P32-P22*
     &  P32))/2D0+(C3(0,0,2)*(K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*
     &  P32))/2D0+(C4(0,0,2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*P32-
     &  P2P3*P32))/2D0
        V4(4) = (C4_3(1,1,1,1)*K(1))/2D0-(3D0*C2(1,1)*K(17))/2D0-
     &  (3D0*C2(2,2)*K(18))/2D0-(3D0*C4(1,1,2,2)*K(23))/2D0+D5(1,1,
     &  1,1,1)*K(8)*DEL+D3(1,1,1)*K(9)*M02-(C4_3(1,1,1,2)*P22*P2P3)/
     &  2D0+(C4_2(1,1,1,1)*P1P2*P32)/2D0+(C4_2(1,1,1,2)*P2P3*P32)/
     &  2D0-(C4(1,1,1,1)*(K(1)+P22*P2P3+P1P2*P32-P22*P32))/2D0-(C0*
     &  (K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*P32))/2D0-(C3(1,1,1)*
     &  (4D0*P1P3*P22-8D0*P1P2*P2P3+3D0*P22*P2P3+2D0*P2P3**2+4D0*
     &  P1P2*P32-5D0*P22*P32))/2D0-(C1(1)*(4D0*P1P3*P22-8D0*P1P2*
     &  P2P3+P22*P2P3+6D0*P2P3**2+4D0*P1P2*P32-7D0*P22*P32))/2D0-
     &  (C4(2,2,2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/
     &  2D0-(C4(1,1,1,2)*(4D0*P1P3*P22-8D0*P1P2*P2P3+3D0*P22*P2P3+
     &  2D0*P2P3**2+4D0*P1P2*P32-4D0*P22*P32-P2P3*P32))/2D0-(3D0*
     &  C3(1,1,2)*(4D0*P1P3*P22-8D0*P1P2*P2P3+2D0*P22*P2P3+4D0*
     &  P2P3**2+4D0*P1P2*P32-5D0*P22*P32-P2P3*P32))/2D0-(3D0*C2(1,
     &  2)*(4D0*P1P3*P22-8D0*P1P2*P2P3+P22*P2P3+6D0*P2P3**2+4D0*
     &  P1P2*P32-6D0*P22*P32-P2P3*P32))/2D0-(C1(2)*(4D0*P1P3*P22-
     &  8D0*P1P2*P2P3+8D0*P2P3**2+4D0*P1P2*P32-7D0*P22*P32-P2P3*
     &  P32))/2D0-(3D0*C3(1,2,2)*(4D0*P1P3*P22-8D0*P1P2*P2P3+P22*
     &  P2P3+6D0*P2P3**2+4D0*P1P2*P32-5D0*P22*P32-2D0*P2P3*P32))/
     &  2D0-(C4(1,2,2,2)*(4D0*P1P3*P22-8D0*P1P2*P2P3+P22*P2P3+6D0*
     &  P2P3**2+4D0*P1P2*P32-4D0*P22*P32-3D0*P2P3*P32))/2D0-(C3(2,2,
     &  2)*(4D0*P1P3*P22-8D0*P1P2*P2P3+8D0*P2P3**2+4D0*P1P2*P32-5D0*
     &  P22*P32-3D0*P2P3*P32))/2D0
        V4(5) = (C4_3(1,1,1,2)*K(1))/2D0+(C2(1,1)*K(19))/2D0+(C3(1,
     &  1,1)*K(20))/2D0+(C2(1,2)*K(21))/2D0+(C3(1,2,2)*K(22))/2D0+
     &  C3(1,1,2)*K(24)+(C4(1,1,2,2)*K(25))/2D0+(C4(1,1,1,2)*K(26))/
     &  2D0+(C2(0,0)*K(3))/2D0+C3(0,0,1)*K(3)+C3(0,0,2)*K(3)+(C4(0,
     &  0,1,1)*K(3))/2D0+C4(0,0,1,2)*K(3)+(C4(0,0,2,2)*K(3))/2D0+
     &  (D4(0,0,1,1)*K(5))/2D0+D5(1,1,1,1,2)*K(8)*DEL+D3(1,1,2)*
     &  K(9)*M02-C4_3(0,0,1,1)*P2P3-(C4_3(1,1,2,2)*P22*P2P3)/2D0+
     &  (C4_2(0,0,1,1)*P32)/2D0+(C4(1,1,1,1)*(K(1)+P22*P2P3+P1P2*
     &  P32-P22*P32))/2D0+(C1(1)*(K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*
     &  P32))/2D0+(C4(1,2,2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*P32-
     &  P2P3*P32))/2D0
        V4(6) = (C2(1,2)*K(19))/2D0+(C3(1,1,2)*K(20))/2D0+(C2(2,2)*
     &  K(21))/2D0+(C3(2,2,2)*K(22))/2D0+C3(1,2,2)*K(24)+(C4(1,2,2,
     &  2)*K(25))/2D0+(C4(1,1,2,2)*K(26))/2D0+D5(1,1,1,1,3)*K(8)*
     &  DEL+D3(1,1,3)*K(9)*M02-(C2(0,0)*P22)/2D0-C3(0,0,1)*P22-C3(0,
     &  0,2)*P22-(C4(0,0,1,1)*P22)/2D0-C4(0,0,1,2)*P22-(C4(0,0,2,2)*
     &  P22)/2D0+(C4_3(0,0,1,1)*P22)/2D0-(D4(0,0,1,1)*F3*P22)/2D0+
     &  (C4_2(1,1,1,2)*P1P2*P32)/2D0+(C4_2(1,1,2,2)*P2P3*P32)/2D0+
     &  (C4(1,1,1,2)*(K(1)+P22*P2P3+P1P2*P32-P22*P32))/2D0+(C1(2)*
     &  (K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*P32))/2D0+(C4(2,2,2,2)*
     &  (K(1)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V4(7) = (C4_3(1,1,2,2)*K(1))/2D0-(C3(1,1,1)*K(17))/2D0-
     &  (C3(1,1,2)*K(18))/2D0-(C4(1,1,1,2)*K(23))/2D0-C3(0,0,1)*
     &  K(3)-C4(0,0,1,1)*K(3)-C4(0,0,1,2)*K(3)+D4(0,0,1,2)*K(5)+
     &  D5(1,1,1,2,2)*K(8)*DEL+D3(1,2,2)*K(9)*M02-2D0*C4_3(0,0,1,2)*
     &  P2P3-(C4_3(1,2,2,2)*P22*P2P3)/2D0-(C4(1,1,1,1)*(K(1)+P22*
     &  P2P3+P1P2*P32-P22*P32))/2D0-(C2(1,1)*(K(1)+2D0*P2P3**2+P1P2*
     &  P32-2D0*P22*P32))/2D0-(C4(1,1,2,2)*(K(1)+2D0*P2P3**2+P1P2*
     &  P32-P22*P32-P2P3*P32))/2D0
        V4(8) = -((C3(1,1,2)*K(17))/2D0)-(C3(1,2,2)*K(18))/2D0-
     &  (C4(1,1,2,2)*K(23))/2D0-(C3(0,0,2)*K(3))/2D0-(C4(0,0,2,2)*
     &  K(3))/2D0+(D4(0,0,1,3)*K(5))/2D0+D5(1,1,1,2,3)*K(8)*DEL+
     &  D3(1,2,3)*K(9)*M02+(C3(0,0,1)*P22)/2D0+(C4(0,0,1,1)*P22)/
     &  2D0+(C4_3(0,0,1,2)*P22)/2D0-(D4(0,0,1,2)*F3*P22)/2D0+
     &  (C4_2(0,0,1,2)*P32)/2D0+(C4(0,0,1,2)*(P22-2D0*P2P3+P32))/
     &  2D0-(C4(1,1,1,2)*(K(1)+P22*P2P3+P1P2*P32-P22*P32))/2D0-
     &  (C2(1,2)*(K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*P32))/2D0-(C4(1,
     &  2,2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V4(9) = -((C3(1,2,2)*K(17))/2D0)-(C3(2,2,2)*K(18))/2D0-
     &  (C4(1,2,2,2)*K(23))/2D0+D5(1,1,1,3,3)*K(8)*DEL+D3(1,3,3)*
     &  K(9)*M02+C3(0,0,2)*P22+C4(0,0,1,2)*P22+C4(0,0,2,2)*P22-D4(0,
     &  0,1,3)*F3*P22+(C4_2(1,1,2,2)*P1P2*P32)/2D0+(C4_2(1,2,2,2)*
     &  P2P3*P32)/2D0-(C4(1,1,2,2)*(K(1)+P22*P2P3+P1P2*P32-P22*
     &  P32))/2D0-(C2(2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*P32))/
     &  2D0-(C4(2,2,2,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*
     &  P32))/2D0
        V4(10) = (C4_3(1,2,2,2)*K(1))/2D0+(3D0*C4(0,0,1,1)*K(3))/
     &  2D0+(3D0*D4(0,0,2,2)*K(5))/2D0+D5(1,1,2,2,2)*K(8)*DEL+D3(2,
     &  2,2)*K(9)*M02-3D0*C4_3(0,0,2,2)*P2P3-(C4_3(2,2,2,2)*P22*
     &  P2P3)/2D0+(C4(1,1,1,1)*(K(1)+P22*P2P3+P1P2*P32-P22*P32))/
     &  2D0+(C3(1,1,1)*(K(1)+2D0*P2P3**2+P1P2*P32-2D0*P22*P32))/2D0+
     &  (C4(1,1,1,2)*(K(1)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/
     &  2D0
        V4(11) = C4(0,0,1,2)*K(3)+D4(0,0,2,3)*K(5)+D5(1,1,2,2,3)*
     &  K(8)*DEL+D3(2,2,3)*K(9)*M02-(C4(0,0,1,1)*P22)/2D0+(C4_3(0,0,
     &  2,2)*P22)/2D0-(D4(0,0,2,2)*F3*P22)/2D0+(C4(1,1,1,2)*(K(1)+
     &  P22*P2P3+P1P2*P32-P22*P32))/2D0+(C3(1,1,2)*(K(1)+2D0*P2P3**
     &  2+P1P2*P32-2D0*P22*P32))/2D0+(C4(1,1,2,2)*(K(1)+2D0*P2P3**2+
     &  P1P2*P32-P22*P32-P2P3*P32))/2D0
        V4(12) = (C4(0,0,2,2)*K(3))/2D0+(D4(0,0,3,3)*K(5))/2D0+D5(1,
     &  1,2,3,3)*K(8)*DEL+D3(2,3,3)*K(9)*M02-C4(0,0,1,2)*P22-D4(0,0,
     &  2,3)*F3*P22+(C4_2(0,0,2,2)*P32)/2D0+(C4(1,1,2,2)*(K(1)+P22*
     &  P2P3+P1P2*P32-P22*P32))/2D0+(C3(1,2,2)*(K(1)+2D0*P2P3**2+
     &  P1P2*P32-2D0*P22*P32))/2D0+(C4(1,2,2,2)*(K(1)+2D0*P2P3**2+
     &  P1P2*P32-P22*P32-P2P3*P32))/2D0
        V4(13) = D5(1,1,3,3,3)*K(8)*DEL+D3(3,3,3)*K(9)*M02-(3D0*
     &  C4(0,0,2,2)*P22)/2D0-(3D0*D4(0,0,3,3)*F3*P22)/2D0+(C4_2(1,2,
     &  2,2)*P1P2*P32)/2D0+(C4_2(2,2,2,2)*P2P3*P32)/2D0+(C4(1,2,2,
     &  2)*(K(1)+P22*P2P3+P1P2*P32-P22*P32))/2D0+(C3(2,2,2)*(K(1)+
     &  2D0*P2P3**2+P1P2*P32-2D0*P22*P32))/2D0+(C4(2,2,2,2)*(K(1)+
     &  2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V4(14) = (C4_3(1,1,1,1)*K(2))/2D0-(C4_2(1,1,1,1)*K(7))/2D0-
     &  2D0*C1(1)*(K(2)+K(6)+K(9))-2D0*C1(2)*(K(2)+K(6)+K(9))-3D0*
     &  C2(1,1)*(K(2)+K(6)+K(9))-6D0*C2(1,2)*(K(2)+K(6)+K(9))-3D0*
     &  C2(2,2)*(K(2)+K(6)+K(9))-2D0*C3(1,1,1)*(K(2)+K(6)+K(9))-6D0*
     &  C3(1,1,2)*(K(2)+K(6)+K(9))-6D0*C3(1,2,2)*(K(2)+K(6)+K(9))-
     &  2D0*C3(2,2,2)*(K(2)+K(6)+K(9))-(C4(1,1,1,1)*(K(2)+K(6)+
     &  K(9)))/2D0-2D0*C4(1,1,1,2)*(K(2)+K(6)+K(9))-3D0*C4(1,1,2,2)*
     &  (K(2)+K(6)+K(9))-2D0*C4(1,2,2,2)*(K(2)+K(6)+K(9))-(C4(2,2,2,
     &  2)*(K(2)+K(6)+K(9)))/2D0-((K(2)+K(6)+K(9))*C0)/2D0+D5(1,1,1,
     &  1,1)*K(8)*DEL
        V4(15) = (C4_3(1,1,1,2)*K(2))/2D0+(C1(1)*(K(2)+K(6)+K(9)))/
     &  2D0+(3D0*C2(1,1)*(K(2)+K(6)+K(9)))/2D0+(3D0*C2(1,2)*(K(2)+
     &  K(6)+K(9)))/2D0+(3D0*C3(1,1,1)*(K(2)+K(6)+K(9)))/2D0+3D0*
     &  C3(1,1,2)*(K(2)+K(6)+K(9))+(3D0*C3(1,2,2)*(K(2)+K(6)+K(9)))/
     &  2D0+(C4(1,1,1,1)*(K(2)+K(6)+K(9)))/2D0+(3D0*C4(1,1,1,2)*
     &  (K(2)+K(6)+K(9)))/2D0+(3D0*C4(1,1,2,2)*(K(2)+K(6)+K(9)))/
     &  2D0+(C4(1,2,2,2)*(K(2)+K(6)+K(9)))/2D0+D5(1,1,1,1,2)*K(8)*
     &  DEL
        V4(16) = -((C4_2(1,1,1,2)*K(7))/2D0)+(C1(2)*(K(2)+K(6)+
     &  K(9)))/2D0+(3D0*C2(1,2)*(K(2)+K(6)+K(9)))/2D0+(3D0*C2(2,2)*
     &  (K(2)+K(6)+K(9)))/2D0+(3D0*C3(1,1,2)*(K(2)+K(6)+K(9)))/2D0+
     &  3D0*C3(1,2,2)*(K(2)+K(6)+K(9))+(3D0*C3(2,2,2)*(K(2)+K(6)+
     &  K(9)))/2D0+(C4(1,1,1,2)*(K(2)+K(6)+K(9)))/2D0+(3D0*C4(1,1,2,
     &  2)*(K(2)+K(6)+K(9)))/2D0+(3D0*C4(1,2,2,2)*(K(2)+K(6)+K(9)))/
     &  2D0+(C4(2,2,2,2)*(K(2)+K(6)+K(9)))/2D0+D5(1,1,1,1,3)*K(8)*
     &  DEL
        V4(17) = (C4_3(1,1,2,2)*K(2))/2D0-(C2(1,1)*(K(2)+K(6)+
     &  K(9)))/2D0-C3(1,1,1)*(K(2)+K(6)+K(9))-C3(1,1,2)*(K(2)+K(6)+
     &  K(9))-(C4(1,1,1,1)*(K(2)+K(6)+K(9)))/2D0-C4(1,1,1,2)*(K(2)+
     &  K(6)+K(9))-(C4(1,1,2,2)*(K(2)+K(6)+K(9)))/2D0+D5(1,1,1,2,2)*
     &  K(8)*DEL
        V4(18) = -((C2(1,2)*(K(2)+K(6)+K(9)))/2D0)-C3(1,1,2)*(K(2)+
     &  K(6)+K(9))-C3(1,2,2)*(K(2)+K(6)+K(9))-(C4(1,1,1,2)*(K(2)+
     &  K(6)+K(9)))/2D0-C4(1,1,2,2)*(K(2)+K(6)+K(9))-(C4(1,2,2,2)*
     &  (K(2)+K(6)+K(9)))/2D0+D5(1,1,1,2,3)*K(8)*DEL
        V4(19) = -((C4_2(1,1,2,2)*K(7))/2D0)-(C2(2,2)*(K(2)+K(6)+
     &  K(9)))/2D0-C3(1,2,2)*(K(2)+K(6)+K(9))-C3(2,2,2)*(K(2)+K(6)+
     &  K(9))-(C4(1,1,2,2)*(K(2)+K(6)+K(9)))/2D0-C4(1,2,2,2)*(K(2)+
     &  K(6)+K(9))-(C4(2,2,2,2)*(K(2)+K(6)+K(9)))/2D0+D5(1,1,1,3,3)*
     &  K(8)*DEL
        V4(20) = (C4_3(1,2,2,2)*K(2))/2D0+(C3(1,1,1)*(K(2)+K(6)+
     &  K(9)))/2D0+(C4(1,1,1,1)*(K(2)+K(6)+K(9)))/2D0+(C4(1,1,1,2)*
     &  (K(2)+K(6)+K(9)))/2D0+D5(1,1,2,2,2)*K(8)*DEL
        V4(21) = (C3(1,1,2)*(K(2)+K(6)+K(9)))/2D0+(C4(1,1,1,2)*
     &  (K(2)+K(6)+K(9)))/2D0+(C4(1,1,2,2)*(K(2)+K(6)+K(9)))/2D0+
     &  D5(1,1,2,2,3)*K(8)*DEL
        V4(22) = (C3(1,2,2)*(K(2)+K(6)+K(9)))/2D0+(C4(1,1,2,2)*
     &  (K(2)+K(6)+K(9)))/2D0+(C4(1,2,2,2)*(K(2)+K(6)+K(9)))/2D0+
     &  D5(1,1,2,3,3)*K(8)*DEL
        V4(23) = -((C4_2(1,2,2,2)*K(7))/2D0)+(C3(2,2,2)*(K(2)+K(6)+
     &  K(9)))/2D0+(C4(1,2,2,2)*(K(2)+K(6)+K(9)))/2D0+(C4(2,2,2,2)*
     &  (K(2)+K(6)+K(9)))/2D0+D5(1,1,3,3,3)*K(8)*DEL
        V4(24) = (C4_3(2,2,2,2)*K(2))/2D0+(C4_1(1,1,1,1)*K(9))/2D0-
     &  (C4(1,1,1,1)*(K(2)+K(6)+K(9)))/2D0+D5(1,2,2,2,2)*K(8)*DEL
        V4(25) = (C4_1(1,1,1,2)*K(9))/2D0-(C4(1,1,1,2)*(K(2)+K(6)+
     &  K(9)))/2D0+D5(1,2,2,2,3)*K(8)*DEL
        V4(26) = (C4_1(1,1,2,2)*K(9))/2D0-(C4(1,1,2,2)*(K(2)+K(6)+
     &  K(9)))/2D0+D5(1,2,2,3,3)*K(8)*DEL
        V4(27) = (C4_1(1,2,2,2)*K(9))/2D0-(C4(1,2,2,2)*(K(2)+K(6)+
     &  K(9)))/2D0+D5(1,2,3,3,3)*K(8)*DEL
        V4(28) = -((C4_2(2,2,2,2)*K(7))/2D0)+(C4_1(2,2,2,2)*K(9))/
     &  2D0-(C4(2,2,2,2)*(K(2)+K(6)+K(9)))/2D0+D5(1,3,3,3,3)*K(8)*
     &  DEL
	do i=1,28
	  X4(i) = 0d0
	do j=1,28
	  X4(i) = X4(i) + IW4(i,j)*V4(j)
	enddo
	enddo
        D4(1,1,1,1) = X4(1)
        D4(1,1,1,2) = X4(2)
        D4(1,1,1,3) = X4(3)
        D4(1,1,2,2) = X4(4)
        D4(1,1,2,3) = X4(5)
        D4(1,1,3,3) = X4(6)
        D4(1,2,2,2) = X4(7)
        D4(1,2,2,3) = X4(8)
        D4(1,2,3,3) = X4(9)
        D4(1,3,3,3) = X4(10)
        D4(2,2,2,2) = X4(11)
        D4(2,2,2,3) = X4(12)
        D4(2,2,3,3) = X4(13)
        D4(2,3,3,3) = X4(14)
        D4(3,3,3,3) = X4(15)
        D5(0,0,0,0,1) = X4(16)
        D5(0,0,0,0,2) = X4(17)
        D5(0,0,0,0,3) = X4(18)
        D5(0,0,1,1,1) = X4(19)
        D5(0,0,1,1,2) = X4(20)
        D5(0,0,1,1,3) = X4(21)
        D5(0,0,1,2,2) = X4(22)
        D5(0,0,1,2,3) = X4(23)
        D5(0,0,1,3,3) = X4(24)
        D5(0,0,2,2,2) = X4(25)
        D5(0,0,2,2,3) = X4(26)
        D5(0,0,2,3,3) = X4(27)
        D5(0,0,3,3,3) = X4(28)

202	continue
	i1=i1+1
	goto 201
250	continue

c*** non-ordered coefficients up to rank 3
	D2(2,1) = D2(1,2)
	D2(3,1) = D2(1,3)
	D2(3,2) = D2(2,3)
        D3(1,3,2) = D3(1,2,3)
        D3(2,1,3) = D3(1,2,3)
        D3(2,3,1) = D3(1,2,3)
        D3(3,1,2) = D3(1,2,3)
        D3(3,2,1) = D3(1,2,3)
        D3(1,2,1) = D3(1,1,2)
        D3(2,1,1) = D3(1,1,2)
        D3(2,2,1) = D3(1,2,2)
        D3(2,1,2) = D3(1,2,2)
        D3(1,3,1) = D3(1,1,3)
        D3(3,1,1) = D3(1,1,3)
        D3(3,3,1) = D3(1,3,3)
        D3(3,1,3) = D3(1,3,3)
        D3(2,3,2) = D3(2,2,3)
        D3(3,2,2) = D3(2,2,3)
        D3(3,3,2) = D3(2,3,3)
        D3(3,2,3) = D3(2,3,3)

	end

***********************************************************************
        SUBROUTINE xD012345_sing2(Q1,Q2,Q3,Q4,Q23,Q12,M02,M12,M22,M32,
     *                     D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
***********************************************************************
*	4-point tensor coefficients with complex masses
*	--- expansion about vanishing Gram determinant
*	    and about vanishing Cayley determinant ---
*-----------------------------------------------------------------------
*       23.11.04 Stefan Dittmaier
***********************************************************************
        implicit real*8 (a-z)
        complex*16 nix
        complex*16 K(29),xD0_,aux
        complex*16 M02,M12,M22,M32,F1,F2,F3,delf
        COMPLEX*16   B0,  B1(1),  B2(0:2,0:2),  B3(0:2,0:2,2)
        COMPLEX*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
        COMPLEX*16   C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_1,C1_1(2),C2_1(0:2,0:2),C3_1(0:2,0:2,2)
        COMPLEX*16 C4_1(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_2,C1_2(2),C2_2(0:2,0:2),C3_2(0:2,0:2,2)
        COMPLEX*16 C4_2(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_3,C1_3(2),C2_3(0:2,0:2),C3_3(0:2,0:2,2)
        COMPLEX*16 C4_3(0:2,0:2,0:2,0:2)
        COMPLEX*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        complex*16 mm02,mm12,mm22,mm32
	real*8 detx(8)
	integer rank,ext,ord,i,j,i1,i2,i3,i4,i5,ncase

	detxx(k1,k2,k3,k4,k23,k12,mm02,mm12,mm22,mm32) = abs(
     &	  4d0*k12*k4*mm02-(k12-k3+k4)**2*mm02-k4*(k12+mm02-mm22)**2
     &	  +(k12-k3+k4)*(k12+mm02-mm22)*(k4+mm02-mm32)
     &	  -k12*(k4+mm02-mm32)**2 )/ref**3

        if (rank.gt.3) then
          write(*,*) 'rank>3 not implemented in xD012345_sing2!',rank
          stop
        endif

	ref = (abs(q1)+abs(q2)+abs(q3)+abs(q4)+abs(q23)+abs(q12))/6d0
	detx(1) = detxx(q1,q2,q3,q4,q23,q12,m02,m12,m22,m32)
	detx(2) = detxx(q4,q3,q2,q1,q23,q12,m02,m32,m22,m12)
	detx(3) = detxx(q3,q4,q1,q2,q23,q12,m22,m32,m02,m12)
	detx(4) = detxx(q2,q1,q4,q3,q23,q12,m22,m12,m02,m32)
	detx(5) = detxx(q3,q2,q1,q4,q12,q23,m32,m22,m12,m02)
	detx(6) = detxx(q2,q12,q4,q23,q3,q1,m12,m22,m02,m32)
	detx(7) = detxx(q1,q4,q3,q2,q12,q23,m12,m02,m32,m22)
	detx(8) = detxx(q4,q12,q2,q23,q1,q3,m32,m02,m22,m12)

	ncase   = 0
	detxmax = 0
	do i=1,8
	if (detx(i).gt.detxmax) then
	  detxmax = detx(i)
	  ncase   = i
	endif
	enddo

	if (detxmax.lt.1d-5) then
	write(*,*)
	write(*,*) 'huhu ',ncase,detxmax
	write(*,*) 'args ',q1,q2,q3,q4,q23,q12,m02,m12,m22,m32
	endif

	p12  = q1
	p22  = q12
	p32  = q4
	p1p2 = (p12+p22-q2 )/2d0
	p1p3 = (p12+p32-q23)/2d0
	p2p3 = (p22+p32-q3 )/2d0

	f1   = p12-m12+m02
	f2   = p22-m22+m02
	f3   = p32-m32+m02

        aux1 = abs(P2P3**2-P22*P32) / ref**2
        aux2 = abs(P1P3**2-P12*P32) / ref**2
        aux3 = abs(P1P2**2-P12*P22) / ref**2

        par1a = abs(F3*P22-F2*P2P3) / ref**2
        par2a = abs(F1*P32-F3*P1P3) / ref**2
        par3a = abs(F2*P12-F1*P1P2) / ref**2

        par1b = abs(F3*P2P3-F2*P32) / ref**2
        par2b = abs(F1*P1P3-F3*P12) / ref**2
        par3b = abs(F2*P1P2-F1*P12) / ref**2

c |P2P3**2-P22*P32| maximal
	if ((aux1.gt.aux2).and.(aux1.gt.aux3)) then
c momentum ordering 123
	  if (par1a.gt.par1b) then
            call xD012345_sing2x(Q1,Q2,Q3,Q4,Q23,Q12,M02,M12,M22,M32,
     &                     D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
c momentum ordering 132
	  else
            call xD012345_sing2x(Q1,Q23,Q3,Q12,Q2,Q4,M02,M12,M32,M22,
     &                     D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
	    call Dswap(D0,D1,D2,D3,D4,D5,2,3,rank)
	  endif

c |P1P3**2-P12*P32| maximal
 	elseif ((aux2.gt.aux1).and.(aux2.gt.aux3)) then

c momentum ordering 231
	  if (par2a.gt.par2b) then
            call xD012345_sing2x(Q12,Q3,Q23,Q1,Q2,Q4,M02,M22,M32,M12,
     &                     D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
            call Drot(D0,D1,D2,D3,D4,D5,1,2,3,rank)
c momentum ordering 213
	  else
            call xD012345_sing2x(Q12,Q2,Q23,Q4,Q3,Q1,M02,M22,M12,M32,
     &                     D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
	    call Dswap(D0,D1,D2,D3,D4,D5,1,2,rank)
	  endif

c |P1P2**2-P12*P22| maximal
	elseif ((aux3.gt.aux1).and.(aux3.gt.aux2)) then
c momentum ordering 312
	  if (par3a.gt.par3b) then
            call xD012345_sing2x(Q4,Q23,Q2,Q12,Q3,Q1,M02,M32,M12,M22,
     &                     D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
            call Drot(D0,D1,D2,D3,D4,D5,1,3,2,rank)
c momentum ordering 321
	  else
            call xD012345_sing2x(Q4,Q3,Q2,Q1,Q23,Q12,M02,M32,M22,M12,
     &                     D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
	    call Dswap(D0,D1,D2,D3,D4,D5,1,3,rank)
	  endif
	endif

c*** test output
c        write(*,*)
c        write(*,*) 'args   ', Q1,Q2,Q3,Q4,Q23,Q12,M02,M12,M22,M32
c        write(*,*) 'aux1   ', aux1
c        write(*,*) 'aux2   ', aux2
c        write(*,*) 'aux3   ', aux3
c        write(*,*) 'par1   ', par1a,par1b
c        write(*,*) 'par2   ', par2a,par2b
c        write(*,*) 'par3   ', par3a,par3b
c	write(*,*) 'f1  ',f1
c	write(*,*) 'f2  ',f2
c	write(*,*) 'f3  ',f3
c
c        write(*,*) '  D0          = ',
c     &		xD0_(Q1,Q2,Q3,Q4,Q12,Q23,M02,M12,M22,M32,0)
c        write(*,*) 'aaD0          = ',D0
c        write(*,*) 'aaD1(1)       = ',D1(1)
c        write(*,*) 'aaD1(2)       = ',D1(2)
c        write(*,*) 'aaD1(3)       = ',D1(3)
c        write(*,*) 'aaD2(0,0)     = ',D2(0,0)
c        write(*,*) 'aaD2(1,1)     = ',D2(1,1)
c        write(*,*) 'aaD2(1,2)     = ',D2(1,2)
c        write(*,*) 'aaD2(1,3)     = ',D2(1,3)
c        write(*,*) 'aaD2(2,2)     = ',D2(2,2)
c        write(*,*) 'aaD2(2,3)     = ',D2(2,3)
c        write(*,*) 'aaD2(3,3)     = ',D2(3,3)
c        write(*,*) 'aaD3(0,0,1)   = ',D3(0,0,1)
c        write(*,*) 'aaD3(0,0,2)   = ',D3(0,0,2)
c        write(*,*) 'aaD3(0,0,3)   = ',D3(0,0,3)
c        write(*,*) 'aaD3(1,1,1)   = ',D3(1,1,1)
c        write(*,*) 'aaD3(1,1,2)   = ',D3(1,1,2)
c        write(*,*) 'aaD3(1,1,3)   = ',D3(1,1,3)
c        write(*,*) 'aaD3(1,2,2)   = ',D3(1,2,2)
c        write(*,*) 'aaD3(1,2,3)   = ',D3(1,2,3)
c        write(*,*) 'aaD3(1,3,3)   = ',D3(1,3,3)
c        write(*,*) 'aaD3(2,2,2)   = ',D3(2,2,2)
c        write(*,*) 'aaD3(2,2,3)   = ',D3(2,2,3)
c        write(*,*) 'aaD3(2,3,3)   = ',D3(2,3,3)
c        write(*,*) 'aaD3(3,3,3)   = ',D3(3,3,3)
c        write(*,*) 'aaD4(0,0,0,0) = ',D4(0,0,0,0)
c        write(*,*) 'aaD4(0,0,1,1) = ',D4(0,0,1,1)
c        write(*,*) 'aaD4(0,0,1,2) = ',D4(0,0,1,2)
c        write(*,*) 'aaD4(0,0,1,3) = ',D4(0,0,1,3)
c        write(*,*) 'aaD4(0,0,2,2) = ',D4(0,0,2,2)
c        write(*,*) 'aaD4(0,0,2,3) = ',D4(0,0,2,3)
c        write(*,*) 'aaD4(0,0,3,3) = ',D4(0,0,3,3)
c        write(*,*) 'aaD4(1,1,1,1) = ',D4(1,1,1,1)
c        write(*,*) 'aaD4(1,1,1,2) = ',D4(1,1,1,2)
c        write(*,*) 'aaD4(1,1,1,3) = ',D4(1,1,1,3)
c        write(*,*) 'aaD4(1,1,2,2) = ',D4(1,1,2,2)
c        write(*,*) 'aaD4(1,1,2,3) = ',D4(1,1,2,3)
c        write(*,*) 'aaD4(1,1,3,3) = ',D4(1,1,3,3)
c        write(*,*) 'aaD4(1,2,2,2) = ',D4(1,2,2,2)
c        write(*,*) 'aaD4(1,2,2,3) = ',D4(1,2,2,3)
c        write(*,*) 'aaD4(1,2,3,3) = ',D4(1,2,3,3)
c        write(*,*) 'aaD4(1,3,3,3) = ',D4(1,3,3,3)
c        write(*,*) 'aaD4(2,2,2,2) = ',D4(2,2,2,2)
c        write(*,*) 'aaD4(2,2,2,3) = ',D4(2,2,2,3)
c        write(*,*) 'aaD4(2,2,3,3) = ',D4(2,2,3,3)
c        write(*,*) 'aaD4(2,3,3,3) = ',D4(2,3,3,3)
c        write(*,*) 'aaD4(3,3,3,3) = ',D4(3,3,3,3)

	end

***********************************************************************
        SUBROUTINE xD012345_sing2x(Q1,Q2,Q3,Q4,Q23,Q12,M02,M12,M22,M32,
     *                     D0,D1,D2,D3,D4,D5,C0,C1,C2,C3,C4,rank,ext)
***********************************************************************
*	4-point tensor coefficients with complex masses
*	--- expansion about vanishing Gram determinant
*	    and about vanishing Cayley determinant ---
*	explicit calculation under conditions
*         |P2P3**2-P22*P32| > 0,|P1P3**2-P12*P32|,|P1P2**2-P12*P22|
*	  |F3*P22-F2*P2P3|  > 0,|F3*P2P3-F2*P32|
*-----------------------------------------------------------------------
*       24.11.04 Stefan Dittmaier
***********************************************************************
        implicit real*8 (a-z)
        complex*16 nix
        complex*16 K(29),xD0_
        complex*16 M02,M12,M22,M32,F1,F2,F3,delf
        COMPLEX*16   B0,  B1(1),  B2(0:2,0:2),  B3(0:2,0:2,2)
        COMPLEX*16   C0,  C1(2),  C2(0:2,0:2),  C3(0:2,0:2,2)
        COMPLEX*16   C4(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_1,C1_1(2),C2_1(0:2,0:2),C3_1(0:2,0:2,2)
        COMPLEX*16 C4_1(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_2,C1_2(2),C2_2(0:2,0:2),C3_2(0:2,0:2,2)
        COMPLEX*16 C4_2(0:2,0:2,0:2,0:2)
        COMPLEX*16 C0_3,C1_3(2),C2_3(0:2,0:2),C3_3(0:2,0:2,2)
        COMPLEX*16 C4_3(0:2,0:2,0:2,0:2)
        COMPLEX*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        COMPLEX*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
	complex*16  W0( 2, 2),V0( 2),X0( 2),IW0( 2, 2)
	complex*16  W1( 6, 6),V1( 6),X1( 6),IW1( 6, 6)
	complex*16  W2(13,13),V2(13),X2(13),IW2(13,13)
	complex*16  W3(23,23),V3(23),X3(23),IW3(23,23)
	integer rank,ext,ord,i,j,i1,i2,i3,i4,i5,rankord

c*** order of expansion
	ord = 0

	rankord = rank+2*ord

	if ((rank.gt.3).or.(ord.gt.0)) then
	  write(*,*) 'rank>3, ord>0 not implemented in xD012345_sing2!',
     &			rank,ord
	  stop
	endif

c*** initialization
	  D0          = 0d0
	  D2(0,0)     = 0d0
	  D4(0,0,0,0) = 0d0
	do 100 i1=1,3
	  D1(i1)         = 0d0
	  D3(0,0,i1)     = 0d0
	  D5(0,0,0,0,i1) = 0d0
	do 100 i2=i1,3
	  D2(i1,i2)     = 0d0
	  D4(0,0,i1,i2) = 0d0
	do 100 i3=i2,3
	  D3(i1,i2,i3)     = 0d0
	  D5(0,0,i1,i2,i3) = 0d0
	do 100 i4=i3,3
	  D4(i1,i2,i3,i4) = 0d0
	do 100 i5=i4,3
	  D5(i1,i2,i3,i4,i5) = 0d0
100	continue

	p12  = q1
	p22  = q12
	p32  = q4
	p1p2 = (p12+p22-q2 )/2d0
	p1p3 = (p12+p32-q23)/2d0
	p2p3 = (p22+p32-q3 )/2d0

	f1   = p12-m12+m02
	f2   = p22-m22+m02
	f3   = p32-m32+m02

	p12  = (P1P3**2*P22-2D0*P1P2*P1P3*P2P3+P1P2**2*P32)
     &  	/(-P2P3**2+P22*P32)
	del  = q1-p12
	f1   = (-f3*p1p3*p22+f3*p1p2*p2p3+f2*p1p3*p2p3-f2*p1p2*p32)
     &          /(p2p3**2-p22*p32)
	delf = p12-m12+m02-f1

        CALL xC01234_(Q2,Q3,Q23,M12,M22,M32,
     &            C0  ,C1  ,C2  ,C3  ,C4  ,B0,B1,B2,B3,rank+ord+1,ext)
        CALL xC01234_(Q12,Q3,Q4,M02,M22,M32,
     &            C0_1,C1_1,C2_1,C3_1,C4_1,B0,B1,B2,B3,rank+ord+1,ext)
        CALL xC01234_(Q1,Q23,Q4,M02,M12,M32,
     &            C0_2,C1_2,C2_2,C3_2,C4_2,B0,B1,B2,B3,rank+ord+1,ext)
        CALL xC01234_(Q1,Q2,Q12,M02,M12,M22,
     &            C0_3,C1_3,C2_3,C3_3,C4_3,B0,B1,B2,B3,rank+ord+1,ext)

cxxx
	ref  = (abs(q1)+abs(q2)+abs(q3)+abs(q4)+abs(q23)+abs(q12))/6d0
        aux1 = abs(P2P3**2-P22*P32) / ref**2
        par1a = abs(F3*P22-F2*P2P3) / ref**2
        par1b = abs(F3*P2P3-F2*P32) / ref**2
c	write(*,*) 'xxx ',aux1,par1a,par1b

c matrices for sets of linear equations
        K(1) = DEL+DELF
        K(2) = -(F3*P22)+F2*P2P3
        K(3) = F3*P22-F2*P2P3
        K(4) = P1P3*P22-2D0*P1P2*P2P3
        K(5) = P1P3*P22-P1P2*P2P3
        K(6) = 2D0*P2P3-P32
        K(7) = 2D0*F3*P2P3-F2*P32
        K(8) = P1P3*P2P3-P1P2*P32
        K(9) = -(P2P3**2)+P22*P32
        K(10) = P2P3**2-P22*P32
        K(11) = -(F3**2*P22)+2D0*F2*F3*P2P3-4D0*M02*P2P3**2-F2**2*
     &  P32+4D0*M02*P22*P32
        K(12) = F3**2*P22-2D0*F2*F3*P2P3+4D0*M02*P2P3**2+F2**2*P32-
     &  4D0*M02*P22*P32
        K(13) = P1P3*P22-2D0*P1P2*P2P3+P22*P2P3+P1P2*P32-P22*P32
        K(14) = DEL*F3*P22-DEL*P1P3*P22-DELF*P1P3*P22-DEL*F2*P2P3+
     &  DEL*P1P2*P2P3+DELF*P1P2*P2P3
        K(15) = P1P3*P22-2D0*P1P2*P2P3+2D0*P2P3**2+P1P2*P32-P22*P32-
     &  P2P3*P32
        K(16) = 2D0*P1P3*P22-4D0*P1P2*P2P3+P22*P2P3+2D0*P2P3**2+2D0*
     &  P1P2*P32-2D0*P22*P32-P2P3*P32
        K(17) = 3D0*P1P3*P22-6D0*P1P2*P2P3+P22*P2P3+4D0*P2P3**2+3D0*
     &  P1P2*P32-3D0*P22*P32-2D0*P2P3*P32
        K(18) = 3D0*P1P3*P22-6D0*P1P2*P2P3+2D0*P22*P2P3+2D0*P2P3**2+
     &  3D0*P1P2*P32-3D0*P22*P32-P2P3*P32
        K(19) = F3*P22+2D0*P1P3*P22-2D0*F3*P2P3-4D0*P1P2*P2P3+4D0*
     &  P2P3**2+F2*P32+2D0*P1P2*P32-4D0*P22*P32
        K(20) = F3*P1P3*P22**2-F3*P1P2*P22*P2P3-F2*P1P3*P22*P2P3+F2*
     &  P1P2*P2P3**2-DEL*P22*P2P3**2-DELF*P22*P2P3**2+DEL*P22**2*
     &  P32+DELF*P22**2*P32
        K(21) = -(F3*P1P3*P22*P2P3)+F2*P1P3*P2P3**2+DEL*P2P3**3+
     &  DELF*P2P3**3+F3*P1P2*P22*P32-F2*P1P2*P2P3*P32-DEL*P22*P2P3*
     &  P32-DELF*P22*P2P3*P32
        K(22) = F3*P22+3D0*P1P3*P22-2D0*F3*P2P3-6D0*P1P2*P2P3+P22*
     &  P2P3+4D0*P2P3**2+F2*P32+3D0*P1P2*P32-5D0*P22*P32
        K(23) = F3*P22+3D0*P1P3*P22-2D0*F3*P2P3-6D0*P1P2*P2P3+6D0*
     &  P2P3**2+F2*P32+3D0*P1P2*P32-5D0*P22*P32-P2P3*P32
        K(24) = F3*P22+4D0*P1P3*P22-2D0*F3*P2P3-8D0*P1P2*P2P3+2D0*
     &  P22*P2P3+4D0*P2P3**2+F2*P32+4D0*P1P2*P32-6D0*P22*P32
        K(25) = F3*P22+4D0*P1P3*P22-2D0*F3*P2P3-8D0*P1P2*P2P3+8D0*
     &  P2P3**2+F2*P32+4D0*P1P2*P32-6D0*P22*P32-2D0*P2P3*P32
        K(26) = F3*P22+6D0*P1P3*P22-2D0*F3*P2P3-12D0*P1P2*P2P3+4D0*
     &  P22*P2P3+4D0*P2P3**2+F2*P32+6D0*P1P2*P32-8D0*P22*P32
        K(27) = F3*P22+6D0*P1P3*P22-2D0*F3*P2P3-12D0*P1P2*P2P3+12D0*
     &  P2P3**2+F2*P32+6D0*P1P2*P32-8D0*P22*P32-4D0*P2P3*P32
        K(28) = F3*P22+6D0*P1P3*P22-2D0*F3*P2P3-12D0*P1P2*P2P3+2D0*
     &  P22*P2P3+8D0*P2P3**2+F2*P32+6D0*P1P2*P32-8D0*P22*P32-2D0*
     &  P2P3*P32
        K(29) = F3*P1P3*P22**2-F3*P1P2*P22*P2P3-F2*P1P3*P22*P2P3-F3*
     &  P1P3*P22*P2P3+F2*P1P2*P2P3**2+F2*P1P3*P2P3**2-DEL*P22*P2P3**
     &  2-DELF*P22*P2P3**2+F3*P22*P2P3**2+DEL*P2P3**3+DELF*P2P3**3-
     &  F2*P2P3**3+F3*P1P2*P22*P32+DEL*P22**2*P32+DELF*P22**2*P32-
     &  F3*P22**2*P32-F2*P1P2*P2P3*P32-DEL*P22*P2P3*P32-DELF*P22*
     &  P2P3*P32+F2*P22*P2P3*P32

	do i=1,2
	do j=1,2
	  W0(i,j) = 0d0
	enddo
	enddo
        W0(1,1) = (K(11))/4D0
        W0(1,2) = 2D0*K(10)
        W0(2,2) = K(2)
	call xinverse(W0,IW0,2)
cxxx
c	if ((abs(k(2)/ref**2).lt.1d-10).or.
c     &	    (abs(k(11)/ref**3).lt.1d-10)) then
c        write(*,*) 'args   ', Q1,Q2,Q3,Q4,Q23,Q12,M02,M12,M22,M32
c	write(*,*) 'f1 ',f1
c	write(*,*) 'f2 ',f2
c	write(*,*) 'f3 ',f3
c	write(*,*) 'k(2)/ref  ',abs(k(2)/ref**2)
c	write(*,*) 'k(11)/ref ',abs(k(11)/ref**2)
c	stop
c	endif

	if (rankord.le.0) goto 200

	do i=1,6
	do j=1,6
	  W1(i,j) = 0d0
	enddo
	enddo
        W1(1,1) = (K(11))/4D0
        W1(1,4) = 4D0*K(10)
        W1(2,2) = (K(11))/4D0
        W1(2,4) = -(2D0*K(8))
        W1(2,5) = 2D0*K(10)
        W1(3,3) = (K(11))/4D0
        W1(3,4) = 2D0*K(5)
        W1(3,6) = 2D0*K(10)
        W1(4,4) = -(2D0*K(3))
        W1(5,4) = -((K(21))/K(10))
        W1(5,5) = K(2)
        W1(6,4) = K(20)/K(9)
        W1(6,6) = K(2)
	call xinverse(W1,IW1,6)

	if (rankord.le.1) goto 200

	do i=1,13
	do j=1,13
	  W2(i,j) = 0d0
	enddo
	enddo
        W2(1,7) = 4D0*K(10)
        W2(1,8) = -(K(9)*DEL)
        W2(2,1) = (K(11))/4D0
        W2(2,8) = 6D0*K(10)
        W2(3,2) = (K(11))/4D0
        W2(3,8) = -(2D0*K(8))
        W2(3,9) = 4D0*K(10)
        W2(4,3) = (K(11))/4D0
        W2(4,8) = 2D0*K(5)
        W2(4,10) = 4D0*K(10)
        W2(5,4) = (K(11))/4D0
        W2(5,7) = 2D0*P32
        W2(5,9) = -(4D0*K(8))
        W2(5,11) = 2D0*K(10)
        W2(6,5) = (K(11))/4D0
        W2(6,7) = -(2D0*P2P3)
        W2(6,9) = 2D0*K(5)
        W2(6,10) = -(2D0*K(8))
        W2(6,12) = 2D0*K(10)
        W2(7,6) = (K(11))/4D0
        W2(7,7) = 2D0*P22
        W2(7,10) = 4D0*K(5)
        W2(7,13) = 2D0*K(10)
        W2(8,8) = -(3D0*K(3))
        W2(9,8) = -((K(21))/K(10))
        W2(9,9) = -(2D0*K(3))
        W2(10,8) = K(20)/K(9)
        W2(10,10) = -(2D0*K(3))
        W2(11,9) = -((2D0*K(21))/K(10))
        W2(11,11) = K(2)
        W2(12,9) = K(20)/K(9)
        W2(12,10) = -((K(21))/K(10))
        W2(12,12) = K(2)
        W2(13,10) = (2D0*K(20))/K(9)
        W2(13,13) = K(2)
	call xinverse(W2,IW2,13)

	if (rankord.le.2) goto 200

	do i=1,23
	do j=1,23
	  W3(i,j) = 0d0
	enddo
	enddo
        W3(1,11) = 6D0*K(10)
        W3(1,14) = -(K(9)*DEL)
        W3(2,11) = -(2D0*K(8))
        W3(2,12) = 4D0*K(10)
        W3(2,15) = -(K(9)*DEL)
        W3(3,11) = 2D0*K(5)
        W3(3,13) = 4D0*K(10)
        W3(3,16) = -(K(9)*DEL)
        W3(4,1) = (K(11))/4D0
        W3(4,14) = 8D0*K(10)
        W3(5,2) = (K(11))/4D0
        W3(5,14) = -(2D0*K(8))
        W3(5,15) = 6D0*K(10)
        W3(6,3) = (K(11))/4D0
        W3(6,14) = 2D0*K(5)
        W3(6,16) = 6D0*K(10)
        W3(7,4) = (K(11))/4D0
        W3(7,11) = 2D0*P32
        W3(7,15) = -(4D0*K(8))
        W3(7,17) = 4D0*K(10)
        W3(8,5) = (K(11))/4D0
        W3(8,11) = -(2D0*P2P3)
        W3(8,15) = 2D0*K(5)
        W3(8,16) = -(2D0*K(8))
        W3(8,18) = 4D0*K(10)
        W3(9,6) = (K(11))/4D0
        W3(9,11) = 2D0*P22
        W3(9,16) = 4D0*K(5)
        W3(9,19) = 4D0*K(10)
        W3(10,7) = (K(11))/4D0
        W3(10,12) = 6D0*P32
        W3(10,17) = -(6D0*K(8))
        W3(10,20) = 2D0*K(10)
        W3(11,8) = (K(11))/4D0
        W3(11,12) = -(4D0*P2P3)
        W3(11,13) = 2D0*P32
        W3(11,17) = 2D0*K(5)
        W3(11,18) = -(4D0*K(8))
        W3(11,21) = 2D0*K(10)
        W3(12,9) = (K(11))/4D0
        W3(12,12) = 2D0*P22
        W3(12,13) = -(4D0*P2P3)
        W3(12,18) = 4D0*K(5)
        W3(12,19) = -(2D0*K(8))
        W3(12,22) = 2D0*K(10)
        W3(13,10) = (K(11))/4D0
        W3(13,13) = 6D0*P22
        W3(13,19) = 6D0*K(5)
        W3(13,23) = 2D0*K(10)
        W3(14,14) = -(4D0*K(3))
        W3(15,14) = -((K(21))/K(10))
        W3(15,15) = -(3D0*K(3))
        W3(16,14) = K(20)/K(9)
        W3(16,16) = -(3D0*K(3))
        W3(17,15) = -((2D0*K(21))/K(10))
        W3(17,17) = -(2D0*K(3))
        W3(18,15) = K(20)/K(9)
        W3(18,16) = -((K(21))/K(10))
        W3(18,18) = -(2D0*K(3))
        W3(19,16) = (2D0*K(20))/K(9)
        W3(19,19) = -(2D0*K(3))
        W3(20,17) = -((3D0*K(21))/K(10))
        W3(20,20) = K(2)
        W3(21,17) = K(20)/K(9)
        W3(21,18) = -((2D0*K(21))/K(10))
        W3(21,21) = K(2)
        W3(22,18) = (2D0*K(20))/K(9)
        W3(22,19) = -((K(21))/K(10))
        W3(22,22) = K(2)
        W3(23,19) = (3D0*K(20))/K(9)
        W3(23,23) = K(2)
	call xinverse(W3,IW3,23)

200	continue

	i1=0
201	continue
	if (i1.gt.ord) goto 250

        V0(1) = (C1_3(1)*K(4))/2D0+(K(19)*C0)/4D0+(K(7)*C0_2)/4D0+
     &  D2(1,1)*K(9)*DEL-(C0_3*F3*P22)/4D0-(C1_3(2)*P22*P2P3)/2D0+
     &  (C1_2(1)*P1P2*P32)/2D0+(C1_2(2)*P2P3*P32)/2D0+(C1(1)*(K(4)+
     &  P22*P2P3+P1P2*P32-P22*P32))/2D0+(C1(2)*(K(4)+2D0*P2P3**2+
     &  P1P2*P32-P22*P32-P2P3*P32))/2D0
        V0(2) = D2(1,1)*K(14)-(C1_2(1)*K(21))/(2D0*K(10))-D2(1,3)*
     &  K(1)*K(9)+(C1_3(1)*K(20))/(2D0*K(9))+(C1(1)*(K(20)+K(21)+F3*
     &  P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))+(C1(2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**
     &  2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(C0*(K(20)+K(21)+F3*P22*
     &  P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))
	do i=1,2
	  X0(i) = 0d0
	do j=1,2
	  X0(i) = X0(i) + IW0(i,j)*V0(j)
	enddo
	enddo
        D0 = X0(1)
        D2(0,0) = X0(2)

	if (rankord-i1.le.0) goto 202

        V1(1) = -((C2(1,2)*K(16))/2D0)-(C1(1)*K(24))/4D0-(C1(2)*
     &  K(25))/4D0+(C2_3(1,1)*K(4))/2D0+(C1_2(1)*K(7))/4D0-(K(19)*
     &  C0)/4D0+D3(1,1,1)*K(9)*DEL-(C1_3(1)*F3*P22)/4D0-(C2_3(1,2)*
     &  P22*P2P3)/2D0+(C2_2(1,1)*P1P2*P32)/2D0+(C2_2(1,2)*P2P3*P32)/
     &  2D0-(C2(1,1)*(K(4)+P22*P2P3+P1P2*P32-P22*P32))/2D0-(C2(2,2)*
     &  (K(4)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V1(2) = (C1(1)*K(19))/4D0+(C2_3(1,2)*K(4))/2D0+(C2(0,0)*
     &  K(6))/2D0+D3(1,1,2)*K(9)*DEL-(C1_3(2)*F3*P22)/4D0-C2_3(0,0)*
     &  P2P3-(C2_3(2,2)*P22*P2P3)/2D0+(C2_2(0,0)*P32)/2D0+(C2(1,1)*
     &  (K(4)+P22*P2P3+P1P2*P32-P22*P32))/2D0+(C2(1,2)*(K(4)+2D0*
     &  P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V1(3) = (C1(2)*K(19))/4D0+(C1_2(2)*K(7))/4D0+D3(1,1,3)*K(9)*
     &  DEL-(C2(0,0)*P22)/2D0+(C2_3(0,0)*P22)/2D0+(C2_2(1,2)*P1P2*
     &  P32)/2D0+(C2_2(2,2)*P2P3*P32)/2D0+(C2(1,2)*(K(4)+P22*P2P3+
     &  P1P2*P32-P22*P32))/2D0+(C2(2,2)*(K(4)+2D0*P2P3**2+P1P2*P32-
     &  P22*P32-P2P3*P32))/2D0
        V1(4) = D3(1,1,1)*K(14)-(C2_2(1,1)*K(21))/(2D0*K(10))-D3(1,
     &  1,3)*K(1)*K(9)+(C2_3(1,1)*K(20))/(2D0*K(9))-(C1(1)*(K(20)+
     &  K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*
     &  P32))/K(9)-(C1(2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*
     &  P22**2*P32+F2*P22*P2P3*P32))/K(9)-(C2(1,1)*(K(20)+K(21)+F3*
     &  P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))-(C2(1,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*
     &  P22**2*P32+F2*P22*P2P3*P32))/K(9)-(C2(2,2)*(K(20)+K(21)+F3*
     &  P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))-(C0*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*
     &  P32+F2*P22*P2P3*P32))/(2D0*K(9))
        V1(5) = D3(1,1,2)*K(14)-D3(1,2,3)*K(1)*K(9)+(C2_3(1,2)*
     &  K(20))/(2D0*K(9))+(C1(1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*
     &  P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(C2(1,1)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/(2D0*K(9))+(C2(1,2)*(K(20)+K(21)+F3*P22*P2P3**2-
     &  F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))
        V1(6) = D3(1,1,3)*K(14)-(C2_2(1,2)*K(21))/(2D0*K(10))-D3(1,
     &  3,3)*K(1)*K(9)+(C1(2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**
     &  3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(C2(1,2)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/(2D0*K(9))+(C2(2,2)*(K(20)+K(21)+F3*P22*P2P3**2-
     &  F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))
	do i=1,6
	  X1(i) = 0d0
	do j=1,6
	  X1(i) = X1(i) + IW1(i,j)*V1(j)
	enddo
	enddo
        D1(1) = X1(1)
        D1(2) = X1(2)
        D1(3) = X1(3)
        D3(0,0,1) = X1(4)
        D3(0,0,2) = X1(5)
        D3(0,0,3) = X1(6)

	if (rankord-i1.le.1) goto 202

        V2(1) = (K(10))/12D0+(D2(0,0)*K(12))/4D0+(C2(0,0)*K(19))/
     &  4D0+(C3_3(0,0,1)*K(4))/2D0+(C2_2(0,0)*K(7))/4D0-(C2_3(0,0)*
     &  F3*P22)/4D0-(C3_3(0,0,2)*P22*P2P3)/2D0+(C3_2(0,0,1)*P1P2*
     &  P32)/2D0+(C3_2(0,0,2)*P2P3*P32)/2D0+(C3(0,0,1)*(K(4)+P22*
     &  P2P3+P1P2*P32-P22*P32))/2D0+(C3(0,0,2)*(K(4)+2D0*P2P3**2+
     &  P1P2*P32-P22*P32-P2P3*P32))/2D0
        V2(2) = (C3(1,2,2)*K(17))/2D0+(C3(1,1,2)*K(18))/2D0+(C1(1)*
     &  K(22))/2D0+(C1(2)*K(23))/2D0+(C2(1,1)*K(26))/4D0+(C2(2,2)*
     &  K(27))/4D0+(C2(1,2)*K(28))/2D0+(C3_3(1,1,1)*K(4))/2D0+
     &  (C2_2(1,1)*K(7))/4D0+(K(19)*C0)/4D0+D4(1,1,1,1)*K(9)*DEL-
     &  (C2_3(1,1)*F3*P22)/4D0-(C3_3(1,1,2)*P22*P2P3)/2D0+(C3_2(1,1,
     &  1)*P1P2*P32)/2D0+(C3_2(1,1,2)*P2P3*P32)/2D0+(C3(1,1,1)*
     &  (K(4)+P22*P2P3+P1P2*P32-P22*P32))/2D0+(C3(2,2,2)*(K(4)+2D0*
     &  P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V2(3) = -((C3(1,1,2)*K(16))/2D0)-(C1(1)*K(19))/4D0-(C2(1,1)*
     &  K(24))/4D0-(C2(1,2)*K(25))/4D0+(C3_3(1,1,2)*K(4))/2D0-(C2(0,
     &  0)*K(6))/2D0-(C3(0,0,1)*K(6))/2D0-(C3(0,0,2)*K(6))/2D0+D4(1,
     &  1,1,2)*K(9)*DEL-(C2_3(1,2)*F3*P22)/4D0-C3_3(0,0,1)*P2P3-
     &  (C3_3(1,2,2)*P22*P2P3)/2D0+(C3_2(0,0,1)*P32)/2D0-(C3(1,1,1)*
     &  (K(4)+P22*P2P3+P1P2*P32-P22*P32))/2D0-(C3(1,2,2)*(K(4)+2D0*
     &  P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V2(4) = -((C3(1,2,2)*K(16))/2D0)-(C1(2)*K(19))/4D0-(C2(1,2)*
     &  K(24))/4D0-(C2(2,2)*K(25))/4D0+(C2_2(1,2)*K(7))/4D0+D4(1,1,
     &  1,3)*K(9)*DEL+(C2(0,0)*P22)/2D0+(C3(0,0,1)*P22)/2D0+(C3(0,0,
     &  2)*P22)/2D0+(C3_3(0,0,1)*P22)/2D0+(C3_2(1,1,2)*P1P2*P32)/
     &  2D0+(C3_2(1,2,2)*P2P3*P32)/2D0-(C3(1,1,2)*(K(4)+P22*P2P3+
     &  P1P2*P32-P22*P32))/2D0-(C3(2,2,2)*(K(4)+2D0*P2P3**2+P1P2*
     &  P32-P22*P32-P2P3*P32))/2D0
        V2(5) = (C2(1,1)*K(19))/4D0+(C3_3(1,2,2)*K(4))/2D0+C3(0,0,
     &  1)*K(6)+D4(1,1,2,2)*K(9)*DEL-(C2_3(2,2)*F3*P22)/4D0-2D0*
     &  C3_3(0,0,2)*P2P3-(C3_3(2,2,2)*P22*P2P3)/2D0+(C3(1,1,1)*
     &  (K(4)+P22*P2P3+P1P2*P32-P22*P32))/2D0+(C3(1,1,2)*(K(4)+2D0*
     &  P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V2(6) = (C2(1,2)*K(19))/4D0+(C3(0,0,2)*K(6))/2D0+D4(1,1,2,
     &  3)*K(9)*DEL-(C3(0,0,1)*P22)/2D0+(C3_3(0,0,2)*P22)/2D0+
     &  (C3_2(0,0,2)*P32)/2D0+(C3(1,1,2)*(K(4)+P22*P2P3+P1P2*P32-
     &  P22*P32))/2D0+(C3(1,2,2)*(K(4)+2D0*P2P3**2+P1P2*P32-P22*P32-
     &  P2P3*P32))/2D0
        V2(7) = (C2(2,2)*K(19))/4D0+(C2_2(2,2)*K(7))/4D0+D4(1,1,3,
     &  3)*K(9)*DEL-C3(0,0,2)*P22+(C3_2(1,2,2)*P1P2*P32)/2D0+
     &  (C3_2(2,2,2)*P2P3*P32)/2D0+(C3(1,2,2)*(K(4)+P22*P2P3+P1P2*
     &  P32-P22*P32))/2D0+(C3(2,2,2)*(K(4)+2D0*P2P3**2+P1P2*P32-P22*
     &  P32-P2P3*P32))/2D0
        V2(8) = D4(1,1,1,1)*K(14)-(C3_2(1,1,1)*K(21))/(2D0*K(10))-
     &  D4(1,1,1,3)*K(1)*K(9)+(C3_3(1,1,1)*K(20))/(2D0*K(9))+(3D0*
     &  C1(1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+
     &  F2*P22*P2P3*P32))/(2D0*K(9))+(3D0*C1(2)*(K(20)+K(21)+F3*P22*
     &  P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))+(3D0*C2(1,1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-
     &  F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(3D0*C2(1,2)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/K(9)+(3D0*C2(2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*
     &  P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(C3(1,1,
     &  1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*
     &  P22*P2P3*P32))/(2D0*K(9))+(3D0*C3(1,1,2)*(K(20)+K(21)+F3*
     &  P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))+(3D0*C3(1,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-
     &  F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(C3(2,2,2)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/(2D0*K(9))+(C0*(K(20)+K(21)+F3*P22*P2P3**2-F2*
     &  P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))
        V2(9) = D4(1,1,1,2)*K(14)-D4(1,1,2,3)*K(1)*K(9)+(C3_3(1,1,
     &  2)*K(20))/(2D0*K(9))-(C1(1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*
     &  P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))-(C2(1,1)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/K(9)-(C2(1,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*
     &  P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/K(9)-(C3(1,1,1)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/(2D0*K(9))-(C3(1,1,2)*(K(20)+K(21)+F3*P22*P2P3**
     &  2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/K(9)-(C3(1,2,
     &  2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*
     &  P22*P2P3*P32))/(2D0*K(9))
        V2(10) = D4(1,1,1,3)*K(14)-(C3_2(1,1,2)*K(21))/(2D0*K(10))-
     &  D4(1,1,3,3)*K(1)*K(9)-(C1(2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*
     &  P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))-(C2(1,2)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/K(9)-(C2(2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*
     &  P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/K(9)-(C3(1,1,2)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/(2D0*K(9))-(C3(1,2,2)*(K(20)+K(21)+F3*P22*P2P3**
     &  2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/K(9)-(C3(2,2,
     &  2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*
     &  P22*P2P3*P32))/(2D0*K(9))
        V2(11) = D4(1,1,2,2)*K(14)-D4(1,2,2,3)*K(1)*K(9)+(C3_3(1,2,
     &  2)*K(20))/(2D0*K(9))+(C2(1,1)*(K(20)+K(21)+F3*P22*P2P3**2-
     &  F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(C3(1,
     &  1,1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+
     &  F2*P22*P2P3*P32))/(2D0*K(9))+(C3(1,1,2)*(K(20)+K(21)+F3*P22*
     &  P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))
        V2(12) = D4(1,1,2,3)*K(14)-D4(1,2,3,3)*K(1)*K(9)+(C2(1,2)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/(2D0*K(9))+(C3(1,1,2)*(K(20)+K(21)+F3*P22*P2P3**
     &  2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+
     &  (C3(1,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*
     &  P32+F2*P22*P2P3*P32))/(2D0*K(9))
        V2(13) = D4(1,1,3,3)*K(14)-(C3_2(1,2,2)*K(21))/(2D0*K(10))-
     &  D4(1,3,3,3)*K(1)*K(9)+(C2(2,2)*(K(20)+K(21)+F3*P22*P2P3**2-
     &  F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(C3(1,
     &  2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+
     &  F2*P22*P2P3*P32))/(2D0*K(9))+(C3(2,2,2)*(K(20)+K(21)+F3*P22*
     &  P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))
	do i=1,13
	  X2(i) = 0d0
	do j=1,13
	  X2(i) = X2(i) + IW2(i,j)*V2(j)
	enddo
	enddo
        D2(1,1) = X2(1)
        D2(1,2) = X2(2)
        D2(1,3) = X2(3)
        D2(2,2) = X2(4)
        D2(2,3) = X2(5)
        D2(3,3) = X2(6)
        D4(0,0,0,0) = X2(7)
        D4(0,0,1,1) = X2(8)
        D4(0,0,1,2) = X2(9)
        D4(0,0,1,3) = X2(10)
        D4(0,0,2,2) = X2(11)
        D4(0,0,2,3) = X2(12)
        D4(0,0,3,3) = X2(13)

	if (rankord-i1.le.2) goto 202

        V3(1) = (D3(0,0,1)*K(12))/4D0-(C4(0,0,1,2)*K(16))/2D0-(C2(0,
     &  0)*K(19))/4D0-(C3(0,0,1)*K(24))/4D0-(C3(0,0,2)*K(25))/4D0+
     &  (C4_3(0,0,1,1)*K(4))/2D0+(C3_2(0,0,1)*K(7))/4D0+(K(9))/48D0-
     &  (C3_3(0,0,1)*F3*P22)/4D0-(C4_3(0,0,1,2)*P22*P2P3)/2D0+
     &  (C4_2(0,0,1,1)*P1P2*P32)/2D0+(C4_2(0,0,1,2)*P2P3*P32)/2D0-
     &  (C4(0,0,1,1)*(K(4)+P22*P2P3+P1P2*P32-P22*P32))/2D0-(C4(0,0,
     &  2,2)*(K(4)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V3(2) = (D3(0,0,2)*K(12))/4D0+(C3(0,0,1)*K(19))/4D0+(C4_3(0,
     &  0,1,2)*K(4))/2D0+(C4(0,0,0,0)*K(6))/2D0+(K(9))/48D0-(C3_3(0,
     &  0,2)*F3*P22)/4D0-C4_3(0,0,0,0)*P2P3-(C4_3(0,0,2,2)*P22*
     &  P2P3)/2D0+(C4_2(0,0,0,0)*P32)/2D0+(C4(0,0,1,1)*(K(4)+P22*
     &  P2P3+P1P2*P32-P22*P32))/2D0+(C4(0,0,1,2)*(K(4)+2D0*P2P3**2+
     &  P1P2*P32-P22*P32-P2P3*P32))/2D0
        V3(3) = (D3(0,0,3)*K(12))/4D0+(C3(0,0,2)*K(19))/4D0+(C3_2(0,
     &  0,2)*K(7))/4D0+(K(9))/48D0-(C4(0,0,0,0)*P22)/2D0+(C4_3(0,0,
     &  0,0)*P22)/2D0+(C4_2(0,0,1,2)*P1P2*P32)/2D0+(C4_2(0,0,2,2)*
     &  P2P3*P32)/2D0+(C4(0,0,1,2)*(K(4)+P22*P2P3+P1P2*P32-P22*
     &  P32))/2D0+(C4(0,0,2,2)*(K(4)+2D0*P2P3**2+P1P2*P32-P22*P32-
     &  P2P3*P32))/2D0
        V3(4) = -((3D0*C4(1,1,2,2)*K(16))/2D0)-(3D0*C2(1,1)*K(24))/
     &  4D0-(3D0*C2(2,2)*K(25))/4D0+(C4_3(1,1,1,1)*K(4))/2D0+
     &  (C3_2(1,1,1)*K(7))/4D0-(K(19)*C0)/4D0+D5(1,1,1,1,1)*K(9)*
     &  DEL-(C3_3(1,1,1)*F3*P22)/4D0-(C4_3(1,1,1,2)*P22*P2P3)/2D0+
     &  (C4_2(1,1,1,1)*P1P2*P32)/2D0+(C4_2(1,1,1,2)*P2P3*P32)/2D0-
     &  (C3(1,1,1)*(F3*P22+8D0*P1P3*P22-2D0*F3*P2P3-16D0*P1P2*P2P3+
     &  6D0*P22*P2P3+4D0*P2P3**2+F2*P32+8D0*P1P2*P32-10D0*P22*P32))/
     &  4D0-(C1(1)*(3D0*F3*P22+8D0*P1P3*P22-6D0*F3*P2P3-16D0*P1P2*
     &  P2P3+2D0*P22*P2P3+12D0*P2P3**2+3D0*F2*P32+8D0*P1P2*P32-14D0*
     &  P22*P32))/4D0-(C4(1,1,1,1)*(K(4)+P22*P2P3+P1P2*P32-P22*
     &  P32))/2D0-(C4(2,2,2,2)*(K(4)+2D0*P2P3**2+P1P2*P32-P22*P32-
     &  P2P3*P32))/2D0-(C4(1,1,1,2)*(4D0*P1P3*P22-8D0*P1P2*P2P3+3D0*
     &  P22*P2P3+2D0*P2P3**2+4D0*P1P2*P32-4D0*P22*P32-P2P3*P32))/
     &  2D0-(3D0*C2(1,2)*(F3*P22+4D0*P1P3*P22-2D0*F3*P2P3-8D0*P1P2*
     &  P2P3+P22*P2P3+6D0*P2P3**2+F2*P32+4D0*P1P2*P32-6D0*P22*P32-
     &  P2P3*P32))/2D0-(3D0*C3(1,1,2)*(F3*P22+8D0*P1P3*P22-2D0*F3*
     &  P2P3-16D0*P1P2*P2P3+4D0*P22*P2P3+8D0*P2P3**2+F2*P32+8D0*
     &  P1P2*P32-10D0*P22*P32-2D0*P2P3*P32))/4D0-(C1(2)*(3D0*F3*P22+
     &  8D0*P1P3*P22-6D0*F3*P2P3-16D0*P1P2*P2P3+16D0*P2P3**2+3D0*F2*
     &  P32+8D0*P1P2*P32-14D0*P22*P32-2D0*P2P3*P32))/4D0-(C4(1,2,2,
     &  2)*(4D0*P1P3*P22-8D0*P1P2*P2P3+P22*P2P3+6D0*P2P3**2+4D0*
     &  P1P2*P32-4D0*P22*P32-3D0*P2P3*P32))/2D0-(3D0*C3(1,2,2)*(F3*
     &  P22+8D0*P1P3*P22-2D0*F3*P2P3-16D0*P1P2*P2P3+2D0*P22*P2P3+
     &  12D0*P2P3**2+F2*P32+8D0*P1P2*P32-10D0*P22*P32-4D0*P2P3*
     &  P32))/4D0-(C3(2,2,2)*(F3*P22+8D0*P1P3*P22-2D0*F3*P2P3-16D0*
     &  P1P2*P2P3+16D0*P2P3**2+F2*P32+8D0*P1P2*P32-10D0*P22*P32-6D0*
     &  P2P3*P32))/4D0
        V3(5) = (C4(1,1,2,2)*K(17))/2D0+(C4(1,1,1,2)*K(18))/2D0+
     &  (C1(1)*K(19))/4D0+(C2(1,1)*K(22))/2D0+(C2(1,2)*K(23))/2D0+
     &  (C3(1,1,1)*K(26))/4D0+(C3(1,2,2)*K(27))/4D0+(C3(1,1,2)*
     &  K(28))/2D0+(C4_3(1,1,1,2)*K(4))/2D0+(C2(0,0)*K(6))/2D0+C3(0,
     &  0,1)*K(6)+C3(0,0,2)*K(6)+(C4(0,0,1,1)*K(6))/2D0+C4(0,0,1,2)*
     &  K(6)+(C4(0,0,2,2)*K(6))/2D0+D5(1,1,1,1,2)*K(9)*DEL-(C3_3(1,
     &  1,2)*F3*P22)/4D0-C4_3(0,0,1,1)*P2P3-(C4_3(1,1,2,2)*P22*
     &  P2P3)/2D0+(C4_2(0,0,1,1)*P32)/2D0+(C4(1,1,1,1)*(K(4)+P22*
     &  P2P3+P1P2*P32-P22*P32))/2D0+(C4(1,2,2,2)*(K(4)+2D0*P2P3**2+
     &  P1P2*P32-P22*P32-P2P3*P32))/2D0
        V3(6) = (C4(1,2,2,2)*K(17))/2D0+(C4(1,1,2,2)*K(18))/2D0+
     &  (C1(2)*K(19))/4D0+(C2(1,2)*K(22))/2D0+(C2(2,2)*K(23))/2D0+
     &  (C3(1,1,2)*K(26))/4D0+(C3(2,2,2)*K(27))/4D0+(C3(1,2,2)*
     &  K(28))/2D0+(C3_2(1,1,2)*K(7))/4D0+D5(1,1,1,1,3)*K(9)*DEL-
     &  (C2(0,0)*P22)/2D0-C3(0,0,1)*P22-C3(0,0,2)*P22-(C4(0,0,1,1)*
     &  P22)/2D0-C4(0,0,1,2)*P22-(C4(0,0,2,2)*P22)/2D0+(C4_3(0,0,1,
     &  1)*P22)/2D0+(C4_2(1,1,1,2)*P1P2*P32)/2D0+(C4_2(1,1,2,2)*
     &  P2P3*P32)/2D0+(C4(1,1,1,2)*(K(4)+P22*P2P3+P1P2*P32-P22*
     &  P32))/2D0+(C4(2,2,2,2)*(K(4)+2D0*P2P3**2+P1P2*P32-P22*P32-
     &  P2P3*P32))/2D0
        V3(7) = -((C4(1,1,1,2)*K(16))/2D0)-(C2(1,1)*K(19))/4D0-
     &  (C3(1,1,1)*K(24))/4D0-(C3(1,1,2)*K(25))/4D0+(C4_3(1,1,2,2)*
     &  K(4))/2D0-C3(0,0,1)*K(6)-C4(0,0,1,1)*K(6)-C4(0,0,1,2)*K(6)+
     &  D5(1,1,1,2,2)*K(9)*DEL-(C3_3(1,2,2)*F3*P22)/4D0-2D0*C4_3(0,
     &  0,1,2)*P2P3-(C4_3(1,2,2,2)*P22*P2P3)/2D0-(C4(1,1,1,1)*(K(4)+
     &  P22*P2P3+P1P2*P32-P22*P32))/2D0-(C4(1,1,2,2)*(K(4)+2D0*
     &  P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V3(8) = -((C4(1,1,2,2)*K(16))/2D0)-(C2(1,2)*K(19))/4D0-
     &  (C3(1,1,2)*K(24))/4D0-(C3(1,2,2)*K(25))/4D0-(C3(0,0,2)*
     &  K(6))/2D0-(C4(0,0,2,2)*K(6))/2D0+D5(1,1,1,2,3)*K(9)*DEL+
     &  (C3(0,0,1)*P22)/2D0+(C4(0,0,1,1)*P22)/2D0+(C4_3(0,0,1,2)*
     &  P22)/2D0+(C4_2(0,0,1,2)*P32)/2D0+(C4(0,0,1,2)*(P22-2D0*P2P3+
     &  P32))/2D0-(C4(1,1,1,2)*(K(4)+P22*P2P3+P1P2*P32-P22*P32))/
     &  2D0-(C4(1,2,2,2)*(K(4)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*
     &  P32))/2D0
        V3(9) = -((C4(1,2,2,2)*K(16))/2D0)-(C2(2,2)*K(19))/4D0-
     &  (C3(1,2,2)*K(24))/4D0-(C3(2,2,2)*K(25))/4D0+(C3_2(1,2,2)*
     &  K(7))/4D0+D5(1,1,1,3,3)*K(9)*DEL+C3(0,0,2)*P22+C4(0,0,1,2)*
     &  P22+C4(0,0,2,2)*P22+(C4_2(1,1,2,2)*P1P2*P32)/2D0+(C4_2(1,2,
     &  2,2)*P2P3*P32)/2D0-(C4(1,1,2,2)*(K(4)+P22*P2P3+P1P2*P32-P22*
     &  P32))/2D0-(C4(2,2,2,2)*(K(4)+2D0*P2P3**2+P1P2*P32-P22*P32-
     &  P2P3*P32))/2D0
        V3(10) = (C3(1,1,1)*K(19))/4D0+(C4_3(1,2,2,2)*K(4))/2D0+
     &  (3D0*C4(0,0,1,1)*K(6))/2D0+D5(1,1,2,2,2)*K(9)*DEL-(C3_3(2,2,
     &  2)*F3*P22)/4D0-3D0*C4_3(0,0,2,2)*P2P3-(C4_3(2,2,2,2)*P22*
     &  P2P3)/2D0+(C4(1,1,1,1)*(K(4)+P22*P2P3+P1P2*P32-P22*P32))/
     &  2D0+(C4(1,1,1,2)*(K(4)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*
     &  P32))/2D0
        V3(11) = (C3(1,1,2)*K(19))/4D0+C4(0,0,1,2)*K(6)+D5(1,1,2,2,
     &  3)*K(9)*DEL-(C4(0,0,1,1)*P22)/2D0+(C4_3(0,0,2,2)*P22)/2D0+
     &  (C4(1,1,1,2)*(K(4)+P22*P2P3+P1P2*P32-P22*P32))/2D0+(C4(1,1,
     &  2,2)*(K(4)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V3(12) = (C3(1,2,2)*K(19))/4D0+(C4(0,0,2,2)*K(6))/2D0+D5(1,
     &  1,2,3,3)*K(9)*DEL-C4(0,0,1,2)*P22+(C4_2(0,0,2,2)*P32)/2D0+
     &  (C4(1,1,2,2)*(K(4)+P22*P2P3+P1P2*P32-P22*P32))/2D0+(C4(1,2,
     &  2,2)*(K(4)+2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V3(13) = (C3(2,2,2)*K(19))/4D0+(C3_2(2,2,2)*K(7))/4D0+D5(1,
     &  1,3,3,3)*K(9)*DEL-(3D0*C4(0,0,2,2)*P22)/2D0+(C4_2(1,2,2,2)*
     &  P1P2*P32)/2D0+(C4_2(2,2,2,2)*P2P3*P32)/2D0+(C4(1,2,2,2)*
     &  (K(4)+P22*P2P3+P1P2*P32-P22*P32))/2D0+(C4(2,2,2,2)*(K(4)+
     &  2D0*P2P3**2+P1P2*P32-P22*P32-P2P3*P32))/2D0
        V3(14) = D5(1,1,1,1,1)*K(14)-(C4_2(1,1,1,1)*K(21))/(2D0*
     &  K(10))-D5(1,1,1,1,3)*K(1)*K(9)+(C4_3(1,1,1,1)*K(20))/(2D0*
     &  K(9))-(2D0*C1(1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*
     &  P22**2*P32+F2*P22*P2P3*P32))/K(9)-(2D0*C1(2)*(K(20)+K(21)+
     &  F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/
     &  K(9)-(3D0*C2(1,1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*
     &  P22**2*P32+F2*P22*P2P3*P32))/K(9)-(6D0*C2(1,2)*(K(20)+K(21)+
     &  F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/
     &  K(9)-(3D0*C2(2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*
     &  P22**2*P32+F2*P22*P2P3*P32))/K(9)-(2D0*C3(1,1,1)*(K(20)+
     &  K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*
     &  P32))/K(9)-(6D0*C3(1,1,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*
     &  P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/K(9)-(6D0*C3(1,2,2)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/K(9)-(2D0*C3(2,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-
     &  F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/K(9)-(C4(1,1,1,
     &  1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*
     &  P22*P2P3*P32))/(2D0*K(9))-(2D0*C4(1,1,1,2)*(K(20)+K(21)+F3*
     &  P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/K(9)-
     &  (3D0*C4(1,1,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*
     &  P22**2*P32+F2*P22*P2P3*P32))/K(9)-(2D0*C4(1,2,2,2)*(K(20)+
     &  K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*
     &  P32))/K(9)-(C4(2,2,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*
     &  P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))-(C0*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/(2D0*K(9))
        V3(15) = D5(1,1,1,1,2)*K(14)-D5(1,1,1,2,3)*K(1)*K(9)+
     &  (C4_3(1,1,1,2)*K(20))/(2D0*K(9))+(C1(1)*(K(20)+K(21)+F3*P22*
     &  P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))+(3D0*C2(1,1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-
     &  F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(3D0*C2(1,2)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/(2D0*K(9))+(3D0*C3(1,1,1)*(K(20)+K(21)+F3*P22*
     &  P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))+(3D0*C3(1,1,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-
     &  F3*P22**2*P32+F2*P22*P2P3*P32))/K(9)+(3D0*C3(1,2,2)*(K(20)+
     &  K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*
     &  P32))/(2D0*K(9))+(C4(1,1,1,1)*(K(20)+K(21)+F3*P22*P2P3**2-
     &  F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(3D0*
     &  C4(1,1,1,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**
     &  2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(3D0*C4(1,1,2,2)*(K(20)+
     &  K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*
     &  P32))/(2D0*K(9))+(C4(1,2,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-
     &  F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))
        V3(16) = D5(1,1,1,1,3)*K(14)-(C4_2(1,1,1,2)*K(21))/(2D0*
     &  K(10))-D5(1,1,1,3,3)*K(1)*K(9)+(C1(2)*(K(20)+K(21)+F3*P22*
     &  P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))+(3D0*C2(1,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-
     &  F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(3D0*C2(2,2)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/(2D0*K(9))+(3D0*C3(1,1,2)*(K(20)+K(21)+F3*P22*
     &  P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))+(3D0*C3(1,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-
     &  F3*P22**2*P32+F2*P22*P2P3*P32))/K(9)+(3D0*C3(2,2,2)*(K(20)+
     &  K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*
     &  P32))/(2D0*K(9))+(C4(1,1,1,2)*(K(20)+K(21)+F3*P22*P2P3**2-
     &  F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(3D0*
     &  C4(1,1,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**
     &  2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(3D0*C4(1,2,2,2)*(K(20)+
     &  K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*
     &  P32))/(2D0*K(9))+(C4(2,2,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-
     &  F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))
        V3(17) = D5(1,1,1,2,2)*K(14)-D5(1,1,2,2,3)*K(1)*K(9)+
     &  (C4_3(1,1,2,2)*K(20))/(2D0*K(9))-(C2(1,1)*(K(20)+K(21)+F3*
     &  P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))-(C3(1,1,1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*
     &  P22**2*P32+F2*P22*P2P3*P32))/K(9)-(C3(1,1,2)*(K(20)+K(21)+
     &  F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/
     &  K(9)-(C4(1,1,1,1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*
     &  P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))-(C4(1,1,1,2)*(K(20)+
     &  K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*
     &  P32))/K(9)-(C4(1,1,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*
     &  P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))
        V3(18) = D5(1,1,1,2,3)*K(14)-D5(1,1,2,3,3)*K(1)*K(9)-(C2(1,
     &  2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*
     &  P22*P2P3*P32))/(2D0*K(9))-(C3(1,1,2)*(K(20)+K(21)+F3*P22*
     &  P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/K(9)-
     &  (C3(1,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*
     &  P32+F2*P22*P2P3*P32))/K(9)-(C4(1,1,1,2)*(K(20)+K(21)+F3*P22*
     &  P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))-(C4(1,1,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-
     &  F3*P22**2*P32+F2*P22*P2P3*P32))/K(9)-(C4(1,2,2,2)*(K(20)+
     &  K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*
     &  P32))/(2D0*K(9))
        V3(19) = D5(1,1,1,3,3)*K(14)-(C4_2(1,1,2,2)*K(21))/(2D0*
     &  K(10))-D5(1,1,3,3,3)*K(1)*K(9)-(C2(2,2)*(K(20)+K(21)+F3*P22*
     &  P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))-(C3(1,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*
     &  P22**2*P32+F2*P22*P2P3*P32))/K(9)-(C3(2,2,2)*(K(20)+K(21)+
     &  F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/
     &  K(9)-(C4(1,1,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*
     &  P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))-(C4(1,2,2,2)*(K(20)+
     &  K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*
     &  P32))/K(9)-(C4(2,2,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*
     &  P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))
        V3(20) = D5(1,1,2,2,2)*K(14)-D5(1,2,2,2,3)*K(1)*K(9)+
     &  (C4_3(1,2,2,2)*K(20))/(2D0*K(9))+(C3(1,1,1)*(K(20)+K(21)+F3*
     &  P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))+(C4(1,1,1,1)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-
     &  F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(C4(1,1,1,2)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/(2D0*K(9))
        V3(21) = D5(1,1,2,2,3)*K(14)-D5(1,2,2,3,3)*K(1)*K(9)+(C3(1,
     &  1,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+
     &  F2*P22*P2P3*P32))/(2D0*K(9))+(C4(1,1,1,2)*(K(20)+K(21)+F3*
     &  P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))+(C4(1,1,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-
     &  F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))
        V3(22) = D5(1,1,2,3,3)*K(14)-D5(1,2,3,3,3)*K(1)*K(9)+(C3(1,
     &  2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+
     &  F2*P22*P2P3*P32))/(2D0*K(9))+(C4(1,1,2,2)*(K(20)+K(21)+F3*
     &  P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))+(C4(1,2,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-
     &  F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))
        V3(23) = D5(1,1,3,3,3)*K(14)-(C4_2(1,2,2,2)*K(21))/(2D0*
     &  K(10))-D5(1,3,3,3,3)*K(1)*K(9)+(C3(2,2,2)*(K(20)+K(21)+F3*
     &  P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*
     &  K(9))+(C4(1,2,2,2)*(K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-
     &  F3*P22**2*P32+F2*P22*P2P3*P32))/(2D0*K(9))+(C4(2,2,2,2)*
     &  (K(20)+K(21)+F3*P22*P2P3**2-F2*P2P3**3-F3*P22**2*P32+F2*P22*
     &  P2P3*P32))/(2D0*K(9))
	do i=1,23
	  X3(i) = 0d0
	do j=1,23
	  X3(i) = X3(i) + IW3(i,j)*V3(j)
	enddo
	enddo
        D3(1,1,1) = X3(1)
        D3(1,1,2) = X3(2)
        D3(1,1,3) = X3(3)
        D3(1,2,2) = X3(4)
        D3(1,2,3) = X3(5)
        D3(1,3,3) = X3(6)
        D3(2,2,2) = X3(7)
        D3(2,2,3) = X3(8)
        D3(2,3,3) = X3(9)
        D3(3,3,3) = X3(10)
        D5(0,0,0,0,1) = X3(11)
        D5(0,0,0,0,2) = X3(12)
        D5(0,0,0,0,3) = X3(13)
        D5(0,0,1,1,1) = X3(14)
        D5(0,0,1,1,2) = X3(15)
        D5(0,0,1,1,3) = X3(16)
        D5(0,0,1,2,2) = X3(17)
        D5(0,0,1,2,3) = X3(18)
        D5(0,0,1,3,3) = X3(19)
        D5(0,0,2,2,2) = X3(20)
        D5(0,0,2,2,3) = X3(21)
        D5(0,0,2,3,3) = X3(22)
        D5(0,0,3,3,3) = X3(23)

202	continue
	i1=i1+2
	goto 201
250	continue

	end

***********************************************************************
        subroutine Cswap(C0,C1,C2,C3,C4,i,j,rank)
***********************************************************************
*	swap indices i <-> j in 3-point tensor coefficients
*-----------------------------------------------------------------------
*       26.11.04 Stefan Dittmaier
***********************************************************************
        implicit real*8 (a-z)
        complex*16 C0,C1(2),C2(0:2,0:2),C3(0:2,0:2,2)
	complex*16 C4(0:2,0:2,0:2,0:2)
        complex*16 aux
	integer i,j,rank

	if (rank.gt.4) then
	  write(*,*) 'Cswap implemented only for rank < 5!',rank
	  stop
	endif

	if (rank.eq.0) return
	aux   = C1(i)
	C1(i) = C1(j)
	C1(j) = aux
	if (rank.eq.1) return
	aux     = C2(i,i)
	C2(i,i) = C2(j,j)
	C2(j,j) = aux
	if (rank.eq.2) return
	aux       = C3(0,0,i)
	C3(0,0,i) = C3(0,0,j)
	C3(0,0,j) = aux
	aux       = C3(i,i,i)
	C3(i,i,i) = C3(j,j,j)
	C3(j,j,j) = aux
	aux       = C3(i,i,j)
	C3(i,i,j) = C3(j,j,i)
	C3(j,j,i) = aux
	aux       = C3(i,j,j)
	C3(i,j,j) = C3(j,i,i)
	C3(j,i,i) = aux
	aux       = C3(j,i,j)
	C3(j,i,j) = C3(i,j,i)
	C3(i,j,i) = aux
	if (rank.eq.3) return
	aux         = C4(0,0,i,i)
	C4(0,0,i,i) = C4(0,0,j,j)
	C4(0,0,j,j) = aux
	aux         = C4(i,i,i,i)
	C4(i,i,i,i) = C4(j,j,j,j)
	C4(j,j,j,j) = aux
	aux         = C4(i,i,i,j)
	C4(i,i,i,j) = C4(j,j,j,i)
	C4(j,j,j,i) = aux
	aux         = C4(i,i,j,i)
	C4(i,i,j,i) = C4(j,j,i,j)
	C4(j,j,i,j) = aux
	aux         = C4(i,j,i,i)
	C4(i,j,i,i) = C4(j,i,j,j)
	C4(j,i,j,j) = aux
	aux         = C4(j,i,i,i)
	C4(j,i,i,i) = C4(i,j,j,j)
	C4(i,j,j,j) = aux

	end

***********************************************************************
        subroutine Dswap(D0,D1,D2,D3,D4,D5,i,j,rank)
***********************************************************************
*	swap indices i <-> j in 4-point tensor coefficients
*	i=0,1,2,3, j=1,2,3
*-----------------------------------------------------------------------
*       24.11.04 Stefan Dittmaier
***********************************************************************
        implicit real*8 (a-z)
        complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        complex*16 D1sum,D2sum0,D2sum(3)
	complex*16 D3sum00,D3sum0(3),D3sum(3,3),D3sumg
        complex*16 aux
	integer i,j,k,l,m,n,rank

	if (rank.gt.3) then
	  write(*,*) 'Dswap implemented only for rank < 4!',rank
	  stop
	endif

	if (i.ne.0) then

	k = 6-i-j

	if (rank.eq.0) return
	aux   = D1(i)
	D1(i) = D1(j)
	D1(j) = aux
	if (rank.eq.1) return
	aux     = D2(i,k)
	D2(i,k) = D2(j,k)
	D2(j,k) = aux
	aux     = D2(k,i)
	D2(k,i) = D2(k,j)
	D2(k,j) = aux
	aux     = D2(i,i)
	D2(i,i) = D2(j,j)
	D2(j,j) = aux
	if (rank.eq.2) return
	aux       = D3(0,0,i)
	D3(0,0,i) = D3(0,0,j)
	D3(0,0,j) = aux
	aux       = D3(i,i,i)
	D3(i,i,i) = D3(j,j,j)
	D3(j,j,j) = aux
	aux       = D3(i,i,j)
	D3(i,i,j) = D3(j,j,i)
	D3(j,j,i) = aux
	aux       = D3(i,j,j)
	D3(i,j,j) = D3(j,i,i)
	D3(j,i,i) = aux
	aux       = D3(j,i,j)
	D3(j,i,j) = D3(i,j,i)
	D3(i,j,i) = aux
	aux       = D3(k,i,i)
	D3(k,i,i) = D3(k,j,j)
	D3(k,j,j) = aux
	aux       = D3(i,k,i)
	D3(i,k,i) = D3(j,k,j)
	D3(j,k,j) = aux
	aux       = D3(i,i,k)
	D3(i,i,k) = D3(j,j,k)
	D3(j,j,k) = aux
	aux       = D3(k,k,i)
	D3(k,k,i) = D3(k,k,j)
	D3(k,k,j) = aux
	aux       = D3(k,i,k)
	D3(k,i,k) = D3(k,j,k)
	D3(k,j,k) = aux
	aux       = D3(i,k,k)
	D3(i,k,k) = D3(j,k,k)
	D3(j,k,k) = aux

c i=0
	else

	if (rank.eq.0) return

	D1sum = D0 + D1(1) + D1(2) + D1(3)
	D1(j) = -D1sum

	if (rank.eq.1) return

        D2sum0   = D2(1,1)+D2(2,2)+D2(3,3)+2d0*(D2(1,2)+D2(1,3)+D2(2,3))
     &             +2d0*(D1(1)+D1(2)+D1(3))+D0
        D2sum(1) = D2(1,1)+D2(1,2)+D2(1,3)+D1(1)
        D2sum(2) = D2(1,2)+D2(2,2)+D2(2,3)+D1(2)
        D2sum(3) = D2(1,3)+D2(2,3)+D2(3,3)+D1(3)

	D2(j,j) = D2sum0
	do 200 l=1,3
	if (j.eq.l) goto 200
	D2(j,l) = -D2sum(l)
	D2(l,j) = D2(j,l)
200	continue


	if (rank.eq.2) return

	D3sumg     = D2(0,0) + D3(0,0,1) + D3(0,0,2) + D3(0,0,3)
        D3sum00    =              D0
        do 300 l=1,3
        D3sum00    = D3sum00    + 3d0*D1(l)
        D3sum0(l)  =              D1(l)
        do 300 m=1,3
        D3sum00    = D3sum00    + 3d0*D2(l,m)
        D3sum0(l)  = D3sum0(l)  + 2d0*D2(l,m)
        D3sum(l,m) =              D2(l,m)
        do 300 n=1,3
        D3sum00    = D3sum00    + D3(l,m,n)
        D3sum0(l)  = D3sum0(l)  + D3(l,m,n)
        D3sum(l,m) = D3sum(l,m) + D3(l,m,n)
300     continue

	D3(0,0,j) = -D3sumg
	D3(j,j,j) = -D3sum00
	do 301 l=1,3
	do 301 m=1,3
	if ((j.eq.l).or.(j.eq.m)) goto 301
	D3(j,l,m) = -D3sum(l,m)
	D3(j,m,l) = D3(j,l,m)
	D3(l,j,m) = D3(j,l,m)
	D3(l,m,j) = D3(j,l,m)
	D3(m,j,l) = D3(j,l,m)
	D3(m,l,j) = D3(j,l,m)
301	continue
	do 302 l=1,3
	if (j.eq.l) goto 302
	D3(j,l,l) = D3sum0(l)
	D3(l,j,l) = D3(j,l,l)
	D3(l,l,j) = D3(j,l,l)
302	continue

	endif

	end

***********************************************************************
        subroutine Drot(D0,D1,D2,D3,D4,D5,i,j,k,rank)
***********************************************************************
*	rotate indices i->j->k->i in 4-point tensor coefficients
*	i,j,k =/= 0
*-----------------------------------------------------------------------
*       24.11.04 Stefan Dittmaier
***********************************************************************
        implicit real*8 (a-z)
        complex*16 D0,D1(3),D2(0:3,0:3),D3(0:3,0:3,3)
        complex*16 D4(0:3,0:3,0:3,0:3),D5(0:3,0:3,0:3,0:3,3)
        complex*16 aux
	integer i,j,k,rank

	if (rank.gt.3) then
	  write(*,*) 'Drot implemented only for rank < 4!',rank
	  stop
	endif

	if (rank.eq.0) return
	aux   = D1(i)
	D1(i) = D1(k)
	D1(k) = D1(j)
	D1(j) = aux
	if (rank.eq.1) return
	aux     = D2(i,i)
	D2(i,i) = D2(k,k)
	D2(k,k) = D2(j,j)
	D2(j,j) = aux
	aux     = D2(i,j)
	D2(i,j) = D2(k,i)
	D2(k,i) = D2(j,k)
	D2(j,k) = aux
	aux     = D2(j,i)
	D2(j,i) = D2(i,k)
	D2(i,k) = D2(k,j)
	D2(k,j) = aux
	if (rank.eq.2) return
	aux       = D3(0,0,i)
	D3(0,0,i) = D3(0,0,k)
	D3(0,0,k) = D3(0,0,j)
	D3(0,0,j) = aux
	aux       = D3(i,i,i)
	D3(i,i,i) = D3(k,k,k)
	D3(k,k,k) = D3(j,j,j)
	D3(j,j,j) = aux
	aux       = D3(i,i,j)
	D3(i,i,j) = D3(k,k,i)
	D3(k,k,i) = D3(j,j,k)
	D3(j,j,k) = aux
	aux       = D3(i,j,i)
	D3(i,j,i) = D3(k,i,k)
	D3(k,i,k) = D3(j,k,j)
	D3(j,k,j) = aux
	aux       = D3(j,i,i)
	D3(j,i,i) = D3(i,k,k)
	D3(i,k,k) = D3(k,j,j)
	D3(k,j,j) = aux
	aux       = D3(i,j,j)
	D3(i,j,j) = D3(k,i,i)
	D3(k,i,i) = D3(j,k,k)
	D3(j,k,k) = aux
	aux       = D3(j,i,j)
	D3(j,i,j) = D3(i,k,i)
	D3(i,k,i) = D3(k,j,k)
	D3(k,j,k) = aux
	aux       = D3(j,j,i)
	D3(j,j,i) = D3(i,i,k)
	D3(i,i,k) = D3(k,k,j)
	D3(k,k,j) = aux

	end

