************************************************************************
*
*     calculate EW virtual corrections from form factors
*
************************************************************************
      function dM2_virt_EW()
      implicit none
      integer j,i1,i2,i3,i4,perm
      real*8 dM2_virt_EW,NDQCDfac
      complex*16 F(13,-1:1,-1:1),F42(13,-1:1,-1:1)
      complex*16 M_virt(-1:1,-1:1,-1:1,-1:1)
      complex*16 M_virt42(-1:1,-1:1,-1:1,-1:1),pre
      include 'COMMON/param.inc'
      include 'COMMON/processpar.inc'
      include 'COMMON/options.inc'
c standard matrix elements
      complex*16 mat(13,-1:1,-1:1),mat42(13,-1:1,-1:1)
      complex*16 matb(-1:1,-1:1,-1:1,-1:1),matb42(-1:1,-1:1,-1:1,-1:1)
      complex*16 fb(13,-1:1,-1:1),fb42(13,-1:1,-1:1)
      real*8 mbcmb
      common/sme/mat,mat42,matb,matb42,fb,fb42,mbcmb

      dM2_virt_EW = 0d0
      if (qqcd.gt.1) return

      call calcform_EW(F,F42)

      if (fname(1).eq.fname(3)) then
        perm=4
      else
        perm=1
      endif

      do i1 = -1,1,2         !sum over polarizations of f1-f4
      do i2 = -1,1,2
      do i3 = -1,1,2
      do i4 = -1,1,2
        M_virt(i1,i2,i3,i4) = 0d0
        M_virt42(i1,i2,i3,i4) = 0d0
        do j = 1,13
          if (qreal.eq.1) then
            M_virt(i1,i2,i3,i4) = M_virt(i1,i2,i3,i4) +
     &            dreal(F(j,i1,i3))*mat(j,i1,i3)
     &            *abs(i1-i2)/2d0*abs(i3-i4)/2d0  !delta(i1,-i2)
            M_virt42(i1,i2,i3,i4) = M_virt42(i1,i2,i3,i4) -
     &            dreal(F42(j,i1,i3))*mat42(j,i1,i3)  !F42 negative(Grassmann)
     &            *abs(i1-i4)/2d0*abs(i3-i2)/2d0  !delta(i1,-i4)
          else
            M_virt(i1,i2,i3,i4) = M_virt(i1,i2,i3,i4) + F(j,i1,i3)
     &            *mat(j,i1,i3)*abs(i1-i2)/2d0*abs(i3-i4)/2d0
            M_virt42(i1,i2,i3,i4) = M_virt42(i1,i2,i3,i4) - F42(j,i1,i3)
     &            *mat42(j,i1,i3)*abs(i1-i4)/2d0*abs(i3-i2)/2d0
          endif
        enddo
        dM2_virt_EW = dM2_virt_EW + el**3*int((2+pol(1)*i1)/2)
     &    *int((2+pol(2)*i2)/2)*int((2+pol(3)*i3)/2)
     &    *int((2+pol(4)*i4)/2)
     &    *2d0*dreal(M_virt(i1,i2,i3,i4)*dconjg(matb(i1,i2,i3,i4))
     &          +M_virt42(i1,i2,i3,i4)*dconjg(matb42(i1,i2,i3,i4))
     &          +M_virt(i1,i2,i3,i4)*dconjg(matb42(i1,i2,i3,i4))
     &               /sqrt(real(color))
     &          +M_virt42(i1,i2,i3,i4)*dconjg(matb(i1,i2,i3,i4))
     &               /sqrt(real(color)) ) *color/perm

      enddo
      enddo
      enddo
      enddo

c heavy-Higgs limit at two loops
      dM2_virt_EW = dM2_virt_EW + mbcmb * (62.0308d0
     &     *(GF*mh2/(16d0*pi**2*dsqrt(2d0)))**2)

      end

************************************************************************
*
*     calculate virtual corrections from form factors
*
************************************************************************
      function dM2_virt_QCD()
      implicit none
      integer j,i1,i2,i3,i4,perm,diag,nondiag
      real*8 dM2_virt_QCD,NDQCDfac
      complex*16 F(13,-1:1,-1:1),F42(13,-1:1,-1:1)
      complex*16 FNDQCD(13,-1:1,-1:1),FNDQCD42(13,-1:1,-1:1)
      complex*16 M_virt(-1:1,-1:1,-1:1,-1:1)
      complex*16 M_virt42(-1:1,-1:1,-1:1,-1:1),pre
      complex*16 M_NDQCD(-1:1,-1:1,-1:1,-1:1)
      complex*16 M_NDQCD42(-1:1,-1:1,-1:1,-1:1)
      include 'COMMON/param.inc'
      include 'COMMON/processpar.inc'
      include 'COMMON/options.inc'
c standard matrix elements
      complex*16 mat(13,-1:1,-1:1),mat42(13,-1:1,-1:1)
      complex*16 matb(-1:1,-1:1,-1:1,-1:1),matb42(-1:1,-1:1,-1:1,-1:1)
      complex*16 fb(13,-1:1,-1:1),fb42(13,-1:1,-1:1)
      real*8 mbcmb
      common/sme/mat,mat42,matb,matb42,fb,fb42,mbcmb

      dM2_virt_QCD = 0d0
      if (qqcd.eq.0) return

      call calcform_QCD(F,F42,FNDQCD,FNDQCD42)

      if (fname(1).eq.fname(3)) then
        perm=4
      else
        perm=1
      endif

      diag = 0 !diagonal part (type a)
      nondiag = 0 !non-diagonal part (type b,c,d)
      if (qqcd.eq.1.or.qqcd.eq.2.or.qqcd.eq.3) diag = 1
      if (qqcd.eq.1.or.qqcd.eq.2.or.qqcd.ge.4) nondiag = 1

      NDQCDfac = 4d0/3d0     !factor from setting G^a/2*G^a/2=1
                             !in non-diag QCD diags
      do i1 = -1,1,2         !sum over polarizations of f1-f4
      do i2 = -1,1,2
      do i3 = -1,1,2
      do i4 = -1,1,2
        M_virt(i1,i2,i3,i4) = 0d0
        M_virt42(i1,i2,i3,i4) = 0d0
        M_NDQCD(i1,i2,i3,i4) = 0d0
        M_NDQCD42(i1,i2,i3,i4) =0d0
        do j = 1,13
          if (qreal.eq.1) then
            M_virt(i1,i2,i3,i4) = M_virt(i1,i2,i3,i4) +
     &            dreal(F(j,i1,i3))*mat(j,i1,i3)
     &            *abs(i1-i2)/2d0*abs(i3-i4)/2d0  !delta(i1,-i2)
            M_virt42(i1,i2,i3,i4) = M_virt42(i1,i2,i3,i4) -
     &            dreal(F42(j,i1,i3))*mat42(j,i1,i3)  !F42 negative(Grassmann)
     &            *abs(i1-i4)/2d0*abs(i3-i2)/2d0  !delta(i1,-i4)
            M_NDQCD(i1,i2,i3,i4) = M_NDQCD(i1,i2,i3,i4) +
     &            dreal(FNDQCD(j,i1,i3))*mat(j,i1,i3)
     &            *abs(i1-i2)/2d0*abs(i3-i4)/2d0
            M_NDQCD42(i1,i2,i3,i4) = M_NDQCD42(i1,i2,i3,i4) -
     &            dreal(FNDQCD42(j,i1,i3))*mat42(j,i1,i3)
     &            *abs(i1-i4)/2d0*abs(i3-i2)/2d0  !delta(i1,-i4)
          else
            M_virt(i1,i2,i3,i4) = M_virt(i1,i2,i3,i4) + F(j,i1,i3)
     &            *mat(j,i1,i3)*abs(i1-i2)/2d0*abs(i3-i4)/2d0
            M_virt42(i1,i2,i3,i4) = M_virt42(i1,i2,i3,i4) - F42(j,i1,i3)
     &            *mat42(j,i1,i3)*abs(i1-i4)/2d0*abs(i3-i2)/2d0
            M_NDQCD(i1,i2,i3,i4) = M_NDQCD(i1,i2,i3,i4) +
     &            FNDQCD(j,i1,i3)*mat(j,i1,i3)
     &            *abs(i1-i2)/2d0*abs(i3-i4)/2d0
            M_NDQCD42(i1,i2,i3,i4) = M_NDQCD42(i1,i2,i3,i4) -
     &            FNDQCD42(j,i1,i3)*mat42(j,i1,i3)
     &            *abs(i1-i4)/2d0*abs(i3-i2)/2d0
          endif
        enddo
c diagonal part
        if (diag.eq.1) then
          dM2_virt_QCD = dM2_virt_QCD + el**3*int((2+pol(1)*i1)/2)
     &      *int((2+pol(2)*i2)/2)*int((2+pol(3)*i3)/2)
     &      *int((2+pol(4)*i4)/2)
     &      *2d0*dreal(M_virt(i1,i2,i3,i4)*dconjg(matb(i1,i2,i3,i4))
     &          +M_virt42(i1,i2,i3,i4)*dconjg(matb42(i1,i2,i3,i4))
     &                 ) *color/perm
        endif
c non-diagonal part
        if (nondiag.eq.1) then
          dM2_virt_QCD = dM2_virt_QCD + el**3*int((2+pol(1)*i1)/2)
     &      *int((2+pol(2)*i2)/2)*int((2+pol(3)*i3)/2)
     &      *int((2+pol(4)*i4)/2)
     &      *2d0*dreal(
     &          +M_virt(i1,i2,i3,i4)*dconjg(matb42(i1,i2,i3,i4))
     &               /sqrt(real(color))
     &          +M_virt42(i1,i2,i3,i4)*dconjg(matb(i1,i2,i3,i4))
     &               /sqrt(real(color))
     &          +M_NDQCD(i1,i2,i3,i4)*dconjg(matb42(i1,i2,i3,i4))
     &               /sqrt(real(color))*NDQCDfac
     &          +M_NDQCD42(i1,i2,i3,i4)*dconjg(matb(i1,i2,i3,i4))
     &               /sqrt(real(color))*NDQCDfac ) *color/perm
        endif
      enddo
      enddo
      enddo
      enddo

      end

************************************************************************
*
*     calculate standard matrix elements for H -> VV -> 4f
*
************************************************************************
      subroutine calcsme()
      implicit none
      integer j,i1,i2,i3,i4,perm
      complex*16 pre
      include 'COMMON/param.inc'
      include 'COMMON/processpar.inc'
      include 'COMMON/xparam.inc'
c prods
      complex*16 sp(5,5),csp(5,5)
      real*8 vp(5,5)
      common/prods/sp,csp,vp
c center of mass energy
      real*8 CMenergy2
      common/CMenergy2/CMenergy2
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c standard matrix elements
      complex*16 mat(13,-1:1,-1:1),mat42(13,-1:1,-1:1)
      complex*16 matb(-1:1,-1:1,-1:1,-1:1),matb42(-1:1,-1:1,-1:1,-1:1)
      complex*16 fb(13,-1:1,-1:1),fb42(13,-1:1,-1:1)
      real*8 mbcmb
      common/sme/mat,mat42,matb,matb42,fb,fb42,mbcmb
c propagators and interchanged charges
      complex*16 pw12,pw34,pz12,pz34,pz14,pz23
      common/propagators/pw12,pw34,pz12,pz34,pz14,pz23

C Mandelstam and other variables
      s   = CMenergy2
      s12 = vp(1,2)
      s13 = vp(1,3)
      s14 = vp(1,4)
      s23 = vp(2,3)
      s24 = vp(2,4)
      s34 = vp(3,4)
      t11 = s23+s24+s34
      t12 = s13+s14+s34
      t13 = s12+s14+s24
      t14 = s12+s13+s23

C propagators and interchanged charges
      pw12 = 1d0/(s12-xmw2)
      pw34 = 1d0/(s34-xmw2)
      pz12 = 1d0/(s12-xmz2)
      pz34 = 1d0/(s34-xmz2)
      pz14 = 1d0/(s14-xmz2)
      pz23 = 1d0/(s23-xmz2)

c standard matrix elements
      do j=1,13
      do i1=-1,1,2
      do i3=-1,1,2
        mat(j,i1,i3) = 0d0
        mat42(j,i1,i3) = 0d0
      enddo
      enddo
      enddo

      MAT(1,1,1) = 2D0*CSP(1,3)*SP(2,4)
      MAT(2,1,1) = 2D0*CSP(1,3)*SP(2,4)*S12
      MAT(3,1,1) = 2D0*CSP(1,3)*SP(2,4)*S34
      MAT(4,1,1) = 2D0*CSP(1,2)*CSP(3,4)*SP(2,4)**2*S13
      MAT(5,1,1) = CSP(1,3)**2*SP(1,4)*SP(2,3)
      MAT(6,1,1) = CSP(1,3)*SP(2,4)*S23
      MAT(7,1,1) = CSP(1,3)*SP(2,4)*S14
      MAT(8,1,1) = CSP(1,4)*CSP(2,3)*SP(2,4)**2
      MAT(9,1,1) = 8D0*CSP(1,3)**2*SP(1,4)*SP(2,3)
      MAT(10,1,1) = 8D0*CSP(1,3)*SP(2,4)*S23
      MAT(11,1,1) = 8D0*CSP(1,3)*SP(2,4)*S14
      MAT(12,1,1) = 8D0*CSP(1,3)*CSP(2,4)*SP(2,4)**2
      MAT(13,1,1) = 32D0*CSP(1,3)*SP(2,4)
      MAT(1,-1,1) = 2D0*CSP(2,3)*SP(1,4)
      MAT(5,-1,1) = CSP(2,3)*SP(1,4)*S13
      MAT(6,-1,1) = CSP(2,3)**2*SP(1,3)*SP(2,4)
      MAT(7,-1,1) = CSP(1,3)*CSP(2,4)*SP(1,4)**2
      MAT(8,-1,1) = CSP(2,3)*SP(1,4)*S24
      MAT(9,-1,1) = 4D0*CSP(2,3)*SP(1,4)*S13
      MAT(10,-1,1) = 4D0*CSP(2,3)**2*SP(1,3)*SP(2,4)
      MAT(11,-1,1) = 4D0*CSP(1,3)*CSP(2,4)*SP(1,4)**2
      MAT(12,-1,1) = 4D0*CSP(2,3)*SP(1,4)*S24
      MAT(13,-1,1) = 8D0*CSP(2,3)*SP(1,4)
      MAT(1,1,-1) = 2D0*CSP(1,4)*SP(2,3)
      MAT(5,1,-1) = CSP(1,4)*SP(2,3)*S13
      MAT(6,1,-1) = CSP(1,3)*CSP(2,4)*SP(2,3)**2
      MAT(7,1,-1) = CSP(1,4)**2*SP(1,3)*SP(2,4)
      MAT(8,1,-1) = CSP(1,4)*SP(2,3)*S24
      MAT(9,1,-1) = 4D0*CSP(1,4)*SP(2,3)*S13
      MAT(10,1,-1) = 4D0*CSP(1,3)*CSP(2,4)*SP(2,3)**2
      MAT(11,1,-1) = 4D0*CSP(1,4)**2*SP(1,3)*SP(2,4)
      MAT(12,1,-1) = 4D0*CSP(1,4)*SP(2,3)*S24
      MAT(13,1,-1) = 8D0*CSP(1,4)*SP(2,3)
      MAT(1,-1,-1) = 2D0*CSP(2,4)*SP(1,3)
      MAT(2,-1,-1) = 2D0*CSP(2,4)*SP(1,3)*S12
      MAT(3,-1,-1) = 2D0*CSP(2,4)*SP(1,3)*S34
      MAT(4,-1,-1) = 2D0*CSP(2,4)**2*SP(1,2)*SP(3,4)*S13
      MAT(5,-1,-1) = CSP(1,4)*CSP(2,3)*SP(1,3)**2
      MAT(6,-1,-1) = CSP(2,4)*SP(1,3)*S23
      MAT(7,-1,-1) = CSP(2,4)*SP(1,3)*S14
      MAT(8,-1,-1) = CSP(2,4)**2*SP(1,4)*SP(2,3)
      MAT(9,-1,-1) = 8D0*CSP(1,4)*CSP(2,3)*SP(1,3)**2
      MAT(10,-1,-1) = 8D0*CSP(2,4)*SP(1,3)*S23
      MAT(11,-1,-1) = 8D0*CSP(2,4)*SP(1,3)*S14
      MAT(12,-1,-1) = 8D0*CSP(2,4)**2*SP(1,3)*SP(2,4)
      MAT(13,-1,-1) = 32D0*CSP(2,4)*SP(1,3)

      MAT42(1,1,1) = 2D0*CSP(1,3)*SP(4,2)
      MAT42(2,1,1) = 2D0*CSP(1,3)*SP(4,2)*S14
      MAT42(3,1,1) = 2D0*CSP(1,3)*SP(4,2)*S23
      MAT42(4,1,1) = 2D0*CSP(1,4)*CSP(3,2)*SP(4,2)**2*S13
      MAT42(5,1,1) = CSP(1,3)**2*SP(1,2)*SP(4,3)
      MAT42(6,1,1) = CSP(1,3)*SP(4,2)*S34
      MAT42(7,1,1) = CSP(1,3)*SP(4,2)*S12
      MAT42(8,1,1) = CSP(1,2)*CSP(4,3)*SP(4,2)**2
      MAT42(9,1,1) = 8D0*CSP(1,3)**2*SP(1,2)*SP(4,3)
      MAT42(10,1,1) = 8D0*CSP(1,3)*SP(4,2)*S34
      MAT42(11,1,1) = 8D0*CSP(1,3)*SP(4,2)*S12
      MAT42(12,1,1) = 8D0*CSP(1,3)*CSP(4,2)*SP(4,2)**2
      MAT42(13,1,1) = 32D0*CSP(1,3)*SP(4,2)
      MAT42(1,-1,1) = 2D0*CSP(4,3)*SP(1,2)
      MAT42(5,-1,1) = CSP(4,3)*SP(1,2)*S13
      MAT42(6,-1,1) = CSP(4,3)**2*SP(1,3)*SP(4,2)
      MAT42(7,-1,1) = CSP(1,3)*CSP(4,2)*SP(1,2)**2
      MAT42(8,-1,1) = CSP(4,3)*SP(1,2)*S24
      MAT42(9,-1,1) = 4D0*CSP(4,3)*SP(1,2)*S13
      MAT42(10,-1,1) = 4D0*CSP(4,3)**2*SP(1,3)*SP(4,2)
      MAT42(11,-1,1) = 4D0*CSP(1,3)*CSP(4,2)*SP(1,2)**2
      MAT42(12,-1,1) = 4D0*CSP(4,3)*SP(1,2)*S24
      MAT42(13,-1,1) = 8D0*CSP(4,3)*SP(1,2)
      MAT42(1,1,-1) = 2D0*CSP(1,2)*SP(4,3)
      MAT42(5,1,-1) = CSP(1,2)*SP(4,3)*S13
      MAT42(6,1,-1) = CSP(1,3)*CSP(4,2)*SP(4,3)**2
      MAT42(7,1,-1) = CSP(1,2)**2*SP(1,3)*SP(4,2)
      MAT42(8,1,-1) = CSP(1,2)*SP(4,3)*S24
      MAT42(9,1,-1) = 4D0*CSP(1,2)*SP(4,3)*S13
      MAT42(10,1,-1) = 4D0*CSP(1,3)*CSP(4,2)*SP(4,3)**2
      MAT42(11,1,-1) = 4D0*CSP(1,2)**2*SP(1,3)*SP(4,2)
      MAT42(12,1,-1) = 4D0*CSP(1,2)*SP(4,3)*S24
      MAT42(13,1,-1) = 8D0*CSP(1,2)*SP(4,3)
      MAT42(1,-1,-1) = 2D0*CSP(4,2)*SP(1,3)
      MAT42(2,-1,-1) = 2D0*CSP(4,2)*SP(1,3)*S14
      MAT42(3,-1,-1) = 2D0*CSP(4,2)*SP(1,3)*S23
      MAT42(4,-1,-1) = 2D0*CSP(4,2)**2*SP(1,4)*SP(3,2)*S13
      MAT42(5,-1,-1) = CSP(1,2)*CSP(4,3)*SP(1,3)**2
      MAT42(6,-1,-1) = CSP(4,2)*SP(1,3)*S34
      MAT42(7,-1,-1) = CSP(4,2)*SP(1,3)*S12
      MAT42(8,-1,-1) = CSP(4,2)**2*SP(1,2)*SP(4,3)
      MAT42(9,-1,-1) = 8D0*CSP(1,2)*CSP(4,3)*SP(1,3)**2
      MAT42(10,-1,-1) = 8D0*CSP(4,2)*SP(1,3)*S34
      MAT42(11,-1,-1) = 8D0*CSP(4,2)*SP(1,3)*S12
      MAT42(12,-1,-1) = 8D0*CSP(4,2)**2*SP(1,3)*SP(4,2)
      MAT42(13,-1,-1) = 32D0*CSP(4,2)*SP(1,3)

c Born matrix elements
      do j=1,13
      do i1=-1,1,2
      do i3=-1,1,2
        fb(j,i1,i3) = 0d0
        fb42(j,i1,i3) = 0d0
      enddo
      enddo
      enddo

      if (fname(1).eq.fname(3)) then
        perm=4
      else
        perm=1
      endif

      if (cc.eq.1) then
        call HWW(fb,pw12,pw34)
        if (nc.eq.1) call HZZ1133_born(fb42,pz14,pz23)
      elseif (nc.eq.1) then
        if(iso(1).eq.1.and.iso(3).eq.1) then
          call HZZ1144_born(fb,pz12,pz34)
          if (fname(1).eq.fname(3))
     &         call HZZ1144_born(fb42,pz14,pz23)
        elseif(iso(1).eq.1.and.iso(3).eq.-1) then
          call HZZ1133_born(fb,pz12,pz34)
        elseif(iso(1).eq.-1.and.iso(3).eq.-1) then
          call HZZ2233_born(fb,pz12,pz34)
          if (fname(1).eq.fname(3))
     &         call HZZ2233_born(fb42,pz14,pz23)
        endif
      endif

      do i1=-1,1,2
      do i2=-1,1,2
      do i3=-1,1,2
      do i4=-1,1,2
        matb(i1,i2,i3,i4) = 0d0     !polarizations of f1,f2,f3,f4
        matb42(i1,i2,i3,i4) = 0d0
      do j=1,13
        matb(i1,i2,i3,i4) = matb(i1,i2,i3,i4) + el**3*fb(j,i1,i3)
     &       *mat(j,i1,i3)*abs(i1-i2)/2d0*abs(i3-i4)/2d0    !delta(i3,-i4)
        matb42(i1,i2,i3,i4) = matb42(i1,i2,i3,i4)
     &       - el**3*fb42(j,i1,i3)   ! fb42 negative because of Grassmann
     &       *mat42(j,i1,i3)*abs(i1-i4)/2d0*abs(i3-i2)/2d0  !delta(i1,-i4)
      enddo
      enddo
      enddo
      enddo
      enddo

      mbcmb = 0d0
      do i1=-1,1,2
      do i2=-1,1,2
      do i3=-1,1,2
      do i4=-1,1,2
        mbcmb = mbcmb + int((2+pol(1)*i1)/2)*int((2+pol(2)*i2)/2)
     &          *int((2+pol(3)*i3)/2)*int((2+pol(4)*i4)/2)
     &          *( abs(matb(i1,i2,i3,i4))**2
     &            +abs(matb42(i1,i2,i3,i4))**2
     &            +2d0*dreal(matb(i1,i2,i3,i4)
     &               *dconjg(matb42(i1,i2,i3,i4)))/sqrt(real(color)) )
     &          *color/perm
      enddo
      enddo
      enddo
      enddo

      end

************************************************************************
*
*     calculate form factors for H -> VV -> 4f
*       convention of SD: SU2-duplett (q,q')=(q1,q2),(q,q')=(q3,q4)
*         fermion masses in common/fmass:
*               mf(1)/mf(4):up-type, mf(2)/mf(3):down-type
*         ZZ1133: uddu/uuss, ZZ1144:uucc/uuuu, ZZ2233:ddss/dddd
*         external masses mf(1:4) in common/processpar, avoid confusion!
*       42: H->ffff, H->ff'f'f particle 2 interchanged with particle 4
*         (only kinematics, not necessary for q and mf,
*          since they are equal for NC
*          or q(1)/q(3),mf(1)/mf(3),ct_zff(1/3) is used for mixed NC/CC)
************************************************************************
      subroutine calcform_EW(F,F42)
      implicit none
      integer j,i1,i3
      complex*16 F(13,-1:1,-1:1),F42(13,-1:1,-1:1)
      include 'COMMON/options.inc'
      include 'COMMON/processpar.inc'
      include 'COMMON/param.inc'
c propagators and interchanged charges
      complex*16 pw12,pw34,pz12,pz34,pz14,pz23
      common/propagators/pw12,pw34,pz12,pz34,pz14,pz23
c standard matrix elements
      complex*16 mat(13,-1:1,-1:1),mat42(13,-1:1,-1:1)
      complex*16 matb(-1:1,-1:1,-1:1,-1:1),matb42(-1:1,-1:1,-1:1,-1:1)
      complex*16 fb(13,-1:1,-1:1),fb42(13,-1:1,-1:1)
      real*8 mbcmb
      common/sme/mat,mat42,matb,matb42,fb,fb42,mbcmb

      do i1 = -1,1,2
      do i3 = -1,1,2
      do j = 1,13
        F(j,i1,i3) = 0d0
        F42(j,i1,i3) = 0d0
      enddo
      enddo
      enddo

c charged current (H->WW->udsc)
      if (cc.eq.1) then
        if (qbos.eq.1) then
          call HWW4f_self_bos(F,pw12,pw34)
ccc          call HWW4f_self_bos2(F,pw12,pw34)  ! test routine
          call HWW4f_vert_bos(F,pw12,pw34)
          call HWW4f_box(F,pw12,pw34)
          call HWW4f_pent(F,pw12,pw34)
          call HWW4f_count_bos(F,pw12,pw34)
        elseif (qbos.eq.2) then
          call HWW4f_self_bos_bgf(F,pw12,pw34)
ccc          call HWW4f_self_bos_bgf2(F,pw12,pw34)   ! test routine
          call HWW4f_vert_bos_bgf(F,pw12,pw34)
          call HWW4f_box_bgf(F,pw12,pw34)
          call HWW4f_pent(F,pw12,pw34)
          call HWW4f_count_bgf(F,pw12,pw34)
        endif
        if (qferm.eq.1) then
          call HWW4f_self_ferm(F,pw12,pw34)
ccc          call HWW4f_self_ferm2(F,pw12,pw34)   ! test routine
          call HWW4f_vert_ferm(F,pw12,pw34)
          call HWW4f_count_ferm(F,pw12,pw34)
        endif
c mixed current (H->WW/ZZ->uudd)
        if (nc.eq.1) then
          call switch42()
          if (qbos.eq.1) then
            call HZZ1133_self_bos(F42,pz14,pz23)
            call HZZ1133_vert_bos(F42,pz14,pz23)
            call HZZ1133_box(F42,pz14,pz23)
            call HZZ1133_pent(F42,pz14,pz23)
            call HZZ1133_count_bos(F42,pz14,pz23)
          elseif (qbos.eq.2) then
            call HZZ1133_self_bos_bgf(F42,pz14,pz23)
            call HZZ1133_vert_bos_bgf(F42,pz14,pz23)
            call HZZ1133_box_bgf(F42,pz14,pz23)
            call HZZ1133_pent(F42,pz14,pz23)
            call HZZ1133_count_bgf(F42,pz14,pz23)
          endif
          if (qferm.eq.1) then
            call HZZ1133_self_ferm(F42,pz14,pz23)
            call HZZ1133_vert_ferm(F42,pz14,pz23)
            call HZZ1133_count_ferm(F42,pz14,pz23)
          endif
          call switch42()
        endif
c neutral current
c H->ZZ->uuuu(cc)
      elseif (nc.eq.1) then
        if(iso(1).eq.1.and.iso(3).eq.1) then
          if (qbos.eq.1) then
            call HZZ1144_self_bos(F,pz12,pz34)
            call HZZ1144_vert_bos(F,pz12,pz34)
            call HZZ1144_box(F,pz12,pz34)
            call HZZ1144_pent(F,pz12,pz34)
            call HZZ1144_count_bos(F,pz12,pz34)
          elseif (qbos.eq.2) then
            call HZZ1144_self_bos_bgf(F,pz12,pz34)
            call HZZ1144_vert_bos_bgf(F,pz12,pz34)
            call HZZ1144_box_bgf(F,pz12,pz34)
            call HZZ1144_pent(F,pz12,pz34)
            call HZZ1144_count_bgf(F,pz12,pz34)
          endif
          if (qferm.eq.1) then
            call HZZ1144_self_ferm(F,pz12,pz34)
            call HZZ1144_vert_ferm(F,pz12,pz34)
            call HZZ1144_count_ferm(F,pz12,pz34)
          endif
          if (fname(1).eq.fname(3)) then
            call switch42()
            if (qbos.eq.1) then
              call HZZ1144_self_bos(F42,pz14,pz23)
              call HZZ1144_vert_bos(F42,pz14,pz23)
              call HZZ1144_box(F42,pz14,pz23)
              call HZZ1144_pent(F42,pz14,pz23)
              call HZZ1144_count_bos(F42,pz14,pz23)
            elseif (qbos.eq.2) then
              call HZZ1144_self_bos_bgf(F42,pz14,pz23)
              call HZZ1144_vert_bos_bgf(F42,pz14,pz23)
              call HZZ1144_box_bgf(F42,pz14,pz23)
              call HZZ1144_pent(F42,pz14,pz23)
              call HZZ1144_count_bgf(F42,pz14,pz23)
            endif
            if (qferm.eq.1) then
              call HZZ1144_self_ferm(F42,pz14,pz23)
              call HZZ1144_vert_ferm(F42,pz14,pz23)
              call HZZ1144_count_ferm(F42,pz14,pz23)
            endif
            call switch42()
          endif
c H->ZZ->uuss
        elseif(iso(1).eq.1.and.iso(3).eq.-1) then
          if (qbos.eq.1) then
            call HZZ1133_self_bos(F,pz12,pz34)
            call HZZ1133_vert_bos(F,pz12,pz34)
            call HZZ1133_box(F,pz12,pz34)
            call HZZ1133_pent(F,pz12,pz34)
            call HZZ1133_count_bos(F,pz12,pz34)
          elseif (qbos.eq.2) then
            call HZZ1133_self_bos_bgf(F,pz12,pz34)
            call HZZ1133_vert_bos_bgf(F,pz12,pz34)
            call HZZ1133_box_bgf(F,pz12,pz34)
            call HZZ1133_pent(F,pz12,pz34)
            call HZZ1133_count_bgf(F,pz12,pz34)
          endif
          if (qferm.eq.1) then
            call HZZ1133_self_ferm(F,pz12,pz34)
            call HZZ1133_vert_ferm(F,pz12,pz34)
            call HZZ1133_count_ferm(F,pz12,pz34)
          endif
c H->ZZ->dddd(ss)
        elseif(iso(1).eq.-1.and.iso(3).eq.-1) then
          if (qbos.eq.1) then
            call HZZ2233_self_bos(F,pz12,pz34)
            call HZZ2233_vert_bos(F,pz12,pz34)
            call HZZ2233_box(F,pz12,pz34)
            call HZZ2233_pent(F,pz12,pz34)
            call HZZ2233_count_bos(F,pz12,pz34)
          elseif (qbos.eq.2) then
            call HZZ2233_self_bos_bgf(F,pz12,pz34)
            call HZZ2233_vert_bos_bgf(F,pz12,pz34)
            call HZZ2233_box_bgf(F,pz12,pz34)
            call HZZ2233_pent(F,pz12,pz34)
            call HZZ2233_count_bgf(F,pz12,pz34)
          endif
          if (qferm.eq.1) then
            call HZZ2233_self_ferm(F,pz12,pz34)
            call HZZ2233_vert_ferm(F,pz12,pz34)
            call HZZ2233_count_ferm(F,pz12,pz34)
          endif
          if (fname(1).eq.fname(3)) then
            call switch42()
            if (qbos.eq.1) then
              call HZZ2233_self_bos(F42,pz14,pz23)
              call HZZ2233_vert_bos(F42,pz14,pz23)
              call HZZ2233_box(F42,pz14,pz23)
              call HZZ2233_pent(F42,pz14,pz23)
              call HZZ2233_count_bos(F42,pz14,pz23)
            elseif (qbos.eq.2) then
              call HZZ2233_self_bos_bgf(F42,pz14,pz23)
              call HZZ2233_vert_bos_bgf(F42,pz14,pz23)
              call HZZ2233_box_bgf(F42,pz14,pz23)
              call HZZ2233_pent(F42,pz14,pz23)
              call HZZ2233_count_bgf(F42,pz14,pz23)
            endif
            if (qferm.eq.1) then
              call HZZ2233_self_ferm(F42,pz14,pz23)
              call HZZ2233_vert_ferm(F42,pz14,pz23)
              call HZZ2233_count_ferm(F42,pz14,pz23)
            endif
            call switch42()
          endif
        endif
      endif

      end

************************************************************************
*
*     calculate form factors for H -> VV -> 4f
*       convention of SD: SU2-duplett (q,q')=(q1,q2),(q,q')=(q3,q4)
*         fermion masses in common/fmass:
*               mf(1)/mf(4):up-type, mf(2)/mf(3):down-type
*         ZZ1133: uddu/uuss, ZZ1144:uucc/uuuu, ZZ2233:ddss/dddd
*         external masses mf(1:4) in common/processpar, avoid confusion!
*       42: H->ffff, H->ff'f'f particle 2 interchanged with particle 4
*         (only kinematics, not necessary for q and mf,
*          since they are equal for NC
*          or q(1)/q(3),mf(1)/mf(3),ct_zff(1/3) is used for mixed NC/CC)
************************************************************************
      subroutine calcform_QCD(F,F42,FNDQCD,FNDQCD42)
      implicit none
      integer j,i1,i3,had,qcdbos1,qcdpent,qcdbos2,qcdbox,qcdferm
      complex*16 F(13,-1:1,-1:1),F42(13,-1:1,-1:1)
      complex*16 FNDQCD(13,-1:1,-1:1),FNDQCD42(13,-1:1,-1:1)
      include 'COMMON/options.inc'
      include 'COMMON/processpar.inc'
      include 'COMMON/param.inc'
c propagators and interchanged charges
      complex*16 pw12,pw34,pz12,pz34,pz14,pz23
      common/propagators/pw12,pw34,pz12,pz34,pz14,pz23
c standard matrix elements
      complex*16 mat(13,-1:1,-1:1),mat42(13,-1:1,-1:1)
      complex*16 matb(-1:1,-1:1,-1:1,-1:1),matb42(-1:1,-1:1,-1:1,-1:1)
      complex*16 fb(13,-1:1,-1:1),fb42(13,-1:1,-1:1)
      real*8 mbcmb
      common/sme/mat,mat42,matb,matb42,fb,fb42,mbcmb

      do i1 = -1,1,2
      do i3 = -1,1,2
      do j = 1,13
        F(j,i1,i3) = 0d0
        F42(j,i1,i3) = 0d0
        FNDQCD(j,i1,i3) = 0d0
        FNDQCD42(j,i1,i3) = 0d0
      enddo
      enddo
      enddo

c QCD corrections
      qcdbos1 = 1   !type a/b according to classification in paper
      qcdpent = 1   !type b
      qcdbos2 = 1   !type c
      qcdbox  = 1   !type c
      qcdferm = 1   !type d
      if (qqcd.eq.3) then  !type a
        qcdpent = 0
        qcdbos2 = 0
        qcdbox  = 0
        qcdferm = 0
      elseif (qqcd.eq.4) then !type b
        qcdbos2 = 0
        qcdbox = 0
        qcdferm = 0
      elseif (qqcd.eq.5) then !type c
        qcdbos1 = 0
        qcdpent  = 0
        qcdferm = 0
      elseif (qqcd.eq.6) then !type d
        qcdbos1 = 0
        qcdpent  = 0
        qcdbos2 = 0
        qcdbox = 0
      endif

c diagonal QCD corrections like EW->F
      if (quark(1).eq.1) had = 1
      if (quark(3).eq.1) had = 2
      if (quark(1).eq.1.and.quark(3).eq.1) had = 3
      if (qqcd.ne.0.and.qcdbos1.eq.1.and.
     &     (quark(1).eq.1.or.quark(3).eq.1)) then
c type H->udsc/uddu
      if (cc.eq.1) then
        call HWW4f_vert_qcd_bos1(F,pw12,pw34,had,mf2(1),mf2(2)
     &        ,mf2(3),mf2(4))
c type H->uddu
        if (nc.eq.1) then
          call switch42()
          call HZZ1133_vert_qcd_bos1(F42,pz14,pz23,had,mf2(1),mf2(4)
     &        ,mf2(3),mf2(2))
          call switch42()
        endif
      elseif (nc.eq.1) then
c type H->uucc/uuuu
        if(iso(1).eq.1.and.iso(3).eq.1) then
          call HZZ1144_vert_qcd_bos1(F,pz12,pz34,had,mf2(1),mf2(2)
     &        ,mf2(3),mf2(4))
c type H->uuuu
          if (fname(1).eq.fname(3)) then
            call switch42()
            call HZZ1144_vert_qcd_bos1(F42,pz14,pz23,had,mf2(1),mf2(4)
     &        ,mf2(3),mf2(2))
            call switch42()
          endif
c type H->uuss
        elseif(iso(1).eq.1.and.iso(3).eq.-1) then
          call HZZ1133_vert_qcd_bos1(F,pz12,pz34,had,mf2(1),mf2(2)
     &        ,mf2(3),mf2(4))
c type H->ddss/dddd
        elseif(iso(1).eq.-1.and.iso(3).eq.-1) then
          call HZZ2233_vert_qcd_bos1(F,pz12,pz34,had,mf2(1),mf2(2)
     &        ,mf2(3),mf2(4))
c type H->dddd
          if (fname(1).eq.fname(3)) then
            call switch42()
            call HZZ2233_vert_qcd_bos1(F42,pz14,pz23,had,mf2(1),mf2(4)
     &        ,mf2(3),mf2(2))
            call switch42()
          endif
        endif
      endif
      endif

c non-diagonal QCD corrections: only interference->FNQCD
      if (qqcd.ne.0.and.quark(1).eq.1.and.quark(3).eq.1) then
c type H->uddu
        if (cc.eq.1.and.nc.eq.1) then
          if(qcdpent.eq.1)call HWW4f_pent_qcd(FNDQCD,pw12,pw34)
          call switch42()
          if(qcdbos2.eq.1)call HZZ1133_vert_qcd_bos2(FNDQCD42,pz14,pz23)
          if(qcdferm.eq.1)call HZZ1133_vert_qcd_ferm(FNDQCD42,pz14,pz23)
          if(qcdbox.eq.1)call HZZ1133_box_qcd(FNDQCD42,pz14,pz23)
          if(qcdpent.eq.1)call HZZ1133_pent_qcd(FNDQCD42,pz14,pz23)
          call switch42()
        elseif (nc.eq.1) then
c type H->uuuu
          if(iso(1).eq.1.and.iso(3).eq.1.and.fname(1).eq.fname(3)) then
            if(qcdbos2.eq.1)call HZZ1144_vert_qcd_bos2(FNDQCD,pz12,pz34)
            if(qcdferm.eq.1)call HZZ1144_vert_qcd_ferm(FNDQCD,pz12,pz34)
            if(qcdbox.eq.1)call HZZ1144_box_qcd(FNDQCD,pz12,pz34)
            if(qcdpent.eq.1)call HZZ1144_pent_qcd(FNDQCD,pz12,pz34)
            call switch42()
            if(qcdbos2.eq.1)
     &           call HZZ1144_vert_qcd_bos2(FNDQCD42,pz14,pz23)
            if(qcdferm.eq.1)
     &           call HZZ1144_vert_qcd_ferm(FNDQCD42,pz14,pz23)
            if(qcdbox.eq.1)call HZZ1144_box_qcd(FNDQCD42,pz14,pz23)
            if(qcdpent.eq.1)call HZZ1144_pent_qcd(FNDQCD42,pz14,pz23)
            call switch42()
c type H->dddd
          elseif(iso(1).eq.-1.and.iso(3).eq.-1.and.fname(1).eq.fname(3))
     &         then
            if(qcdbos2.eq.1)call HZZ2233_vert_qcd_bos2(FNDQCD,pz12,pz34)
            if(qcdferm.eq.1)call HZZ2233_vert_qcd_ferm(FNDQCD,pz12,pz34)
            if(qcdbox.eq.1)call HZZ2233_box_qcd(FNDQCD,pz12,pz34)
            if(qcdpent.eq.1)call HZZ2233_pent_qcd(FNDQCD,pz12,pz34)
            call switch42()
            if(qcdbos2.eq.1)
     &           call HZZ2233_vert_qcd_bos2(FNDQCD42,pz14,pz23)
            if(qcdferm.eq.1)
     &           call HZZ2233_vert_qcd_ferm(FNDQCD42,pz14,pz23)
            if(qcdbox.eq.1)call HZZ2233_box_qcd(FNDQCD42,pz14,pz23)
            if(qcdpent.eq.1)call HZZ2233_pent_qcd(FNDQCD42,pz14,pz23)
            call switch42()
          endif
        endif
      endif

      end

************************************************************************
*
*     exchange mandelstein variables and fmass of fermion 2 and 4
*        always call twice in order to restore old values!!!
*
************************************************************************
      subroutine switch42()
      implicit none
      real*8 temp
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14

      temp = s12
      s12 = s14
      s14 = temp
      temp = s23
      s23 = s34
      s34 = temp
      temp = t12
      t12 = t14
      t14 = temp

      end

************************************************************************
*
*     Born matrix element for H->WW->4f
*
************************************************************************
      subroutine HWW(F,pw12,pw34)
      implicit none
      complex*16 pre,F(13,-1:1,-1:1),pw12,pw34
      include 'COMMON/xparam.inc'

C       Process: S1F21aF22F23aF24,   Model: SM4f

C       G(T1,N1,FULL)

      PRE = (PW12*PW34*XMW)/(2D0*XSW*XSW2)

      F(1,-1,-1) = F(1,-1,-1)+PRE

      end

************************************************************************
*
*     Born matrix element for H->ZZ->uudd
*
************************************************************************
      subroutine HZZ1133_born(F,pz12,pz34)
      implicit none
      complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf

C       Process: S1F21aF21F23aF23,   Model: SM4f

C       G(T1,N1,FULL)

      PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)-(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(3)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(1)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(3)*PRE*XSW

      end

************************************************************************
*
*     Born matrix element for H->ZZ->uuuu
*
************************************************************************
      subroutine HZZ1144_born(F,pz12,pz34)
      implicit none
      complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf

C       Process: S1F21aF21F24aF24,   Model: SM4f

C       G(T1,N1,FULL)

      PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0-2D0*QF(1)*XSW2)*(1D0-2D0*
     &  QF(4)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)-(2D0*QF(4)*PRE*(1D0-2D0*QF(1)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)-(2D0*QF(1)*PRE*(1D0-2D0*QF(4)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(1)*QF(4)*PRE*XSW

      end

************************************************************************
*
*     Born matrix element for H->ZZ->dddd (generic d)
*
************************************************************************
      subroutine HZZ2233_born(F,pz12,pz34)
      implicit none
      complex*16 pre,F(13,-1:1,-1:1),pz12,pz34
      include 'COMMON/xparam.inc'
c fermion charges of isospin duplets
      real*8 qf(4)
      common/fcharge/qf

C       Process: S1F22aF22F23aF23,   Model: SM4f

C       G(T1,N1,FULL)

      PRE = (PZ12*PZ34*XCW2**(-2)*XMW)/4D0

      F(1,-1,-1) = F(1,-1,-1)+(PRE*(1D0+2D0*QF(2)*XSW2)*(1D0+2D0*
     &  QF(3)*XSW2))/(XSW*XSW2)
      F(1,-1,1) = F(1,-1,1)+(2D0*QF(3)*PRE*(1D0+2D0*QF(2)*XSW2))/
     &  XSW
      F(1,1,-1) = F(1,1,-1)+(2D0*QF(2)*PRE*(1D0+2D0*QF(3)*XSW2))/
     &  XSW
      F(1,1,1) = F(1,1,1)+4D0*QF(2)*QF(3)*PRE*XSW

      end

************************************************************************
        subroutine xcalcrenc
************************************************************************
*	calculate renormalization constants
*	bosonic loops only
*	conventional formalism
*-----------------------------------------------------------------------
*       2.6.04 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 xseww,seaa,seaz,sezz,dZff_a
	complex*16 xB0_,B00H,B00W,B00Z,BW0W,BWWZ,BWHW,BZWW,BZHZ
	complex*16 xB1_,B1Z,B1W
	complex*16 xDB0_,xDB1_,DBW0W,DBWWZ,DBWHW,DBZWW,DBZHZ,DB0WW
	complex*16 DB00W,DB0HW,DB0WZ
	complex*16 BHWW,BHZZ,DBHHH,DBHWW,DBHZZ
	complex*16 seww0
        complex*16 gnnl,geer,geel,gffr(4),gffl(4)
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_hww,ct_hzz,ct_hza
        real*8 iw3f(4)
	integer i,dir(7)

        include 'COMMON/param.inc'
        include 'COMMON/options.inc'
        include 'COMMON/xparam.inc'
        include 'COMMON/processpar.inc'
        COMMON/UV/MUDIM2
        COMMON/IR/LAMBDA,LAMBDA2
        common/xrenc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &                    dZeer,dZeel,dZnnl,dZffr,dZffl,
     &                    ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &                    ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &                    ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &                    ct_hww,ct_hzz,ct_hza

	B00H  = xB0_(0d0,null,xmh2,0)
	B00W  = xB0_(0d0,null,xmw2,0)
	B00Z  = xB0_(0d0,null,xmz2,0)
	BW0W  = xB0_(mw2,null,xmw2,0)
	BWWZ  = xB0_(mw2,xmw2,xmz2,0)
	BWHW  = xB0_(mw2,xmh2,xmw2,0)
	BZWW  = xB0_(mz2,xmw2,xmw2,0)
	BZHZ  = xB0_(mz2,xmh2,xmz2,0)
        BHWW  = xB0_(MH2,xMW2,xMW2,0)
        BHZZ  = xB0_(MH2,xMZ2,xMZ2,0)
	DBW0W = xDB0_(mw2,null,xmw2,0)
	DBWHW = xDB0_(mw2,xmh2,xmw2,0)
	DBWWZ = xDB0_(mw2,xmw2,xmz2,0)
	DBZHZ = xDB0_(mz2,xmh2,xmz2,0)
	DBZWW = xDB0_(mz2,xmw2,xmw2,0)
	DB0WW = xDB0_(0d0,xmw2,xmw2,0)
	DB00W = xDB0_(0d0,null,xmw2,0)
	DB0HW = xDB0_(0d0,xmh2,xmw2,0)
	DB0WZ = xDB0_(0d0,xmw2,xmz2,0)
        DBHHH = xDB0_(MH2,xMH2,xMH2,0)
        DBHWW = xDB0_(MH2,xMW2,xMW2,0)
        DBHZZ = xDB0_(MH2,xMZ2,xMZ2,0)

        B1W   = xB1_(0D0,null,xMW2,0)
        B1Z   = xB1_(0D0,null,xMZ2,0)

	dmw2 = xseww(mw2)

	call xsevv(mz2,seaa,seaz,sezz)
	dmz2 = sezz
	dZaz = -2d0*seaz/mz2

	call xsevv(0d0,seaa,seaz,sezz)

	dZza = 2d0*seaz/xmz2

	dZaz = dZaz + (xmz2-mz2)/mz2*dZza

	dZaa = -ALPHA/(4D0*PI)*(3D0-3D0*B00W-4D0*xMW2*DB0WW)

	x = mw2
	dZw = -ALPHA/(144D0*PI)*(
     &	-(4D0/XSW2)+(3D0*X**(-2)*XMH2*(XMH2-XMW2)*B00H)/XSW2
     &	-(3D0*X**(-2)*XMW2*(XMH2-2D0*XMW2+XMZ2)*B00W)/XSW2
     &	-(3D0*X**(-2)*(1D0+8D0*XCW2)*XMZ2*(XMW2-XMZ2)*B00Z)/XSW2
     &	-24D0*X**(-2)*(5D0*X**2+XMW2**2)*BW0W
     &	+(3D0*X**(-2)*(X**2-XMH2**2+2D0*XMH2*XMW2-XMW2**2)*BWHW)/XSW2
     &	-3D0*X**(-2)*XMW2*XMZ2**(-2)*(8D0*XMW2**3-X**2*XMZ2
     &    -15D0*XMW2**2*XMZ2+XMZ2**3+XMW2*(40D0*X**2+6D0*XMZ2**2))*BWWZ
     &    /(XCW2*XSW2)
     &	+(24D0*(-(5D0*X**2)-2D0*X*XMW2+XMW2**2)*DBW0W)/X
     &	+3D0*(X**2+XMH2**2+10D0*X*XMW2+XMW2**2-2D0*XMH2*(X+XMW2))
     &    *DBWHW/(X*XSW2)
     &	+(3D0*XMW2*XMZ2**(-2)*(8D0*XMW2**3-XMW2**2*(16D0*X+15D0*XMZ2)
     &    +XMZ2*(X**2+10D0*X*XMZ2+XMZ2**2)+XMW2*(-(40D0*X**2)
     &    -54D0*X*XMZ2+6D0*XMZ2**2))*DBWWZ)/(X*XCW2*XSW2)
     &	)

	x = mz2
	dZzz = -ALPHA/(144D0*PI*XCW2*XSW2)*(
     &	-(4D0*(1D0-2D0*XSW2))
     &	+3D0*X**(-2)*XMH2*(XMH2-XMZ2)*B00H
     &	-3D0*X**(-2)*XMZ2*(XMH2-XMZ2)*B00Z
     &	+3D0*X**(-2)*(X**2-XMH2**2+2D0*XMH2*XMZ2-XMZ2**2)*BZHZ
     &	-3D0*(39D0-76D0*XSW2+36D0*XSW2**2)*BZWW
     &	+(3D0*(X**2+XMH2**2+10D0*X*XMZ2+XMZ2**2-2D0*XMH2*(X+XMZ2))
     &	  *DBZHZ)/X
     &	-3D0*(4D0*XMW2*(15D0-32D0*XSW2+12D0*XSW2**2)
     &	  +X*(39D0-76D0*XSW2+36D0*XSW2**2))*DBZWW)

	x = mh2
	dZh = -ALPHA/(32D0*PI*XSW2)*(
     &	-8D0*BHWW-4D0*XMZ2*BHZZ/XMW2+9D0*XMH2**2*DBHHH/XMW2
     &  +(2D0*(XMH2**2-4D0*X*XMW2+12D0*XMW2**2)*DBHWW)/XMW2
     &  +(XMH2**2-4D0*X*XMZ2+12D0*XMZ2**2)*DBHZZ/XMW2 )

	seww0 =  ALPHA/(48D0*PI)*(
     &	-2D0/xCW2/xSW2*(xMH2+19D0*xMW2-xMH2*xSW2-18D0*xMW2*xSW2)
     &  +8D0*xMH2*xMW2/xSW2*B00H/(xMH2-xMW2)
     &	+4D0*xMW2/xSW**4*(15D0*xMH2-15D0*xMW2-16D0*xMH2*xSW2
     &   +14D0*xMW2*xSW2)*B00W/(xMH2-xMW2)
     &	-4D0/xCW2*xMW2/xSW**4*(5D0-2D0*xSW2)*(3D0-4D0*xSW2)*B00Z
     & 	+8D0*xMW**4*DB00W+(xMH2-xMW2)**2/xSW2*DB0HW
     &	+xMW**4/xCW**4*xSW2*(9D0-8D0*xSW2)*DB0WZ	)

c modifications for complex renormalization
        dmw2 = dmw2 - (xmw2-mw2)*dZw
        dmz2 = dmz2 - (xmz2-mz2)*dZzz

c dependent parameters
        dsw  = xcw2/2d0/xsw*( dmz2/xmz2 - dmw2/xmw2 )

	drbos = -dZaa-2d0*dsw/xsw+(seww0-dmw2)/xmw2+xcw/xsw*dZza
     &		+alpha/4d0/pi/xsw2*(6d0+(7d0-4d0*xsw2)
     &			/2d0/xsw2*log(xcw2))

	if ((qalp.eq.0).or.(qalp.eq.2)) then
	  dZe = -dZaa/2d0-dZza*xsw/2d0/xcw
	elseif (qalp.eq.1) then
	  dZe = -dZaa/2d0-dZza*xsw/2d0/xcw - drbos/2d0
	endif

        iw3f(1) = iso(1)/2d0
        iw3f(2) = iso(2)/2d0
        iw3f(3) = iso(3)/2d0
        iw3f(4) = iso(4)/2d0
        do i=1,4
          gffr(i) = -q(i)*xsw/xcw
          gffl(i) = -q(i)*xsw/xcw+iw3f(i)/xsw/xcw
	  if (q(i).eq.0d0) then
	    dZff_a = 0d0
	  else
	    dZff_a  = -ALPHA/4D0/PI*q(i)**2*( log(mudim2/mf(i)**2)+4d0
     &		  	                      +4d0*log(lambda/mf(i)) )
	  endif
          dZffl(i) = dZff_a + ALPHA/4D0/PI*(
     &              + gffl(i)**2*(2D0*B1Z+1D0)
     &              + (2D0*B1W+1D0)/2D0/xSW2               )
          dZffr(i) = dZff_a + ALPHA/4D0/PI*(
     &              + gffr(i)**2*(2D0*B1Z+1D0) )
	enddo

c*** vertex counterterms
	ct_aww = dZe+dZw+dZaa/2d0-xcw/xsw*dZza/2d0
	ct_zww = dZe-dsw/xsw/xcw2+dZw+dZzz/2d0+dZaz/2d0/(-xcw/xsw)

	ct_wf1f2 = dZe-dsw/xsw+(dZw+dZffl(1)+dZffl(2))/2d0
	ct_wf3f4 = dZe-dsw/xsw+(dZw+dZffl(3)+dZffl(4))/2d0

	do i=1,4
	  ct_zffr(i) = dZe+dsw/xsw/xcw2+dZzz/2d0+dZffr(i)
     &			+dZaz/2d0/xsw*xcw
	  ct_zffl(i) = dZe+dsw/xsw/xcw2-2d0*iw3f(i)/xsw2/xcw*dsw/gffl(i)
     &			+dZzz/2d0+dZffl(i)
     &			-q(i)*dZaz/2d0/gffl(i)
	enddo

c HVV counterterms
        ct_hww = dZe - dsw/xsw + dmw2/xmw2/2d0 + dZh/2d0 + dZw
        ct_hzz = dZe + (2d0*xsw2-xcw2)/xcw2*dsw/xsw + dmw2/xmw2/2d0
     &           + dZh/2d0 + dZzz
        ct_hza = dZza/2d0

c$$$      print*,'bosonisch:'
c$$$      write(*,'((a),2f26.18)')'dmw2=',dmw2
c$$$      write(*,'((a),2f26.18)')'dmz2=',dmz2
c$$$      write(*,'((a),2f26.18)')'dsw=',dsw
c$$$      write(*,'((a),2f26.18)')'dZe=',dZe
c$$$      write(*,'((a),2f26.18)')'dZaa=',dZaa
c$$$      write(*,'((a),2f26.18)')'dZaz=',dZaz
c$$$      write(*,'((a),2f26.18)')'dZza=',dZza
c$$$      write(*,'((a),2f26.18)')'dZzz=',dZzz
c$$$      write(*,'((a),2f26.18)')'dZw=',dZw
c$$$      write(*,'((a),2f26.18)')'dZh=',dZh
c$$$      write(*,'((a),2f26.18)')'dZffr(1)=',dZffr(1)
c$$$      write(*,'((a),2f26.18)')'dZffr(2)=',dZffr(2)
c$$$      write(*,'((a),2f26.18)')'dZffr(3)=',dZffr(3)
c$$$      write(*,'((a),2f26.18)')'dZffr(4)=',dZffr(4)
c$$$      write(*,'((a),2f26.18)')'dZffl(1)=',dZffl(1)
c$$$      write(*,'((a),2f26.18)')'dZffl(2)=',dZffl(2)
c$$$      write(*,'((a),2f26.18)')'dZffl(3)=',dZffl(3)
c$$$      write(*,'((a),2f26.18)')'dZffl(4)=',dZffl(4)

	end

************************************************************************
        subroutine xcalcrenc_bgf
************************************************************************
*	calculate renormalization constants
*	bosonic loops only
*	background-field formalism
*-----------------------------------------------------------------------
*       13.6.04 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 xseww_bgf,seaa,seaz,sezz,dZff_a
	complex*16 xB0_,B00H,B00W,B00Z,BW0W,BWWZ,BWHW,BZWW,BZHZ
	complex*16 xB1_,B1Z,B1W
	complex*16 xDB0_,DBW0W,DBWWZ,DBWHW,DBZWW,DBZHZ,DB0WW
	complex*16 DB00W,DB0HW,DB0WZ
	complex*16 BHWW,BHZZ,DBHHH,DBHWW,DBHZZ
	complex*16 seww0conv
        complex*16 gnnl,geer,geel,gffr(4),gffl(4)
        complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
        complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
        complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
        complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
        complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_hww,ct_hzz,ct_hza
        real*8 iw3f(4)
	integer i,dir(7)

        include 'COMMON/param.inc'
        include 'COMMON/options.inc'
        include 'COMMON/xparam.inc'
        include 'COMMON/processpar.inc'
        COMMON/UV/MUDIM2
        COMMON/IR/LAMBDA,LAMBDA2
        common/xrenc_bgf/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &                    dZeer,dZeel,dZnnl,dZffr,dZffl,
     &                    ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &                    ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &                    ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &                    ct_hww,ct_hzz,ct_hza

	B00H  = xB0_(0d0,null,xmh2,0)
	B00W  = xB0_(0d0,null,xmw2,0)
	B00Z  = xB0_(0d0,null,xmz2,0)
	BW0W  = xB0_(mw2,null,xmw2,0)
	BWWZ  = xB0_(mw2,xmw2,xmz2,0)
	BWHW  = xB0_(mw2,xmh2,xmw2,0)
	BZWW  = xB0_(mz2,xmw2,xmw2,0)
	BZHZ  = xB0_(mz2,xmh2,xmz2,0)
        BHWW  = xB0_(MH2,xMW2,xMW2,0)
        BHZZ  = xB0_(MH2,xMZ2,xMZ2,0)
	DBW0W = xDB0_(mw2,null,xmw2,0)
	DBWHW = xDB0_(mw2,xmh2,xmw2,0)
	DBWWZ = xDB0_(mw2,xmw2,xmz2,0)
	DBZHZ = xDB0_(mz2,xmh2,xmz2,0)
	DBZWW = xDB0_(mz2,xmw2,xmw2,0)
	DB0WW = xDB0_(0d0,xmw2,xmw2,0)
	DB00W = xDB0_(0d0,null,xmw2,0)
	DB0HW = xDB0_(0d0,xmh2,xmw2,0)
	DB0WZ = xDB0_(0d0,xmw2,xmz2,0)
        DBHHH = xDB0_(MH2,xMH2,xMH2,0)
        DBHWW = xDB0_(MH2,xMW2,xMW2,0)
        DBHZZ = xDB0_(MH2,xMZ2,xMZ2,0)
        B1W   = xB1_(0D0,null,xMW2,0)
        B1Z   = xB1_(0D0,null,xMZ2,0)

	dmw2 = xseww_bgf(mw2)

	call xsevv_bgf(mz2,seaa,seaz,sezz)
	dmz2 = sezz
	dZaz = -2d0*seaz/mz2
	dZza = 0d0

	dZaz = dZaz + (xmz2-mz2)/mz2*dZza

	dZaa = -ALPHA/(4D0*PI)*(3D0-3D0*B00W-4D0*xMW2*DB0WW
     &  			+4d0*(1D0-B00W) )

	x = mw2
	dZw = -ALPHA/(144D0*PI)*(
     &	-(4D0/XSW2)+(3D0*X**(-2)*XMH2*(XMH2-XMW2)*B00H)/XSW2
     &	-(3D0*X**(-2)*XMW2*(XMH2-2D0*XMW2+XMZ2)*B00W)/XSW2
     &	-(3D0*X**(-2)*(1D0+8D0*XCW2)*XMZ2*(XMW2-XMZ2)*B00Z)/XSW2
     &	-24D0*X**(-2)*(5D0*X**2+XMW2**2)*BW0W
     &	+(3D0*X**(-2)*(X**2-XMH2**2+2D0*XMH2*XMW2-XMW2**2)*BWHW)/XSW2
     &	-3D0*X**(-2)*XMW2*XMZ2**(-2)*(8D0*XMW2**3-X**2*XMZ2
     &    -15D0*XMW2**2*XMZ2+XMZ2**3+XMW2*(40D0*X**2+6D0*XMZ2**2))*BWWZ
     &    /(XCW2*XSW2)
     &	+(24D0*(-(5D0*X**2)-2D0*X*XMW2+XMW2**2)*DBW0W)/X
     &	+3D0*(X**2+XMH2**2+10D0*X*XMW2+XMW2**2-2D0*XMH2*(X+XMW2))
     &    *DBWHW/(X*XSW2)
     &	+(3D0*XMW2*XMZ2**(-2)*(8D0*XMW2**3-XMW2**2*(16D0*X+15D0*XMZ2)
     &    +XMZ2*(X**2+10D0*X*XMZ2+XMZ2**2)+XMW2*(-(40D0*X**2)
     &    -54D0*X*XMZ2+6D0*XMZ2**2))*DBWWZ)/(X*XCW2*XSW2)
     &  -144d0*(xSW2*BW0W+xCW2*BWWZ)/xSW2		)

	x = mz2
	dZzz = -ALPHA/(144D0*PI*XCW2*XSW2)*(
     &	-(4D0*(1D0-2D0*XSW2))
     &	+3D0*X**(-2)*XMH2*(XMH2-XMZ2)*B00H
     &	-3D0*X**(-2)*XMZ2*(XMH2-XMZ2)*B00Z
     &	+3D0*X**(-2)*(X**2-XMH2**2+2D0*XMH2*XMZ2-XMZ2**2)*BZHZ
     &	-3D0*(39D0-76D0*XSW2+36D0*XSW2**2)*BZWW
     &	+(3D0*(X**2+XMH2**2+10D0*X*XMZ2+XMZ2**2-2D0*XMH2*(X+XMZ2))
     &	  *DBZHZ)/X
     &	-3D0*(4D0*XMW2*(15D0-32D0*XSW2+12D0*XSW2**2)
     &	  +X*(39D0-76D0*XSW2+36D0*XSW2**2))*DBZWW
     &  -144d0*xCW2**2*BZWW	)

	x = mh2
	dZh = -ALPHA/(32D0*PI*XSW2)*(
     &	-8D0*BHWW-4D0*XMZ2*BHZZ/XMW2+9D0*XMH2**2*DBHHH/XMW2
     &  +(2D0*(XMH2**2-4D0*X*XMW2+12D0*XMW2**2)*DBHWW)/XMW2
     &  +(XMH2**2-4D0*X*XMZ2+12D0*XMZ2**2)*DBHZZ/XMW2 )
     &  +ALPHA/xSW2/(8D0*PI)*(
     &	2D0*BHWW+BHZZ/xCW2-(xMH2-X)/xCW2*(2D0*xCW2*DBHWW+DBHZZ) )

	seww0conv =  ALPHA/(48D0*PI)*(
     &	-2D0/xCW2/xSW2*(xMH2+19D0*xMW2-xMH2*xSW2-18D0*xMW2*xSW2)
     &  +8D0*xMH2*xMW2/xSW2*B00H/(xMH2-xMW2)
     &	+4D0*xMW2/xSW**4*(15D0*xMH2-15D0*xMW2-16D0*xMH2*xSW2
     &   +14D0*xMW2*xSW2)*B00W/(xMH2-xMW2)
     &	-4D0/xCW2*xMW2/xSW**4*(5D0-2D0*xSW2)*(3D0-4D0*xSW2)*B00Z
     & 	+8D0*xMW**4*DB00W+(xMH2-xMW2)**2/xSW2*DB0HW
     &	+xMW**4/xCW**4*xSW2*(9D0-8D0*xSW2)*DB0WZ	)

c modifications for complex renormalization
        dmw2 = dmw2 - (xmw2-mw2)*dZw
        dmz2 = dmz2 - (xmz2-mz2)*dZzz

c dependent parameters
        dsw  = xcw2/2d0/xsw*( dmz2/xmz2 - dmw2/xmw2 )

	drbos = -dZaa-2d0*dsw/xsw+(seww0conv-dmw2)/xmw2
     &          +alpha/pi/xsw2*(-1d0+B00w)
     &		+alpha/4d0/pi/xsw2*(6d0+(7d0-4d0*xsw2)
     &			/2d0/xsw2*log(xcw2))

	if ((qalp.eq.0).or.(qalp.eq.2)) then
	  dZe = -dZaa/2d0
	elseif (qalp.eq.1) then
	  dZe = -dZaa/2d0 - drbos/2d0
	endif

        iw3f(1) = iso(1)/2d0
        iw3f(2) = iso(2)/2d0
        iw3f(3) = iso(3)/2d0
        iw3f(4) = iso(4)/2d0
        do i=1,4
          gffr(i) = -q(i)*xsw/xcw
          gffl(i) = -q(i)*xsw/xcw+iw3f(i)/xsw/xcw
	  if (q(i).eq.0d0) then
	    dZff_a = 0d0
	  else
	    dZff_a  = -ALPHA/4D0/PI*q(i)**2*( log(mudim2/mf(i)**2)+4d0
     &		  	                      +4d0*log(lambda/mf(i)) )
	  endif
          dZffl(i) = dZff_a + ALPHA/4D0/PI*(
     &              + gffl(i)**2*(2D0*B1Z+1D0)
     &              + (2D0*B1W+1D0)/2D0/xSW2               )
          dZffr(i) = dZff_a + ALPHA/4D0/PI*(
     &              + gffr(i)**2*(2D0*B1Z+1D0) )
	enddo

c*** vertex counterterms
	ct_aww = dZe+dZw+dZaa/2d0-xcw/xsw*dZza/2d0
	ct_zww = dZe-dsw/xsw/xcw2+dZw+dZzz/2d0+dZaz/2d0/(-xcw/xsw)

	ct_wf1f2 = dZe-dsw/xsw+(dZw+dZffl(1)+dZffl(2))/2d0
	ct_wf3f4 = dZe-dsw/xsw+(dZw+dZffl(3)+dZffl(4))/2d0

	do i=1,4
	  ct_zffr(i) = dZe+dsw/xsw/xcw2+dZzz/2d0+dZffr(i)
     &			+dZaz/2d0/xsw*xcw
	  ct_zffl(i) = dZe+dsw/xsw/xcw2-2d0*iw3f(i)/xsw2/xcw*dsw/gffl(i)
     &			+dZzz/2d0+dZffl(i)
     &			-q(i)*dZaz/2d0/gffl(i)
	enddo

c HVV counterterms
        ct_hww = dZe - dsw/xsw + dmw2/xmw2/2d0 + dZh/2d0 + dZw
        ct_hzz = dZe + (2d0*xsw2-xcw2)/xcw2*dsw/xsw + dmw2/xmw2/2d0
     &           + dZh/2d0 + dZzz
        ct_hza = 0d0

	end

************************************************************************
        subroutine xcalcrenc_ferm
************************************************************************
*	calculate renormalization constants
*	fermion-loop contributions only
*-----------------------------------------------------------------------
*       28.5.04 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 xseww_ferm,xseaa,xseaz,xsezz
	complex*16 xB0_,B00l,B00u,B00d,B0du,BWnl,BWud,BZ00,BZll,BZdd,BZuu
	complex*16 xDB0_,DBWnl,DBWud,DBZ00,DBZll,DBZdd,DBZuu
	complex*16 DB0ll,DB0dd,DB0uu,DB00l,DB0du,seww0
	complex*16 gnnl,geer,geel,gffr(4),gffl(4)
	complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh
	complex*16 dZeer,dZeel,dZnnl,dZffr(4),dZffl(4)
	complex*16 ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4
	complex*16 ct_annl,ct_aeer,ct_aeel,ct_affr(4),ct_affl(4)
	complex*16 ct_znnl,ct_zeer,ct_zeel,ct_zffr(4),ct_zffl(4)
        complex*16 ct_hww,ct_hzz,ct_hza
	real*8 iw3f(4)
	integer i,dir(7)
        include 'COMMON/param.inc'
        include 'COMMON/options.inc'
        include 'COMMON/xparam.inc'
        include 'COMMON/processpar.inc'
	common/xrenc_ferm/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,dZh,
     &	                  dZeer,dZeel,dZnnl,dZffr,dZffl,
     &			  ct_aww,ct_zww,ct_wen,ct_wf1f2,ct_wf3f4,
     &			  ct_annl,ct_aeer,ct_aeel,ct_affr,ct_affl,
     &			  ct_znnl,ct_zeer,ct_zeel,ct_zffr,ct_zffl,
     &                    ct_hww,ct_hzz,ct_hza

	dmw2  = 0d0
	dmz2  = 0d0
	dZw   = 0d0
	dZzz  = 0d0
	dZaa  = 0d0
	dZza  = 0d0
	dZaz  = 0d0
	dZh   = 0d0
	dalpz = 0d0
	seww0 = 0d0

	do 10 i=1,3

	B00l  =  xB0_(0D0,   null, XML2(I),0)
	B00u  =  xB0_(0D0,   null,XMQP2(I),0)
	B00d  =  xB0_(0D0,   null,XMQM2(I),0)
	B0du  =  xB0_(0D0,XMQM2(I),XMQP2(I),0)
	BWnl  =  xB0_(MW2,   null, XML2(I),0)
	BWud  =  xB0_(MW2,XMQP2(I),XMQM2(I),0)
	DBWnl = xDB0_(MW2,   null, XML2(I),0)
	DBWud = xDB0_(MW2,XMQP2(I),XMQM2(I),0)
	BZ00  =  xB0_(MZ2,null,null,0)
	BZll  =  xB0_(MZ2,XML2(I),XML2(I),0)
	BZdd  =  xB0_(MZ2,XMQM2(I),XMQM2(I),0)
	BZuu  =  xB0_(MZ2,XMQP2(I),XMQP2(I),0)
	DBZ00 = xDB0_(MZ2,null,null,0)
	DBZll = xDB0_(MZ2,XML2(I),XML2(I),0)
	DBZdd = xDB0_(MZ2,XMQM2(I),XMQM2(I),0)
	DBZuu = xDB0_(MZ2,XMQP2(I),XMQP2(I),0)
	DB0ll = xDB0_(0d0,XML2(I),XML2(I),0)
	DB0dd = xDB0_(0d0,XMQM2(I),XMQM2(I),0)
	DB0uu = xDB0_(0d0,XMQP2(I),XMQP2(I),0)
	DB00l = xDB0_(0d0,null,XML2(I),0)
	DB0du = xDB0_(0d0,XMQM2(I),XMQP2(I),0)

	dZw   = dZw  + ALPHA/(72D0*PI*xSW2)*(
     &	8D0 + 3D0*MW2**(-2)*B00l*XML2(I)**2
     & 	+3D0*DBWnl*(-MW2+XML2(I))*(2D0*MW2+XML2(I))/MW2
     &  -3D0*MW2**(-2)*BWnl*(2D0*MW2**2+XML2(I)**2)
     & 	+9D0*MW2**(-2)*B00d*XMQM2(I)*(XMQM2(I)-XMQP2(I))
     & 	-9D0*MW2**(-2)*B00u*XMQP2(I)*(XMQM2(I)-XMQP2(I))
     &	-9D0*MW2**(-2)*BWud*(2D0*MW2**2+XMQM2(I)**2-2D0*XMQM2(I)*XMQP2(I)
     &			     +XMQP2(I)**2)
     &	+9D0*DBWud*(-2D0*MW2**2+MW2*XMQM2(I)+XMQM2(I)**2+MW2*XMQP2(I)
     &  	    -2D0*XMQM2(I)*XMQP2(I)+XMQP2(I)**2)/MW2	    )

	dZzz  = dZzz - ALPHA/(216D0*xCW2*PI)*(
     &	48D0-64D0*xSW2-24D0/xSW2
     &	+9D0*BZ00/xSW2
     &  +9D0*(1D0-4D0*xSW2+8D0*xSW2**2)*BZll/xSW2
     &  +3D0*(9D0-12D0*xSW2+8D0*xSW2**2)*BZdd/xSW2
     &  +3D0*(9D0-24D0*xSW2+32D0*xSW2**2)*BZuu/xSW2
     &	+9D0*MZ2*DBZ00/xSW2
     &	-9D0*DBZll*(-MZ2+4D0*MZ2*xSW2-8D0*MZ2*xSW2**2+XML2(I)
     &  	    +8D0*xSW2*XML2(I)-16D0*xSW2**2*XML2(I))/xSW2
     &	+3D0*DBZdd*(9D0*MZ2-12D0*MZ2*xSW2+8D0*MZ2*xSW2**2-9D0*XMQM2(I)
     &  	    -24D0*xSW2*XMQM2(I)+16D0*xSW2**2*XMQM2(I))/xSW2
     &	+3D0*DBZuu*(9D0*MZ2-24D0*MZ2*xSW2+32D0*MZ2*xSW2**2-9D0*XMQP2(I)
     &		    -48D0*xSW2*XMQP2(I)+64D0*xSW2**2*XMQP2(I))/xSW2     )

	dZaa  = dZaa - ALPHA/(27D0*PI)*(
     &	-32D0+9D0*B00l+3D0*B00d+12D0*B00u
     &	+18D0*DB0ll*XML2(I)+6D0*DB0dd*XMQM2(I)+24D0*DB0uu*XMQP2(I)	)

        dZh = dZh
     &       +3D0*ALPHA*XMQP2(I)/xMW2/xSW2/8D0/PI
     &        *( -xB0_(MH2,XMQP2(I),XMQP2(I),0)
     &           +(-MH2+4D0*XMQP2(I))*xDB0_(MH2,XMQP2(I),XMQP2(I),0) )
     &       +3D0*ALPHA*XMQM2(I)/xMW2/xSW2/8D0/PI
     &        *( -xB0_(MH2,XMQM2(I),XMQM2(I),0)
     &           +(-MH2+4D0*XMQM2(I))*xDB0_(MH2,XMQM2(I),XMQM2(I),0) )
     &       +ALPHA*XML2(I)/xMW2/xSW2/8D0/PI
     &        *( -xB0_(MH2,XML2(I),XML2(I),0)
     &           +(-MH2+4D0*XML2(I))*xDB0_(MH2,XML2(I),XML2(I),0) )

	dalpz = dalpz + alpha/3d0/pi*dreal(
     & 	     ( 1d0/3d0+(1d0+2d0* xml2(i)/mz2)*(B00l-1d0-BZll) )
     & 	    +( 1d0/3d0+(1d0+2d0*xmqm2(i)/mz2)*(B00d-1d0-BZdd) )/3d0 )
	if (i.ne.3)
     &  dalpz = dalpz + alpha/3d0/pi*dreal(
     &    ( 1d0/3d0+(1d0+2d0*xmqp2(i)/mz2)*(B00u-1d0-BZuu) )*4d0/3d0 )

	seww0 = seww0 - ALPHA/(24D0*PI*xSW2)*(
     & 	-6D0*xmqm2(i)-2D0*xml2(i)-6D0*xmqp2(i)
     &	+6D0*xmqm2(i)*B00d+3D0*xml2(i)*B00l+6D0*xmqp2(i)*B00u
     &	+3D0*(xmqm2(i)+xmqp2(i))*B0du
     &	+xml2(i)**2*DB00l+3D0*(xmqm2(i)-xmqp2(i))**2*DB0du	)

10	continue

	dmw2 = xseww_ferm(mw2)
        call xsevv_ferm(mz2,xseaa,xseaz,xsezz)
	dmz2 = xsezz
	dZaz = -2d0*xseaz/mz2
        call xsevv_ferm(0d0,xseaa,xseaz,xsezz)
c	dZza = 2d0*xseaz/xmz2
	dZza = 0d0

c modifications for complex renormalization
	dmw2 = dmw2 - (xmw2-mw2)*dZw
	dmz2 = dmz2 - (xmz2-mz2)*dZzz
	dZaz = dZaz + (xmz2-mz2)/mz2*dZza

c dependent parameters
	dsw  = xcw2/2d0/xsw*( dmz2/xmz2 - dmw2/xmw2 )

	drferm = -dZaa-2d0*dsw/xsw+(seww0-dmw2)/xmw2

	if (qalp.eq.0) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw
	elseif (qalp.eq.2) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw - dalpz/2d0
	elseif (qalp.eq.1) then
	  dZe = -dZaa/2d0 - dZza/2d0*xsw/xcw - drferm/2d0
	endif

	do i=1,4
	  dZffr(i) = 0d0
	  dZffl(i) = 0d0
	enddo

c*** vertex counterterms
	ct_aww = dZe+dZw+dZaa/2d0-xcw/xsw*dZza/2d0
	ct_zww = dZe-dsw/xsw/xcw2+dZw+dZzz/2d0+dZaz/2d0/(-xcw/xsw)

	ct_wf1f2 = dZe-dsw/xsw+(dZw+dZffl(1)+dZffl(2))/2d0
	ct_wf3f4 = dZe-dsw/xsw+(dZw+dZffl(3)+dZffl(4))/2d0

        iw3f(1) = iso(1)/2d0
        iw3f(2) = iso(2)/2d0
        iw3f(3) = iso(3)/2d0
        iw3f(4) = iso(4)/2d0
	do i=1,4
	  gffr(i) = -q(i)*xsw/xcw
	  gffl(i) = -q(i)*xsw/xcw+iw3f(i)/xsw/xcw
	enddo

	do i=1,4
	  ct_zffr(i) = dZe+dsw/xsw/xcw2+dZzz/2d0+dZffr(i)
     &                  +dZaz/2d0/xsw*xcw
	  ct_zffl(i) = dZe+dsw/xsw/xcw2-2d0*iw3f(i)/xsw2/xcw*dsw/gffl(i)
     &			+dZzz/2d0+dZffl(i)
     &			-q(i)*dZaz/2d0/gffl(i)
	enddo

c HVV counterterms
        ct_hww = dZe - dsw/xsw + dmw2/xmw2/2d0 + dZh/2d0 + dZw
        ct_hzz = dZe + (2d0*xsw2-xcw2)/xcw2*dsw/xsw + dmw2/xmw2/2d0
     &           + dZh/2d0 + dZzz
        ct_hza = dZza/2d0

c$$$      print*,'fermionisch:'
c$$$      write(*,'((a),2f26.18)')'dmw2=',dmw2
c$$$      write(*,'((a),2f26.18)')'dmz2=',dmz2
c$$$      write(*,'((a),2f26.18)')'dsw=',dsw
c$$$      write(*,'((a),2f26.18)')'dZe=',dZe
c$$$      write(*,'((a),2f26.18)')'dZaa=',dZaa
c$$$      write(*,'((a),2f26.18)')'dZaz=',dZaz
c$$$      write(*,'((a),2f26.18)')'dZza=',dZza
c$$$      write(*,'((a),2f26.18)')'dZzz=',dZzz
c$$$      write(*,'((a),2f26.18)')'dZw=',dZw
c$$$      write(*,'((a),2f26.18)')'dZh=',dZh
c$$$      write(*,'((a),2f26.18)')'dZffr(1)=',dZffr(1)
c$$$      write(*,'((a),2f26.18)')'dZffr(2)=',dZffr(2)
c$$$      write(*,'((a),2f26.18)')'dZffr(3)=',dZffr(3)
c$$$      write(*,'((a),2f26.18)')'dZffr(4)=',dZffr(4)
c$$$      write(*,'((a),2f26.18)')'dZffl(1)=',dZffl(1)
c$$$      write(*,'((a),2f26.18)')'dZffl(2)=',dZffl(2)
c$$$      write(*,'((a),2f26.18)')'dZffl(3)=',dZffl(3)
c$$$      write(*,'((a),2f26.18)')'dZffl(4)=',dZffl(4)

	end

**********************************************************************
        function xseww(s)
**********************************************************************
*       unrenormalized W self-energy
*	bosonic loops only
*       conventional formalism
*---------------------------------------------------------------------
*       2.6.04 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 B00H,B00W,B00Z,Bs0W,BsHW,BsWZ
        complex*16 xseww,B0_,xB0_
        include 'COMMON/param.inc'
        include 'COMMON/xparam.inc'

c	B00H = B0_(0D0,0D0,MH,0)
c	B00W = B0_(0D0,0D0,MW,0)
c	B00Z = B0_(0D0,0D0,MZ,0)
c	Bs0W = B0_(S,0D0,MW,0)
c	BsHW = B0_(S,MH,MW,0)
c	BsWZ = B0_(S,MW,MZ,0)

	B00H = xB0_(0D0,null,xMH2,0)
	B00W = xB0_(0D0,null,xMW2,0)
	B00Z = xB0_(0D0,null,xMZ2,0)
	Bs0W = xB0_(S,null,xMW2,0)
	BsHW = xB0_(S,xMH2,xMW2,0)
	BsWZ = xB0_(S,xMW2,xMZ2,0)

        xseww = ALPHA/PI*(
     &  (-3D0*xMH2-57D0*xMW2-2D0*S+3D0*xMH2*xSW2+54D0*xMW2*xSW2
     &    +2D0*S*xSW2)/72D0/xCW2/xSW2
     &  -xMH2*(xMH2-xMW2-2D0*S)/xSW2*B00H/(48D0*S)
     &  +xMW2/xSW2/xCW2*(xMH2-xMW2+20D0*S-xMH2*xSW2+2D0*xMW2*xSW2
     &    -20D0*S*xSW2)*B00W/(48D0*S)
     &  +xMW2/xSW2/xCW**4*(-9D0+8D0*xSW2)*(-2D0*S+xMW2*xSW2+2D0*S*xSW2)
     &    *B00Z/(48D0*S)
     &  -(-xMW**4+2D0*xMW2*S+5D0*S**2)*Bs0W/(6D0*S)
     &  +(xMH**4-2D0*xMH2*xMW2+xMW**4-2D0*xMH2*S+10D0*xMW2*S+S**2)/xSW2
     &    *BsHW/(48D0*S)
     &  +(-60D0*xMW2*S-39D0*S**2+146D0*xMW2*S*xSW2+118D0*S**2*xSW2
     &    +9D0*xMW**4*xSW**4-102D0*xMW2*S*xSW**4-119D0*S**2*xSW**4
     &    -8D0*xMW**4*xSW**6+16D0*xMW2*S*xSW**6+40D0*S**2*xSW**6)
     &    /xCW**4/xSW2*BsWZ/(48D0*S)       )

        end


**********************************************************************
        function xseww_bgf(s)
**********************************************************************
*       unrenormalized W self-energy
*	bosonic loops only
*       background-field formalism
*---------------------------------------------------------------------
*       13.6.04 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 B00H,B00W,B00Z,Bs0W,BsHW,BsWZ
        complex*16 xseww_bgf,B0_,xB0_
        include 'COMMON/param.inc'
        include 'COMMON/xparam.inc'

c	B00H = B0_(0D0,0D0,MH,0)
c	B00W = B0_(0D0,0D0,MW,0)
c	B00Z = B0_(0D0,0D0,MZ,0)
c	Bs0W = B0_(S,0D0,MW,0)
c	BsHW = B0_(S,MH,MW,0)
c	BsWZ = B0_(S,MW,MZ,0)

	B00H = xB0_(0D0,null,xMH2,0)
	B00W = xB0_(0D0,null,xMW2,0)
	B00Z = xB0_(0D0,null,xMZ2,0)
	Bs0W = xB0_(S,null,xMW2,0)
	BsHW = xB0_(S,xMH2,xMW2,0)
	BsWZ = xB0_(S,xMW2,xMZ2,0)

        xseww_bgf = ALPHA/PI*(
     &  (-3D0*xMH2-57D0*xMW2-2D0*S+3D0*xMH2*xSW2+54D0*xMW2*xSW2
     &    +2D0*S*xSW2)/72D0/xCW2/xSW2
     &  -xMH2*(xMH2-xMW2-2D0*S)/xSW2*B00H/(48D0*S)
     &  +xMW2/xSW2/xCW2*(xMH2-xMW2+20D0*S-xMH2*xSW2+2D0*xMW2*xSW2
     &    -20D0*S*xSW2)*B00W/(48D0*S)
     &  +xMW2/xSW2/xCW**4*(-9D0+8D0*xSW2)*(-2D0*S+xMW2*xSW2+2D0*S*xSW2)
     &    *B00Z/(48D0*S)
     &  -(-xMW**4+2D0*xMW2*S+5D0*S**2)*Bs0W/(6D0*S)
     &  +(xMH**4-2D0*xMH2*xMW2+xMW**4-2D0*xMH2*S+10D0*xMW2*S+S**2)/xSW2
     &    *BsHW/(48D0*S)
     &  +(-60D0*xMW2*S-39D0*S**2+146D0*xMW2*S*xSW2+118D0*S**2*xSW2
     &    +9D0*xMW**4*xSW**4-102D0*xMW2*S*xSW**4-119D0*S**2*xSW**4
     &    -8D0*xMW**4*xSW**6+16D0*xMW2*S*xSW**6+40D0*S**2*xSW**6)
     &    /xCW**4/xSW2*BsWZ/(48D0*S)
     &  +(xMW2-S)*(Bs0W+xCW2/xSW2*BsWZ)		)

        end

**********************************************************************
        subroutine xsevv(s,seaa,seaz,sezz)
**********************************************************************
*       unrenormalized neutral boson self-energies
*	bosonic loops only
*       conventional formalism
*---------------------------------------------------------------------
*       2.6.04 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 seaa,seaz,sezz
	complex*16 B0_,xB0_,xDB0_,B00H,B00W,B00Z,BSHZ,BSWW,DB0HZ
        include 'COMMON/param.inc'
        include 'COMMON/xparam.inc'

c	B00H = B0_(0D0,0D0,MH,0)
c	B00W = B0_(0D0,0D0,MW,0)
c	B00Z = B0_(0D0,0D0,MZ,0)
c	BSHZ = B0_(S,MH,MZ,0)
c	BSWW = B0_(S,MW,MW,0)

	B00H = xB0_(0D0,null,xMH2,0)
	B00W = xB0_(0D0,null,xMW2,0)
	B00Z = xB0_(0D0,null,xMZ2,0)
	BSHZ = xB0_(S,xMH2,xMZ2,0)
	BSWW = xB0_(S,xMW2,xMW2,0)
	DB0HZ= xDB0_(0D0,XMH2,XMZ2,0)

        seaa = -ALPHA/(4D0*PI)*(
     &  -4d0*xMW2*(B00W-1d0) + (3D0*S+4D0*xMW2)*BSWW )

        seaz = ALPHA/(72D0*xCW*PI*xSW)*(
     &	2D0*S+12D0*(1D0-6D0*xCW2)*xMW2*(B00W-1D0)
     &  +3D0*(8D0*(1D0+3D0*xCW2)*xMW2+S+18D0*xCW2*S)*BSWW)

	if (s.ne.0d0) then
          sezz = ALPHA/PI*(
     &    (-3D0*xMH2-57D0*xMZ2-2D0*S+174D0*xMZ2*xSW2+4D0*S*xSW2
     &      -192D0*xMZ2*xSW**4+72D0*xMZ2*xSW**6)/72D0/xCW2/xSW2
     &    -xMH2*(xMH2-xMZ2-2D0*S)/xSW2/xCW2*B00H/(48D0*S)
     &    +xMZ2/xSW2*(9D0-20D0*xSW2+12D0*xSW**4)*B00W/12D0
     &    -xMZ2*(-xMH2+xMZ2-2D0*S)/xSW2/xCW2*B00Z/(48D0*S)
     &    +(xMH**4-2D0*xMH2*xMZ2+xMZ**4-2D0*xMH2*S+10D0*xMZ2*S+S**2)
     &      /xSW2/xCW2*BSHZ/(48D0*S)
     &    +(-60D0*xMZ2-39D0*S+188D0*xMZ2*xSW2+76D0*S*xSW2
     &      -176D0*xMZ2*xSW**4-36D0*S*xSW**4+48D0*xMZ2*xSW**6)
     &	    /xSW2/xCW2*BSWW/48D0   )
	else
	  sezz = ALPHA/(48D0*PI*XCW2*XSW2)*(
     &	  -2D0*(XMH2+(1D0+12D0*XCW2-24D0*XCW2**2)*XMZ2)
     &    +8D0*XMH2*XMW2*B00H/(XCW2*(XMH2-XMZ2))
     &    -24D0*XMW2*(XCW2-XSW2)*B00W
     &	  +4D0*XMZ2*(XMH2-3D0*XMZ2)*B00Z/(XMH2-XMZ2)
     &    +(XMH2-XMZ2)**2*DB0HZ 			)
	endif

	end

**********************************************************************
        subroutine xsevv_bgf(s,seaa,seaz,sezz)
**********************************************************************
*       unrenormalized neutral boson self-energies
*	bosonic loops only
*       background-field formalism
*---------------------------------------------------------------------
*       13.6.04 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 seaa,seaz,sezz
	complex*16 B0_,xB0_,xDB0_,B00H,B00W,B00Z,BSHZ,BSWW,DB0HZ
        include 'COMMON/param.inc'
        include 'COMMON/xparam.inc'

c	B00H = B0_(0D0,0D0,MH,0)
c	B00W = B0_(0D0,0D0,MW,0)
c	B00Z = B0_(0D0,0D0,MZ,0)
c	BSHZ = B0_(S,MH,MZ,0)
c	BSWW = B0_(S,MW,MW,0)

	B00H = xB0_(0D0,null,xMH2,0)
	B00W = xB0_(0D0,null,xMW2,0)
	B00Z = xB0_(0D0,null,xMZ2,0)
	BSHZ = xB0_(S,xMH2,xMZ2,0)
	BSWW = xB0_(S,xMW2,xMW2,0)
	DB0HZ= xDB0_(0D0,XMH2,XMZ2,0)

        seaa = -ALPHA/(4D0*PI)*(
     &  -4d0*xMW2*(B00W-1d0) + (3D0*S+4D0*xMW2)*BSWW
     &  +4d0*S*BsWW	)

        seaz = ALPHA/(72D0*xCW*PI*xSW)*(
     &	2D0*S+12D0*(1D0-6D0*xCW2)*xMW2*(B00W-1D0)
     &  +3D0*(8D0*(1D0+3D0*xCW2)*xMW2+S+18D0*xCW2*S)*BSWW
     &  -36d0*xCW2*(xMZ2-2D0*S)*BsWW	)

	if (s.ne.0d0) then
          sezz = ALPHA/PI*(
     &    (-3D0*xMH2-57D0*xMZ2-2D0*S+174D0*xMZ2*xSW2+4D0*S*xSW2
     &      -192D0*xMZ2*xSW**4+72D0*xMZ2*xSW**6)/72D0/xCW2/xSW2
     &    -xMH2*(xMH2-xMZ2-2D0*S)/xSW2/xCW2*B00H/(48D0*S)
     &    +xMZ2/xSW2*(9D0-20D0*xSW2+12D0*xSW**4)*B00W/12D0
     &    -xMZ2*(-xMH2+xMZ2-2D0*S)/xSW2/xCW2*B00Z/(48D0*S)
     &    +(xMH**4-2D0*xMH2*xMZ2+xMZ**4-2D0*xMH2*S+10D0*xMZ2*S+S**2)
     &      /xSW2/xCW2*BSHZ/(48D0*S)
     &    +(-60D0*xMZ2-39D0*S+188D0*xMZ2*xSW2+76D0*S*xSW2
     &      -176D0*xMZ2*xSW**4-36D0*S*xSW**4+48D0*xMZ2*xSW**6)
     &	    /xSW2/xCW2*BSWW/48D0
     &    +xCW2*(xMZ2-S)/xSW2*BsWW )
	else
	  sezz = ALPHA/(48D0*PI*XCW2*XSW2)*(
     &	  -2D0*(XMH2+(1D0+12D0*XCW2-24D0*XCW2**2)*XMZ2)
     &    +8D0*XMH2*XMW2*B00H/(XCW2*(XMH2-XMZ2))
     &    -24D0*XMW2*(XCW2-XSW2)*B00W
     &	  +4D0*XMZ2*(XMH2-3D0*XMZ2)*B00Z/(XMH2-XMZ2)
     &    +(XMH2-XMZ2)**2*DB0HZ 			)
     &    +ALPHA/PI*xMW2/xSW2*(-1D0+B00W)
	endif

	end

**********************************************************************
	function xseww_ferm(s)
**********************************************************************
*	unrenormalized W self-energy
*	closed fermion loops only
*---------------------------------------------------------------------
*	28.5.04 Stefan Dittmaier
**********************************************************************
	implicit real*8 (a-z)
	complex*16 xseww_ferm,xB0_,xdB0_
        integer i
        include 'COMMON/param.inc'
        include 'COMMON/xparam.inc'

	xseww_ferm = 0d0

	if (s.ne.0d0) then

	do 10 i=1,3
	xseww_ferm = xseww_ferm - ALPHA/PI/xsw2/72D0*(
     &  8D0*S-6D0*XML2(I)-18D0*XMQM2(I)-18D0*XMQP2(I)
     &	-3D0*xB0_(0D0,null,XML2(I),0)*XML2(I)*(-2D0*S+XML2(I))/S
     &	+(3D0*xB0_(S,null,XML2(I),0)*(-S+XML2(I))*(2D0*S+XML2(I)))/S
     &	-9D0*xB0_(0D0,null,XMQM2(I),0)*XMQM2(I)
     &          *(-2D0*S+XMQM2(I)-XMQP2(I))/S
     &	+9D0*xB0_(0D0,null,XMQP2(I),0)*XMQP2(I)
     &          *(2D0*S+XMQM2(I)-XMQP2(I))/S
     &	+9D0*xB0_(S,XMQM2(I),XMQP2(I),0)*(-2D0*S**2+S*XMQM2(I)
     &	    +XMQM2(I)**2+S*XMQP2(I)-2D0*XMQM2(I)*XMQP2(I)+XMQP2(I)**2)/S)
10	continue

	else

	do 20 i=1,3
        xseww_ferm = xseww_ferm - ALPHA/(24D0*PI*xsw2)*(
     &  -6D0*xmqm2(i)-2D0*xml2(i)-6D0*xmqp2(i)
     &  +6D0*xmqm2(i)*xB0_(0d0,null,xmqm2(i),0)
     &	+3D0*xml2(i)*xB0_(0d0,null,xml2(i),0)
     &	+6D0*xmqp2(i)*xB0_(0d0,null,xmqp2(i),0)
     &  +3D0*(xmqm2(i)+xmqp2(i))*xB0_(0d0,xmqm2(i),xmqp2(i),0)
     &  +xml2(i)**2*xDB0_(0d0,null,xml2(i),0)
     &	+3D0*(xmqm2(i)-xmqp2(i))**2*xDB0_(0d0,xmqm2(i),xmqp2(i),0)  )
20	continue

	endif

	end

**********************************************************************
        subroutine xsevv_ferm(s,xseaa,xseaz,xsezz)
**********************************************************************
*       unrenormalized neutral boson self-energies
*       closed fermion loops only
*---------------------------------------------------------------------
*	28.5.04 Stefan Dittmaier
**********************************************************************
        implicit real*8 (a-z)
        complex*16 xseaa,xseaz,xsezz
        complex*16 B0_,xB0_,B00l,B00u,B00d,Bsll,SBs00,Bsuu,Bsdd
        integer i
        include 'COMMON/param.inc'
        include 'COMMON/xparam.inc'

        xseaa   = 0d0
        xseaz   = 0d0
        xsezz   = 0d0

	if (s.ne.0d0) then
          SBs00 = S*B0_(S,0d0,0d0,0)
	else
	  SBs00 = 0d0
	endif

        do 100 i=1,3

        B00l = xB0_(0D0,null,xml2(i),0)
        B00u = xB0_(0D0,null,xmqp2(i),0)
        B00d = xB0_(0D0,null,xmqm2(i),0)
        Bsll = xB0_(S,xml2(i),xml2(i),0)
        Bsuu = xB0_(S,xmqp2(i),xmqp2(i),0)
        Bsdd = xB0_(S,xmqm2(i),xmqm2(i),0)

        xseaa = xseaa -ALPHA/(27D0*PI)*(
     &  -2D0*(3D0*xmqm2(i)+9D0*xml2(i)+12D0*xmqp2(i)-4D0*S)
     &  +6D0*xmqm2(i)*B00d+18D0*xml2(i)*B00l+24D0*xmqp2(i)*B00u
     &  -3D0*(2D0*xmqm2(i)+S)*Bsdd-9D0*(2D0*xml2(i)+S)*Bsll
     &  -12D0*(2D0*xmqp2(i)+S)*Bsuu)

        xseaz = xseaz -ALPHA/(108D0*xcw*PI)*(
     &  32D0*S*xsw-12D0*S/xsw-72D0*xsw*XML2(I)+18D0*XML2(I)/xsw
     &  -24D0*xsw*XMQM2(I)+18D0*XMQM2(I)/xsw
     &	-96D0*xsw*XMQP2(I)+36D0*XMQP2(I)/xsw
     &  -18D0*(1D0-4D0*xsw2)*B00l*XML2(I)/xsw
     &  + 9D0*(1D0-4D0*xsw2)*Bsll*(S+2D0*XML2(I))/xsw
     &  - 6D0*(3D0-4D0*xsw2)*B00d*XMQM2(I)/xsw
     &  + 3D0*(3D0-4D0*xsw2)*Bsdd*(S+2D0*XMQM2(I))/xsw
     &  -12D0*(3D0-8D0*xsw2)*B00u*XMQP2(I)/xsw
     &  + 6D0*(3D0-8D0*xsw2)*Bsuu*(S+2D0*XMQP2(I))/xsw )

        xsezz = xsezz + ALPHA/(216D0*xcw2*PI)*(
     &  48D0*S-64D0*S*xsw2-24D0*S/xsw2
     &  -72D0*XML2(I)+144D0*xsw2*XML2(I)+18D0*XML2(I)/xsw2
     &  -72D0*XMQM2(I)+48D0*xsw2*XMQM2(I)+54D0*XMQM2(I)/xsw2
     &  -144D0*XMQP2(I)+192D0*xsw2*XMQP2(I)+54D0*XMQP2(I)/xsw2
     &  +9D0*SBs00/xsw2
     &  -18D0*(1D0+8D0*xsw**4-4D0*xsw2)*B00l*XML2(I)/xsw2
     &  -9D0*Bsll*(-S-8D0*S*xsw**4+4D0*S*xsw2
     &    +XML2(I)-16D0*xsw**4*XML2(I)+8D0*xsw2*XML2(I))/xsw2
     &  -6D0*(9D0+8D0*xsw**4-12D0*xsw2)*B00d*XMQM2(I)/xsw2
     &  +3D0*Bsdd*(9D0*S+8D0*S*xsw**4-12D0*S*xsw2
     &    -9D0*XMQM2(I)+16D0*xsw**4*XMQM2(I)-24D0*xsw2*XMQM2(I))/xsw2
     &  -6D0*(9D0+32D0*xsw**4-24D0*xsw2)*B00u*XMQP2(I)/xsw2
     &  +3D0*Bsuu*(9D0*S+32D0*S*xsw**4-24D0*S*xsw2
     &    -9D0*XMQP2(I)+64D0*xsw**4*XMQP2(I)-48D0*xsw2*XMQP2(I))/xsw2 )

100	continue

	end

**************************************************************
*
*     narrow (=zero) width approximation
*
**************************************************************
      function narrwidappr(order)
      implicit none
      integer order,qgwqcd
      real*8 narrwidappr
      real*8 zwidth,wwidth,width_HZZ,width_HWW,width_Zff,width_Wff
      real*8 gw_nwa,gz_nwa
      include 'COMMON/param.inc'
      include 'COMMON/processpar.inc'
      include 'COMMON/options.inc'
c unit (e.g. MeV)
      real*8 unit
      common/unit/unit

      narrwidappr = 0d0
      qgwqcd = 1  !QCD corrections always included for order=1

      if (qwidth.eq.0.and.order.eq.0) then
         gz_nwa = zwidth(0,0) !order=0:LO width
         gw_nwa = wwidth(0,0) !order=1:NLO width, QCD corr.incl.
      else
         gz_nwa = zwidth(1,1) !order=0:LO width
         gw_nwa = wwidth(1,1) !order=1:NLO width, QCD corr.incl.
      endif

      if (nc.eq.1) then
        if (cc.eq.0) then !ordering according to nc process
          narrwidappr = narrwidappr + width_HZZ(order)
     &      * width_Zff(q(1),q(2),gen(1),order,qgwqcd)/gz_nwa
     &      * width_Zff(q(3),q(4),gen(3),order,qgwqcd)/gz_nwa *unit *2d0
        else              !ordering according to cc process
          narrwidappr = narrwidappr + width_HZZ(order)
     &      * width_Zff(q(1),q(4),gen(1),order,qgwqcd)/gz_nwa
     &      * width_Zff(q(3),q(2),gen(3),order,qgwqcd)/gz_nwa *unit *2d0
        endif
        if (iso(1).eq.iso(3).and.gen(1).eq.gen(3).and.
     &       quark(1).eq.quark(3))  narrwidappr = narrwidappr /2d0
      endif
      if (cc.eq.1) then
        narrwidappr = narrwidappr + width_HWW(order)
     &        * width_Wff(q(1),q(2),order,qgwqcd)/gw_nwa
     &        * width_Wff(q(3),q(4),order,qgwqcd)/gw_nwa *unit      ! 3:W boson
      endif

      end

**************************************************************
*
*     partial decay width H->ZZ
*       order=0:born, order=1:born+corrections
**************************************************************
      function width_HZZ(order)
      implicit none
      integer iden,order
      real*8 width_HZZ,ghzz,born,beta,G0
      complex*16 A,B
      include 'COMMON/param.inc'
      include 'COMMON/options.inc'

      width_HZZ = 0d0
      if (mh.lt.2d0*mz) return

      A = 0d0
      B = 0d0
      iden = 2     !symmetry factor

      ghzz = mz2/sw/mw
      beta = dsqrt(1d0-4d0*mz2/mh2)
      G0 = MH2**2-4D0*MH2*MZ2+12D0*MZ2**2

      born = alpha/16d0/iden/sw2/mw2/mh*beta *G0

      if (qbos.eq.1) call calcform_HZZ_bos(A,B)
      if (qferm.eq.1) call calcform_HZZ_ferm(A,B)

      width_HZZ = width_HZZ + born
      if (order.eq.1) then
        width_HZZ = width_HZZ
     &     + (2d0*born *(dreal(A)/el/ghzz + dreal(B)/el/ghzz
     &       *beta**2*(mh2/2d0-mz2)*mh2**2/G0))
      endif

c heavy-Higgs limit at two loops
      if (order.eq.1.and.qbos.eq.1) then
        width_HZZ = width_HZZ + born*(62.0308d0
     &     *(GF*mh2/(16d0*pi**2*dsqrt(2d0)))**2)
      endif

      end

**************************************************************
*
*     partial decay width H->WW
*       order=0:born, order=1:born+corrections
**************************************************************
      function width_HWW(order)
      implicit none
      integer iden,order
      real*8 width_HWW,ghww,born,G0,brems
      complex*16 A,B,cspen,B1,beta
      include 'COMMON/param.inc'
      include 'COMMON/options.inc'
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2

      width_HWW = 0d0
      if (mh.lt.2d0*mw) return

      A = 0d0
      B = 0d0
      iden = 1  !symmetry factor

      ghww = mw2/sw/mw
      beta = cdsqrt(1d0-4d0*mw2/mh2+dcmplx(0,1d-20))
      G0 = MH2**2-4D0*MH2*MW2+12D0*MW2**2

      born = alpha/16d0/sw2/mw2/mh*beta *G0

      if (qbos.eq.1) call calcform_HWW_bos(A,B)
      if (qferm.eq.1) call calcform_HWW_ferm(A,B)

c Bremsstrahlung
       B1 = ((1D0-BETA)*MH)/(2D0*MW)

      if (qbos.eq.1) then
        brems = (2D0*ALPHA*(9D0*(MH2-2D0*MW2)*LOG(B1)**2+(3D0*LOG(B1)*(-
     &  (G0*MH2)+8D0*MW2**2*(MH2-2D0*MW2)+2D0*G0*(MH2-2D0*MW2)*
     &  LOG(BETA**(-2)*LAMBDA*MH**(-3)*MW2)))/G0+(-(3D0*G0*(MH2-2D0*
     &  MW2)*CSPEN(1D0-B1**2))+3D0*G0*(MH2-2D0*MW2)*CSPEN(1D0-B1**(-
     &  4))+BETA*MH2*(6D0*G0+BETA**2*MH2**2+12D0*MW2**2-3D0*G0*
     &  LOG((BETA**2*MH**3)/(LAMBDA*MW2))))/G0))/(3D0*BETA*MH2*PI)
      else
        brems = 0d0
      endif

      width_HWW = width_HWW + born
      if (order.eq.1) then
        width_HWW = width_HWW
     &     + (2d0*born *(dreal(A)/el/ghww + dreal(B)/el/ghww
     &       *beta**2*(mh2/2d0-mw2)*mh2**2/G0)
     &     + born*brems)
      endif

c heavy-Higgs limit at two loops
      if (order.eq.1.and.qbos.eq.1) then
        width_HWW = width_HWW + born*(62.0308d0
     &     *(GF*mh2/(16d0*pi**2*dsqrt(2d0)))**2)
      endif

      end

**************************************************************
*
*     partial decay width Z->ff
*
**************************************************************
      function width_Zff(q1,q2,gen,order,qgwqcd)
      implicit none
      integer order,ncf,qgwborn,qgwcorr,qgwbos,qgwferm,qgwqcd,gen
      real*8 q1,q2,width_Zff,m1,m2,iso
      real*8 corr(-1:1),FZreal,FZrealQCD,gzff(-1:1)
      complex*16 fzff(-1:1),FZf1f2virt_QCD
      include 'COMMON/param.inc'
      include 'COMMON/options.inc'
c fermionic renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      complex*16 dalpz,drbos,drferm
      complex*16 dZh
      common/renc_ferm/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &	                 dZeer,dZeel,dZnnl,dZh
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2

      qgwborn = 1
      qgwbos = qbos
      qgwferm = qferm
      if (order.eq.1) then
        qgwcorr = 1
      else
        qgwcorr = 0
      endif

c coupling constant
      if (q1.ge.0d0) then
        iso = +1d0/2d0
      else
        iso = -1d0/2d0
      endif
      gzff(+1) = -q1*sw/cw
      gzff(-1) = -q1*sw/cw+iso/sw/cw

c colour factor
      if ((q1.eq.-1d0).or.(q1.eq.0d0)) ncf = 1d0
      if ((q1.eq.-1d0/3d0).or.(q1.eq.2d0/3d0)) ncf = 3d0

      m1 = 1d0
      m2 = 1d0

      FZreal = -alpha/pi*(       !q1=q2, m1=m2
     &  q1**2*( log(mz2/lambda2)*log(m1/mz)+log(m1/mz)**2
     &    +pi**2/3d0+log(mz2/lambda2)-log(m1/mz)/2d0-77d0/24d0 )
     &  +q2**2*( log(mz2/lambda2)*log(m2/mz)+log(m2/mz)**2
     &   +pi**2/3d0+log(mz2/lambda2)-log(m2/mz)/2d0-77d0/24d0 )
     &	+q1*q2*( log(lambda2/mz2)+22d0/6d0 )		       )

      if (q1*q2.ne.0d0.and.q1*q2.ne.1d0) then
	FZrealQCD = -alphas/pi*4d0/3d0*(
     &	 log(mz2/lambda2)*log(m1*m2/mz2)+log(m1/mz)**2+log(m2/mz)**2
     &	+2d0*pi**2/3d0+log(mz2/lambda2)-log(m1*m2/mz2)/2d0-33d0/12d0 )
      else
	FZrealQCD = 0d0
      endif

      corr(+1) = 0d0
      corr(-1) = 0d0

      call FZffvirt(MZ2,q1,m1,gen,fzff)

      if (qgwbos.eq.1) then
          corr(+1) = corr(+1) + 2d0*dreal(fzff(+1)) + FZreal
          corr(-1) = corr(-1) + 2d0*dreal(fzff(-1)) + FZreal
      endif

      if (qgwferm.eq.1) then
        corr(+1) = corr(+1) + 2d0*(dZe+dsw/sw/cw2+dZzz/2d0
     &                             +dZaz/2d0/sw*cw)
        corr(-1) = corr(-1) + 2d0*(dZe+dsw/sw/cw2
     &     -2d0*iso/sw2/cw*dsw/gzff(-1) +dZzz/2d0 -q1*dZaz/2d0/gzff(-1))
      endif

c QCD correction (not rescaled with alpha0/alpha !)
      if (qgwqcd.ne.0) then
        corr(+1) = corr(+1) + 2d0*dreal(FZf1f2virt_QCD(MZ2,q1,q2,m1,m2))
     &            + FZrealQCD
        corr(-1) = corr(-1) + 2d0*dreal(FZf1f2virt_QCD(MZ2,q1,q2,m1,m2))
     &            + FZrealQCD
      endif

      width_zff = alpha*ncf*mz/6d0
     &     * (gzff(+1)**2*(qgwborn+corr(+1)*qgwcorr)
     &       +gzff(-1)**2*(qgwborn+corr(-1)*qgwcorr))

      end

**************************************************************
*
*     partial decay width W->ff at tree level
*
**************************************************************
      function width_Wff(q1,q2,order,qgwqcd)
      implicit none
      integer order,ncf,qgwborn,qgwcorr,qgwbos,qgwferm,qgwqcd
      real*8 q1,q2,width_Wff,m1,m2
      real*8 FWreal,FWrealQCD,corr
      complex*16 FWf1f2virt,FWf1f2virt_bgf,FWf1f2virt_QCD
      include 'COMMON/param.inc'
      include 'COMMON/options.inc'
c fermionic renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      complex*16 dalpz,drbos,drferm
      complex*16 dZh
      common/renc_ferm/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &	                 dZeer,dZeel,dZnnl,dZh
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2

      qgwborn = 1
      qgwbos = qbos
      qgwferm = qferm
      if (order.eq.1) then
        qgwcorr = 1
      else
        qgwcorr = 0
      endif

      if ((q1.eq.-1d0).or.(q1.eq.0d0)) ncf = 1d0
      if ((q1.eq.-1d0/3d0).or.(q1.eq.2d0/3d0)) ncf = 3d0

      m1 = 1d0
      m2 = 1d0

      FWreal = -alpha/pi*(
     &  q1**2*( log(mw2/lambda2)*log(m1/mw)+log(m1/mw)**2+pi**2/3d0
     &         +log(mw2/lambda2)-log(m1/mw)/2d0-77d0/24d0 )
     & +q2**2*( log(mw2/lambda2)*log(m2/mw)+log(m2/mw)**2+pi**2/3d0
     &         +log(mw2/lambda2)-log(m2/mw)/2d0-77d0/24d0 )
     & +q1*q2*( log(lambda2/mw2)+22d0/6d0 )		       )

      if (q1*q2.ne.0d0) then
	FWrealQCD = -alphas/pi*4d0/3d0*(
     &	 log(mw2/lambda2)*log(m1*m2/mw2)+log(m1/mw)**2+log(m2/mw)**2
     &	+2d0*pi**2/3d0+log(mw2/lambda2)-log(m1*m2/mw2)/2d0-33d0/12d0 )
      else
	FWrealQCD = 0d0
      endif

      corr   = 0d0

      if (qgwbos.eq.1) then
        corr = corr + 2d0*dreal(FWf1f2virt(MW2,q1,q2,m1,m2))
     &              + FWreal
      elseif (qgwbos.eq.2) then
        corr = corr + 2d0*dreal(FWf1f2virt_bgf(MW2,q1,q2,m1,m2))
     &              + FWreal
      endif

      if (qgwferm.eq.1) corr = corr + 2d0*dZe - 2d0*dsw/sw + dZW

c QCD correction (not rescaled with alpha0/alpha !)
      if (qgwqcd.ne.0)
     &  corr = corr + 2d0*dreal(FWf1f2virt_QCD(MW2,q1,q2,m1,m2))
     &            + FWrealQCD

      width_Wff = alpha*ncf*mw/12d0/sw2 *(qgwborn+qgwcorr*corr)

      end

************************************************************************
      function Wwidth(order,qcd)
************************************************************************
*     total decay width for W --> f1 f2bar    (f1,f2 massless)
*-----------------------------------------------------------------------
*     30.7.99 Stefan Dittmaier, modified by Axel (24.10.05)
*     order=0:Born, order=1: one-loop
************************************************************************
      implicit none
      integer order,qcd
      real*8 Wwidth,width_Wff
      include 'COMMON/param.inc'

      Wwidth = 3d0*width_Wff(-1d0,0d0,order,qcd)
     &       + 2d0*width_Wff(-1d0/3d0,2d0/3d0,order,qcd)

      end

************************************************************************
      function Zwidth(order,qcd)
************************************************************************
*     total decay width for W --> f1 f2bar    (f1,f2 massless)
*-----------------------------------------------------------------------
*     30.7.99 Stefan Dittmaier, modified by Axel (24.10.05)
*     order=0:Born, order=1: one-loop
************************************************************************
      implicit none
      integer order,qcd,gen
      real*8 Zwidth,width_Zff
      include 'COMMON/param.inc'

      gen = 1
      Zwidth = 3d0*width_Zff(0d0,0d0,gen,order,qcd)
     &       + 3d0*width_Zff(-1d0,-1d0,gen,order,qcd)
     &       + 2d0*width_Zff(-1d0/3d0,-1d0/3d0,gen,order,qcd)
     &       + 2d0*width_Zff(2d0/3d0,2d0/3d0,gen,order,qcd)

c Z->bb with massive top loop
      gen = 3
      Zwidth = Zwidth + width_Zff(-1d0/3d0,-1d0/3d0,gen,order,qcd)

      end

************************************************************************
*
*     calculate form factors for H->VV (A*g(mu,nu),B*k1(nu)*k2(mu))
*
************************************************************************
      subroutine calcform_HZZ_bos(A,B)
      implicit none
      integer ext
      real*8 ghzz
      complex*16 A,B,B0_,C0_,ct_hzz
      include 'COMMON/param.inc'
c renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      complex*16 dalpz,drbos,drferm
      complex*16 dZh
      common/renc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &            dZeer,dZeel,dZnnl,dZh

      ext = 0
      ghzz = mz2/sw/mw

        A = A-(CW**(-3)*EL**3*PI**(-2)*SW**(-3)*(-((((3D0-4D0*CW2+
     &  4D0*CW2**2)*MH2+(1D0+2D0*CW2-8D0*CW2**2+24D0*CW2**3)*MZ2))/
     &  MZ)+(3D0*MH2*(MH2-2D0*MZ2)*B0_(MH2,MH,MH,EXT))/(MZ*(MH2-4D0*
     &  MZ2))-((MH2**2+3D0*MH2*MZ2-4D0*MZ2**2)*B0_(MH2,MZ,MZ,EXT))/
     &  (MH2*MZ-4D0*MZ**3)-(2D0*MZ*((1D0-3D0*CW2+4D0*CW2**2)*MH2-
     &  2D0*CW2*(1D0+4D0*CW2-12D0*CW2**2)*MZ2)*B0_(MH2,CW*MZ,CW*MZ,
     &  EXT))/(MH2-4D0*MZ2)-(2D0*(MH2-2D0*MZ2)*B0_(MZ2,MH,MZ,EXT))/
     &  MZ+(2D0*MZ*((1D0-4D0*CW2**2)*MH2-2D0*CW2*(7D0-12D0*CW2-12D0*
     &  CW2**2)*MZ2)*B0_(MZ2,CW*MZ,CW*MZ,EXT))/(MH2-4D0*MZ2)-(2D0*
     &  (MH2**3-6D0*MH2*MZ2**2+8D0*MZ2**3)*C0_(MZ2,MH2,MZ2,MH,MZ,MZ,
     &  EXT))/(MH2*MZ-4D0*MZ**3)-(2D0*MZ*(MH2*MZ2+24D0*CW**8*MZ2*
     &  (MH2-4D0*MZ2)-CW2*(MH2**2-2D0*MZ2**2)-12D0*CW2**3*(MH2**2-
     &  6D0*MH2*MZ2+6D0*MZ2**2)+2D0*CW2**2*(2D0*MH2**2-9D0*MH2*MZ2+
     &  8D0*MZ2**2))*C0_(MZ2,MH2,MZ2,MW,MW,MW,EXT))/(MH2-4D0*MZ2)-
     &  (3D0*MH2*(MH2**2-5D0*MH2*MZ2+8D0*MZ2**2)*C0_(MZ2,MH2,MZ2,MZ,
     &  MH,MH,EXT))/(MZ*(MH2-4D0*MZ2))))/64D0

        B = B+(CW**(-3)*EL**3*PI**(-2)*SW**(-3)*(-(((MH2-2D0*MZ2)*
     &  ((3D0-4D0*CW2+4D0*CW2**2)*MH2+(1D0+2D0*CW2-8D0*CW2**2+24D0*
     &  CW2**3)*MZ2))/(MH2*MZ*(MH2-4D0*MZ2)))-(2D0*(MH2-MZ2)*
     &  B0_(0D0,0D0,MH,EXT))/(MH2*MZ-4D0*MZ**3)+(2D0*MZ*(MH2-MZ2)*
     &  B0_(0D0,0D0,MZ,EXT))/(MH2*(MH2-4D0*MZ2))+(3D0*MH2*(MH2-4D0*
     &  MZ2)**(-2)*(2D0*MH2-5D0*MZ2)*B0_(MH2,MH,MH,EXT))/MZ-((MH2-
     &  4D0*MZ2)**(-2)*(2D0*MH2**3+5D0*MH2**2*MZ2-18D0*MH2*MZ2**2+
     &  8D0*MZ2**3)*B0_(MH2,MZ,MZ,EXT))/(MH2*MZ)-(2D0*MZ*(MH2-4D0*
     &  MZ2)**(-2)*((1D0+4D0*CW2**2)*MH2**2+2D0*(1D0-11D0*CW2+12D0*
     &  CW2**3)*MH2*MZ2+4D0*CW2*(1D0-4D0*CW2+12D0*CW2**2)*MZ2**2)*
     &  B0_(MH2,CW*MZ,CW*MZ,EXT))/MH2-(2D0*MH2*B0_(MZ2,MH,MZ,EXT))/
     &  (MZ*(MH2-4D0*MZ2))+(2D0*MZ*(MH2-4D0*MZ2)**(-2)*((1D0+4D0*
     &  CW2**2)*MH2**2+2D0*(1D0-11D0*CW2+12D0*CW2**3)*MH2*MZ2+4D0*
     &  CW2*(1D0-4D0*CW2+12D0*CW2**2)*MZ2**2)*B0_(MZ2,CW*MZ,CW*MZ,
     &  EXT))/MH2-((MH2-4D0*MZ2)**(-2)*(3D0*MH2**3+2D0*MH2**2*MZ2-
     &  24D0*MH2*MZ2**2+16D0*MZ2**3)*C0_(MZ2,MH2,MZ2,MH,MZ,MZ,EXT))/
     &  MZ-(2D0*MZ*(MH2-4D0*MZ2)**(-2)*(2D0*MH2*MZ2*(MH2-MZ2)+24D0*
     &  CW**8*MZ2*(MH2**2-6D0*MH2*MZ2+8D0*MZ2**2)-4D0*CW2**3*(3D0*
     &  MH2**3-24D0*MH2**2*MZ2+32D0*MH2*MZ2**2+28D0*MZ2**3)+CW2**2*
     &  (4D0*MH2**3-30D0*MH2**2*MZ2+60D0*MH2*MZ2**2+32D0*MZ2**3)+
     &  CW2*(MH2**3-10D0*MH2**2*MZ2+4D0*MH2*MZ2**2-4D0*MZ2**3))*
     &  C0_(MZ2,MH2,MZ2,MW,MW,MW,EXT))/MH2-(3D0*MH2*(MH2-4D0*MZ2)**
     &  (-2)*(2D0*MH2**2-9D0*MH2*MZ2+10D0*MZ2**2)*C0_(MZ2,MH2,MZ2,
     &  MZ,MH,MH,EXT))/MZ))/32D0

c counterterms
      ct_hzz = dZe + (2d0*sw2-cw2)/cw2*dsw/sw + dmw2/mw2/2d0
     &         + dZh/2d0 + dZzz
      A = A + ct_hzz*el*ghzz

      end

************************************************************************
*
*     calculate form factors for H->VV (A*g(mu,nu),B*k1(nu)*k2(mu))
*       fermionic contribution
*
************************************************************************
      subroutine calcform_HZZ_ferm(A,B)
      implicit none
      integer bos,i,ext
      real*8 ghzz
      complex*16 A,B,B0_,C0_,ct_hzz
      include 'COMMON/param.inc'
c fermionic renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      complex*16 dalpz,drbos,drferm
      complex*16 dZh
      common/renc_ferm/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &                 dZeer,dZeel,dZnnl,dZh

      ext = 0
      ghzz = mz2/sw/mw

      do i=1,3
        A = A-(EL**3*PI**(-2)*SW**(-3)*(3D0*(1D0-4D0*SW2+8D0*SW2**
     &  2)*ML2(I)+(6D0*MZ2*(1D0-4D0*SW2+8D0*SW2**2)*B0_(MH2,ML(I),
     &  ML(I),EXT)*ML2(I))/(MH2-4D0*MZ2)-(3D0*(MH2-2D0*MZ2*(1D0+4D0*
     &  SW2-8D0*SW2**2))*B0_(MZ2,ML(I),ML(I),EXT)*ML2(I))/(MH2-4D0*
     &  MZ2)-(3D0*C0_(MZ2,MH2,MZ2,ML(I),ML(I),ML(I),EXT)*ML2(I)*
     &  (MH2**2*(-(2D0*SW2)+4D0*SW2**2)+2D0*MZ2*(MZ2*(1D0-4D0*SW2+
     &  8D0*SW2**2)-16D0*SW2*(1D0-2D0*SW2)*ML2(I))-MH2*(MZ2*(1D0-
     &  12D0*SW2+24D0*SW2**2)-8D0*SW2*(1D0-2D0*SW2)*ML2(I))))/(MH2-
     &  4D0*MZ2)+(9D0-12D0*SW2+8D0*SW2**2)*MQM2(I)+(2D0*MZ2*(9D0-
     &  12D0*SW2+8D0*SW2**2)*B0_(MH2,MQM(I),MQM(I),EXT)*MQM2(I))/
     &  (MH2-4D0*MZ2)-((9D0*MH2-2D0*MZ2*(9D0+12D0*SW2-8D0*SW2**2))*
     &  B0_(MZ2,MQM(I),MQM(I),EXT)*MQM2(I))/(MH2-4D0*MZ2)-(C0_(MZ2,
     &  MH2,MZ2,MQM(I),MQM(I),MQM(I),EXT)*MQM2(I)*(MH2**2*(-(6D0*
     &  SW2)+4D0*SW2**2)+2D0*MZ2*(MZ2*(9D0-12D0*SW2+8D0*SW2**2)-
     &  16D0*SW2*(3D0-2D0*SW2)*MQM2(I))+MH2*(-(3D0*MZ2*(3D0-12D0*
     &  SW2+8D0*SW2**2))+8D0*SW2*(3D0-2D0*SW2)*MQM2(I))))/(MH2-4D0*
     &  MZ2)+(9D0-24D0*SW2+32D0*SW2**2)*MQP2(I)+(2D0*MZ2*(9D0-24D0*
     &  SW2+32D0*SW2**2)*B0_(MH2,MQP(I),MQP(I),EXT)*MQP2(I))/(MH2-
     &  4D0*MZ2)-((9D0*MH2-2D0*MZ2*(9D0+24D0*SW2-32D0*SW2**2))*
     &  B0_(MZ2,MQP(I),MQP(I),EXT)*MQP2(I))/(MH2-4D0*MZ2)-(C0_(MZ2,
     &  MH2,MZ2,MQP(I),MQP(I),MQP(I),EXT)*MQP2(I)*(-(4D0*MH2**2*SW2*
     &  (3D0-4D0*SW2))+MH2*(-(MZ2*(9D0-72D0*SW2+96D0*SW2**2))+16D0*
     &  SW2*(3D0-4D0*SW2)*MQP2(I))+2D0*MZ2*(MZ2*(9D0-24D0*SW2+32D0*
     &  SW2**2)-32D0*SW2*(3D0-4D0*SW2)*MQP2(I))))/(MH2-4D0*MZ2)))/
     &  (96D0*CW2*MW)

        B = B+(EL**3*PI**(-2)*SW**(-3)*((3D0*(MH2**2-2D0*MH2*MZ2*
     &  (1D0+4D0*SW2-8D0*SW2**2)+4D0*MZ2**2*(1D0-4D0*SW2+8D0*SW2**
     &  2))*B0_(MH2,ML(I),ML(I),EXT)*ML2(I))/(MH2-4D0*MZ2)-(3D0*
     &  (MH2**2-2D0*MH2*MZ2*(1D0+4D0*SW2-8D0*SW2**2)+4D0*MZ2**2*
     &  (1D0-4D0*SW2+8D0*SW2**2))*B0_(MZ2,ML(I),ML(I),EXT)*ML2(I))/
     &  (MH2-4D0*MZ2)+(3D0*(MH2-2D0*MZ2)*C0_(MZ2,MH2,MZ2,ML(I),
     &  ML(I),ML(I),EXT)*ML2(I)*(MH2*MZ2*(1D0-12D0*SW2+24D0*SW2**2)+
     &  MH2**2*(2D0*SW2-4D0*SW2**2)+2D0*MZ2**2*(1D0-4D0*SW2+8D0*
     &  SW2**2)+2D0*(MH2-4D0*MZ2)*(1D0-4D0*SW2+8D0*SW2**2)*ML2(I)))/
     &  (MH2-4D0*MZ2)+((9D0*MH2**2-2D0*MH2*MZ2*(9D0+12D0*SW2-8D0*
     &  SW2**2)+4D0*MZ2**2*(9D0-12D0*SW2+8D0*SW2**2))*B0_(MH2,
     &  MQM(I),MQM(I),EXT)*MQM2(I))/(MH2-4D0*MZ2)-((9D0*MH2**2-2D0*
     &  MH2*MZ2*(9D0+12D0*SW2-8D0*SW2**2)+4D0*MZ2**2*(9D0-12D0*SW2+
     &  8D0*SW2**2))*B0_(MZ2,MQM(I),MQM(I),EXT)*MQM2(I))/(MH2-4D0*
     &  MZ2)+((MH2-2D0*MZ2)*C0_(MZ2,MH2,MZ2,MQM(I),MQM(I),MQM(I),
     &  EXT)*MQM2(I)*(MH2**2*(6D0*SW2-4D0*SW2**2)+3D0*MH2*MZ2*(3D0-
     &  12D0*SW2+8D0*SW2**2)+2D0*MZ2**2*(9D0-12D0*SW2+8D0*SW2**2)+
     &  2D0*(MH2-4D0*MZ2)*(9D0-12D0*SW2+8D0*SW2**2)*MQM2(I)))/(MH2-
     &  4D0*MZ2)+((9D0*MH2**2-2D0*MH2*MZ2*(9D0+24D0*SW2-32D0*SW2**
     &  2)+4D0*MZ2**2*(9D0-24D0*SW2+32D0*SW2**2))*B0_(MH2,MQP(I),
     &  MQP(I),EXT)*MQP2(I))/(MH2-4D0*MZ2)-((9D0*MH2**2-2D0*MH2*MZ2*
     &  (9D0+24D0*SW2-32D0*SW2**2)+4D0*MZ2**2*(9D0-24D0*SW2+32D0*
     &  SW2**2))*B0_(MZ2,MQP(I),MQP(I),EXT)*MQP2(I))/(MH2-4D0*MZ2)+
     &  (MH2-2D0*MZ2)*(3D0*(1D0-4D0*SW2+8D0*SW2**2)*ML2(I)+(9D0-
     &  12D0*SW2+8D0*SW2**2)*MQM2(I)+(9D0-24D0*SW2+32D0*SW2**2)*
     &  MQP2(I))+((MH2-2D0*MZ2)*C0_(MZ2,MH2,MZ2,MQP(I),MQP(I),
     &  MQP(I),EXT)*MQP2(I)*(4D0*MH2**2*SW2*(3D0-4D0*SW2)+2D0*MZ2*
     &  (9D0-24D0*SW2+32D0*SW2**2)*(MZ2-4D0*MQP2(I))+MH2*(3D0*MZ2*
     &  (3D0-24D0*SW2+32D0*SW2**2)+2D0*(9D0-24D0*SW2+32D0*SW2**2)*
     &  MQP2(I))))/(MH2-4D0*MZ2)))/(48D0*CW2*MH2*MW*(MH2-4D0*MZ2))
      enddo

c counterterms
      ct_hzz = dZe + (2d0*sw2-cw2)/cw2*dsw/sw + dmw2/mw2/2d0
     &         + dZh/2d0 + dZzz
      A = A + ct_hzz*el*ghzz

      end

************************************************************************
*
*     calculate form factors for H->VV (A*g(mu,nu),B*k1(nu)*k2(mu))
*
************************************************************************
      subroutine calcform_HWW_bos(A,B)
      implicit none
      integer ext
      real*8 ghww
      complex*16 A,B,B0_,C0_,ct_hww
      include 'COMMON/param.inc'
c renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      complex*16 dalpz,drbos,drferm
      complex*16 dZh
      common/renc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &            dZeer,dZeel,dZnnl,dZh

      ext = 0
      ghww = mw2/sw/mw

        A = A-(EL**3*PI**(-2)*(-(((MW2+3D0*CW2*(MH2+6D0*MW2)))/(CW2*
     &  MW*SW))+(3D0*MH2*(MH2-2D0*MW2)*B0_(MH2,MH,MH,EXT))/(MW*(MH2-
     &  4D0*MW2)*SW)-((MW2*(MH2+2D0*MW2)+CW2*(MH2**2+4D0*MH2*MW2+
     &  8D0*MW2**2))*B0_(MH2,MW,MW,EXT))/(CW2*(MH2*MW-4D0*MW**3)*
     &  SW)+(2D0*CW**(-4)*MW*(MW2+8D0*CW2*MW2-CW2**2*(MH2+16D0*
     &  MW2))*B0_(MH2,MZ,MZ,EXT))/((MH2-4D0*MW2)*SW)-(2D0*(MH2-2D0*
     &  MW2)*B0_(MW2,MH,MW,EXT))/(MW*SW)-(2D0*CW**(-4)*MW*(MW2+CW2*
     &  (-(2D0*MH2)+13D0*MW2)+CW2**2*(5D0*MH2-48D0*MW2))*B0_(MW2,MW,
     &  MZ,EXT))/((MH2-4D0*MW2)*SW)+8D0*MW*(MH2-2D0*MW2)*SW2**(1D0/
     &  2D0)*C0_(MW2,MH2,MW2,0D0,MW,MW,EXT)-(2D0*(MH2**3-6D0*MH2*
     &  MW2**2+8D0*MW2**3)*C0_(MW2,MH2,MW2,MH,MW,MW,EXT))/((MH2*MW-
     &  4D0*MW**3)*SW)-(3D0*MH2*(MH2**2-5D0*MH2*MW2+8D0*MW2**2)*
     &  C0_(MW2,MH2,MW2,MW,MH,MH,EXT))/(MW*(MH2-4D0*MW2)*SW)-(CW**(-
     &  6)*MW*(2D0*MW2**2-3D0*CW2*MW2*(MH2-8D0*MW2)+2D0*CW2**2*(5D0*
     &  MH2*MW2-56D0*MW2**2)+CW2**3*(-(9D0*MH2**2)+72D0*MH2*MW2-
     &  64D0*MW2**2))*C0_(MW2,MH2,MW2,MW,MZ,MZ,EXT))/((MH2-4D0*MW2)*
     &  SW)-(CW**(-4)*MW*(MW2*(MH2+2D0*MW2)+28D0*CW2**2*MW2*(MH2-
     &  4D0*MW2)-CW2*(MH2**2-2D0*MH2*MW2-24D0*MW2**2)-8D0*CW2**3*
     &  (MH2**2-6D0*MH2*MW2+8D0*MW2**2))*C0_(MW2,MH2,MW2,MZ,MW,MW,
     &  EXT))/((MH2-4D0*MW2)*SW)))/(64D0*SW2)

        B = B-(EL**3*(((MH2-2D0*MW2)*(MW2+3D0*CW2*(MH2+6D0*MW2))*
     &  PI**(-2)*SW**(-3))/(CW2*MH2*MW*(MH2-4D0*MW2))+(2D0*(MH2-
     &  MW2)*PI**(-2)*SW**(-3)*B0_(0D0,0D0,MH,EXT))/(MH2*MW-4D0*MW**
     &  3)-(2D0*MW*(MW2+CW2*(MH2-2D0*MW2))*PI**(-2)*SW**(-3)*
     &  B0_(0D0,0D0,MW,EXT))/(CW2*MH2*(MH2-4D0*MW2))+(2D0*CW**(-4)*
     &  (1D0+8D0*CW2)*MW**3*PI**(-2)*B0_(0D0,0D0,MZ,EXT))/(MH2*(MH2-
     &  4D0*MW2)*SW)-(3D0*MH2*(MH2-4D0*MW2)**(-2)*(2D0*MH2-5D0*MW2)*
     &  PI**(-2)*SW**(-3)*B0_(MH2,MH,MH,EXT))/MW+(2D0*(MH2-4D0*
     &  MW2)**(-2)*(MW2*(MH2**2+MH2*MW2-2D0*MW2**2)+CW2*(MH2**3+4D0*
     &  MH2**2*MW2-8D0*MH2*MW2**2+24D0*MW2**3))*PI**(-2)*SW**(-3)*
     &  B0_(MH2,MW,MW,EXT))/(CW2*MH2*MW)+(CW**(-4)*MW*(MH2-4D0*
     &  MW2)**(-2)*(-(4D0*MH2*MW2)+4D0*MW2**2+3D0*CW2**2*(MH2**2+
     &  16D0*MH2*MW2)+2D0*CW2*(MH2**2-20D0*MH2*MW2+16D0*MW2**2))*
     &  PI**(-2)*SW**(-3)*B0_(MH2,MZ,MZ,EXT))/MH2-(16D0*MW*PI**(-2)*
     &  B0_(MW2,0D0,MW,EXT))/((MH2-4D0*MW2)*SW)-(32D0*MH2*B0_(MW2,
     &  MH,MW,EXT))/(-(16D0*MH2*MW*PI**2*SW**3)+64D0*MW**3*PI**2*
     &  SW**3)+(2D0*CW**(-4)*MW*(MH2-4D0*MW2)**(-2)*(MW2*(MH2+2D0*
     &  MW2)-8D0*CW2**3*(MH2**2-4D0*MH2*MW2)-CW2*(2D0*MH2**2-13D0*
     &  MH2*MW2-10D0*MW2**2)-CW2**2*(-(5D0*MH2**2)+50D0*MH2*MW2+
     &  48D0*MW2**2))*PI**(-2)*SW**(-3)*B0_(MW2,MW,MZ,EXT))/MH2+
     &  ((MH2-4D0*MW2)**(-2)*(3D0*MH2**3+2D0*MH2**2*MW2-24D0*MH2*
     &  MW2**2+16D0*MW2**3)*PI**(-2)*SW**(-3)*C0_(MW2,MH2,MW2,MH,MW,
     &  MW,EXT))/MW+(3D0*MH2*(MH2-4D0*MW2)**(-2)*(2D0*MH2**2-9D0*
     &  MH2*MW2+10D0*MW2**2)*PI**(-2)*SW**(-3)*C0_(MW2,MH2,MW2,MW,
     &  MH,MH,EXT))/MW-(CW**(-6)*MW*(MH2-4D0*MW2)**(-2)*(-(4D0*MH2*
     &  MW2**2)+4D0*MW2**3-2D0*CW2**2*MW2*(MH2**2-74D0*MH2*MW2+64D0*
     &  MW2**2)+2D0*CW2*MW2*(MH2**2-15D0*MH2*MW2+8D0*MW2**2)+CW2**3*
     &  (7D0*MH2**3-82D0*MH2**2*MW2+96D0*MH2*MW2**2))*PI**(-2)*SW**
     &  (-3)*C0_(MW2,MH2,MW2,MW,MZ,MZ,EXT))/MH2+(CW**(-4)*MW*(MH2-
     &  4D0*MW2)**(-2)*(2D0*MW2*(MH2**2+MH2*MW2-2D0*MW2**2)-8D0*
     &  CW2**2*(MH2**3-12D0*MH2**2*MW2+36D0*MH2*MW2**2-16D0*MW2**3)+
     &  CW2*(MH2**3-16D0*MH2**2*MW2+76D0*MH2*MW2**2-16D0*MW2**3))*
     &  PI**(-2)*SW**(-3)*C0_(MW2,MH2,MW2,MZ,MW,MW,EXT))/MH2))/32D0

c counterterms
      ct_hww = dZe - dsw/sw + dmw2/mw2/2d0 + dZh/2d0 + dZw
      A = A + ct_hww*el*ghww

      end

************************************************************************
*
*     calculate form factors for H->VV (A*g(mu,nu),B*k1(nu)*k2(mu))
*       fermionic contribution
*
************************************************************************
      subroutine calcform_HWW_ferm(A,B)
      implicit none
      integer bos,i,ext
      real*8 ghww
      complex*16 A,B,B0_,C0_,ct_hww
      include 'COMMON/param.inc'
c fermionic renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      complex*16 dalpz,drbos,drferm
      complex*16 dZh
      common/renc_ferm/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &                 dZeer,dZeel,dZnnl,dZh

      ext = 0
      ghww = mw2/sw/mw

      do i=1,3
        A = A+(EL**3*PI**(-2)*SW**(-3)*((2D0*B0_(MH2,ML(I),ML(I),
     &  EXT)*ML2(I)*(-(MW2)+ML2(I)))/(MH2*MW-4D0*MW**3)-(B0_(MW2,
     &  0D0,ML(I),EXT)*ML2(I)*(-(MH2)+2D0*MW2+2D0*ML2(I)))/(MH2*MW-
     &  4D0*MW**3)-(C0_(MW2,MH2,MW2,0D0,ML(I),ML(I),EXT)*ML2(I)*(-
     &  (MW2)+ML2(I))*(-(MH2)+2D0*MW2+2D0*ML2(I)))/(MH2*MW-4D0*MW**
     &  3)-(6D0*B0_(MH2,MQP(I),MQP(I),EXT)*MQP2(I)*(MW2+MQM2(I)-
     &  MQP2(I)))/(MH2*MW-4D0*MW**3)+(6D0*B0_(MH2,MQM(I),MQM(I),
     &  EXT)*MQM2(I)*(-(MW2)+MQM2(I)-MQP2(I)))/(MH2*MW-4D0*MW**3)-
     &  (3D0*C0_(MW2,MH2,MW2,MQP(I),MQM(I),MQM(I),EXT)*MQM2(I)*(-
     &  (MW2)+MQM2(I)-MQP2(I))*(-(MH2)+2D0*MW2+2D0*MQM2(I)-2D0*
     &  MQP2(I)))/(MH2*MW-4D0*MW**3)-((ML2(I)+3D0*MQM2(I)+3D0*
     &  MQP2(I)))/MW-(3D0*C0_(MW2,MH2,MW2,MQM(I),MQP(I),MQP(I),EXT)*
     &  MQP2(I)*(MW2+MQM2(I)-MQP2(I))*(MH2+2D0*MQM2(I)-2D0*(MW2+
     &  MQP2(I))))/(MH2*MW-4D0*MW**3)+(3D0*B0_(MW2,MQM(I),MQP(I),
     &  EXT)*(-(2D0*MQM(I)**4)+MQM2(I)*(MH2-2D0*MW2+4D0*MQP2(I))+
     &  MQP2(I)*(MH2-2D0*(MW2+MQP2(I)))))/(MW*(MH2-4D0*MW2))))/32D0

        B = B+(EL**3*((16D0*B0_(0D0,0D0,ML(I),EXT)*ML(I)**4)/(8D0*
     &  MH2**2*MW*PI**2*SW**3-32D0*MH2*MW**3*PI**2*SW**3)+((MH2-4D0*
     &  MW2)**(-2)*PI**(-2)*SW**(-3)*B0_(MH2,ML(I),ML(I),EXT)*
     &  ML2(I)*(MH2**2-2D0*MH2*MW2+4D0*MW2**2-4D0*(MH2-MW2)*
     &  ML2(I)))/(MH2*MW)-((MH2-4D0*MW2)**(-2)*PI**(-2)*SW**(-3)*
     &  B0_(MW2,0D0,ML(I),EXT)*ML2(I)*(MH2**2-2D0*MH2*MW2+4D0*MW2**
     &  2-2D0*(MH2+2D0*MW2)*ML2(I)))/(MH2*MW)+((MH2-4D0*MW2)**(-2)*
     &  PI**(-2)*SW**(-3)*C0_(MW2,MH2,MW2,0D0,ML(I),ML(I),EXT)*
     &  ML2(I)*(MW2*(MH2**2-4D0*MW2**2)+4D0*(MH2-MW2)*ML(I)**4-
     &  (MH2**2+4D0*MH2*MW2-8D0*MW2**2)*ML2(I)))/(MH2*MW)+(6D0*PI**
     &  (-2)*SW**(-3)*B0_(0D0,0D0,MQM(I),EXT)*MQM2(I)*(MQM2(I)-
     &  MQP2(I)))/(MH2*MW*(MH2-4D0*MW2))-(6D0*PI**(-2)*SW**(-3)*
     &  B0_(0D0,0D0,MQP(I),EXT)*MQP2(I)*(MQM2(I)-MQP2(I)))/(MH2*MW*
     &  (MH2-4D0*MW2))+((MH2-2D0*MW2)*PI**(-2)*SW**(-3)*(ML2(I)+3D0*
     &  MQM2(I)+3D0*MQP2(I)))/(MH2*MW*(MH2-4D0*MW2))+(3D0*(MH2-4D0*
     &  MW2)**(-2)*PI**(-2)*SW**(-3)*B0_(MH2,MQP(I),MQP(I),EXT)*
     &  MQP2(I)*(MH2**2+4D0*(MH2-MW2)*MQM2(I)+4D0*MW2*(MW2+MQP2(I))-
     &  2D0*MH2*(MW2+2D0*MQP2(I))))/(MH2*MW)+(3D0*(MH2-4D0*MW2)**(-
     &  2)*PI**(-2)*SW**(-3)*B0_(MH2,MQM(I),MQM(I),EXT)*MQM2(I)*
     &  (MH2**2+4D0*MW2**2-4D0*(MH2-MW2)*MQM2(I)-4D0*MW2*MQP2(I)+
     &  MH2*(-(2D0*MW2)+4D0*MQP2(I))))/(MH2*MW)+(3D0*(MH2-4D0*MW2)**
     &  (-2)*PI**(-2)*SW**(-3)*C0_(MW2,MH2,MW2,MQM(I),MQP(I),MQP(I),
     &  EXT)*MQP2(I)*(4D0*(MH2-MW2)*MQM(I)**4-(-(MW2)+MQP2(I))*
     &  (MH2**2-4D0*MW2**2-4D0*MH2*MQP2(I)+4D0*MW2*MQP2(I))+MQM2(I)*
     &  (3D0*MH2**2-8D0*MH2*(MW2+MQP2(I))+8D0*MW2*(MW2+MQP2(I)))))/
     &  (MH2*MW)+(3D0*(MH2-4D0*MW2)**(-2)*PI**(-2)*SW**(-3)*C0_(MW2,
     &  MH2,MW2,MQP(I),MQM(I),MQM(I),EXT)*MQM2(I)*(4D0*(MH2-MW2)*
     &  MQM(I)**4+MH2**2*(MW2+3D0*MQP2(I))-4D0*(-(MW**3)+MW*
     &  MQP2(I))**2+4D0*MH2*(MQP(I)**4-2D0*MW2*MQP2(I))-MQM2(I)*
     &  (MH2**2-8D0*MW2*(MW2+MQP2(I))+4D0*MH2*(MW2+2D0*MQP2(I)))))/
     &  (MH2*MW)-(3D0*(MH2-4D0*MW2)**(-2)*PI**(-2)*SW**(-3)*B0_(MW2,
     &  MQM(I),MQP(I),EXT)*(-(2D0*(MH2+2D0*MW2)*MQM(I)**4)+MQP2(I)*
     &  (MH2**2+4D0*MW2**2-4D0*MW2*MQP2(I)-2D0*MH2*(MW2+MQP2(I)))+
     &  MQM2(I)*(MH2**2+4D0*MW2*(MW2+2D0*MQP2(I))+MH2*(-(2D0*MW2)+
     &  4D0*MQP2(I)))))/(MH2*MW)))/16D0
      enddo

c counterterms
      ct_hww = dZe - dsw/sw + dmw2/mw2/2d0 + dZh/2d0 + dZw
      A = A + ct_hww*el*ghww

      end

**********************************************************************
	subroutine FZffvirt(p12,Qf,mf,gen,fzff)
**********************************************************************
*	Form factors for O(alpha) correction to Zff vertex
*	conventional formalism
*---------------------------------------------------------------------
*	Z boson:  invariant mass = p12
*	fermions: on shell, masses mf as regulators
*       Z->bb with massive top loop included (23.7.07)
*---------------------------------------------------------------------
*	10.6.04 Stefan Dittmaier, modified by Axel 15.9.05
**********************************************************************
      implicit none
      integer gen
      real*8 p12,qf,mf,mf2,gzff(-1:1),I3f,mt,mt2
      complex*16 B0_,DB0_,C0_,BW,BZ,BP,BPWW,C0Z0,C0W0,CW0W,Cfaf
      complex*16 fzff(-1:1),dzff_a,dzffl,dzffr,Bf0f,B1W,B1Z,B1_
      include 'COMMON/param.inc'
c renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      complex*16 dalpz,drbos,drferm
      complex*16 dZh
      common/renc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &            dZeer,dZeel,dZnnl,dZh
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2
c renormalization scale
      real*8 mudim2
      common/uv/mudim2

      mf2 = mf**2

      mt  = mqp(3) !top mass
      mt2 = mqp2(3)

      if (qf.ge.0d0) then       !weak iso spin
         I3F = +1d0/2d0
      else
         I3F = -1d0/2d0
      endif
      gzff(+1) = -qf*sw/cw      !Zff coupling constant
      gzff(-1) = -qf*sw/cw+I3f/sw/cw


      BW   = B0_(0D0,0d0,MW,0)
      BZ   = B0_(0D0,0d0,MZ,0)
      BP   = B0_(p12,0d0,0d0,0)
      BPWW = B0_(p12,MW,MW,0)
      C0Z0 = C0_(0d0,0d0,p12,0d0,MZ,0d0,0)
      C0W0 = C0_(0d0,0d0,p12,0d0,MW,0d0,0)
      CW0W = C0_(0d0,0d0,p12,MW,0d0,MW,0)
      B1W  = B1_(0D0,0d0,MW,0)
      B1Z  = B1_(0D0,0d0,MZ,0)

c*** Mass- and IR-singular scalar integrals
      if (qf.eq.0d0) then
         Bf0f = 0d0
         CfAf = 0d0
      else
         Bf0f = B0_(mf2,0d0,mf,0)
         CfAf = C0_(mf2,p12,mf2,0d0,mf,mf,307)
      endif

c*** one-loop correction
      FZFF(+1) = -ALPHA*Qf**2/(4D0*PI)*(
     &  2D0/CW2-(2D0*(MZ2+2D0*P12)*SW2*BZ)/(CW2*P12)
     &	-4D0*Bf0f+((3D0*P12+2D0*MZ2*SW2)*BP)/(CW2*P12)
     &  +(2D0*(MZ2+P12)**2*SW2*C0Z0)/(CW2*P12)+2D0*P12*CfAf	)

      FZFF(-1) = ALPHA/(8D0*PI)*(
     &  (2D0*(I3F-2D0*I3F**3-3D0*I3F*SW2+Qf*SW2+6D0*I3F**2*
     &  Qf*SW2-2D0*I3F*Qf**2*SW2+2D0*I3F*SW2**2-Qf*SW2**2-4D0*I3F*
     &  Qf**2*SW2**2+2D0*Qf**3*SW2**2))/(CW2*SW2*(I3F-Qf*SW2))
     &  +(2D0*(MW2+2D0*P12)*BW)/(P12*SW2)
     &  +(4D0*(MZ2+2D0*P12)*(I3F-Qf*SW2)**2*BZ)/(CW2*P12*SW2)
     &  +8D0*Qf**2*Bf0f
     &	+((2D0*MW2+3D0*P12)*(I3F-2D0*I3F*SW2+Qf*SW2)*BP)
     &	/(P12*SW2*(I3F-Qf*SW2))
     &  +2D0*(-(2D0*I3F**2*MZ2)-3D0*I3F**2*P12+4D0*I3F*MZ2*Qf*SW2
     &  +6D0*I3F*P12*Qf*SW2-3D0*P12*Qf**2*SW2-2D0*MZ2*Qf**2*SW2**2)
     &	*BP/(CW2*P12*SW2)
     &	-(2D0*CW2*I3F*(2D0*MW2+P12)*BPWW)/(P12*SW2*(I3F-Qf*SW2))
     &	+(4D0*CW2*I3F*MW2*(MW2+2D0*P12)*CW0W)
     &	/(P12*SW2*(I3F-Qf*SW2))
     &  +(2D0*(MW2+P12)**2*(I3F-2D0*I3F*SW2+Qf*SW2)*C0W0)
     &  /(P12*SW2*(I3F-Qf*SW2))
     &  -(4D0*(MZ2+P12)**2*(I3F-Qf*SW2)**2*C0Z0)/(CW2*P12*SW2)
     &	-4D0*P12*Qf**2*CfAf	)

c Z->bb with massive top-loop
      if (Qf.eq.-1d0/3d0.and.gen.eq.3) then
       FZFF(-1) = FZFF(-1) -ALPHA/(16d0*Pi*SW2)*(
     &    ((7d0-10d0*CW2)*MT2)/((1d0+2d0*CW2)*MW2)
     &  + MT2*(2d0*CW2*MT2**2+MT2*MW2+2d0*CW2*MT2*MW2-6d0*MW2**2
     &         -4d0*CW2*MW2**2)*B0_(0d0,0d0,MT,0)/((MT2-MW2)*MW2**2)
     &  - MT2*(2d0*CW2*MT2-5d0*MW2-2d0*CW2*MW2)
     &       *B0_(0d0,0d0,MW,0)/((MT2-MW2)*MW2)
     &  - 2d0*(1d0-4d0*CW2)*(3d0+2d0*CW2)
     &       *B0_(MZ2,0d0,0d0,0)/(1d0+2d0*CW2)
     &  - 2d0*(4d0*CW2*MT2**2-4d0*CW2**2*MT2**2+2d0*MT2*MW2
     &         -4d0*CW2*MT2*MW2-4d0*CW2**2*MT2*MW2-3d0*MW2**2
     &         +10d0*CW2*MW2**2+8d0*CW2**2*MW2**2)
     &       *B0_(MZ2,MT,MT,0)/((1d0+2d0*CW2)*MW2**2)
     &  -3d0*MT2*(-2d0*CW2*MT2+4d0*CW2**2*MT2-MW2+4d0*CW2*MW2
     &            +4d0*CW2**2*MW2)*B0_(MZ2,MW,MW,0)
     &      /((1d0+2d0*CW2)*MW2**2)
     &  +24d0*CW2*(2d0+CW2)*MW2*C0_(0d0,MZ2,0d0,0d0,MW,MW,0)
     &       /(1d0+2d0*CW2)
     &  + 6d0*(CW2*MT2**3-2d0*CW2**2*MT2**3+MT2**2*MW2
     &         -4d0*CW2*MT2**2*MW2-4d0*MT2*MW2**2+5d0*CW2*MT2*MW2**2
     &         +6d0*CW2**2*MT2*MW2**2-8d0*CW2*MW2**3-4d0*CW2**2*MW2**3)
     &       *C0_(0d0,MZ2,0d0,MT,MW,MW,0)/((1d0+2d0*CW2)*MW2**2)
     &  -4d0*(1d0-4d0*CW2)*(1d0+CW2)**2*MZ2
     &      *C0_(0d0,MZ2,0d0,MW,0d0,0d0,0)/(1d0+2d0*CW2)
     &  -2d0*(-4d0*CW2**2*MT2**3+4d0*CW2**3*MT2**3-CW2*MT2**2*MW2
     &        +10d0*CW2**2*MT2**2*MW2-4d0*CW2*MT2*MW2**2
     &        -8d0*CW2**2*MT2*MW2**2-12d0*CW2**3*MT2*MW2**2-2d0*MW2**3
     &        +4d0*CW2*MW2**3+14d0*CW2**2*MW2**3+8d0*CW2**3*MW2**3)
     &      *C0_(0d0,MZ2,0d0,MW,MT,MT,0)/(CW2*(1d0+2d0*CW2)*MW2**2)
     &  +2d0*MW2*DB0_(0d0,0d0,MW,0)
     &  +(MT2-MW2)*(MT2+2d0*MW2)*DB0_(0d0,MT,MW,0)/MW2
     &  )
      endif

c counter terms
        if (qf.eq.0d0) then
	  dZff_a = 0d0
	else
	  dZff_a  = -ALPHA/4D0/PI*qf**2*( log(mudim2/mf2)+4d0
     &	         	                      +4d0*log(lambda/mf) )
        endif
        dZffl = dZff_a + ALPHA/4D0/PI*(
     &            + gzff(-1)**2*(2D0*B1Z+1D0)
     &            + (2D0*B1W+1D0)/2D0/SW2   )
        dZffr = dZff_a + ALPHA/4D0/PI*(
     &            + gzff(+1)**2*(2D0*B1Z+1D0) )

        FZFF(+1) = FZFF(+1) + dZe+dsw/sw/cw2+dZzz/2d0+dZffr
     &			      +dZaz/2d0/sw*cw
        FZFF(-1) = FZFF(-1) + dZe+dsw/sw/cw2-2d0*I3f/sw2/cw*dsw/gzff(-1)
     &			+dZzz/2d0+dZffl	-qf*dZaz/2d0/gzff(-1)

	end

**********************************************************************
	function FZf1f2virt_QCD(kw2,Q1,Q2,m1,m2)
**********************************************************************
*	Form factor for one-loop QCD correction to  Z-f1-f2bar vertex
*---------------------------------------------------------------------
*	Z boson:  invariant mass = kw2
*	fermions: on shell, masses m1 and m2 as regulators
*---------------------------------------------------------------------
*	8.6.99 Stefan Dittmaier, modified by Axel (24.10.05)
**********************************************************************
	implicit none
        real*8 kw2,q1,q2,m1,m2,fac1,fac2,m12,m22
	complex*16 BK,B1,B2,CK12,FZf1f2virt_QCD,B0_,C0_

      include 'COMMON/param.inc'
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2
c renormalization scale
      real*8 mudim2
      common/uv/mudim2

	if (q1*q2.ne.0d0.and.q1*q2.ne.1d0) then
	  m12  = m1**2
	  m22  = m2**2
	  BK   = B0_(KW2,0D0,0D0,0)
	  B1   = B0_(m12,0d0,m1,0)
      	  fac1 = log(mudim2/m12)+4d0+4d0*log(lambda/m1)
	  B2   = B0_(m22,0d0,m2,0)
      	  fac2 = log(mudim2/m22)+4d0+4d0*log(lambda/m2)
	  CK12 = C0_(M12,KW2,M22,0D0, M1, M2,307)
	  FZf1f2virt_QCD = ALPHAS/3D0/PI*(-2D0+2D0*B1+2D0*B2-3D0*BK
     &		                -2D0*KW2*CK12-fac1/2d0-fac2/2d0)
	else
	  FZf1f2virt_QCD = 0d0
	endif

	end

**********************************************************************
	function FWf1f2virt(kw2,Q1,Q2,m1,m2)
**********************************************************************
*	Form factor for O(alpha) correction to  W-f1-f2bar vertex
*	conventional formalism
*---------------------------------------------------------------------
*	W boson:  invariant mass = kw2
*	fermions: on shell, masses m1 and m2 as regulators
*---------------------------------------------------------------------
*	8.6.99 Stefan Dittmaier
**********************************************************************
	implicit none
        real*8 kw2,Q1,Q2,m1,m2,fac1,fac2,m12,m22
	complex*16 BW,BZ,BW1,BZ1,BK,BKW,BKWZ,B1,B2
	complex*16 CK1W,CK2W,CKWZ,CKZ,CK12
	complex*16 dZf1m,dZf2m,ct,corr,FWf1f2virt
	complex*16 B0_,B1_,C0_
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      complex*16 dZh
      common/renc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &            dZeer,dZeel,dZnnl,dZh

      include 'COMMON/param.inc'
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2
c renormalization scale
      real*8 mudim2
      common/uv/mudim2

	m12 = m1**2
	m22 = m2**2

	BW   = B0_(0D0,0D0, MW,0)
	BZ   = B0_(0D0,0D0, MZ,0)
	BW1  = B1_(0D0,0D0, MW,0)
	BZ1  = B1_(0D0,0D0, MZ,0)
	BK   = B0_(KW2,0D0,0D0,0)
	BKW  = B0_(KW2,0D0, MW,0)
	BKWZ = B0_(KW2, MW, MZ,0)
	CKWZ = C0_(0D0,KW2,0D0,0D0, MW, MZ,0)
	CKZ  = C0_(0D0,KW2,0D0, MZ,0D0,0D0,0)

c*** Mass- and IR-singular scalar integrals
	if (q1.eq.0d0) then
	  B1   = 0d0
	  CK1W = 0d0
      	  fac1 = 0d0
	else
	  B1   = B0_(m12,0d0,m1,0)
	  CK1W = C0_(M12,KW2,0D0,M1,0D0,MW,306)
      	  fac1 = log(mudim2/m12)+4d0+4d0*log(lambda/m1)
	endif
	if (q2.eq.0d0) then
	  B2   = 0d0
	  CK2W = 0d0
      	  fac2 = 0d0
	else
	  B2   = B0_(m22,0d0,m2,0)
	  CK2W = C0_(M22,KW2,0D0,M2,0D0,MW,306)
      	  fac2 = log(mudim2/m22)+4d0+4d0*log(lambda/m2)
 	endif
	if (q1*q2.eq.0d0) then
	  CK12 = 0d0
	else
	  CK12 = C0_(M12,KW2,M22,0D0, M1, M2,307)
	endif

c*** one-loop EW correction
	corr = -ALPHA/16D0/PI*(
     &	-2D0/CW2/SW2*(1D0-2D0*SW2-4D0*Q1*Q2*SW2)
     &  +4D0*BKW*(KW2+MW2)/KW2
     &	-4D0*BW*(2D0*KW2+MW2)/SW2/KW2
     &	+4D0*BKWZ*CW2*(KW2+MW2+MZ2)/SW2/KW2
     &	-2D0*BZ/CW2*(2D0*KW2+MZ2)/SW2
     &  	*(1D0-2D0*SW2+2D0*Q1**2*SW**4+2D0*Q2**2*SW**4)/KW2
     &	+BK/CW2/SW2*(-2D0*MZ2*(Q1-Q2-2D0*Q1*SW2)*(Q1-Q2+2D0*Q2*SW2)
     &		-3D0*KW2*(1D0-2D0*SW2-4D0*Q1*Q2*SW2))/KW2
     &	-8D0*B1*Q1**2
     &	-8D0*B2*Q2**2
     &	+8D0*CK12*KW2*Q1*Q2
     &	-8D0*CK1W*MW2*Q1*(Q1-Q2)
     &	+8D0*CK2W*MW2*Q2*(Q1-Q2)
     &	-8D0*CKWZ*CW2*(KW2*MW2+KW2*MZ2+MW2*MZ2)/SW2/KW2
     &	-2D0*CKZ/CW2*(KW2+MZ2)**2/SW2
     &		*(Q1-Q2-2D0*Q1*SW2)*(Q1-Q2+2D0*Q2*SW2)/KW2	    )

c*** counterterms
	dZf1m = ALPHA/4D0/PI*(
     &	  	  - Q1**2*fac1
     &		  + ((Q1-Q2)/2d0/sw/cw-sw/cw*Q1)**2*(2D0*BZ1+1D0)
     &		  + (2D0*BW1+1D0)/2D0/SW2		)
	dZf2m = ALPHA/4D0/PI*(
     &		  - Q2**2*fac2
     &		  + ((Q2-Q1)/2d0/sw/cw-sw/cw*Q2)**2*(2D0*BZ1+1D0)
     &		  + (2D0*BW1+1D0)/2D0/SW2		)
	ct    = dZe - dsw/sw + (dZW+dZf1m+dZf2m)/2d0

	FWf1f2virt = corr + ct

	end

**********************************************************************
	function FWf1f2virt_QCD(kw2,Q1,Q2,m1,m2)
**********************************************************************
*	Form factor for one-loop QCD correction to  W-f1-f2bar vertex
*---------------------------------------------------------------------
*	W boson:  invariant mass = kw2
*	fermions: on shell, masses m1 and m2 as regulators
*---------------------------------------------------------------------
*	8.6.99 Stefan Dittmaier
**********************************************************************
	implicit none
        real*8 kw2,q1,q2,m1,m2,fac1,fac2,m12,m22
	complex*16 BK,B1,B2,CK12,FWf1f2virt_QCD,B0_,C0_

      include 'COMMON/param.inc'
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2
c renormalization scale
      real*8 mudim2
      common/uv/mudim2

	if (q1*q2.ne.0d0) then
	  m12  = m1**2
	  m22  = m2**2
	  BK   = B0_(KW2,0D0,0D0,0)
	  B1   = B0_(m12,0d0,m1,0)
      	  fac1 = log(mudim2/m12)+4d0+4d0*log(lambda/m1)
	  B2   = B0_(m22,0d0,m2,0)
      	  fac2 = log(mudim2/m22)+4d0+4d0*log(lambda/m2)
	  CK12 = C0_(M12,KW2,M22,0D0, M1, M2,307)
	  FWf1f2virt_QCD = ALPHAS/3D0/PI*(-2D0+2D0*B1+2D0*B2-3D0*BK
     &		                -2D0*KW2*CK12-fac1/2d0-fac2/2d0)
	else
	  FWf1f2virt_QCD = 0d0
	endif

	end

**********************************************************************
	function FWf1f2virt_bgf(kw2,Q1,Q2,m1,m2)
**********************************************************************
*	Form factor for one-loop correction to  W-f1-f2bar vertex
*	background-field formalism
*---------------------------------------------------------------------
*	W boson:  invariant mass = kw2
*	fermions: on shell, masses m1 and m2 as regulators
*---------------------------------------------------------------------
*	8.6.99 Stefan Dittmaier
**********************************************************************
	implicit none
        real*8 kw2,q1,q2,m1,m2,fac1,fac2,m12,m22
	complex*16 BW,BZ,BW1,BZ1,BK,BKW,BKWZ,B1,B2
	complex*16 CK1W,CK2W,CKWZ,CKZ,CK12
	complex*16 dZf1m,dZf2m,ct,corr,FWf1f2virt_bgf
	complex*16 B0_,B1_,C0_

      include 'COMMON/param.inc'
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      common/renc_bgf/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &                dZeer,dZeel,dZnnl
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2
c renormalization scale
      real*8 mudim2
      common/uv/mudim2

	m12 = m1**2
	m22 = m2**2

	BW   = B0_(0D0,0D0, MW,0)
	BZ   = B0_(0D0,0D0, MZ,0)
	BW1  = B1_(0D0,0D0, MW,0)
	BZ1  = B1_(0D0,0D0, MZ,0)
	BK   = B0_(KW2,0D0,0D0,0)
	BKW  = B0_(KW2,0D0, MW,0)
	BKWZ = B0_(KW2, MW, MZ,0)
	CKWZ = C0_(0D0,KW2,0D0,0D0, MW, MZ,0)
	CKZ  = C0_(0D0,KW2,0D0, MZ,0D0,0D0,0)

c*** Mass- and IR-singular scalar integrals
	if (q1.eq.0d0) then
	  B1   = 0d0
	  CK1W = 0d0
      	  fac1 = 0d0
	else
	  B1   = B0_(m12,0d0,m1,0)
	  CK1W = C0_(M12,KW2,0D0,M1,0D0,MW,306)
      	  fac1 = log(mudim2/m12)+4d0+4d0*log(lambda/m1)
	endif
	if (q2.eq.0d0) then
	  B2   = 0d0
	  CK2W = 0d0
      	  fac2 = 0d0
	else
	  B2   = B0_(m22,0d0,m2,0)
	  CK2W = C0_(M22,KW2,0D0,M2,0D0,MW,306)
      	  fac2 = log(mudim2/m22)+4d0+4d0*log(lambda/m2)
 	endif
	if (q1*q2.eq.0d0) then
	  CK12 = 0d0
	else
	  CK12 = C0_(M12,KW2,M22,0D0, M1, M2,307)
	endif

c*** one-loop EW correction
	corr = -ALPHA/16D0/PI*(
     &  +4D0*BKW*(3D0*KW2+MW2)/KW2
     &  +4D0*BKWZ*CW2*(3D0*KW2+MW2+MZ2)/SW2/KW2
     &	-4D0*BW*(2D0*KW2+MW2)/SW2/KW2
     &	-2D0*BZ/CW2*(2D0*KW2+MZ2)/SW2
     &		*(1D0-2D0*SW2+2D0*Q1**2*SW**4+2D0*Q2**2*SW**4)/KW2
     &	+BK/CW2/SW2*(-2D0*MZ2*(Q1-Q2-2D0*Q1*SW2)*(Q1-Q2+2D0*Q2*SW2)
     &		-3D0*KW2*(1D0-2D0*SW2-4D0*Q1*Q2*SW2))/KW2
     &	-8D0*B1*Q1**2
     &	-8D0*B2*Q2**2
     &	+8D0*CK12*KW2*Q1*Q2
     &	-8D0*CK1W*MW2*Q1*(Q1-Q2)
     &	+8D0*CK2W*MW2*Q2*(Q1-Q2)
     &	-8D0*CKWZ*CW2*(KW2*MW2+KW2*MZ2+MW2*MZ2)/SW2/KW2
     &	-2D0*CKZ/CW2*(KW2+MZ2)**2/SW2
     &		*(Q1-Q2-2D0*Q1*SW2)*(Q1-Q2+2D0*Q2*SW2)/KW2
     &	-2D0/CW2/SW2*(1D0-2D0*SW2-4D0*Q1*Q2*SW2)		)

c*** counterterms
	dZf1m = ALPHA/4D0/PI*(
     &	  	  - Q1**2*fac1
     &		  + ((Q1-Q2)/2d0/sw/cw-sw/cw*Q1)**2*(2D0*BZ1+1D0)
     &		  + (2D0*BW1+1D0)/2D0/SW2		)
	dZf2m = ALPHA/4D0/PI*(
     &		  - Q2**2*fac2
     &		  + ((Q2-Q1)/2d0/sw/cw-sw/cw*Q2)**2*(2D0*BZ1+1D0)
     &		  + (2D0*BW1+1D0)/2D0/SW2		)
	ct    = dZe - dsw/sw + (dZW+dZf1m+dZf2m)/2d0

	FWf1f2virt_bgf = corr + ct

	end

************************************************************************
        subroutine calcrenc
************************************************************************
*	calculate renormalization constants
*	conventional formalism
*-----------------------------------------------------------------------
*       26.5.99 Stefan Dittmaier
************************************************************************
        implicit none
	complex*16 B0_,B00H,B00W,B00Z,BW0W,BWWZ,BWHW,BZWW,BZHZ
	complex*16 DB0_,DBW0W,DBWWZ,DBWHW,DBZWW,DBZHZ,DB0WW
	complex*16 DB00W,DB0HW,DB0WZ
        complex*16 BHWW,BHZZ,DBHWW,DBHZZ,DBHHH
	complex*16 seww0

      real*8 x
      include 'COMMON/param.inc'
      include 'COMMON/options.inc'
c renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      complex*16 dalpz,drbos,drferm
      complex*16 dZh
      common/renc/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &            dZeer,dZeel,dZnnl,dZh
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2
c renormalization scale
      real*8 mudim2
      common/uv/mudim2

	B00H  = B0_(0d0,0d0,mh,0)
	B00W  = B0_(0d0,0d0,mw,0)
	B00Z  = B0_(0d0,0d0,mz,0)
	BW0W  = B0_(mw2,0d0,mw,0)
	BWWZ  = B0_(mw2, mw,mz,0)
	BWHW  = B0_(mw2, mh,mw,0)
	BZWW  = B0_(mz2, mw,mw,0)
	BZHZ  = B0_(mz2, mh,mz,0)
	BHWW  = B0_(mh2, mw,mw,0)
	BHZZ  = B0_(mh2, mz,mz,0)
	DBW0W = DB0_(mw2,0d0,mw,0)
	DBWHW = DB0_(mw2, mh,mw,0)
	DBWWZ = DB0_(mw2, mw,mz,0)
	DBZHZ = DB0_(mz2, mh,mz,0)
	DBZWW = DB0_(mz2, mw,mw,0)
	DB0WW = DB0_(0d0, mw,mw,0)
	DB00W = DB0_(0d0,0d0,mw,0)
	DB0HW = DB0_(0d0, mh,mw,0)
	DB0WZ = DB0_(0d0, mw,mz,0)
	DBHWW = DB0_(mh2, mw,mw,0)
	DBHZZ = DB0_(mh2, mz,mz,0)
	DBHHH = DB0_(mh2, mh,mh,0)

	dmw2 = ALPHA/PI*(
     &	   -BW0W*MW2
     &	   +B00Z*(-1D0+3D0*CW2)*(1D0+8D0*CW2)*MZ2/(48D0*CW2*SW2)
     &	   +BWWZ*(1D0-4D0*CW2)*(1D0+20D0*CW2+12D0*CW2**2)*MZ2
     &	    /(48D0*CW2*SW2)
     &	   +B00H*MH2*(-MH2+3D0*MW2)/(48D0*CW2*MZ2*SW2)
     &	   +BWHW*(MH2**2-4D0*MH2*MW2+12D0*MW2**2)
     &       /(48D0*CW2*MZ2*SW2)
     &	   +B00W*(MH2+18D0*MW2+MZ2)/(48D0*SW2)
     &	   -(3D0*MH2+56D0*MW2+3D0*MZ2)/(72D0*SW2)	)

	dmz2 = ALPHA/PI*(
     &	  BZWW*(1D0-4D0*CW2)*(1D0+20D0*CW2+12D0*CW2**2)*MZ2
     &      /(48D0*CW2*SW2)
     &	  +B00W*(1D0-4D0*CW2+12D0*CW2**2)*MZ2/(12D0*SW2)
     &	  +B00Z*(MH2+MZ2)/(48D0*CW2*SW2)
     & 	  +B00H*MH2*(-MH2+3D0*MZ2)/(48D0*CW2*MZ2*SW2)
     &	  +BZHZ*(MH2**2-4D0*MH2*MZ2+12D0*MZ2**2)/(48D0*CW2*MZ2*SW2)
     &	  +(-3D0*MH2-10D0*MW2-MZ2+24D0*CW2**2*MZ2-72D0*CW2**3*MZ2)
     &	    /(72D0*CW2*SW2)	)

	dZw = - ALPHA/PI*(
     &	   -BW0W+B00Z/CW2**2*(1D0+8D0*CW2)/48D0
     &	   -1D0/(36D0*SW2)
     &	   +BWWZ/CW2**2*(-1D0-6D0*CW2+16D0*CW2**2-48D0*CW2**3)
     &	    /(48D0*SW2)
     &	   +B00H/CW2**2*MH2*(MH2-MW2)/MZ2**2/(48D0*SW2)
     &	   +BWHW/CW2**2*MH2*(-MH2+2D0*MW2)/MZ2**2/(48D0*SW2)
     &	   +B00W*(-MH2+2D0*MW2-MZ2)/(48D0*CW2*MZ2*SW2)
     &	   -DBW0W*MW2
     &	   +DBWHW*(MH2**2-4D0*MH2*MW2+12D0*MW2**2)
     &	    /(48D0*CW2*MZ2*SW2)
     &	   +DBWWZ*(1D0-4D0*CW2)*(1D0+20D0*CW2+12D0*CW2**2)*MZ2
     &	    /(48D0*CW2*SW2)		)

	x = mh2
	dZh = -ALPHA/(32D0*PI*SW2)*(
     &	-8D0*BHWW-4D0*MZ2*BHZZ/MW2+9D0*MH2**2*DBHHH/MW2
     &  +(2D0*(MH2**2-4D0*X*MW2+12D0*MW2**2)*DBHWW)/MW2
     &  +(MH2**2-4D0*X*MZ2+12D0*MZ2**2)*DBHZZ/MW2 )

	dZzz = -ALPHA/PI*(
     &	    (1D0-2D0*CW2)/(36D0*CW2*SW2)
     &	   +BZWW*(1D0-4D0*CW2-36D0*CW2**2)/(48D0*CW2*SW2)
     &	   +B00Z*(-MH2+MZ2)/(48D0*CW2*MZ2*SW2)
     &	   +B00H*MH2/MZ2**2*(MH2-MZ2)/(48D0*CW2*SW2)
     &	   +BZHZ*MH2/MZ2**2*(-MH2+2D0*MZ2)/(48D0*CW2*SW2)
     &	   +DBZHZ*(MH2**2-4D0*MH2*MZ2+12D0*MZ2**2)
     &       /(48D0*CW2*MZ2*SW2)
     &	   +DBZWW*(1D0-4D0*CW2)*(1D0+20D0*CW2+12D0*CW2**2)*MZ2
     &	    /(48D0*CW2*SW2)		)
	dZaa = -ALPHA/(4D0*PI)*(3D0-3D0*B00W-4D0*MW2*DB0WW)
	dZza = ALPHA/(PI*SW)*CW*(-1D0+B00W)
	dZaz = ALPHA/(CW*PI*SW)*(
     &	   B00W*CW2*(-1D0+6D0*CW2)/3D0
     &	  -BZWW*(1D0+26D0*CW2+24D0*CW2**2)/12D0
     &	  +(-1D0+6D0*CW2-36D0*CW2**2)/18D0	)

	seww0 =  ALPHA/(48D0*PI)*(
     &	-2D0/CW2/SW2*(MH2+19D0*MW2-MH2*SW2-18D0*MW2*SW2)
     &  +8D0*MH2*MW2/SW2*B00H/(MH2-MW2)
     &	+4D0*MW2/SW**4*(15D0*MH2-15D0*MW2-16D0*MH2*SW2
     &       +14D0*MW2*SW2) *B00W/(MH2-MW2)
     &	-4D0/CW2*MW2/SW**4*(5D0-2D0*SW2)*(3D0-4D0*SW2)*B00Z
     & 	+8D0*MW**4*DB00W+(MH2-MW2)**2/SW2*DB0HW
     &	+MW**4/CW**4*SW2*(9D0-8D0*SW2)*DB0WZ	)

	dsw = cw2/2d0/sw*(dmz2/mz2-dmw2/mw2)

	drbos = -dZaa-2d0*dsw/sw+(seww0-dmw2)/mw2+cw/sw*dZza
     &		+alpha/4d0/pi/sw2*(6d0+(7d0-4d0*sw2)/2d0/sw2*log(cw2))

	if ((qalp.eq.0).or.(qalp.eq.2)) then
	  dZe = -dZaa/2d0-dZza*sw/2d0/cw
	elseif (qalp.eq.1) then
	  dZe = -dZaa/2d0-dZza*sw/2d0/cw - drbos/2d0
	endif

	dZeer = ALPHA/4d0/PI*(
     &	  -4d0-2d0*LOG(lambda2/ml2(1))+LOG(ml2(1)/MUDIM2)
     &	  +SW2/CW2*( log(mz2/mudim2)+1d0/2d0 ) )
	dZeel = ALPHA/4d0/PI*(
     &	  -4d0-2d0*LOG(lambda2/ml2(1))+LOG(ml2(1)/MUDIM2)
     &	  +(SW/CW-1d0/2d0/SW/CW)**2*( log(mz2/mudim2)+1d0/2d0 )
     &	  +1d0/2d0/SW2*( log(mw2/mudim2)+1d0/2d0 )		)
	dZnnl = ALPHA/4d0/PI*(
     &	  +1d0/4d0/SW2/CW2*( log(mz2/mudim2)+1d0/2d0 )
     &	  +1d0/2d0/SW2*( log(mw2/mudim2)+1d0/2d0 )		)

	dmw2  = dreal( dmw2  )
	dmz2  = dreal( dmz2  )
	dsw   = dreal( dsw   )
	dZe   = dreal( dZe   )
	dZaa  = dreal( dZaa  )
	dZaz  = dreal( dZaz  )
	dZza  = dreal( dZza  )
	dZzz  = dreal( dZzz  )
	dZw   = dreal( dZw   )
        dZh   = dreal( dZh   )
	dZeer = dreal( dZeer )
	dZeel = dreal( dZeel )
	dZnnl = dreal( dZnnl )

c        print*,'dmw2=',dmw2
c        print*,'dmz2=',dmz2
c        print*,'dsw=',dsw
c        print*,'dze=',dze
c        print*,'dzaa=',dzaa
c        print*,'dzaz=',dzaz
c        print*,'dzza=',dzza
c        print*,'dzzz=',dzzz
c        print*,'dzw=',dzw
c        print*,'dzh=',dzh

	end

************************************************************************
        subroutine calcrenc_bgf
************************************************************************
*	calculate renormalization constants
*	background-field formalism
*-----------------------------------------------------------------------
*       26.5.99 Stefan Dittmaier
************************************************************************
        implicit none
	complex*16 B0_,B00H,B00W,B00Z,BW0W,BWWZ,BWHW,BZWW,BZHZ
	complex*16 DB0_,DBW0W,DBWWZ,DBWHW,DBZWW,DBZHZ,DB0WW
	complex*16 DB00W,DB0HW,DB0WZ
	complex*16 seww0conv

      include 'COMMON/param.inc'
      include 'COMMON/options.inc'
c bgf renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      complex*16 dalpz,drbos,drferm
      common/renc_bgf/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &               dZeer,dZeel,dZnnl
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2
c renormalization scale
      real*8 mudim2
      common/uv/mudim2

	B00H  = B0_(0d0,0d0,mh,0)
	B00W  = B0_(0d0,0d0,mw,0)
	B00Z  = B0_(0d0,0d0,mz,0)
	BW0W  = B0_(mw2,0d0,mw,0)
	BWWZ  = B0_(mw2, mw,mz,0)
	BWHW  = B0_(mw2, mh,mw,0)
	BZWW  = B0_(mz2, mw,mw,0)
	BZHZ  = B0_(mz2, mh,mz,0)
	DBW0W = DB0_(mw2,0d0,mw,0)
	DBWHW = DB0_(mw2, mh,mw,0)
	DBWWZ = DB0_(mw2, mw,mz,0)
	DBZHZ = DB0_(mz2, mh,mz,0)
	DBZWW = DB0_(mz2, mw,mw,0)
	DB0WW = DB0_(0d0, mw,mw,0)
	DB00W = DB0_(0d0,0d0,mw,0)
	DB0HW = DB0_(0d0, mh,mw,0)
	DB0WZ = DB0_(0d0, mw,mz,0)

	dmw2 = ALPHA/PI*(
     &	   -BW0W*MW2
     &	   +B00Z*(-1D0+3D0*CW2)*(1D0+8D0*CW2)*MZ2/(48D0*CW2*SW2)
     &	   +BWWZ*(1D0-4D0*CW2)*(1D0+20D0*CW2+12D0*CW2**2)*MZ2
     &	    /(48D0*CW2*SW2)
     &	   +B00H*MH2*(-MH2+3D0*MW2)/(48D0*CW2*MZ2*SW2)
     &	   +BWHW*(MH2**2-4D0*MH2*MW2+12D0*MW2**2)
     &       /(48D0*CW2*MZ2*SW2)
     &	   +B00W*(MH2+18D0*MW2+MZ2)/(48D0*SW2)
     &	   -(3D0*MH2+56D0*MW2+3D0*MZ2)/(72D0*SW2)	)

	dmz2 = ALPHA/PI*(
     &	  BZWW*(1D0-4D0*CW2)*(1D0+20D0*CW2+12D0*CW2**2)*MZ2
     &      /(48D0*CW2*SW2)
     &	  +B00W*(1D0-4D0*CW2+12D0*CW2**2)*MZ2/(12D0*SW2)
     &	  +B00Z*(MH2+MZ2)/(48D0*CW2*SW2)
     & 	  +B00H*MH2*(-MH2+3D0*MZ2)/(48D0*CW2*MZ2*SW2)
     &	  +BZHZ*(MH2**2-4D0*MH2*MZ2+12D0*MZ2**2)
     &       /(48D0*CW2*MZ2*SW2)
     &	  +(-3D0*MH2-10D0*MW2-MZ2+24D0*CW2**2*MZ2
     &       -72D0*CW2**3*MZ2) /(72D0*CW2*SW2) )

	dZw = - ALPHA/PI*(
     &	   -2D0*BW0W
     &	   +B00Z/CW2**2*(1D0+8D0*CW2)/48D0
     &	   -1D0/(36D0*SW2)
     &	   +BWWZ/CW2**2*(-1D0-6D0*CW2+16D0*CW2**2-96D0*CW2**3)
     &	    /(48D0*SW2)
     &	   +B00H/CW2**2*MH2*(MH2-MW2)/MZ2**2/(48D0*SW2)
     &	   +BWHW/CW2**2*MH2*(-MH2+2D0*MW2)/MZ2**2/(48D0*SW2)
     &	   +B00W*(-MH2+2D0*MW2-MZ2)/(48D0*CW2*MZ2*SW2)
     &	   -MW2*DBW0W
     &	   +DBWHW*(MH2**2-4D0*MH2*MW2+12D0*MW2**2)
     &      /(48D0*CW2*MZ2*SW2)
     &	   +DBWWZ*(1D0-4D0*CW2)*(1D0+20D0*CW2+12D0*CW2**2)*MZ2
     &	    /(48D0*CW2*SW2)		)
	dZzz = -ALPHA/PI*(
     &	    (1D0-2D0*CW2)/(36D0*CW2*SW2)
     &	   +BZWW*(1D0-4D0*CW2-84D0*CW2**2)/(48D0*CW2*SW2)
     &	   +B00Z*(-MH2+MZ2)/(48D0*CW2*MZ2*SW2)
     &	   +B00H*MH2/MZ2**2*(MH2-MZ2)/(48D0*CW2*SW2)
     & 	   +BZHZ*MH2/MZ2**2*(-MH2+2D0*MZ2)/(48D0*CW2*SW2)
     &	   +DBZHZ*(MH2**2-4D0*MH2*MZ2+12D0*MZ2**2)
     &       /(48D0*CW2*MZ2*SW2)
     &	   +DBZWW*(1D0-4D0*CW2)*(1D0+20D0*CW2+12D0*CW2**2)*MZ2
     &	    /(48D0*CW2*SW2)		)
	dZaa = -ALPHA/(4D0*PI)*(7D0-7D0*B00W-4D0*MW2*DB0WW)
	dZza = 0d0
	dZaz = ALPHA/(CW*PI*SW)*(
     &	   B00W*CW2*(-1D0+6D0*CW2)/3D0
     &	  -BZWW*(1D0+38D0*CW2+24D0*CW2**2)/12D0
     &	  +(-1D0+6D0*CW2-36D0*CW2**2)/18D0	)

	seww0conv =  ALPHA/(48D0*PI)*(
     &	-2D0/CW2/SW2*(MH2+19D0*MW2-MH2*SW2-18D0*MW2*SW2)
     &  +8D0*MH2*MW2/SW2*B00H/(MH2-MW2)
     &	+4D0*MW2/SW**4*(15D0*MH2-15D0*MW2-16D0*MH2*SW2
     &       +14D0*MW2*SW2) *B00W/(MH2-MW2)
     &	-4D0/CW2*MW2/SW**4*(5D0-2D0*SW2)*(3D0-4D0*SW2)*B00Z
     & 	+8D0*MW**4*DB00W+(MH2-MW2)**2/SW2*DB0HW
     &	+MW**4/CW**4*SW2*(9D0-8D0*SW2)*DB0WZ	)

	dsw = cw2/2d0/sw*(dmz2/mz2-dmw2/mw2)

	drbos = -dZaa-2d0*dsw/sw+(seww0conv-dmw2)/mw2
     &		+alpha/pi/sw2*(-1d0+B00w)
     &		+alpha/4d0/pi/sw2*(6d0+(7d0-4d0*sw2)/2d0/sw2*log(cw2))

	if ((qalp.eq.0).or.(qalp.eq.2)) then
	  dZe = -dZaa/2d0
	elseif (qalp.eq.1) then
	  dZe = -dZaa/2d0 - drbos/2d0
	endif

	dZeer = ALPHA/4d0/PI*(
     &	  -4d0-2d0*LOG(lambda2/ml2(1))+LOG(ml2(1)/MUDIM2)
     &	  +SW2/CW2*( log(mz2/mudim2)+1d0/2d0 ) )
	dZeel = ALPHA/4d0/PI*(
     &	  -4d0-2d0*LOG(lambda2/ml2(1))+LOG(ml2(1)/MUDIM2)
     &	  +(SW/CW-1d0/2d0/SW/CW)**2*( log(mz2/mudim2)+1d0/2d0 )
     &	  +1d0/2d0/SW2*( log(mw2/mudim2)+1d0/2d0 )		)
	dZnnl = ALPHA/4d0/PI*(
     &	  +1d0/4d0/SW2/CW2*( log(mz2/mudim2)+1d0/2d0 )
     &	  +1d0/2d0/SW2*( log(mw2/mudim2)+1d0/2d0 )		)

	dmw2  = dreal( dmw2  )
	dmz2  = dreal( dmz2  )
	dsw   = dreal( dsw   )
	dZe   = dreal( dZe   )
	dZaa  = dreal( dZaa  )
	dZaz  = dreal( dZaz  )
	dZza  = dreal( dZza  )
	dZzz  = dreal( dZzz  )
	dZw   = dreal( dZw   )
	dZeer = dreal( dZeer )
	dZeel = dreal( dZeel )
	dZnnl = dreal( dZnnl )

	end

************************************************************************
        subroutine calcrenc_ferm
************************************************************************
*	calculate renormalization constants
*	fermion-loop contributions only
*-----------------------------------------------------------------------
*       2.6.99 Stefan Dittmaier
************************************************************************
      implicit none
      integer i
      complex*16 B0_,B00l,B00u,B00d,B0du,BWnl,BWud,BZ00,BZll,BZdd,BZuu
      complex*16 DB0_,DBWnl,DBWud,DBZ00,DBZll,DBZdd,DBZuu
      complex*16 DB0ll,DB0dd,DB0uu,DB00l,DB0du,seww0

      include 'COMMON/param.inc'
      include 'COMMON/options.inc'
c fermionic renormalization constants
      complex*16 dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw
      complex*16 dZeer,dZeel,dZnnl
      complex*16 dalpz,drbos,drferm
      complex*16 dZh
      common/renc_ferm/dmw2,dmz2,dsw,dZe,dZaa,dZaz,dZza,dZzz,dZw,
     &                 dZeer,dZeel,dZnnl,dZh
c IR
      real*8 lambda,lambda2
      common/ir/lambda,lambda2
c renormalization scale
      real*8 mudim2
      common/uv/mudim2

	dmw2  = 0d0
	dmz2  = 0d0
	dZw   = 0d0
	dZzz  = 0d0
	dZaa  = 0d0
	dZza  = 0d0
	dZaz  = 0d0
        dZh   = 0d0
	dalpz = 0d0
	seww0 = 0d0

	do 10 i=1,3

	B00l  =  B0_(0D0,   0D0, ML(I),0)
	B00u  =  B0_(0D0,   0D0,MQP(I),0)
	B00d  =  B0_(0D0,   0D0,MQM(I),0)
	B0du  =  B0_(0D0,MQM(I),MQP(I),0)
	BWnl  =  B0_(MW2,   0D0, ML(I),0)
	BWud  =  B0_(MW2,MQP(I),MQM(I),0)
	DBWnl = DB0_(MW2,   0D0, ML(I),0)
	DBWud = DB0_(MW2,MQP(I),MQM(I),0)
	BZ00  =  B0_(MZ2,0D0,0D0,0)
	BZll  =  B0_(MZ2,ML(I),ML(I),0)
	BZdd  =  B0_(MZ2,MQM(I),MQM(I),0)
	BZuu  =  B0_(MZ2,MQP(I),MQP(I),0)
	DBZ00 = DB0_(MZ2,0D0,0D0,0)
	DBZll = DB0_(MZ2,ML(I),ML(I),0)
	DBZdd = DB0_(MZ2,MQM(I),MQM(I),0)
	DBZuu = DB0_(MZ2,MQP(I),MQP(I),0)
	DB0ll = DB0_(0d0,ML(I),ML(I),0)
	DB0dd = DB0_(0d0,MQM(I),MQM(I),0)
	DB0uu = DB0_(0d0,MQP(I),MQP(I),0)
	DB00l = DB0_(0d0,0d0,ML(I),0)
	DB0du = DB0_(0d0,MQM(I),MQP(I),0)

	dmw2  = dmw2 - ALPHA/(72D0*PI*SW2)*(
     &	8D0*MW2-6D0*ML2(I)-18D0*MQM2(I)-18D0*MQP2(I)
     &  -3D0*B00l*ML2(I)*(-2D0*MW2+ML2(I))/MW2
     &	+3D0*BWnl*(-MW2+ML2(I))*(2D0*MW2+ML2(I))/MW2
     &  -9D0*B00d*MQM2(I)*(-2D0*MW2+MQM2(I)-MQP2(I))/MW2
     &	+9D0*B00u*MQP2(I)*(2D0*MW2+MQM2(I)-MQP2(I))/MW2
     &	+9D0*BWud*(-2D0*MW2**2+MW2*MQM2(I)+MQM2(I)**2
     &          +MW2*MQP2(I)-2D0*MQM2(I)*MQP2(I)+MQP2(I)**2)/MW2 )

	dmz2  = dmz2 + ALPHA/(216D0*CW2*PI)*(
     &	48D0*MZ2-64D0*MZ2*SW2-24D0*MZ2/SW2+18D0*ML2(I)/SW2
     &	-72D0*ML2(I)+144D0*SW2*ML2(I)
     &	-72D0*MQM2(I)+48D0*SW2*MQM2(I)+54D0*MQM2(I)/SW2
     &	-144D0*MQP2(I)+192D0*SW2*MQP2(I)+54D0*MQP2(I)/SW2
     &	+9D0*MZ2*BZ00/SW2
     &	-18D0*(1D0-4D0*SW2+8D0*SW2**2)*B00l*ML2(I)/SW2
     &	-6D0*(9D0-12D0*SW2+8D0*SW2**2)*B00d*MQM2(I)/SW2
     &	-6D0*(9D0-24D0*SW2+32D0*SW2**2)*B00u*MQP2(I)/SW2
     &	-9D0*BZll*(-MZ2+4D0*MZ2*SW2-8D0*MZ2*SW2**2+ML2(I)
     &		   +8D0*SW2*ML2(I)-16D0*SW2**2*ML2(I))/SW2
     &	+3D0*BZdd*(9D0*MZ2-12D0*MZ2*SW2+8D0*MZ2*SW2**2
     &           -9D0*MQM2(I)-24D0*SW2*MQM2(I)+16D0*SW2**2*MQM2(I))/SW2
     &	+3D0*BZuu*(9D0*MZ2-24D0*MZ2*SW2+32D0*MZ2*SW2**2
     &           -9D0*MQP2(I)-48D0*SW2*MQP2(I)+64D0*SW2**2*MQP2(I))/SW2)

	dZw   = dZw  + ALPHA/(72D0*PI*SW2)*(
     &	8D0 + 3D0*MW2**(-2)*B00l*ML2(I)**2
     & 	+3D0*DBWnl*(-MW2+ML2(I))*(2D0*MW2+ML2(I))/MW2
     &  -3D0*MW2**(-2)*BWnl*(2D0*MW2**2+ML2(I)**2)
     & 	+9D0*MW2**(-2)*B00d*MQM2(I)*(MQM2(I)-MQP2(I))
     & 	-9D0*MW2**(-2)*B00u*MQP2(I)*(MQM2(I)-MQP2(I))
     &	-9D0*MW2**(-2)*BWud*(2D0*MW2**2+MQM2(I)**2
     &			     -2D0*MQM2(I)*MQP2(I)+MQP2(I)**2)
     &	+9D0*DBWud*(-2D0*MW2**2+MW2*MQM2(I)+MQM2(I)**2
     &           +MW2*MQP2(I)-2D0*MQM2(I)*MQP2(I)+MQP2(I)**2)/MW2)

        dZh = dZh
     &       +3D0*ALPHA*MQP2(I)/mw2/SW2/8D0/PI
     &        *( -B0_(MH2,MQP(I),MQP(I),0)
     &           +(-MH2+4D0*MQP2(I))*DB0_(MH2,MQP(I),MQP(I),0) )
     &       +3D0*ALPHA*MQM2(I)/mw2/SW2/8D0/PI
     &        *( -B0_(MH2,MQM(I),MQM(I),0)
     &           +(-MH2+4D0*MQM2(I))*DB0_(MH2,MQM(I),MQM(I),0) )
     &       +ALPHA*ML2(I)/mw2/SW2/8D0/PI
     &        *( -B0_(MH2,ML(I),ML(I),0)
     &           +(-MH2+4D0*ML2(I))*DB0_(MH2,ML(I),ML(I),0) )

	dZzz  = dZzz - ALPHA/(216D0*CW2*PI)*(
     &	48D0-64D0*SW2-24D0/SW2
     &	+9D0*BZ00/SW2
     &  +9D0*(1D0-4D0*SW2+8D0*SW2**2)*BZll/SW2
     &  +3D0*(9D0-12D0*SW2+8D0*SW2**2)*BZdd/SW2
     &  +3D0*(9D0-24D0*SW2+32D0*SW2**2)*BZuu/SW2
     &	+9D0*MZ2*DBZ00/SW2
     &	-9D0*DBZll*(-MZ2+4D0*MZ2*SW2-8D0*MZ2*SW2**2+ML2(I)
     &  	    +8D0*SW2*ML2(I)-16D0*SW2**2*ML2(I))/SW2
     &	+3D0*DBZdd*(9D0*MZ2-12D0*MZ2*SW2+8D0*MZ2*SW2**2
     & 	         -9D0*MQM2(I)-24D0*SW2*MQM2(I)+16D0*SW2**2*MQM2(I))/SW2
     &	+3D0*DBZuu*(9D0*MZ2-24D0*MZ2*SW2+32D0*MZ2*SW2**2
     &       -9D0*MQP2(I)-48D0*SW2*MQP2(I)+64D0*SW2**2*MQP2(I))/SW2 )

	dZaa  = dZaa - ALPHA/(27D0*PI)*(
     &	-32D0+9D0*B00l+3D0*B00d+12D0*B00u
     &	+18D0*DB0ll*ML2(I)+6D0*DB0dd*MQM2(I)+24D0*DB0uu*MQP2(I)	)

	dZaz  = dZaz + ALPHA/(54D0*CW*MZ2*PI)*(
     &	32D0*MZ2*SW-12D0*MZ2/SW-72D0*SW*ML2(I)+18D0*ML2(I)/SW
     &	-24D0*SW*MQM2(I)+18D0*MQM2(I)/SW
     &	-96D0*SW*MQP2(I)+36D0*MQP2(I)/SW
     &	-18D0*(1D0-4D0*SW2)*B00l*ML2(I)/SW
     &	+9D0*(1D0-4D0*SW2)*BZll*(MZ2+2D0*ML2(I))/SW
     &	-6D0*(3D0-4D0*SW2)*B00d*MQM2(I)/SW
     &	+3D0*(3D0-4D0*SW2)*BZdd*(MZ2+2D0*MQM2(I))/SW
     &	-12D0*(3D0-8D0*SW2)*B00u*MQP2(I)/SW
     &	+6D0*(3D0-8D0*SW2)*BZuu*(MZ2+2D0*MQP2(I))/SW		)

	dalpz = dalpz + alpha/3d0/pi*dreal(
     & 	     ( 1d0/3d0+(1d0+2d0* ml2(i)/mz2)*(B00l-1d0-BZll) )
     & 	    +( 1d0/3d0+(1d0+2d0*mqm2(i)/mz2)*(B00d-1d0-BZdd) )/3d0 )
	if (i.ne.3)
     &  dalpz = dalpz + alpha/3d0/pi*dreal(
     &     ( 1d0/3d0+(1d0+2d0*mqp2(i)/mz2)*(B00u-1d0-BZuu) )*4d0/3d0)

	seww0 = seww0 - ALPHA/(24D0*PI*SW2)*(
     & 	-6D0*mqm2(i)-2D0*ml2(i)-6D0*mqp2(i)
     &	+6D0*mqm2(i)*B00d+3D0*ml2(i)*B00l+6D0*mqp2(i)*B00u
     &	+3D0*(mqm2(i)+mqp2(i))*B0du
     &	+ml(i)**4*DB00l+3D0*(mqm2(i)-mqp2(i))**2*DB0du	)

10	continue

	dsw  = cw2/2d0/sw*(dmz2/mz2-dmw2/mw2)

	drferm = -dZaa-2d0*dsw/sw+(seww0-dmw2)/mw2

	if (qalp.eq.0) then
	  dZe = -dZaa/2d0
	elseif (qalp.eq.2) then
	  dZe = -dZaa/2d0 - dalpz/2d0
	elseif (qalp.eq.1) then
	  dZe = -dZaa/2d0 - drferm/2d0
	endif

	dZeer = 0d0
	dZeel = 0d0
	dZnnl = 0d0

	dmw2  = dreal( dmw2  )
	dmz2  = dreal( dmz2  )
	dsw   = dreal( dsw   )
	dZe   = dreal( dZe   )
	dZaa  = dreal( dZaa  )
	dZaz  = dreal( dZaz  )
	dZza  = dreal( dZza  )
	dZzz  = dreal( dZzz  )
	dZw   = dreal( dZw   )
        dZh   = dreal( dZh   )

c$$$        print*,'dmw2=',dmw2
c$$$        print*,'dmz2=',dmz2
c$$$        print*,'dsw=',dsw
c$$$        print*,'dze=',dze
c$$$        print*,'dzaa=',dzaa
c$$$        print*,'dzaz=',dzaz
c$$$        print*,'dzza=',dzza
c$$$        print*,'dzzz=',dzzz
c$$$        print*,'dzw=',dzw
c$$$        print*,'dzh=',dzh

	end

************************************************************************
*
*     Improved Born approximation
*
************************************************************************
      function M2IBA()
      implicit none
      integer i1,i2,i3,i4,perm,f1p,f2p,f3p,f4p,f1m,f2m,f3m,f4m
      real*8 M2,M2A,M2B,M2IBA,M2WW,coul,coulsing,bb,weight
      real*8 dzz(-1:1,-1:1),dww,qcdfac
      complex*16 m(-1:1,-1:1,-1:1,-1:1),m42(-1:1,-1:1,-1:1,-1:1)
      complex*16 xB0_,xDB0_,xC0_,cspen,betat,xt
      complex*16 tauhww,tauhzz
      include 'COMMON/param.inc'
      include 'COMMON/xparam.inc'
      include 'COMMON/options.inc'
      include 'COMMON/processpar.inc'
c couplings
      complex*16 cvf(-1:1,3,4),cvs(3)
      common/couplings/cvf,cvs
c mandelstam variables
      real*8 s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
      common/mandel/s,s12,s13,s14,s23,s24,s34,t11,t12,t13,t14
c fitted constant for IBA
      real*8 chww,chzz
      common/IBA/chww,chzz

c symmetry factor
      if (fname(1).eq.fname(3)) then
        perm=4
      else
        perm=1
      endif

      M2IBA = 0d0
      do i1=-1,1,2
      do i2=-1,1,2
      do i3=-1,1,2
      do i4=-1,1,2
        m(i1,i2,i3,i4)=0d0
        m42(i1,i2,i3,i4)=0d0   !for matrix element with f2<->f4
      enddo
      enddo
      enddo
      enddo

      if(cc.eq.1)then  !CC and mixed
        call m_hvv4f(m,+1,1,2,3,4,3)   ! H->WW->nue/num anti-e/mu mu anti-num
        if(nc.eq.1)
     &     call m_hvv4f(m42,-1,1,4,3,2,2) ! H->ZZ->num anti-num mu anti-mu
      else             !NC
        call m_hvv4f(m,+1,1,2,3,4,2)   ! H->ZZ->e anti-e mu anti-mu
        if(perm.eq.4)
     &     call m_hvv4f(m42,-1,1,4,3,2,2) ! H->ZZ->mu anti-mu mu anti-mu
      endif

c mt-,mh-dependent corrections
      if (qqcd.eq.0.or.qqcd.eq.1) then
        betat = cdsqrt(1d0-4d0*xmqp2(3)/mh2)
        xt = (betat-1d0)/(betat+1d0)
        tauhww = 8d0+12d0*betat**2+3d0*betat*(3d0*betat**2-1d0)*log(xt)
     &       +3d0/2d0*(1d0-betat**2)**2*log(xt)**2
        tauhzz = 20d0+6d0*betat**2+3d0*betat*(betat**2+1d0)*log(xt)
     &       +3d0*(1d0-betat**2)*log(xt)**2
        do i1=-1,1,2
        do i3=-1,1,2
          if (nc.ne.0) then
            dzz(i1,i3) = dsqrt(2d0)*GF/(16d0*pi**2)*xmqp2(3)
     &       *(1d0-6d0*xcw/xsw*(el*q(1)/cvf(i1,2,1)+el*q(3)/cvf(i3,2,3))
     &            +tauhzz)
     &        +GF*mh2/(8d0*dsqrt(2d0)*pi**2)
     &            *(5d0*pi**2/6d0-3d0*dsqrt(3d0)*pi+19d0/2d0)
     &        +(GF*mh2/(16d0*dsqrt(2d0)*pi**2))**2 *62.0308d0
          endif
        enddo
        enddo

        dww = dsqrt(2d0)*GF/(16d0*pi**2)*xmqp2(3)
     &                  *(-5d0+tauhww)
     &       +GF*mh2/(8d0*dsqrt(2d0)*pi**2)
     &          *(5d0*pi**2/6d0-3d0*dsqrt(3d0)*pi+19d0/2d0)
     &       +(GF*mh2/(16d0*dsqrt(2d0)*pi**2))**2 *62.0308d0

c Coulomb singularity
        coul   = coulsing(s,s12,s34,1)
        bb     = dsqrt((s-s12-s34)**2-4d0*s12*s34)/s
        weight = (1d0-bb**2)**2
      else
        dww = 0d0
        do i1=-1,1,2
        do i3=-1,1,2
          dzz(i1,i3) = 0d0
        enddo
        enddo
        coul = 0d0
      endif

c QCD factor
      if (qqcd.eq.1.or.qqcd.eq.2.or.qqcd.eq.3) then
        if (quark(1).eq.1.or.quark(3).eq.1) qcdfac = alphas/pi
        if (quark(1).eq.1.and.quark(3).eq.1) qcdfac = 2d0*alphas/pi
      else
        qcdfac = 0d0
      endif

c sum over fermion helicities
      do i1=-1,1,2
      do i2=-1,1,2
      do i3=-1,1,2
      do i4=-1,1,2
        f1p = int((2+pol(1)*i1)/2)
        f2p = int((2+pol(2)*i2)/2)
        f3p = int((2+pol(3)*i3)/2)
        f4p = int((2+pol(4)*i4)/2)

        if (cc.eq.1) then
          M2A = abs(m(i1,i2,i3,i4))**2 * (1d0+dww+qcdfac+chww)
        else
          M2A = abs(m(i1,i2,i3,i4))**2 * (1d0+dzz(i1,i3)+qcdfac+chzz)
        endif
        M2B = abs(m42(i1,i2,i3,i4))**2 * (1d0+dzz(i1,i3)+qcdfac+chzz)

        M2 = ( M2A + M2B +2d0*dreal(m(i1,i2,i3,i4)
     &             *dconjg(m42(i1,i2,i3,i4)))/dsqrt(dfloat(color)) )
     &       *color/perm     !no fitting constant for interference (negligible)

        if (cc.eq.1) then
          M2WW = abs(m(i1,i2,i3,i4))**2*color/perm
        else
          M2WW = 0d0
        endif

        M2IBA  = M2IBA + (M2 + M2WW*coul*weight) *f1p*f2p*f3p*f4p

      enddo
      enddo
      enddo
      enddo

      end

************************************************************************
        function coulsing(s,kp2off,km2off,qcoul)
************************************************************************
*	Correction factor for Coulomb singularity
*	qcoul = 0:   on-shell singularity
*	qcoul = 1:  off-shell singularity according to
*			D.Bardin, W.Beenakker, A.Denner,
*			Phys.Lett.B317(1993)213.
*-----------------------------------------------------------------------
*       12.7.00 Stefan Dittmaier
************************************************************************
        implicit real*8 (a-z)
	complex*16 b
	integer qcoul
        include 'COMMON/param.inc'


        d  = abs(kp2off-km2off)/s

	if (qcoul.eq.0) then
	  bw = sqrt(1d0-4d0*mw2/s)
          coulsing = alpha0/bw*dimag(
     &		       log((kp2off+km2off-2d0*dcmplx(mw2,-mw*gw)+s*bw*d)
     &           	   /2d0/bw**2/s) )
	else
          b  = sqrt(1d0-4d0*dcmplx(mw2,-mw*gw)/s)
          bb = sqrt((s-kp2off-km2off)**2-4d0*kp2off*km2off)/s
          coulsing = alpha0/bb*dimag( log((b-bb+d)/(b+bb+d)) )
	endif

	end
